/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package HtmlToRichText;

public enum STYLES {
    BOLD("b"),
    EM("em"),
    STRONG("strong"),
    STRIKE("s"),
    COLOR("color"),
    UNDERLINE("u"),
    SPAN("span"),
    ITALLICS("i"),
    UNKNOWN("unknown"),
    PRE("pre"),
    FONTSIZE("font-size"),
    FONTFAMILY("font-family");

    private String type;

    private STYLES(String type) {
        this.type = type;
    }

    public String getType() {
        return type;
    }

    public static STYLES fromValue(String type) {
        for (STYLES style : values()) {
            if (style.type.equalsIgnoreCase(type)) {
                return style;
            }
        }
        return UNKNOWN;
    }
}
