/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

    /* 
     *   (С) 2018  ООО ФОРС-Центр Разработки, ООО ФОРС-Телеком
     *   http://www.fors.ru
     *   http://www.forstelecom.ru
     *
     *   Класс доступа к данным в СУБД Postgres
     *   
     *   РЕВИЗИЯ:
     *  $Rev:: 1            $:  Ревизия файла
     *  $Author:: achibuk   $:  Автор последних изменений
     *  $Date:: 2018-06-26 1#$: Дата последних изменений
     *   ПРИМЕЧАНИЯ:
    ****************************************************************************** */
package LuiDbMyS;

import static LuiCollection.LuiString.*;
import LuiDb.LuiDbConnect;
//import LuiCollection.LuiCollection;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbCur;
import java.sql.*;
import java.util.ArrayList;
//import com.mysql.cj.jdbc.result.ResultSetImpl;
//import com.mysql.cj.jdbc.result.ResultSetMetaData;
import com.mysql.cj.jdbc.exceptions.MySQLStatementCancelledException;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Types;



public class LuiDbConnMyS extends LuiDbConnect {
   
    /**
     * Соединение с БД
     * @param pDataBaseURL URL для доступа к БД например "jdbc:oracle:thin:@fst1:1521:fst" или "jdbc:mysql://localhost:3306/mysql"
     * @param pUsername имя пользователя
     * @param pPassword пароль
     * @param pAutocommit режим автокоммита
     * @param pReadonly режим только чтения
     * @throws SQLException
     */
    @Override
    public void connect(String pDataBaseURL, String pUsername, String pPassword, String pSchema, boolean pAutocommit, boolean pReadonly) throws SQLException {
        super.connect(pDataBaseURL, pUsername, pPassword, pSchema, pAutocommit, pReadonly);
        sid = getSelectResult("select connection_id()");
System.out.println(Integer.parseInt(dbVersion.substring(0,1)));
    }

    /**
     * Определение версии базы данных, к которой выполняется/выполнен соединение
     * @return версия БД
     * @throws SQLException
     */
    public String getDbVersion() throws SQLException {
        if (dbVersion == null) return getSelectResult("select version() vers");
        return dbVersion;
    };
    
    
    @Override
    public int CursorOpen(String pStmt) throws SQLException {
        try{
            Cursor c = new Cursor();
            c.open(pStmt);
            cursorCount++;
            openedCursors.put(cursorCount,c);
            lastActivity = System.currentTimeMillis();
            return cursorCount;
        } catch(SQLException e) {
            if  (!conn.getAutoCommit()){
                conn.rollback();
            }
            throw e;
        }
    }
    
/**
     * Выполняет генерацию одного или более операторов для попытки 
     * блокировки данных извлекаемых оператором select. 
     * Обычно это делается добавлением фразы for update of ...
     * @param pStmt -- оператор select пример: select cl.id,cl.fullname from cl_t_client cl
     * @param uk -- список столбцов являющихся членами уникального ключа строк извлекаемых запросом
     * @return список строк - операторов
     * @throws SQLException 
**/
    @Override
    public ArrayList<String> select4update(String pStmt, ArrayList<ColInfo> uk) throws SQLException {
        boolean isCol=false;
        boolean isNeedTab=true;
        class tableEntry {
          String tableName;
          ArrayList<ColInfo> keyCols;
        }
        ArrayList<tableEntry> tabs;
        tabs=new ArrayList<>();
        ArrayList<String> s4u=new ArrayList<>();
        for (int i=0;i<uk.size();i++) {
            isNeedTab=true;
            // такая таблица в списке есть?
           for (int j=0;j<tabs.size();j++) {
               if (tabs.get(j).tableName.equals(uk.get(i).tableName)) { // есть
                   // проверим есть ли в ней такой столбец
                   isCol=false;
                   for (int k=0;k<tabs.get(j).keyCols.size();k++){
                       if (uk.get(i).name.equals(tabs.get(j).keyCols.get(k).name)) {
                           //есть!
                           isCol=true;
                           break;
                       }                    
                   }
                   if (isCol==false) { // нет в ней такого столбца - значит добавляем и новой таблицы вводить не надо
                       tabs.get(j).keyCols.add(uk.get(i));
                       isNeedTab=false;
                       break;
                   }
               }
           }
           if (isNeedTab){
            tableEntry te=new tableEntry();   
            te.tableName=uk.get(i).tableName;
            te.keyCols=new ArrayList<>();
            te.keyCols.add(uk.get(i));
            tabs.add(te);
           }
        }
        String forUpd;
        for (int i=0;i<tabs.size();i++){
           forUpd="select null from "+tabs.get(i).tableName+" where ";
          for (int j=0;j<tabs.get(i).keyCols.size();j++) {
              if (j>0) {
                  forUpd=forUpd+" and ";
              }
              forUpd=forUpd+tabs.get(i).keyCols.get(j).name;
              forUpd = forUpd +uk.get(i).value;
             /* switch (NVL(tabs.get(i).keyCols.get(j).LuiDATATYPE,"CHAR")){
                     case "CHAR":
                     if (tabs.get(i).keyCols.get(j).value==null){
                     forUpd=forUpd+" is null ";   
                     } else {
                     forUpd=forUpd+"='"+tabs.get(i).keyCols.get(j).value+"'";
                     }
                     break;
                     case "NUMBER":
                     if (tabs.get(i).keyCols.get(j).value==null){
                     forUpd=forUpd+" is null ";   
                     } else {    
                     forUpd=forUpd+"="+tabs.get(i).keyCols.get(j).value;
                     }
                     break;
                     case "DATE":
                     case "DATETIME":
                       if (is_not_null(tabs.get(i).keyCols.get(j).LuiFORMAT)) {
                         forUpd=forUpd+"=date_format(convert('"+tabs.get(i).keyCols.get(j).value+"', DATETIME), '"+tabs.get(i).keyCols.get(j).LuiFORMAT+"')";
                       } else
                       {
                        forUpd=forUpd+"=convert('"+tabs.get(i).keyCols.get(j).value+"', DATETIME)";
                       }   
                    break;
              }*/
          }
          forUpd=forUpd+" for update";
          s4u.add(forUpd);
        }
      
      return s4u;
    }

    
    /**
     * Выполнение оператора если он не вызовет зависание в блокировке
     * @param pStmt оператор SQL
     * @return список строк. В первой - либо "locked", либо "success". Во второй - либо имя блокирующего пользователя, либо количество изменённых строк
     * @throws SQLException
     */
    @Override
    public ArrayList<String> executeIfNoLocks(String pStmt) throws SQLException {
        //во- первых попробуем оптимистично выполнить оператор установив предельное время ожидания блокировки 0.5 сек
        // читаем умолчание
        lastActivity=System.currentTimeMillis();
        ThreadForFindLocks t4l;
        String dflt;
        int cnt;
        
        try {
            dflt = getSelectResult("select @@session.innodb_lock_wait_timeout");
            alString.clear(); // очищаем массив строк
            executeDDL("set local innodb_lock_wait_timeout = 500");
            try {
                savepoint("UI4l");
                if (like((LTrim(pStmt.toUpperCase())),"SELECT%")) {
                    selectAndIgnore(pStmt);
                    //stmt //try( ResultSet aRs = stmt.executeQuery(pStmt) ) { } //++ Было странно
                    cnt=1;    
                } else {
                    cnt = executeUpdate(pStmt); //stmt.executeUpdate(pStmt);
                }
                //Ура - всё получилось
                alString.add("success"); // пишем успех
                alString.add(String.valueOf(cnt));// и количество изменённых строк
                executeDDL("set local innodb_lock_wait_timeout="+dflt); // восстановим умолчание
                return alString;
            } catch  (SQLException e) { // возникло исключение
                if (!e.getSQLState().equals("40001")) { // это не наше исключение?  (т.е. сообщение не о "lock_not_available")
                    rollbackToSavepoint("UI4l"); // Откат испорченной транзакции
                    executeDDL("set local innodb_lock_wait_timeout="+dflt); // восстановим умолчание
                    throw e; // не наше -- уходим, отдавая исключение
                }
            }
            // В эту точку попадаем если оптимистичный сценарий не удался
            rollbackToSavepoint("UI4l"); // Откат испорченной транзакции
            savepoint("UI4l"); // Новая точка возврата
            executeDDL("set local innodb_lock_wait_timeout="+dflt); // восстановление умолчания
            t4l = new ThreadForFindLocks(); // запускаем тред поиска блокировок   
           
            try {
                if (like((LTrim(pStmt.toUpperCase())),"SELECT%")){
                    selectAndIgnore(pStmt);
                    //stmt //try( ResultSet aRs = stmt.executeQuery(pStmt) ) { } //++ Было странно
                    cnt=1;
                } else {
                    cnt= executeUpdate(pStmt); //stmt.executeUpdate(pStmt); // пытаемся выполнить оператор
                }
                // // выполнился таки! если тред жив ждём его завершения *//
                if (t4l.thrd.isAlive()) t4l.thrd.join(); 
                alString.clear(); // очищаем список возвращаемых строк, возможно испорченный тредом
                alString.add("success");
                alString.add(String.valueOf(cnt));
                return alString;
            } catch (MySQLStatementCancelledException e) { 
                // если сообщение наше, т.е. о "query cancelled/interrupted", то ничего не делаем 
            } catch (SQLException e){ // попали на исключение
                throw e; // отдаём и уходим
            } catch (InterruptedException e) {
                // ничего не делаем, если основной тред прервут                
            }
            // в эту точку попадаем, если оператор повисал в блокировке
            rollbackToSavepoint("UI4l"); // Откат испорченной транзакции
            return alString; // массив строк заполнен в треде поиска блокировок
        } catch(SQLException e) {
            if (!autoCommit){
                conn.rollback();
            }
            throw e;
        }
    }

    
    /**
     * Rollback to Savepoint
     * @param pPointName
     * @throws SQLException
    */
    @Override
    public boolean rollbackToSavepoint(String pPointName) throws SQLException {
        lastActivity = System.currentTimeMillis();
        try {    
            executeDDL("rollback to savepoint " + pPointName);
            return true;
        } catch (SQLException e) { // возникло исключение
            if (!e.getSQLState().equals("42000")){ // это не наше исключение?
                throw e; // не наше -- уходим отдавая исключение
            } else {
                return false;    
            }
        }
    }
    
    @Override
    public void setSessionInfo(String pInfo) throws SQLException {
        super.setSessionInfo(pInfo);
        // В MySQL в таблице information_schema.processlist нет никаких данных о приложении, создавшем сессию. Нет полей apllication (как в postgresql) или module (как в oracle).
        // От achibuk: Ну, или я не нашёл, где эти данные хранятся.
        // Поэтому, кроме как в атрибуте sessionInfo класса LuiDbConnMyS, данная информация нигде не сохраняется.
    }
    
    @Override
    public String NextVal(String pSequence) throws SQLException {
        // В MySQL отсутствует понятие sequence. Есть auto_increment, но он указывается только для конкретного столбца конкретной таблицы. 
        // Если должна использоваться одна последовательность, из которой выбираются значения для более чем одного столбца одной или нескольких таблиц, 
        // то auto_increment не подходит.
        // Для полноценной реализации в MySQL подобия ораклового или постгресного sequence, надо создавать свою таблицу, в которой будут храниться последние значения для
        // каждого pSequence, а также написать свою функцию nextval, которая будет извлекать данные из этой таблицы, увеличивая последнее сохранённое значение и сохраняя его.
        throw new UnsupportedOperationException("Not supported yet."); 
    }

    @Override
    public String setOffsetClause(String query,String offsetColAlias,String hint,int rows_fetched){
        return query+" limit 999999999 offset " + String.valueOf(rows_fetched);
    }

    /**
     * Преобразование данных из строки полученной в результате выполнения запроса в строку по указанному формату
     * Все данные в результате выполнения запроса преобразовываются к строке по умолчанию
     * их необходимо преобразовать в нужный тип целевой БД, а потом опять в строку, но по заданному в параметре формату
     * @param pResultsetString -
     * @param pColInfo
     * @param pFormat - формат (для чисел в mysql "формат" - это кол-во знаков после запятой; используется так же значение locale, определяющее способ отображения числа в виде строки)
     * @return
    */
/*    @Override
    public String fromRStoStringByFormat(String pStringFromResultSet, ColInfo pColInfo, String pFormat) throws SQLException {
        switch (pColInfo.columnType) {
            case Types.BIGINT:
            case Types.INTEGER:
            case Types.SMALLINT:    
            case Types.NUMERIC: return getSelectResult("select format(convert('" + pStringFromResultSet + "', SIGNED), '" + pFormat + "', " + locale + ")");
            case Types.DECIMAL:
            case Types.DOUBLE:
            case Types.FLOAT:
            case Types.REAL: return getSelectResult("select format(convert('" + pStringFromResultSet + "', DECIMAL(65,30)), '" + pFormat + "', " + locale + "')");
            case Types.VARCHAR:
            case Types.CHAR:
            case Types.LONGVARCHAR:
            case Types.CLOB: return pStringFromResultSet;
            case Types.DATE: 
            case Types.TIMESTAMP:
            case Types.TIMESTAMP_WITH_TIMEZONE: return getSelectResult("select date_format(convert('" + pStringFromResultSet + "', DATETIME), '" + pFormat + "')");
        }
        return null;
    };
*/

    /**
     * Преобразование строки к числу/дате/времени... и обратно к строке по указанному формату
     * исходная строка может не соответствовать формату, но нужно попытаться её преобразовать
     * с использованием подмен , на .
     * @param pString - исходная строка
     * @param pFormat - формат (для чисел в mysql "формат" - это кол-во знаков после запятой; используется так же значение locale, определяющее способ отображения числа в виде строки)
     * @param pLuiDataType - тип данных Lui:NUMBER DATE DATETIME
     * @return
     * @throws SQLException 
     */
 /*   @Override
    public String StringToStringByFormat(String pString, String pFormat, String pLuiDataType) throws SQLException {
        switch (pLuiDataType) {   
            case "NUMBER":
                pString = pString.replace(" ", ""); // удаляем пробелы
                pString = pString.replace(".", ","); // заменяем точку на запятую
                if (is_not_null(pFormat)){
                    return getSelectResult("select format(convert('" + pString + "', DECIMAL(65,30)), '" + pFormat + "', " + locale + "')");
                } else {
                    return getSelectResult("select convert('" + pString + "', DECIMAL(65,30))");    
                }
            case "DATETIME":
            case "DATE":
                if (is_not_null(pFormat)) {
                    return getSelectResult("select date_format(str_to_date('" + pString + "','" + pFormat + "'), '" + pFormat + "')");
                } else {
                    return getSelectResult("select convert('" + pString + "', DATETIME)");           
                }
        }   
        return pString;     
    }
*/
    /**
     * Проверка наличия несохранённых изменений (транзакции)
     * @return boolean true - есть, false - нет
     * @throws SQLException
     */
    @Override
    public boolean isTransaction() throws SQLException {
        String r = getSelectResult("select 1 from information_schema.innodb_trx where trx_mysql_thread_id = " + sid + " and trx_state = 'RUNNING'");
        if (r == null) return false;
        return (r.equals("1"));
    }


    @Override
    public String getSelectResult(String pStmt, int pRows) throws SQLException {
        StringBuilder res = null;
        String s = null;
        int i = 0;
        rowCount = 0;
        lastActivity = System.currentTimeMillis();
    
        Statement aSt = null;
        try {
            aSt = conn.createStatement();
            mStatements.add(aSt);
            try( ResultSet rs = aSt.executeQuery(pStmt)) {
            //stmt //try (ResultSet rs = stmt.executeQuery(pStmt)) {
                while (rs.next()) {
                    rowCount++;
                    if(res==null) res = new StringBuilder();
                    s = rs.getString(1);
                    if (!(s==null)){
                        res.append((String)s);
                    }
                    i++;
                    if (i>=pRows & pRows>0)break;
                }   
                if (res != null) { return res.toString(); }
                return null;
            }
        } catch(SQLException e) {
            if (e.getSQLState().equals("S1009")) return ""; // если это ошибка связанная с тем, что это не запрос а что-то иное, то просто вернём пустую строку
            if (!autoCommit) conn.rollback();
            throw e;
        }
        finally {
            if(aSt != null) {
                aSt.close();
                mStatements.remove(aSt);
            }
        }
    }


    /**
     * Формирование строки, содержащей обращение к данным в заданном столбце, для её использования в SQL-запросе
     * @param pColumn - код столбца
     * @param pLuiDataTypeSrc - исходный тип данных (LUI)
     * @param pLuiDataTypeTgt - целевой тип данных (LUI)
     * @param pLuiFormat - формат данных (для чисел в mysql "формат" - это кол-во знаков после запятой; используется так же значение locale, определяющее способ отображения числа в виде строки)    * @return 
     */
    @Override
    public String getColumnSQLClause(String pColumn, String pLuiDataTypeSrc, String pLuiDataTypeTgt, String pLuiFormat) {
        String s = null;
        switch (NVL(pLuiDataTypeSrc,"CHAR")) {
            case "CHAR":
                switch (NVL(pLuiDataTypeTgt,"CHAR")) {
                    case "CHAR": 
                        s = pColumn; 
                        break;
                    case "NUMBER":
                        s = "convert(" + pColumn + ", DECIMAL(65,30))";
                        break;
                    case "DATE":
                    case "DATETIME":
                        if (is_not_null(pLuiFormat)) s = "str_to_date(" + pColumn + ", '" + pLuiFormat + "')";
                        else s = "convert(" + pColumn + ", DATETIME)";
                        break;
                }
                break;
            case "NUMBER":
                switch (NVL(pLuiDataTypeTgt,"CHAR")) {
                    case "CHAR": 
                        if (is_not_null(pLuiFormat)) s = "format(" + pColumn + ", '" + pLuiFormat + "', " + locale + "')";
                        else s = "convert(" + pColumn + ", CHAR)";
                        break;
                    case "NUMBER":
                    case "DATE":
                    case "DATETIME":
                        s = pColumn;
                        break;
                }
                break;
            case "DATE":
            case "DATETIME":
                switch (NVL(pLuiDataTypeTgt,"CHAR")) {
                    case "CHAR": 
                        if (is_not_null(pLuiFormat)) s = "date_format(" + pColumn + ", '" + pLuiFormat + "')";
                        else s = "convert(" + pColumn + ", CHAR)";
                        break;
                    case "NUMBER": 
                    case "DATE": 
                    case "DATETIME":
                        s = pColumn;
                        break;
                }
                break;
        }
        return s;
    }

    @Override
    public String getDBvendor() {
        return "MyS";
    }

    @Override
    public String getOffsetColumn(String alias) {
      return "";  
    }

    @Override
    public String getQuery4Column(String pTable) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public String getQuery4Table() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
   
    
    /**
    * Вложенный класс - курсор
    */
    class Cursor implements LuiDbCur {
        
        private ArrayList<ColInfo> colList; //список столбцов
        private PreparedStatement prstmt; //Объект JDBC "Оператор"
        private ResultSet resSet; // Набор строк
        private ResultSetMetaData resSetMetaData; // JDBC описание столбцов
        private ArrayList<String> row;
        private int cols;
 private boolean is_executed;
        /**
        * Конструктор - инициализатор
        * 
        */
        Cursor() {
            colList=new ArrayList<ColInfo>();
            cols=0;
            row=new ArrayList<String>();
            prstmt=null;
            resSet=null;
            is_executed=false;
        }

        @Override
        public void open(String pStmt) throws SQLException {
            try {
                if (isOpen()) close();
            } catch (Exception ex){}
            colList.clear();
            row.clear();
            prstmt=conn.prepareStatement(pStmt);
            resSetMetaData= prstmt.getMetaData();
            cols=resSetMetaData.getColumnCount();
            colList=new ArrayList<>();
            for (int i = 1; i <= cols; i++) {
                ColInfo ci;
                ci = new ColInfo(resSetMetaData.getSchemaName(i), 
                                 resSetMetaData.getTableName(i), // oracle не даёт имя таблицы
                                 resSetMetaData.getTableName(i), // вот здесь собака oracle не даёт алиас имени таблицы и из-за этого невозможно правильно сочинить
                                                         // select ... from table1 t1,table2 t2... for update of t1,t2 
                                                         // И не откуда взять имена этих алиасов
                                                         // 
                                 resSetMetaData.getColumnName(i),
                                 resSetMetaData.getColumnLabel(i),
                                 resSetMetaData.getColumnClassName(i),
                                 resSetMetaData.getColumnTypeName(i),
                                 resSetMetaData.getColumnType(i));
                ci.LuiDATATYPE="CHAR";
                switch (ci.columnType) {
                    case Types.BIGINT:
                    case Types.DECIMAL:
                    case Types.DOUBLE:
                    case Types.FLOAT:
                    case Types.INTEGER:
                    case Types.REAL:
                    case Types.SMALLINT:    
                    case Types.NUMERIC: ci.LuiDATATYPE = "NUMBER"; break;
                    case Types.VARCHAR:
                    case Types.CHAR:
                    case Types.LONGVARCHAR:
                    case Types.CLOB: ci.LuiDATATYPE = "CHAR"; break;   
                    case Types.DATE: ci.LuiDATATYPE = "DATETIME"; break;
                    case Types.TIMESTAMP:
                    case Types.TIMESTAMP_WITH_TIMEZONE: ci.LuiDATATYPE = "DATETIME"; break; // в mysql вид данных в полях datetime и timestamp, а также функции преобразования типов для них одни и те же (все для DATETIME)
                }
                colList.add(ci);
            }
        }
    
        /**
        * закрытие курсора
        * @throws java.sql.SQLException
        */
        @Override
        public void close() throws SQLException {
            if (resSet!=null) {if (!resSet.isClosed()) resSet.close();}
            if (prstmt!=null) {if (!prstmt.isClosed()) prstmt.close();}
            is_executed=false;
        }

        /**
        * Извлечение очередной строки из курсора
        * @return true - строка извлечена false -- данных больше нет
        * @throws java.sql.SQLException
        */
        @Override
        public boolean nextRow() throws SQLException {
            if (!is_executed){
            resSet= prstmt.executeQuery();
            is_executed=true;
        }
            if (resSet.next()){
                row.clear();
                for (int i=1;i<=cols;i++) {
                    row.add(resSet.getString(i));
                }
                return true;
            }
            return false;
        }
        
        /**
        * Проверка открытости курсора
        * @return true - открыт, false - закрыт
        */
        @Override
        public boolean isOpen() {
            return cols>0;
        }

        /**
        * Возвращает количество столбцов в строке курсора
        * @return количество столбцов в строке
        */
        @Override
        public int getCols() {
            return cols;
        }
        
        /**
        * Получить описание столбцов запроса
        * @return список объектов ColInfo
        */
        @Override
        public ArrayList<ColInfo> getColsInfo() {
            return colList;
        }

        /**
        * Получить текущую строку c данными курсора (последняя извлечённая строка запроса)
        * @return список объектов ColInfo
        */
        @Override
        public ArrayList<String> getRow() {
            return row;
        }
        
    }
    
    /* Вложенный класс для обнюхивания другим тредом "блокировок текущего процесса другим сеансом" */    
    class ThreadForFindLocks implements Runnable{
        Thread thrd; // тред
        Connection conn4l; // соединение
        Statement stmt4l;
        ResultSet rs;
      
        /**
        * Конструктор объектов класса 
        * @throws java.sql.SQLException
        */
        public ThreadForFindLocks() throws SQLException{
            thrd = new Thread(this);
            this.thrd.start();
        }
    
        @Override
        public void run() {
            //  System.out.println("Thread running");
            try {
                Thread.sleep(500);
                try { 
                    conn4l = DriverManager.getConnection(dbURL, username, password);
                    stmt4l = conn4l.createStatement();
                    // В mysql в версиях 8.% выполняются обращения к некоторым таблицам performance_schema вместо information_schema, используемых до 8-й версии mysql
                    if (Integer.parseInt(dbVersion.substring(0,1)) < 8) {
                        // обращения к таблице information_schema.innodb_lock_waits
                        rs = stmt4l.executeQuery("select trx_l.trx_mysql_thread_id " +
                                                 "  from information_schema.innodb_trx trx_w, " +
                                                 "       information_schema.innodb_trx trx_l, " +
                                                 "       information_schema.innodb_lock_waits lw " +
                                                 " where trx_w.trx_mysql_thread_id = " + sid + " and trx_w.trx_state = 'LOCK WAIT' " +
                                                 "   and lw.requesting_trx_id = trx_w.trx_id " +
                                                 "   and trx_l.trx_id = lw.blocking_trx_id");
                    } else {
                        // обращения к таблице perfomance_schema.data_lock_waits
                        rs = stmt4l.executeQuery("select trx_l.trx_mysql_thread_id " +
                                                 "  from information_schema.innodb_trx trx_w, " +
                                                 "       information_schema.innodb_trx trx_l, " +
                                                 "       perfomance_schema.data_lock_waits lw " +
                                                 " where trx_w.trx_mysql_thread_id = " + sid + " and trx_w.trx_state = 'LOCK WAIT' " +
                                                 "   and lw.requesting_engine_transaction_id = trx_w.trx_id " +
                                                 "   and trx_l.trx_id = lw.blocking_engine_transaction_id");
                    }
                    if (rs.next()) { // запрос вернул строку - блокировка найдена
                        String locking_sid = rs.getString(1); // извлекаем sid (session id) блокирующего процесса
                        if (locking_sid != null){ // если не пуст совсем
                            if (!locking_sid.isEmpty()) { // если не пуст
                                rs.close(); // закрываем запрос
                                rs = stmt4l.executeQuery("select user from information_schema.processlist where id = " + locking_sid); // ищем сеанс с таким sid
                                if (rs.next()) { // есть сеанс, извлекаем данные о пользователе
                                    String locking_usr = rs.getString(1);
                                    alString.clear();
                                    alString.add("locked");
                                    alString.add(locking_usr);
                                    
                                    for(Statement aSt: mStatements) {
                                        aSt.cancel();
                                        //stmt.cancel(); // убиваем оператор основного треда, выполняющийся и заблокировавшийся
                                    }
                                    mStatements.clear();
                                }
                                
                            }
                        } 
                    }
                    stmt4l.close();
                    conn4l.close(); // 
                } catch (SQLException e) {
                    System.err.println(e);
                }
            } catch (InterruptedException e) {}
        }
    }

    
}



