/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Класс LuiException
 */
package LuiExceptionMsg;

import static LuiCollection.LuiString.is_not_null;
import java.util.ArrayList;
import luiserver.LuiApplication;


/**
 *
 * @author aliubushkin
 */

public class LuiException extends Exception{
public    String message_code; //код сообщения
public    String message_text; //текст сообщения
public    Integer message_index; // номер сообщения в массиве
public    String severity; //тип сообщения
//private    ArrayList<LuiMsg>  msgArray;    //массив накапливаемых сообщений    
public    String calling; // описание точки возникновения (тред,класс,метод,номер строки
public    String message_helptext;
    LuiApplication app;
//public LuiException(String pCode,String pText,String pSeverity,ArrayList<LuiMsg> pMsgArray,String pCalling) {
    public LuiException(String pCode,String pText,String pHelpText,String pSeverity,Integer pMsgIndex,String pCalling,LuiApplication pApp) {
    message_code=pCode;
    message_text=pText;
    severity=pSeverity;
    calling=pCalling;
    message_helptext=pHelpText;
    message_index=pMsgIndex;
    app=pApp;
    
    //msgArray=pMsgArray;
    //try{BILLING.getConn().rollback();}
    //catch(Exception ex){}
}

    
    @Override
public String toString(){
    try{
    if ("Y".equals(app.getProperty("DEBUG_MODE"))) {
    if (is_not_null(message_helptext)){
    return "("+this.severity+")"+this.message_code+":"+this.message_text+"\n"+app.NLS.NLS("RUS:Совет: ;ENG:Advise: ;")+message_helptext+"\n("+this.calling+")"; 
    }    
    return "("+this.severity+")"+this.message_code+":"+this.message_text+"\n("+this.calling+")";
    }
    else 
     if (is_not_null(message_helptext)){
     return this.message_text+"\n"+app.NLS.NLS("RUS:Совет: ;ENG:Advise: ;")+message_helptext;
    }   
     return this.message_text;    
    } catch (Exception ex){
        return "";
    }
}
    @Override
    public String getMessage(){
        return this.toString();
    }
    public String getLocalizedMessage(){
        return this.getMessage();
    }
  /* public void remove(){
       int i=msgArray.size()-1;
       msgArray.remove(i);
    }*/
    public String getCode(){return this.message_code;}
    public Integer getIndex(){return this.message_index;}
    public String getShortMessage(){
    return this.message_code+":"+this.message_text;
}
}

