/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Класс "Сообщение" обеспечивает хранение сообщения об ошибке или не об ошибке
 */
package LuiExceptionMsg;

/**
 *
 * @author aliubushkin
 */
public class LuiMsg {
public    String code; //код сообщения
public    String messageText; //текст сообщения
public    String helpText; // текст пояснения
public    String severity; // тип сообщения
public    String calling; // описание где возникло
    /**
     * Конструктор объекта "сообщение"
     * @param pCode - код
     * @param pText - текст
     * @param pHelpText - текст пояснения
     * @param pSeverety - тип
     * @param pCalling  - где возникло
     */   
public LuiMsg(String pCode,String pText,String pHelpText,String pSeverety,String pCalling){
    this.code=pCode;
    this.messageText=pText;
    this.helpText=pHelpText;
    this.severity=pSeverety;
    this.calling=pCalling;
    }    
    @Override
    public String toString(){return "("+this.severity+")"+this.code+":"+this.messageText+" ("+calling+")";}
    
}