/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Вычисляет право доступа к действию над объектом определённого типа
* Синтаксис вычисления
Access:<object_type>;<object_code>;<action>;
Пример:
Access:MENUITEM;AD;RUN;
 */
package Standard;

import LuiCollection.LuiString;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiPlugin;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Access implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String objType= LuiString.Extract_Word(pString, 1, ";");
        String objCode= LuiString.Extract_Word(pString, 2, ";");
        String action= LuiString.Extract_Word(pString, 3, ";");
        
       return app.getEffectiveRight(objType, objCode, action);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        compute(pString,pProp);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
