/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import luiserver.LuiAppConn;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiParser;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class BSQL implements LuiPlugin{
LuiApplication app;
LuiDbConn lc=null;
String stmt;
PreparedStatement pstmt;
LuiAppConn ac;
public RUN r;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
          return exe('C',pString,pProp);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        exe('E',pString,pProp);
    }
private String exe(char executeOrCompute,String pString,LuiAppProp pProp) throws  LuiException,SQLException{
    ac=null;
    pstmt=null;
    lc=null;
    
   // if (like(pString,"%SPLITSHOW%")){
   //  String here="here";   
   // }
    // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return "";
    ArrayList<String> acs=app.getAppConnAndStmt(pString,"",frm.getFormID());
        ac=app.userDbConnections.get(acs.get(0));
        stmt=LuiParser.reMask(acs.get(1));
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае создадим ещё одно
            
            ac=app.addUserDbConnection(ac.code+String.valueOf(System.currentTimeMillis()),ac.name, "P", ac.username, 
                    app.crypter.decrypt(ac.getPWDC()),ac.dbURL,ac.schema);
         //   ac.connect();
            lc=ac.currentConnection;
        }
         if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        }
     
    
         Connection c=lc.getConnection();
     try{
     pstmt=c.prepareStatement(stmt);
     
     r=new RUN();
     r.thread= new Thread(r);
     r.thread.setDaemon(true);
     r.thread.setName("LUI async SQL excecutor");
     r.thread.start();
     }   
         catch (SQLException ex){
           //if (frm!=null) {
               if (frm.getProperty("SuppressErrors").equals("Y")) return "";
           //} 
   
            app.msgWriter.sqlError(lc, ex, pProp, stmt);
 //          if (lc!=null){
           if (pstmt!=null) pstmt.close();
           if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            } else {
            ac.disconnect();
            app.userDbConnections.remove(ac.code);
          } 
 //        }         
            //app.msgWriter.write("LUI-00034","State:"+ex.getSQLState()+"\n"+ex.getLocalizedMessage()+" ("+pString+") ",pProp.getGenesis4msg() );
            return "ERROR";
        }finally{
         
     } 
    return "SUCESS";
}
    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       
    }
  public class RUN implements Runnable{
  public Thread thread; // ссылка на работающий     
  public RUN(){
      
  }  
        @Override
        public void run() {
           try {
            pstmt.execute();
         //    System.out.println("BSQL:Success done "+pstmt.toString());
           } catch (SQLException ex){
             System.out.println("BSQL:"+pstmt.toString()+":"+ex.getLocalizedMessage());
             System.out.println(new Date());
             System.out.println("DbUser="+ac.username);
           }
           finally{
              if (lc!=null){
           try{       
           pstmt.close();
          if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            } else {
            ac.disconnect();
            app.userDbConnections.remove(ac.code);
                   } 
           }catch(Exception ex2){
            }
         } 
           }
        }
      
  }  
}
