/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/* Вызов календаря
*  Синтаксис Compute:
{Calendar:<код_поля>;DATA_TYPE:<типданных DATE/DATETIME>;FORMAT:<формат>;DEFAULT:<дата/время в указанном формате>;
<код_поля> - возле которого показать
<тип_данных> - тип данных DATE или DATETIME
<формат> - формат данных
<дата/время в указанном формате> -- дата/dhtvz которую должен отобразить календарь при возникновении
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiAppWFE;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiClEvent;
import luiserver.LuiClEventReader;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Calendar implements LuiPlugin{
LuiApplication app;
LuiClCommandWriter cw;
LuiClEventReader er;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        //er=new LuiClEventReader(app.eventReader.getReader(),app.msgWriter,app.TotalTimer);
        er=app.eventReader;
              // cw=new LuiClCommandWriter(app.commandWriter.getWriter(),app.TotalTimer); 
              cw=app.commandWriter;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        // установим зависимость от LastRunSCN чтобы LOV появился опять при выполнении действия
        app.changes();
        LuiAppWFE el=pProp.ownerObj;
        LuiAppForm frm=el.getForm();
        if (frm==null)return"";
        String curField=frm.getVal("CurrentField");
        String OldValue="";
        if (frm.elements.containsKey(curField)){
            OldValue=frm.elements.get(curField).getProperty("Value");
        }
       // if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        } else {
          el=el.ownerObj;  
          if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        }
          }
        }
        //}
        pString=LuiString.RTrim(pString);
        String v="";
        pString=LuiString.LTrim(pString);
        if (pString.charAt(pString.length()-1)!=';'){
            pString=pString+";";
        }
        LuiCollection cc=new LuiCollection(pString);
        String field=cc.Get_Element("FIELD");
        String datatype=NVL(cc.Get_Element("DATA_TYPE"),"DATE");
        String format=cc.Get_Element("FORMAT").toUpperCase();
        String def="";
        def=cc.Get_Element("DEFAULT");
        if (is_not_null(def))OldValue=def;
        if (!like(datatype,"DATE") && !like(datatype,"%TIME%")) return def;
        if (is_null(format)) {
         if (datatype.equals("DATE"))format="DD.MM.YYYY";
         else format="DD.MM.YYYY HH24:MI:SS";
        }
        String dateDetail="";
        String timeDetail="";
      
        if (like(format,"%DD%")) {
           dateDetail="D";
        } else if (like(format,"%MM%") || like(format,"%MON%")||like(format,"%MONTH%")) {
           dateDetail="M";
        } else if (like(format,"%YY%") || like(format,"%YEAR%") || like(format,"%RR%")) {
           dateDetail="Y"; 
        }   
        if (like(format,"%SS%")) {
            timeDetail="S";
        } else if (like(format,"%MI%")) {
            timeDetail="M";
        } else if (like(format,"%HH%")) {
            timeDetail="H";
        }
        
        LuiDbConn lc=null;
        try {                
              lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
              if (is_not_null(def)){
               def=lc.getSelectResult("select to_char(to_timestamp('"+def+"','"+format+"'),'YYYYMMDDHH24MISS')");
              } else {
                if (like(datatype,"%TIME%")) {
               def=lc.getSelectResult("select to_char(clock_timestamp(),'YYYYMMDDHH24MISS')");
                } else {
                if ("DATE".equals(datatype)) {
               def=lc.getSelectResult("select to_char(current_date,'YYYYMMDDHH24MISS')");     
                }
                }
              }
        }
        finally{
            if (lc!=null) {
                app.metaConnPool.SetFree(lc);
            }
        }
        LuiClCommandGroup XMLcg=cw.addGroup("Calendar");
        LuiClCommand XMLcmd = XMLcg.addCommand("Calendar");
        XMLcmd.addScaPar("FormID",app.getVal("FormID"));
        XMLcmd.addScaPar("Field",field);
        XMLcmd.addScaPar("DateDetail",dateDetail);
        if (like(datatype,"%TIME%")) {
        XMLcmd.addScaPar("TimeDetail",timeDetail);    
        }
        XMLcmd.addScaPar("Default",def);
        app.changes();
        app.getSeance().remZeroCmd();
        app.getSeance().remFrmWinApp();
        LuiClEvent ev;
        boolean b=true;      
        while (b){
        cw.flush();
        er.readEvents();
        while (true){
        ev=er.getEvent();
        if (ev==null) break;
         if (ev.name.equals("Calendar")){
             b=false;
             v=ev.getParValue("DateTime");
             break;
         }
         else {if (ev.name.equals("Interval")){
                app.interval(); 
         }
         else {   
                app.eventReader.eventList.add(0,ev);
                return OldValue;

         }
        } 
        }
        }
      if (is_not_null(v)) {
       try {                
              lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                if (like(datatype,"%TIME%")) {
               v=lc.getSelectResult("select to_char(to_timestamp('"+v+"','YYYYMMDDHH24MISS'),'"+format+"')");
                } else {
                if ("DATE".equals(datatype)) {
               v=lc.getSelectResult("select to_char(to_date('"+v+"','YYYYMMDDHH24MISS'),'"+format+"')");     
                }
                }
              
        }
        finally{
            if (lc!=null) {
                app.metaConnPool.SetFree(lc);
            }
        }   
      }
      return NVL(v,OldValue);  
    }
    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
