/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiString;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Cell implements LuiPlugin{
LuiApplication app;
boolean is_it_range=false;
String sminus="(~";
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       is_it_range=false; 
       return comp(pString,pProp,false,false,null);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String lq=pString.split("=",2)[0];
        String rq=pString.split("=",2)[1];
          comp(lq,pProp,false,true,rq);
    
     }
    

    
    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        comp(pString,pProp,true,false,null);
    }
     public String comp(String pString, LuiAppProp pProp,boolean pFindOnly,boolean exe,String pPropValue) throws LuiException, SQLException {
      LuiAppForm frm=pProp.ownerObj.getForm();
      ArrayList<String> array=null;
      pString=pString.replace("(-", sminus);
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
    String[] massiv=pString.split(",");
    if (massiv.length<2) return"";
    String PropCode="CELL_TEXT";
    if (massiv.length>2) PropCode=massiv[2];
    String rowrange=getRange(frm,pProp,massiv[0],"ROW");
    String colrange=getRange(frm,pProp,massiv[1],"COL");
    if (is_not_null(rowrange) && is_not_null(colrange)){
      int fr=Integer.valueOf(rowrange.split(":",2)[0]);
      int lr=Integer.valueOf(rowrange.split(":",2)[1]);
      int fc=Integer.valueOf(colrange.split(":",2)[0]);
      int lc=Integer.valueOf(colrange.split(":",2)[1]);
      
      
      for(int r=fr;r<=lr;r++){
         for (int c=fc;c<=lc;c++){
            for (String ec:frm.elements.keySet()){
                if (!frm.elements.get(ec).getType().equals("CELL"))continue;
                if (!frm.elements.get(ec).getProperty("RowNo").equals(String.valueOf(r))) continue;
                if (!frm.elements.get(ec).getProperty("ColNo").equals(String.valueOf(c))) continue;
                LuiAppElement cell=frm.elements.get(ec);
                if (!exe) { 
                    if (!cell.properties.containsKey(PropCode)) return"";
                    cell.properties.get(PropCode).setDepend(pProp); 
                    if (pFindOnly) return null;
                    if (array==null)array=new ArrayList<>();
                    array.add(NVL(cell.properties.get(PropCode).getComputedProperty(),""));
                } else {
                    cell.addProperty(PropCode, pPropValue);
                } 
                break;    
            }
         } 
      }
    }
    if (array!=null && array.size()>0 && !exe && !pFindOnly){
       if (array.size()>1 || is_it_range) return app.toJSON(array);
       else return array.get(0);
    }
    /*
    String RowCode=massiv[0].replace(" ","");
    RowCode=getAddressElement(frm,pProp,RowCode,"ROW");
    if (is_null(RowCode)) return "";
    String ColCode=massiv[1].replace(" ","");
    ColCode=getAddressElement(frm,pProp,ColCode,"COL");
    if (is_null(ColCode)) return "";
    String PropCode="CELL_TEXT";
    if (massiv.length>2) PropCode=massiv[2];
    
    for (String k:frm.elements.keySet()){
      if (frm.elements.get(k).getType().equals("Cell")){
          if (frm.elements.get(k).getProperty("ROW").equals(RowCode)){
              if (frm.elements.get(k).getProperty("COL").equals(ColCode)){
                  frm.elements.get(k).properties.get(PropCode).setDepend(pProp); 
                  if (pFindOnly) return null;
                  return NVL(frm.elements.get(k).properties.get(PropCode).getComputedProperty(),"");
              }
          }
      }  
    }*/
    return "";
     }
String  getRange(LuiAppForm frm,LuiAppProp pProp,String pAddress,String pType) throws LuiException, SQLException{
    pAddress=pAddress.replace(" ","");
    boolean range=false;
    if (like(pAddress,"%-%")) { // вроде как диапазон
        range=true;is_it_range=true;
        if (pAddress.charAt(0)!='[') pAddress="["+pAddress;
        if (pAddress.charAt(pAddress.length()-1)!=']')pAddress=pAddress+"]";
    }else { // если не диапазон приведём к нему
        pAddress="["+pAddress+"-"+pAddress+"]";
    }
    // берём первое и второе слово диапазона
    String wr1=pAddress.split("-",2)[0].replace("[","");
    Integer rl=null;
    String wr2=pAddress.split("-",2)[1].replace("]","");
    Integer rr=null;
    if (is_null(wr1) && range)rl=1;
    if (is_null(wr2) && range)rr=Integer.valueOf(frm.getProperty("Last"+pType));
    if (rl==null) rl=getTupleNo(frm,pProp,wr1,pType);
    if (rr==null){
      if (wr2.equals(wr1))rr=rl;
      else {
          rr=getTupleNo(frm,pProp,wr2,pType);
      }
    }
    if (rl!=null && rr!=null) return rl.toString()+":"+rr.toString();
    return null;
}
 Integer getTupleNo(LuiAppForm frm,LuiAppProp pProp,String pAddress,String pType) throws LuiException, SQLException{
    Integer tn=null;
    String  stn=null;
    if (is_null(pAddress)){ // если пусто
       LuiAppElement c=pProp.getParentElement("CELL"); // контекстная ячейка
       if (c!=null){ // если ячейка
            stn=c.getProperty(LuiString.withCapitalLetter(pType)+"No");
            if (is_not_null(stn))return Integer.valueOf(stn);
            else return null;
        } else { //если не ячейка
          c=pProp.getParentElement(pType);
          if (c!=null){ // если строка или столбей
            stn=c.getProperty("ltn");
            if (is_not_null(stn))return Integer.valueOf(stn);
            else return null;
          } else return null;
        }
    }
    // если не пусто
    if (frm.elements.containsKey(pAddress)){
        // есть такой элемент код которого совпадает с pAddress
        LuiAppElement c=frm.elements.get(pAddress);
        if (c.getType().equals("CELL")){
            stn=c.getProperty(LuiString.withCapitalLetter(pType)+"No");
            if (is_not_null(stn))return Integer.valueOf(stn);
            else return null;
        } else {
            stn=c.getProperty("ltn");
            if (is_not_null(stn))return Integer.valueOf(stn);
            else return null;
        }
    } else { // адрес != коду элемента
        if (like(pAddress,"%_(+%)") ||like(pAddress,"%_"+sminus+"-_%)")) { // адрес состоит мз кода элемента и смещения
           String ec=pAddress.split("(")[0];
           if (!frm.elements.containsKey(ec))return null;
           String sshift=pAddress.replace(sminus,"(-").split("(")[1].replace(")","");
           Integer shift;
           try {
            shift=Integer.valueOf(sshift);
           }catch (Exception ex){
               return null;
           }
           LuiAppElement c=frm.elements.get(pAddress);
           if (c.getType().equals("CELL")){
            stn=c.getProperty(LuiString.withCapitalLetter(pType)+"No");
            if (is_not_null(stn))return shift+Integer.valueOf(stn);
            else return null;
        } else {
            stn=c.getProperty("ltn");
            if (is_not_null(stn))return shift+Integer.valueOf(stn);
            else return null;
        }
        }
      if (like(pAddress,"(+_%)") ||like(pAddress,sminus+"_%)")) { // адрес состоит мз смещения относительно контекстного элемента
          String sshift=pAddress.replace(sminus,"(-").replace("(","").replace(")","");
           Integer shift;
           try {
            shift=Integer.valueOf(sshift);
           }catch (Exception ex){
               return null;
           }
           LuiAppElement c=pProp.getParentElement("CELL"); // контекстная ячейка
           if (c!=null){ // если ячейка
            stn=c.getProperty(LuiString.withCapitalLetter(pType)+"No");
            if (is_not_null(stn))return shift+Integer.valueOf(stn);
            else return null;
           } else { //если не ячейка
          c=pProp.getParentElement(pType);
          if (c!=null){ // если строка или столбей
            stn=c.getProperty("ltn");
            if (is_not_null(stn))return shift+Integer.valueOf(stn);
            else return null;
          } else return null;
        }
      }
     if (like(pAddress,"(_%)")){ // адрес это абслолютный номер кортежа
         stn=pAddress.replace("(","").replace(")","");
         try{
             tn=Integer.valueOf(stn);
             for (String ec:frm.elements.keySet()){
                 if (!frm.elements.get(ec).getType().equals(pType))continue;
                 if (!frm.elements.get(ec).getProperty("ltn").equals(stn))continue;
                 return tn;
             }
             return null; // не нашлось кортежа с таким номером
         } catch (Exception ex){
               return null;
           }
     } 
    }
    return tn;
 }
 /*String getAddressElement(LuiAppForm frm,LuiAppProp pProp,String pAddress,String pType) throws LuiException, SQLException{
     String elCode=pAddress;
     if (is_null(elCode)){ // если строка не указана
        LuiAppElement c=pProp.getParentElement("Cell");
        if (c!=null){ // если ячейка
            elCode=c.getProperty(pType);
        } else { //если не ячейка
          c=pProp.getParentElement(pType);
          if (c!=null){ // если строка или столбей
            elCode=c.Code;  
          } else return null;
        }
    }  //что-там в elCode есть
        if (!frm.elements.containsKey(elCode)){ // но элемента с таким кодом нет
          if (!like(elCode,"%(%)")) return null; //-- если парных круглых скобок нет уходим
          if (like(elCode,"(+%)")) { // ссылка вниз относительно контекстной
             // вычислим контекстную ячейку
            LuiAppElement c=pProp.getParentElement("Cell");
            if (c==null){ // если не определилась по пропери поищем по свойству CurrentCell
               if (frm.elements.containsKey(frm.getProperty("CurrentCELL"))){
                   c=frm.elements.get(frm.getProperty("CurrentCELL"));
               } 
            }
            if (c==null)return null; // уходим если не нашли
            String tc=c.getProperty(pType); // берём код кортежа
            if (!frm.elements.containsKey(tc))return null; // уход если такого нет
            String tln=frm.elements.get(tc).getProperty("ltn");// берём номер этого кортежа (д.б. не пуст если листовой)
            if (is_null(tln))return null; // уходим если пуст
            String shift=elCode.replace("(","").replace(")",""); // сдвиг
            String ltn=String.valueOf(Integer.valueOf(tln)+Integer.valueOf(shift)); // требуемый номер
            int maxT=Integer.valueOf(frm.getProperty("Last"+pType));
            if (Integer.valueOf(ltn)>maxT)return null; // выход за прелелы матрицы
             for (String ec:frm.elements.keySet()){ // поиск кортежа с требуемым номером
                 if (!frm.elements.get(ec).getType().equals(pType))continue;
                 if (!frm.elements.get(ec).getProperty("ltn").equals(ltn))continue;
                 return ec;
             }
             return null; // уходим если  не нашли  
          } else
          if (like(elCode,"(-%)")) { // ссылка вверх относительно контекстной
            // вычислим контекстную ячейку
            LuiAppElement c=pProp.getParentElement("Cell");
            if (c==null){ // если не определилась по пропери поищем по свойству CurrentCell
               if (frm.elements.containsKey(frm.getProperty("CurrentCELL"))){
                   c=frm.elements.get(frm.getProperty("CurrentCELL"));
               } 
            }
            if (c==null)return null; // уходим если не нашли
            String tc=c.getProperty(pType); // берём код кортежа
            if (!frm.elements.containsKey(tc))return null; // уход если такого нет
            String tln=frm.elements.get(tc).getProperty("ltn");// берём номер этого кортежа (д.б. не пуст если листовой)
            if (is_null(tln))return null; // уходим если пуст
            String shift=elCode.replace("(","").replace(")",""); // сдвиг
            String ltn=String.valueOf(Integer.valueOf(tln)+Integer.valueOf(shift)); // требуемый номер
            if (Integer.valueOf(ltn)<1)return null; // выход за прелелы матрицы
             for (String ec:frm.elements.keySet()){ // поиск кортежа с требуемым номером
                 if (!frm.elements.get(ec).getType().equals(pType))continue;
                 if (!frm.elements.get(ec).getProperty("ltn").equals(ltn))continue;
                 return ec;
             }
             return null; // уходим если  не нашли
          } else {
          if (like(elCode,"(%)")) { // ссылка абсолютная номерная
             //ищем кортеж со свойством ltn равным указанному
             String ltn=elCode.replace("(","").replace(")", "");
             for (String ec:frm.elements.keySet()){
                 if (!frm.elements.get(ec).getType().equals(pType))continue;
                 if (!frm.elements.get(ec).getProperty("ltn").equals(ltn))continue;
                 return ec;
             }
             return null;
          } else {
             String gParent=elCode.split("(", 2)[0];
          }
              }    
        } else { // элемент с таким кодом есть
           if (!frm.elements.get(elCode).getType().equals(pType)) return null; // уходим если не тот тип
           return elCode; 
        }
    
     return null;
     
 } */ 
}
