/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * CellProperty:FormId.RowCode:ColCode.Property
 * CellProperty:RowCode:ColCode.Property
 * CellProperty:Property
  */
package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class CellProperty implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
         return comp(pString,pProp,false);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
public String comp(String pString, LuiAppProp pProp,boolean pFindOnly) throws LuiException, SQLException {
   String rc="";
   String words[]=pString.split("\\.",3);
   int len=words.length;
   if  (len==0) return "";
   LuiAppForm frm=null;
   String RC=null;
   String P=null;
   if (len<3){
       frm=pProp.ownerObj.getForm();
       if (frm==null) {
           String curFrmID=app.getVal("FormID"); 
           if (app.forms.containsKey(curFrmID)){
               frm=app.forms.get(curFrmID);
           }
       }
     if (len<2){
         LuiAppElement elcel=pProp.getParentElement("CELL");
         if (elcel!=null){
             RC=elcel.getProperty("ROW")+":"+elcel.getProperty("COL");
         } else {
             if (frm!=null)
             RC=frm.getProperty("CurrentCELL");
         }
         P=words[0];
     }  else {
         RC=words[0];
         P=words[1];
     } 
   } else {
      if (app.forms.containsKey(words[0])){
               frm=app.forms.get(words[0]);
           } 
      RC=words[1];
      P=words[2];
   }
   if (frm==null || P==null || RC==null)return"";
   words=RC.split(":");
   if (words.length<2)return "";
   String rn=null;
   if (frm.elements.containsKey(words[0]) && frm.elements.get(words[0]).properties.containsKey("ltn")) {
       rn=frm.elements.get(words[0]).getProperty("ltn");
   }
   String cn=null;
   if (frm.elements.containsKey(words[1]) && frm.elements.get(words[1]).properties.containsKey("ltn")) {
       cn=frm.elements.get(words[1]).getProperty("ltn");
   }
   
   LuiAppProp p=frm.MatrixGetCellP(rn+":"+cn, P);
   if (p==null)return "";
   if (pProp!=null)p.setDepend(pProp);
   if (pFindOnly) return "";
   return p.getComputedProperty();

}
    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        comp(pString,pProp,true);
    }
    
}
