/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ChartControl implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    LuiCollection col=new LuiCollection("ChartControl:"+pString);
    LuiAppForm frm=null;
    String command=null;
    String data=null;
    String dataAddon=null;
    String FormID=col.Get_Element("ChartControl");
    if (app.forms.containsKey(FormID)){
      frm=app.forms.get(FormID);
      command=col.Get_Element("Command");
    } else {
    frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return;
    }    
    command=col.Get_Element("ChartControl");
            }
    data=col.Get_Element("Data");
    dataAddon=col.Get_Element("DataAddon");
    LuiClCommandGroup XMLcg=app.commandWriter.addGroup("ChartControl");
    // посмотрим новые размеры
    // и если они не совпадают со старыми
    if (command.equals("clearAndSetOption")) {
    LuiClCommand XMLcmd=XMLcg.addCommand("Chart");
    XMLcmd.addScaPar("FormID",frm.getFormID());
    XMLcmd.addScaPar("Command", "clear");
    command="setOption";    
    }
    LuiClCommand XMLcmd=XMLcg.addCommand("Chart");
    XMLcmd.addScaPar("FormID",frm.getFormID());
    XMLcmd.addScaPar("Command", command);
    String orientation="";
    if (NVL(frm.getProperty("CHART_SIZE_TYPE"),"W").equals("WL"))orientation="Landscape";
    if (NVL(frm.getProperty("CHART_SIZE_TYPE"),"W").equals("WP"))orientation="Portrait";
    // если портрет сменяет пейзаж или наоборот то диаграмму надо провести сначала через нейтральный W- режим
    /*if ((orientation.equals("Landscape") && frm.getVal("LastChartOrientation").equals("Portrait"))||
            (orientation.equals("Portrait") && frm.getVal("LastChartOrientation").equals("Landscape"))){
        XMLcmd.addScaPar("Orientation","");
        XMLcmd.addScaPar("Width","");
         XMLcmd.addScaPar("Height","");
         XMLcmd.addJPar("Data", data);
    if (is_not_null(dataAddon))   XMLcmd.addJPar("PieData", dataAddon);
    if (is_not_null(col.Get_Element("Position"))){
    XMLcmd.addScaPar("Position", col.Get_Element("Position"));
    }
       // добавляем ещё команду  
    } // конец проводки черезнейтральный режим
    */
    if (!orientation.equals(frm.getVal("LastChartOrientation"))) {
        XMLcmd.addScaPar("Orientation",orientation);
        frm.setVal("LastChartOrientation",orientation);
         
    }
    String chartWidth="";
    String chartHeight="";
    if (is_null(orientation) && like(NVL(frm.getProperty("CHART_SIZE_TYPE"),"W"),"F%")){
      chartWidth=frm.getProperty("CHART_WIDTH");
      chartHeight=frm.getProperty("CHART_HEIGHT");
    }
    if (!chartWidth.equals(frm.getVal("LastChartWidth"))) {
    XMLcmd.addScaPar("Width",chartWidth);
    frm.setVal("LastChartWidth",chartWidth);
    }
    if (!chartHeight.equals(frm.getVal("LastChartHeight"))) {
    XMLcmd.addScaPar("Height",chartHeight);
    frm.setVal("LastChartHeight",chartHeight);
    }
    XMLcmd.addJPar("Data", data);
    if (is_not_null(dataAddon))   XMLcmd.addJPar("PieData", dataAddon);
    if (is_not_null(col.Get_Element("Position"))){
    XMLcmd.addScaPar("Position", col.Get_Element("Position"));
    }
    }
    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
     @Override
    public String quoteMask(String prefixString, String Value) {
        return Value.replace(";","#$");
    }
}
