/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
* проверка качества
 */
package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class CheckListQuality implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       String retval="";
       String frmID=pString;
/*       HashMap<String,LuiAppProp> safeAppProp =new HashMap<>();
       for(String pk:app.properties.keySet()){
           safeAppProp.put(pk, app.properties.get(pk));
       }*/
       if (!app.forms.containsKey(frmID)) return "N";
       
       String safeFormId=app.getVal("FormID");
       LuiAppForm frm=app.forms.get(frmID);
       String params=frm.getVal("TransitParam");
       String metadata=frm.getProperty("MetadataCode");
       String metadataApp=frm.getProperty("MetadataApp");
       String parentFormID=frm.getVal("ParentFormID");
       String configCode=frm.getProperty("ConfigCode");
       app.commandWriter.really=false;
       String checkFormID="CHK-"+System.currentTimeMillis();
       try{
       app.addForm(checkFormID,metadata,"LIST"/*,"N"*/);
       LuiAppForm chkfrm=app.forms.get(checkFormID);
       chkfrm.setVal("CheckQuality","Y");
       chkfrm.addProperty("ConfigCode",configCode);
       chkfrm.load(metadataApp,false);
       chkfrm.loadParams(params);
       chkfrm.resetRecalc();
       chkfrm.reloadForm();
       retval=chkfrm.getVal("CheckQualityError");
       } catch (SQLException sex){
           retval=sex.getLocalizedMessage();
       }
       catch (Exception ex){
           retval=ex.getLocalizedMessage();
       }
       
       
          if (app.forms.containsKey(checkFormID)){
              //app.forms.remove(checkFormID);
              app.removeForm(checkFormID);
          } 
       
       app.luiSeance.remZeroCmd();

       app.commandWriter.really=true;
       app.setVal("FormID",safeFormId);
       return retval;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
