/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Сброс сортировок в списке
 * Синтаксис:ClearSort:FormID;
 * Пример ClearSort:{Property:FormID}
 */
package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ClearSort implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return null;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        if (app.forms.containsKey(pString)){
         LuiAppForm frm=app.forms.get(pString);
         if ("LIST".equals(frm.getType())){
             for (String ec:frm.elements.keySet()){
                 LuiAppElement el=frm.elements.get(ec);
                 if ("ITEM".equals(el.getType())){
                   el.addProperty("SORT","");
                 }
             }
         frm.makeEl4order();
         }
        }
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
