/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Сброс настроек отображения
 * ClearVisual:FormID;
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;
import static LuiCollection.LuiString.NVL;

/**
 *
 * @author aliubushkin
 */
public class ClearVisual implements LuiPlugin {
LuiApplication app;
private static final String STMT4DEL="Delete from lui_t_user_pref where user_name='<user_name>' and form_code='<form_code>' and config_code='<config_code>' and app_code='<app_code>' and coalesce(usrcfg_id,0)=<id>";
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return null;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        LuiCollection coll=new LuiCollection("ClearVisual:"+pString);
        LuiDbConn lc=null;
        String FormID=coll.Get_Element("ClearVisual");
        if (is_null(FormID))return;
        String user_name=app.getAppUser();
        if (is_null(user_name)) return;
        if (!app.forms.containsKey(FormID)) return;  
        LuiAppForm frm=app.forms.get(FormID);
        String win=frm.getVal("WindowID");
        try{
        for (String frmid:app.forms.keySet()){
        frm=app.forms.get(frmid);
        if (!win.equals(frm.getVal("WindowID")))continue;
        String form_code=frm.getCode();
        String app_code=app.code;
        String config_code=frm.getConfigCode();
        String id=NVL(frm.getVal("UserConfiguration"),"0");
        lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        String stmt;
        stmt=STMT4DEL.replace("<app_code>",app_code);
        stmt=stmt.replace("<form_code>",form_code);
        stmt=stmt.replace("<config_code>",config_code);
        stmt=stmt.replace("<user_name>", user_name);
        stmt=stmt.replace("<id>", id);
        lc.executeDML(stmt);
        }
        }finally{
           if (lc!=null) app.metaConnPool.SetFree(lc);
        }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      //  throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
