/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
Вызов редактора цветов
ColorPicker:FormID;Field:<код поля>;Color:rgba(255,255,255,1);
                                          rgba(255,255,255,0.0) - цвет не задан
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ColorPicker implements LuiPlugin{
LuiApplication app;
LuiClCommandWriter cw;
    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
       cw=app.commandWriter;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      LuiAppForm frm=null;
      LuiCollection col=new LuiCollection("ColorPicker:"+pString);
      String color=col.Get_Element("Color");
      String FormID=col.Get_Element("ColorPicker");
      if (app.forms.containsKey(FormID)){
      frm=app.forms.get(FormID);
    } else {
    frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return;
    }    
      }
      LuiAppElement el=null;
      String FieldCode=col.Get_Element("Field");
      if (frm.elements.containsKey(FieldCode)){
          el=frm.elements.get(FieldCode);
      } else {
          LuiAppElement action=pProp.getParentElement(FieldCode);
          if (action==null)return;
          FieldCode=action.getParent();
          if (frm.elements.containsKey(FieldCode)){
          el=frm.elements.get(FieldCode);
      } else return;
      }
      if (!col.containsKey("Color")){
          color=el.getProperty("Value");
      }
    LuiClCommandGroup XMLcg=cw.addGroup("ColorPicker");
    LuiClCommand XMLcmd=XMLcg.addCommand("ColorPicker");
    XMLcmd.addScaPar("FormID", frm.getFormID());
    XMLcmd.addScaPar("Field", el.Code);
    XMLcmd.addScaPar("Color", NVL(color,"rgba(255,255,255,0)"));
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    
    }
    
}
