/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Вычисляет перечень столбцов запроса и помещает его в JSON массив. Каждый элемент массива состоит из атрибутов tab,col,dt
 * Синтаксис: 
Columns2JSON:(CONN)select * from table
Пример использования:
LOVQ:select col,tab from {Columns2JSON:(ORA)select * from table}

 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import luiserver.LuiAppConn;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 * 
 * @author aliubushkin
 */
public class Columns2JSON implements LuiPlugin{
static final String STMT4TYPE="select dc.lui_datatype from lui_t_data_convert dc where dc.dbms_type='<dbms_type>' and dc.app_code='<app_code>' and dc.dbms_datatype='<dbms_datatype>' order by dc.is_default4dbms2lui desc";
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    pString=pString.replace("LOVQ:","");
    String appCode=NVL(app.getProperty("EditAppCode"),app.code).trim();
    String retVal=null;    
    if (is_null(pString)) {
    retVal="[";
                retVal=retVal+"{";
                 retVal=retVal+"\"tab\":\""+"\",";
                 retVal=retVal+"\"col\":\""+"\",";
                 retVal=retVal+"\"dt\":\""+"\",";
                 retVal=retVal+"\"alias\":\""+"\",";
                 retVal=retVal+"\"dbbms\":\""+"\"";
                retVal=retVal+"}";
                retVal=retVal+"]";    
    return retVal;            
    }
    LuiAppConn ac=null;
    LuiDbConn lc=null;
    LuiDbConn mlc=null;
    Integer cursor=null;
    String stmt;
    ArrayList<ColInfo> ColsInfo = null;
    LuiCollection dtdbcCol;
    int cols=0;
    // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return "";
    try{
    try {
    ArrayList<String> acs=app.getAppConnAndStmt(pString,"",frm.getFormID());
    stmt=acs.get(1); //берём только select. 
    if (!app.code.equals("LUI")) {
    dtdbcCol= new LuiCollection(acs.get(0)+":;");
    } else {
    // Если это LUI-редактор код соединения не берём, там может быть что-то специфическое прикладное
    mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser()); // соединение с LUI
    dtdbcCol=mlc.getSelectAllRowsTwoColsValMap("select code,name from lui_t_dtdbc where app_code='"+appCode+"'"); //получаем список соединений
    if (dtdbcCol==null) {
        dtdbcCol=new LuiCollection("LUI$:;");
    }
    }
    for (String dtdbc:dtdbcCol.keySet()){
       ac=null;
       cursor=null;
     
      if (!app.userDbConnections.containsKey(dtdbc)) continue;
      ac=app.userDbConnections.get(dtdbc);
      try{
         if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=ac.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        return null;
        } 
        
        // пытаемся открыть курсор
        try{
            cursor=lc.CursorOpen(stmt);
         } catch (SQLException ex){ // неполучилось убираем всё начиная с where
            int w=stmt.toUpperCase().indexOf("WHERE");
            if (w>-1) {
            stmt=stmt.substring(0, w); 
            cursor=lc.CursorOpen(stmt);
            } else throw ex;
         }
        cols=lc.CursorGetCols(cursor); // количество столбцов
        ColsInfo=lc.CursorGetColsInfo(cursor); // столбцы
        break; // уходим из цикла по dtdbc-соединениям
      }   catch (SQLException sqlex){ // если ошибка SQL вернём её выше
                          if (frm.code.equals("LUI_B_PROPERTY_COLOR"))
     //          if (pProp.getGenesis().equals("Application:LUI; BLANK:LUI_B_PROPERTY_COLOR;FormID:FRM14; FIELD:LUI_LANG; ACTION:LOV_ADD_LINK;PropertyCode:PROC_INITIALLY;")) {
                    return "[]";
               // }

          throw sqlex;
      }   catch (Exception ex){ // если не ошибка SQL
          
      }
          finally{
          if (cursor!=null) {
                lc.CursorClose(cursor);
            }
         /*   if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            }*/
      }
    }
    //если столбцы есть
    if (cols>0 && ColsInfo!=null && ColsInfo.size()>0 ){
            retVal="[";
              for (int i=0;i<cols;i++){
            ColInfo cf=ColsInfo.get(i);
            String alias=cf.alias;
            Pattern pattern = Pattern.compile("\""+cf.alias+"[^\"]*\"", Pattern.MULTILINE);
            Matcher matcher = pattern.matcher(stmt);
            if (!matcher.find(1)) {
                alias="";
                
            }
            String ldt=null;
            if (appCode.equals(app.code) && lc!=null) {
            if (app.dataConverter.dbmsTypes.containsKey(lc.getDBvendor())){
                if (app.dataConverter.dbmsTypes.get(lc.getDBvendor()).dataTypes.containsKey(cf.columnTypeName)) {
                   ldt= app.dataConverter.dbmsTypes.get(lc.getDBvendor()).dataTypes.get(cf.columnTypeName).LuiDataType;
                }
            }}
            if (is_null(ldt) && mlc!=null){
            ldt=mlc.getSelectResult(STMT4TYPE.replace("<app_code>",appCode).replace("<dbms_type>",lc.getDBvendor()).replace("<dbms_datatype>",cf.columnTypeName),1);
            }
            if (is_null(ldt) && mlc!=null){
            ldt=mlc.getSelectResult(STMT4TYPE.replace("<app_code>","LUI").replace("<dbms_type>",lc.getDBvendor()).replace("<dbms_datatype>",cf.columnTypeName),1);    
            }
            if (is_not_null(ldt)){
                cf.LuiDATATYPE=ldt;
            }
                if (i>0) retVal=retVal+",";
                retVal=retVal+"{";
                 retVal=retVal+"\"tab\":\""+NVL(cf.tableAlias,cf.tableName)+"\",";
                 retVal=retVal+"\"col\":\""+NVL(cf.alias,cf.name)+"\",";
                 retVal=retVal+"\"dt\":\""+NVL(cf.LuiDATATYPE,"CHAR")+"\",";
                 retVal=retVal+"\"alias\":\""+alias+"\",";
                 retVal=retVal+"\"dbms\":\""+lc.getDBvendor()+"\"";
                retVal=retVal+"}";
            }
            retVal=retVal+"]";
            }
           
    }    
        finally {
            if (mlc!=null) {app.metaConnPool.SetFree(mlc);}
            if (cursor!=null && lc!=null) {
                if (lc.CursorisOpen(cursor))     lc.CursorClose(cursor);
            }
           if (ac!=null && ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                
                ac.connPool.SetFree(lc);
            }
        }
    } catch (SQLException ex){ 
    }
    if (is_null(retVal)) {
        retVal="[";
                retVal=retVal+"{";
                 retVal=retVal+"\"tab\":\""+"\",";
                 retVal=retVal+"\"col\":\""+"\",";
                 retVal=retVal+"\"dt\":\""+"\"";
                retVal=retVal+"}";
                retVal=retVal+"]"; 
    }
        return retVal;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
