/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 * Счётчик уровня формы
 * Compute;
 * Counter:FormID.Name.nextval/curval
 * Counter:Name.nextval/curval
 * Counter:Name
 * Excecute:
 * Counter:[FormID].[Name]=целое больше или равное нулю
 * @author aliubushkin
 */
public class Counter implements LuiPlugin{
LuiApplication app;
LuiAppProp pcounter;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return comp(pString,pProp,false,null);
    }
    public String comp(String pString, LuiAppProp pProp,boolean pexe,String v) throws LuiException, SQLException {
      LuiAppForm frm=null;
      String retval="";
      String counter="";
       boolean next=true;
       String words[]=pString.split(".");
       if (words.length>2){
           if (app.forms.containsKey(words[0])){
               frm=app.forms.get(words[0]);
           }
           counter=words[1];
           if (words[2].equals("curval"))next=false;
       }
       if (words.length==2){
           frm=pProp.ownerObj.getForm();
           counter=words[0];
           if (words[1].equals("curval"))next=false;
       }
       if (words.length<2){
           frm=pProp.ownerObj.getForm();
           if (words.length==1) counter=NVL(words[0],pString);
           else counter=pString;
       } 
       if (frm==null)return "";
       counter="Counter$"+counter;
       if (frm.properties.containsKey(counter)){
          pcounter=frm.properties.get(counter); 
       } else {
          pcounter=frm.addProperty(counter,"0");
       }
       if (!pexe) {
           int iv=0;
           try{
           iv=Integer.valueOf(pcounter.getComputedProperty());
           }catch(Exception ex){}
           if (next) {iv++;
           frm.setProperty(counter,String.valueOf(iv));}
           retval=String.valueOf(iv);
           pcounter.setDepend(pProp);
           
       } else {
           pcounter.setProperty(v);
       }
       return retval;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String lr[]=pString.split("");
        if (lr.length>=2) comp(lr[0],pProp,true,lr[1]);
        if (lr.length==1) comp(lr[0],pProp,true,"0");
        if (lr.length==1) comp(pString,pProp,true,"0");
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
