/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Выполнение отключения от БД или вычисление свойств имеющнгося соединения
 * Cинтаксис для execute:
    * DBDisconnect:Код_соединения;
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppConn;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class DBDisconnect implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
           app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return null;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        pString=LuiString.RTrim(pString);
        if (pString.charAt(pString.length()-1)!=';'){
            pString=pString+";";
        }
        LuiCollection col=new LuiCollection("DBDisconnect:"+pString);
        pString=col.Get_Element("DBDisconnect");
        if (app.userDbConnections.containsKey(pString)) {
        LuiAppConn ac= app.userDbConnections.get(pString);
        ac.disconnect();
        app.userDbConnections.remove(pString);
        }
        if (app.properties.containsKey("Connection")){
            if (app.getProperty("Connection").equals(pString)){
                app.setProperty("Connection","");
            }
        }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
