/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Удаление пользовательской конфигурации
 * DeleteConfig:FormID;Name:Имя конфигурации;
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class DeleteConfig implements LuiPlugin{
LuiApplication app;
private static final String STMT4SELECTCONF="select max(ID) from lui_t_user_config c where c.parent_app='<parent_app>' and c.parent_form='<parent_form>' \n" +
"and c.parent_config='<parent_config>' and c.name='<name>' and c.user_name='<user_name>'";

    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return null;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
                
        LuiCollection coll=new LuiCollection("DeleteConfig:"+pString);
        String name=coll.Get_Element("NAME");
        String id=coll.Get_Element("ID");
        if (is_null(name) && is_null(id))return;
        String FormID=coll.Get_Element("DeleteConfig");
        if (is_null(FormID))return;
        String user_name=app.getAppUser();
        if (is_null(user_name)) return;
        if (!app.forms.containsKey(FormID)) return;  
        LuiAppForm frm=app.forms.get(FormID);
        frm.setVal("UserConfigurationShow","Y");
        if (frm.getVal("UserConfiguration").equals(id)){
            frm.setVal("UserConfiguration","");
        }
        if (frm.getVal("UserConfigurationName").equals(name)){
            frm.setVal("UserConfigurationName","");
        }
        String parent_form=frm.getProperty("FEATURE");
        String parent_app=app.code;
        String parent_config=frm.getConfigCode();
        LuiDbConn lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        String stmt;
        try {
          if (is_null(id)){  
            stmt=STMT4SELECTCONF.replace("<parent_app>",parent_app);
            stmt=stmt.replace("<parent_form>",parent_form);
            stmt=stmt.replace("<parent_config>",parent_config);
            stmt=stmt.replace("<user_name>",user_name);
            stmt=stmt.replace("<name>",name);
            id=lc.getSelectResult(stmt);
            if (is_null(id)) return;
            if (frm.getVal("UserConfiguration").equals(id)){
            frm.setVal("UserConfiguration","");
        }
          }
            lc.executeDML("delete from lui_t_user_config where id="+id);
            lc.executeDML("delete from lui_t_user_pref where usrcfg_id="+id);
            lc.executeDML("delete from lui_t_user_pref p where p.user_name='"+app.getAppUser()+"' and p.form_code='"+frm.getCode()+"' and p.config_code='"+frm.getConfigCode()+"' and p.app_code='"+app.code+"' and p.property_code='DEF_USER_CFG' and p.element_code is null and p.value='"+id+"'");   
        }finally {
            app.metaConnPool.SetFree(lc);
            frm.setUsrConfigListProperty();

        }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       // throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
