/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Запись содержимого элемента типа FILE в файл
* Compute отсутствует
* Синтаксис Execute:
ElementFILE2File:<код элемента типа FILE>;Filename:<имя файла>;
Если в форме отсутствует элемент типа FILE с указанным кодом, то файл сгенерирован не будет
Filename может отсутствовать, тогда сгенерируется файл с именем указанном в свойстве FILE_NAME элемента типа FILE
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.io.IOException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ElementFILE2File implements LuiPlugin{
LuiApplication app;
LuiAppForm frm;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return;
    } 
    int i=pString.length();
    if (i==0)return;
    if (pString.charAt(i-1)==';') {
     
    } else pString=pString+";";
    LuiCollection col=new LuiCollection("ElementFILE2File:"+pString);
    String elcode=col.Get_Element("ElementFILE2File");
    if (!frm.elements.containsKey(elcode))return;
    LuiAppElement el=frm.elements.get(elcode);
    if (!el.getType().equals("FILE")) return;
    String filename=col.Get_Element("Filename");
    if (is_null(filename)){
        filename=el.getProperty("FILE_NAME");
    }
    if (filename.indexOf(System.getProperty("file.separator"))<0) {
            filename=app.getTmpDir()+filename;
        }
    String metaApp=frm.getProperty("MetadataApp");
    String metaFrm=frm.getProperty("MetadataCode");
    String metaCfg=frm.getProperty("ConfigCode");
    LuiDbConn lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
    if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        }
    String stmt="select valueb from lui_t_value where app_code='"+metaApp+"' and form_code='"+metaFrm+"' and config_code='"+metaCfg+"' and element_code='"+elcode+"' and property_code='FILE_NAME'";
    try {
       lc.readBlobToFile(stmt
               , filename); 
    } catch (IOException ex) {
       app.msgWriter.write("LUI-00100", filename,ex.getMessage());
    } catch (SQLException ex){
        app.msgWriter.sqlError(lc, ex, pProp, stmt);
    }
    finally {
        app.metaConnPool.SetFree(lc);
    }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
