/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Создание массива JSON элементов из элеменов и их значений указанной формы
* Execute отсутствует
* Compute:
ElementValues2JSONArray:<FormID>;[Short:N/Y;][Parent:<ElementCode>;]
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ElementValues2JSONArray implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    LuiAppForm frm=null;
    if (is_null(pString) ||pString.charAt(pString.length()-1)!=';'){
        pString=pString+";";
    }
    LuiCollection col=new LuiCollection("ElementValues2JSONArray:"+pString);
    String fid=col.Get_Element("ElementValues2JSONArray");
    String Short=col.Get_Element("Short");
    String Group=col.Get_Element("Groups");
    String Parent=col.Get_Element("Parent");
    String Params=NVL(col.Get_Element("Params"),"Y");
    if (col.containsKey("Parent") && is_null(Parent))return "[]";
    boolean s;
    if (Short.equals("Y")) s=false;
    else s=true;
    String retVal="";
        if (is_not_null(fid)) {
            
            if (!app.forms.containsKey(fid))return "";
            frm=app.forms.get(fid);
        } else {
                frm=pProp.ownerObj.getForm();
                if (frm==null) {
                pString=app.getVal("FormID");        
                if (app.forms.containsKey(pString)){
                   frm=app.forms.get(pString);
                } else return "";
                } 
        }
        LuiAppElement el=null;
        LuiCollection elCol=null;
        
        for (int i=0;i<frm.elements.size();i++){
          el=frm.elSort(i);
          if (el.getType().equals("PARAM") && Params.equals("N"))continue;
          if (is_not_null(Parent)){
              if (!el.getParent().equals(Parent))continue;
          }
          
          if (el.properties.containsKey("Value") ||(el.getType().equals("GROUP") && Group.equals("Y")) || frm.getType().equals("GRID")  ){
          elCol=new LuiCollection("");
          elCol.Add_Element("code", el.getCode());
          elCol.Add_Element("name", el.getName4show());
          if (!el.getParent().equals("Form")){
        if (s)  elCol.Add_Element("parent", el.getParent());
        if (s)  elCol.Add_Element("parentname",frm.elements.get(el.getParent()).getName4show()+" ");
        if (s)  elCol.Add_Element("parentseq", frm.elements.get(el.getParent()).getProperty("Seq"));
        if (s)  elCol.Add_Element("parentmseq",String.valueOf(frm.elements.get(el.getParent()).mutSeq));
        if (s && frm.elements.get(el.getParent()).getType().equals("GROUP"))  elCol.Add_Element("parenthint",frm.elements.get(el.getParent()).getProperty("GROUP_HINT"));
          } else {
        if (s)  elCol.Add_Element("parent","");    
        if (s)  elCol.Add_Element("parentname","");
        if (s)  elCol.Add_Element("parentseq","-9999999");
        if (s)  elCol.Add_Element("parentmseq","-9999999");
          }
        if (s)  elCol.Add_Element("hint", el.getProperty("HINT"));
        if (s && like(el.getProperty("ITEM_DEV_NOTES"),"PGC:%"))elCol.Add_Element("pgc", el.getProperty("ITEM_DEV_NOTES").replace("PGC:",""));
        if (s)  elCol.Add_Element("value", el.getProperty("Value"));
          elCol.Add_Element("type",el.getType());
          elCol.Add_Element("datatype",NVL(el.getProperty("DATA_TYPE"),"CHAR"));
        if (s)  elCol.Add_Element("visible",el.getProperty("VISIBLE"));
        if (s)  {
            String tstr=frm.getVisualPref(el.getCode(),"ColWidth", null);
            if (tstr!=null) elCol.Add_Element("width",tstr);
            else elCol.Add_Element("width",el.getProperty("WIDTH"));
        }
        if (s)  elCol.Add_Element("variants",el.getProperty("VARIANTS"));
          elCol.Add_Element("seq",el.getProperty("Seq"));
        if (s)  elCol.Add_Element("mseq",String.valueOf(el.mutSeq));
        if (s)  elCol.Add_Element("format",el.getProperty("FORMAT"));
        if (s)  elCol.Add_Element("pk",el.getProperty("FOR_UNIQUE_KEY"));
        if (s && el.properties.containsKey("PARAM_SEMANTICS")) elCol.Add_Element("semaintics",el.getProperty("PARAM_SEMANTICS"));
        if (frm.getType().equals("LIST")){
        if (s)  elCol.Add_Element("sintetic",el.getProperty("Sintetic"));
        if (s)  elCol.Add_Element("definition",el.getProperty("DEFINITION"));
        }
          if (is_not_null(retVal))retVal=retVal+",";
          retVal=retVal+elCol.ToJSON();
          }
        }
     return "["+retVal+"]";   
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
