/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 * Elements:FormID.EType[.Parent](attr,attr,...)
 * @author aliubushkin
 */
public class Elements implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String mas=pString;        
        if (mas.indexOf("(")>0)mas=mas.substring(0,mas.indexOf("("));
        String ma[]=mas.split("\\.");
        if (ma.length<2)return "[]";
         LuiAppForm frm=null;
        if (is_null(ma[0])){
                          frm=pProp.ownerObj.getForm();
                          if (frm==null){
                              String fi=app.getVal("FormID"); 
                              if (app.forms.containsKey(fi)){
                                frm=app.forms.get(fi);
                                }
                          }
        } else {
            String fi=ma[0];
                                if (app.forms.containsKey(fi)){
                                frm=app.forms.get(fi);
                                }
        }
        if (frm==null)return "[]";
        String parent=null;
        String etype=ma[1];
        
        if (ma.length>2){
          parent=ma[2];
       //   if (parent.equals("Form"))parent=null;
        }
        if (is_not_null(parent) && !parent.equals("Form")){
        if (!frm.elements.containsKey(parent)){
            return "[]";
        }}
        String pas[]=pString.split("\\(");
        LuiCollection pCol=new LuiCollection("");
        if (pas.length<2) {
         pCol.Add_Element("Code","");
        }else {
          String ppas=pas[1].replace(")","");
          if (ppas.indexOf(",")<0){
              pCol.Add_Element("Code", "");
              if (is_not_null(ppas)) pCol.Add_Element(ppas,"");}
          else {
              pas=ppas.split(",");
              pCol.Add_Element("Code", "");
              for (int i=0;i<pas.length;i++){
                  String vt="";
                  String pk=pas[i];
                  if (pk.indexOf("|")>0){
                    vt=pk.split("\\|")[1];
                    pk=pk.split("\\|")[0];
                  }
                  pCol.Add_Element(pk,vt);
              }
          }
        }
        String retVal="";
        LuiAppElement el=null;
        LuiCollection elCol=null;
        if (frm.getType().equals("GRID")){
         for (String ec:frm.elements.keySet()){
            el=frm.elements.get(ec);
            if (is_not_null(etype) && !etype.equals(el.getType()))continue;
            if (is_not_null(parent) && !parent.equals(el.getParent()))continue;
            elCol=new LuiCollection("");
            for (String pk:el.properties.keySet()){
                if (!pCol.containsKey(pk))continue;
                 if (pCol.get(pk).equals("C")){
                     elCol.Add_Element(pk, el.properties.get(pk).currentValue);
                 }
                else elCol.Add_Element(pk, el.getProperty(pk));
                //elCol.Add_Element(pk, el.properties.get(pk).currentValue);
            }
        if (is_not_null(retVal))retVal=retVal+",";
          retVal=retVal+elCol.ToJSON();
        }   
        } else {
        for (int i=0;i<frm.elements.size();i++){
            el=frm.elSort(i);
            if (is_not_null(etype) && !etype.equals(el.getType()))continue;
            if (is_not_null(parent) && !parent.equals(el.getParent()))continue;
            elCol=new LuiCollection("");
            for (String pk:el.properties.keySet()){
                if (!pCol.containsKey(pk))continue;
                if (pCol.get(pk).equals("C"))elCol.Add_Element(pk, el.properties.get(pk).currentValue);
                else elCol.Add_Element(pk, el.getProperty(pk));
                elCol.Add_Element(pk, el.getProperty(pk));
                //elCol.Add_Element(pk, el.properties.get(pk).currentValue);
            }
        if (is_not_null(retVal))retVal=retVal+",";
          retVal=retVal+elCol.ToJSON();
        }
        }
         return "["+retVal+"]"; 
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
