/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Вычисление значения поля и присваивание полю значения
 */
package Standard;



import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.HashMap;
import luiserver.LuiPlugin;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;

/**
 *
 * @author aliubushkin
 */
public class F implements LuiPlugin {
   LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       
       return comp(pString,pProp,false);
     }

    /**
     * Выполнение программы на языке "F" - присваивание элементу значения. На входе должна быть строка вида Код_элемента=Значение
     * @param pString программа
     * @param pProp свойство
     */
    @Override
    public void execute(String pString,LuiAppProp pProp) throws LuiException, SQLException  {
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return ;
    }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
        // выясняем код элемента
        int w= pString.indexOf("=");
        if (w<0)return;
        String sElCode=pString.substring(0,w);
        // и значение, которое надо установить
        String eElVal=pString.substring(w+1);
        
        if (frm.elements.containsKey(sElCode)){ //если есть такой элемент
            LuiAppElement el=frm.elements.get(sElCode);
            String vN=null;
          if (el.properties.containsKey("Value")) vN="Value"; 
          else  if (el.properties.containsKey("VALUE")) vN="VALUE";
            if (vN!=null){
            //if (el.getType().equals("FIELD") || el.getType().equals("ITEM") || el.getType().equals("PARAM")){
             app.changeSCN("NewValue");
             if (vN.equals("Value") && !el.getType().equals("PARAM"))
             el.newValue(NVL(eElVal,""),null,null,"Y",false,false);
             else
             //el.properties.get(vN).setCurrentValue(NVL(eElVal,""));
               el.setProperty(vN,eElVal);
          /*   if (el.getCode().equals("P_REPORT")){
             System.out.println("eElVal="+eElVal);
             System.out.println("Value="+el.properties.get("Value").currentValue);
             }*/
             //el.setValue(eElVal, false, "N");
            /*if (app.forms.get(curFrmID).elements.get(sElCode).properties.containsKey("Value")) { // и у этого элемента есть свойство Value
                app.forms.get(curFrmID).elements.get(sElCode).setProperty("Value", eElVal);
                app.forms.get(curFrmID).elements.get(sElCode).setProperty("UserChanged",""); //изменено не пользователем
              */  
            }
        }
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        comp(pString,pProp,true);
    }
    
    public String comp(String pString, LuiAppProp pProp,boolean pFindOnly) throws LuiException, SQLException {
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
    
      if (frm.elements.containsKey(pString)){ //если есть такой элемент
          String vN=null;
          if (frm.elements.get(pString).properties.containsKey("Value")) vN="Value"; 
          else  {if (frm.elements.get(pString).properties.containsKey("VALUE")) 
              vN="VALUE";
          }
            if (vN!=null){ // и у этого элемента есть свойство Value или VALUE
              
              frm.elements.get(pString).properties.get(vN).setDepend(pProp);
              if (pFindOnly) return null;
                if (frm.getType().equals("LIST") &&
                   NVL(frm.getVal("Is_QBE_Mode"),"N").equals("Y")){ // если QBE 
                   String currentRow=frm.getVal("CurrentRow"); 
                   if (frm.listQBE.containsKey(currentRow)){ // если есть строка QBE
                      HashMap<String,String> rowQBE;
                      rowQBE=frm.listQBE.get(currentRow);
                       if (rowQBE.containsKey(pString)) { // и в QBE есть условие на элемент формы
                           return rowQBE.get(pString); // то вернём то что лежит в QBE
                       }
                   }
                }        
                String retval= NVL(frm.elements.get(pString).properties.get(vN).getComputedProperty(),"");
                if (frm.elements.get(pString).properties.containsKey("DATA_TYPE")){ // если у элемента есть DATA_TYPE
                   String ldt=frm.elements.get(pString).getProperty("DATA_TYPE"); 
                   if ("SPEC_SYMBOL_FOR_NULL".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)){
                      if  (app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol.equals(retval)) retval="";
                   }
                   if ("SPEC_SYNBOL_FOR_EMPTY_STRING".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)){
                      if  (app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol.equals(retval)) retval="";
                   }
                }
                return retval;
          }
      }
      
    return null;
    }   
}
