/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import static LuiCollection.LuiString.NVL;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import luiserver.LuiAppConn;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class F2SQL implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
     app=pContext;   
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       return comp(pString,pProp,false);
     /*   
     String retval=app.parser.plugins.get("F").compute(pString, pProp);
     retval=retval.replace("\'", "\'\'");
     retval=retval.replace("\n", "\'||chr(10)||\'");
     return "\'"+retval+"\'";
*/
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return ;
    }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
    // выясняем код элемента
        int w= pString.indexOf("=");
        if (w<0)return;
        String sElCode=pString.substring(0,w);
        // и значение, которое надо установить
        String eElVal=pString.substring(w+1);
        if (frm.elements.containsKey(sElCode)){ //если есть такой элемент
            LuiAppElement el=frm.elements.get(sElCode);
            if (el.properties.containsKey("Value")){ // и у него есть value
            LuiDbConn lc=null;
            LuiAppConn ac=null;
            String cc=null;
            cc=frm.getProperty("Connection"); // выясняем код соединения
            try {
             if (app.userDbConnections.containsKey(cc)){
           ac=app.userDbConnections.get(cc);
       }
       if (ac==null){
           for(String acc:app.userDbConnections.keySet()){
            if (!("LUI$".equals(acc))) {
         ac=app.userDbConnections.get(acc);
         break;
            }
            }
       }
       if (ac==null){
           for(String acc:app.userDbConnections.keySet()){
         ac=app.userDbConnections.get(acc);
         break;
            }
       }
       if (ac==null) {
         
     return ;
       }
       if (ac.getSessionMode()=='C'){
           lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
       } else {lc=ac.currentConnection;}
       ColInfo ci=el.colinfo;
       if (ci==null){ // если нет данных о свойствах столбца запроса, то создадим их
        //ColInfo(String pSchemaName,String pTableName,String pTableAlias,String pName,String pAlias,String pColumnClassName,String pColumnTypeName,int pColumnType)
        ci=new ColInfo();
        ci.LuiDATATYPE=NVL(el.getProperty("DATA_TYPE"),"CHAR"); 
        ci.LuiFORMAT=NVL(el.getProperty("FORMAT"),""); 
        ci.alias=el.getCode();
        ci.columnType=0;
        ci.columnTypeName="?";
    }
           el.addProperty("v", eElVal);el.properties.get("v").recalculate=false;
           el.properties.get("v").currentValue=el.properties.get("v").startedValue;
           String f="'"+el.getProperty("FORMAT")+"'";
           el.addProperty("f", f);
           String conv=app.dataConverter.getConvString(ci,lc,true,true);
        if (conv==null){
        conv= lc.getColumnSQLClause(eElVal,el.colinfo.LuiDATATYPE,"CHAR",el.colinfo.LuiFORMAT);
    } else {
    if (!conv.equals("")) {
    LuiAppProp p=el.addProperty("ColumnSQLClause",conv);
    conv=p.getComputedProperty();
    } else conv=eElVal;
           
       String stmt=app.dataConverter.dbmsTypes.get(lc.getDBvendor()).dummyQuery;
       stmt=stmt.replace("?",conv);
       try{
       ArrayList<String>sl=lc.getSelectFirstRowValList(stmt);
       eElVal=sl.get(0);
       } catch (SQLException ex){
           //retVal="null";//здесь надо генерировать ошибку преобразования
           return;
       
       }
    }
             app.changeSCN("NewValue");
             el.newValue(NVL(eElVal,""),null,null,"Y",false,false);
            } finally {
                if (ac!=null){
                 if (ac.getSessionMode()=='C'){   
                if (lc!=null) ac.connPool.SetFree(lc);
                        }
                }
            }
      
        }
    }
    }
    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
comp(pString,pProp,true);
    }
     public String comp(String pString, LuiAppProp pProp,boolean pFindOnly) throws LuiException, SQLException {
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
    String retVal=null;
    LuiAppElement el=null;
    boolean qbe=false;
      if (frm.elements.containsKey(pString)){ //если есть такой элемент
          if (frm.elements.get(pString).properties.containsKey("Value")) { // и у этого элемента есть свойство Value
              el=frm.elements.get(pString);
              frm.elements.get(pString).properties.get("Value").setDepend(pProp);
              if (pFindOnly) return null;
                if (frm.getType().equals("LIST") &&
                   NVL(frm.getVal("Is_QBE_Mode"),"N").equals("Y")){ // если QBE 
                   String currentRow=frm.getVal("CurrentRow"); 
                   if (frm.listQBE.containsKey(currentRow)){ // если есть строка QBE
                      HashMap<String,String> rowQBE;
                      rowQBE=frm.listQBE.get(currentRow);
                       if (rowQBE.containsKey(pString)) { // и в QBE есть условие на элемент формы
                           retVal=rowQBE.get(pString); // то вернём то что лежит в QBE
                           qbe=true;
                       }
                   }
                }        
                   if (!qbe)retVal=NVL(frm.elements.get(pString).properties.get("Value").getComputedProperty(),"");
          }
      }
   if (retVal!=null && el!=null) {
       LuiDbConn lc=null;
       LuiAppConn ac=null;
       String cc=null;
       cc=frm.getProperty("Connection"); // выясняем код соединения
       try {  
       if (app.userDbConnections.containsKey(cc)){
           ac=app.userDbConnections.get(cc);
       }
       if (ac==null){
           for(String acc:app.userDbConnections.keySet()){
            if (!("LUI$".equals(acc))) {
         ac=app.userDbConnections.get(acc);
         break;
            }
            }
       }
       if (ac==null){
           for(String acc:app.userDbConnections.keySet()){
         ac=app.userDbConnections.get(acc);
         break;
            }
       }
       if (ac==null) {
           retVal=retVal.replace("\'", "\'\'");
     retVal=retVal.replace("\n", "\'||chr(10)||\'");
     return "'"+retVal+"'";
       }
       if (ac.getSessionMode()=='C'){
           lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
       } else {lc=ac.currentConnection;}
       
       retVal=app.dataConverter.getFromLuiConversion(retVal, el, lc);
       //if (retVal.equals("null") || retVal.equals("''")) return retVal;
       
       String stmt=app.dataConverter.dbmsTypes.get(lc.getDBvendor()).dummyQuery;
       stmt=stmt.replace("?",retVal);
       try{
           ArrayList<String>sl=lc.getSelectFirstRowValList(stmt);
           //if (sl.get(0)==null){ retVal="null";}
           
       } catch (SQLException ex){
           //retVal="null";//здесь надо генерировать ошибку преобразования
           return retVal;
       }
     } finally {
         if (ac!=null){
          if (ac.getSessionMode()=='C'){   
         if (lc!=null) ac.connPool.SetFree(lc);
                 }
         }
     }
   }
   if (el!=null){ // если элемент известен
     if (NVL(el.getProperty("DATA_TYPE"),"CHAR").equals("CHAR")){ // и тип данных "CHAR"
      if (retVal!=null) {
      retVal=retVal.replace("\r\n","\n");   // удалим возврат корретки
      retVal=retVal.replace("\n", "\'||chr(10)||\'");  // а переводы строк заменим на chr(10)
      }
     }  
   }
   return retVal;
     }
@Override
public boolean needRunImplant() {
  return false;
}
    
}
