/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Синтаксис Execute
File2Lob:<имя файла с путём>;Type:B/T;SQL:(Conn)insert into t1 values(?);Remove:Y/N; 
 */
package Standard;

import LuiCollection.LuiCollection;

import static LuiCollection.LuiString.Filter;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.util.ArrayList;
import luiserver.LuiAppConn;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class File2Lob implements LuiPlugin{
 LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     return "";   
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        LuiAppConn ac=null;
        LuiDbConn lc=null;
        LuiCollection col=new LuiCollection("File2Lob:"+pString);
        String filename=col.Get_Element("File2Lob");
        if (is_null(filename)){
            return;
        }
        String Type=col.Get_Element("Type");
        if (is_null(Type)) Type="B";
        String stmt=col.Get_Element("SQL");
        String remove=col.Get_Element("Remove");
        
        if (is_null(stmt)) {
         return;   
        }
        // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return;
        ArrayList<String> acStmt=app.getAppConnAndStmt(stmt,"",frm.getFormID());
        ac=app.userDbConnections.get(acStmt.get(0));
        stmt=acStmt.get(1);
        if (is_null(stmt)) {
         return;   
        }
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=ac.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        return;
        }
        
        try{
        
        if (filename.indexOf(System.getProperty("file.separator"))<0) {
            filename=app.getTmpDir()+filename;
        }
        
        if (Type.equals("B")){
          lc.saveFileToBlob(stmt, filename);
        } else
        {
          lc.saveFileToClob(stmt, filename);
        }    
        if (NVL(remove,"N").equals("Y")){
        File f=new File(filename);
        f.delete();
        }
        } catch (IOException ex) {
         app.msgWriter.write("LUI-00099", filename,ex.getMessage());
        }  
          catch (SQLException ex){
            app.msgWriter.sqlError(lc, ex, pProp, stmt);
        }
        finally {
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            }
    }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    @Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\'").length() % 2 == 1) 
      Value=Value.replace("\'", "\'\'");
      Value=Value.replace(";","#$");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }
    
}
