/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Запись в свойство Элемента или формы содержимого файла
* Compute отсутствует
* Синтаксис Execute:
File2Property:Имя файла;Property:Имя свойства;Mode:[A/R];
Имя свойства задаётся в формате:
  <ID формы>.<Код элемента или "Form">.<Код свойства>
Mode - если A - значит добавляем к текущему значению
R- замена содержимого (по умолчанию)
Пример:
File2Property:my_file.txt;Property:{Property:FormID}.Field1.Value;Mode:A;
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
//import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_null;

import LuiExceptionMsg.LuiException;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author achibuk
 */


public class File2Property implements LuiPlugin{
    LuiApplication app;
//    String ls;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
//        ls=System.getProperty("line.separator");
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       return null;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        LuiCollection pcol=new LuiCollection("File2Property:"+pString);
        String mode=NVL(pcol.Get_Element("Mode"),"R");
        String filename=pcol.get("File2Property");
        if (is_null(filename)) return;
        if (filename.indexOf("/")!=-1 || filename.indexOf("\\")!=-1) {
            // имя файла указано с путём
        } else {
            String tmpdir=app.getTmpDir();
            filename=tmpdir+filename;
        }

        String propPath=pcol.Get_Element("Property");
        String FrmID=LuiString.Extract_Word(propPath,1,".");
        
        LuiAppProp p=app.findProperty(propPath);
        if (p==null) return;
        
        String s="";
        StringBuilder propVal = new StringBuilder("");
       
//        String lineSep = NVL(pcol.Get_Element("LineSeparator"),"OS");
    BufferedReader reader =null;
     FileInputStream fileInputStream =null;
        try {
            File file = new File(filename);
            fileInputStream = new FileInputStream(file);
            reader = new BufferedReader(new InputStreamReader(fileInputStream, StandardCharsets.UTF_8));
        
            do {
                s = reader.readLine();
                if (propVal.length() == 0) propVal.append(s);
                else {
                    if (s != null) {
                        propVal.append("\n");
                        propVal.append(s);
                    }
                }
            } while (s != null);
            
            //reader.close();
            
            if ("R".equals(mode)){
            p.setProperty(propVal.toString());}
            else {
              String v=p.getComputedProperty();
              if (is_not_null(v))v=v+"\n";
              v=v+propVal.toString();
              p.setProperty(v);
            }

        } catch (IOException ex) {
            app.msgWriter.write("LUI-00119",filename,ex.getMessage());
        } finally{
            if (reader!=null)try{reader.close();}catch(Exception ex){}
            if (fileInputStream!=null)try{fileInputStream.close();}catch(Exception ex){}
        }
       
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
