/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Принудительный перевод фокуса в поле указанного бланка
 * Ececute; Focus:<FormID>[.<FieldCode>]
 * Compute отсутствует
 */
package Standard;

import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Focus implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return null;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String FormID=pString.split("\\.",2)[0];
        String Field=pString.split("\\.",2)[1];
        if (is_null(FormID)) return;
         LuiClCommandGroup XMLcg=app.commandWriter.addAddGroup("SetFocus");
         LuiClCommand XMLcmd=XMLcg.addCommand("Focus");
         XMLcmd.addScaPar("FormID",FormID);
         if (is_null(Field)) return;
         LuiClCommand XMLcmd2=XMLcg.addCommand("CurrentField");
         XMLcmd2.addScaPar("FormID", FormID);
         XMLcmd2.addScaPar("Field", Field);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return;
    }
    
}
