/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import static LuiCollection.LuiString.is_not_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ForEachItem implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    pString=app.parser.reMask(pString);
    pString=pString.replace("{Iterate", "{");
    String retval="";
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    String delimiter=",";
    if (pString.charAt(0)=='(') { // если начинается со скобки
            // ищем где она закрывается
            int cb=pString.indexOf(")"); 
            if (cb>0){// и если она закрывается
                delimiter=pString.substring(1,cb); // будем подозревать, что там между скобками спрятан разделитель
                pString=pString.substring(cb+1);
            }
        }
    for (int i=0;i<frm.elements.size();i++){
       LuiAppElement el=frm.elSort(i);
       if (el.getType().equals("ITEM")){
           el.addProperty("ForEachItem",pString);
           if (is_not_null(retval)) retval=retval+delimiter;
           retval=retval+el.getProperty("ForEachItem");
       }
    }
    return retval;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
