/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Выполение формы
* Синтаксис:
* Form:<КодФомы>;P1:Параметр1;P2:Параметр2;
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Form implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
     app.setProperty("FormRetVal", "");
        LuiCollection fcol=new LuiCollection("Form:"+pString);
        String form=fcol.Get_Element("Form");
        fcol.remove("Form");
        String params=fcol.toString();
        app.executeForm(form, params,frm.getFormID(), ""/*,"Y"*/);
     return app.getProperty("FormRetVal");
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        compute(pString,pProp);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
