/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * вычисление значение свойства формы
 * Ситаксис
FormProperty:<код свойства>
 * установка значения свойства приложения
 * Ситаксис
FormProperty:<код свойства>=<значение>
 */
package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

import static LuiCollection.LuiString.LTrim;
import static LuiCollection.LuiString.NVL;

import static LuiCollection.LuiString.like;
import luiserver.LuiAppForm;

/**
 *
 * @author aliubushkin
 */
public class FormProperty implements LuiPlugin{
    LuiApplication app;

    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
          return comp(pString,pProp,false);
    }
private String comp(String pString, LuiAppProp pProp, boolean pFindOnly) throws LuiException, SQLException {
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    if (like(pString,"%.%")){
     String FrmID=pString.split("\\.",2)[0];
     if (app.forms.containsKey(FrmID)){
        frm=app.forms.get(FrmID);
        pString=pString.split("\\.",2)[1];
     }
    }
    if (!frm.properties.containsKey(pString)) { // если св-ва нет
       frm.addProperty(pString, "").setDepend(pProp);         // создаём с пустым значением
       if (pFindOnly) return null;
       return "";
    }    
        frm.properties.get(pString).setDepend(pProp); // то говорим, что оно определяет свойство pProp
          if (pFindOnly) return null;
          return NVL(frm.properties.get(pString).getComputedProperty(),"");
    /*} else
        return null;*/
}
    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return;
    }
    
        // выясняем код свойства
        pString=LTrim(pString);
        int eq=pString.indexOf("=");
        String pc=pString.substring(0, eq);
        if (like(pc,"%.%")){
         String FrmID=pc.split("\\.",2)[0]; 
          if (app.forms.containsKey(FrmID)){
            frm=app.forms.get(FrmID);
            pc=pc.split("\\.",2)[1];  
          }
        }
        // выясняем значение
        String v=pString.substring(eq+1);
        frm.addProperty(pc, v);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    comp(pString, pProp, true);
    }
    
}
