/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Выполнение команды OC
Execute:
HOST:<код команды>;<код параметра1>:<значение параметра1>;<код параметра2>:<значение параметра2>;....
Compute возвращеет вычисленный формой команды ОС результат

 */
package Standard;

import LuiCollection.LuiCollection;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class HOST implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        if (pString.charAt(pString.length()-1)!=';'){
            pString=pString+";";
        }
        LuiCollection c=new LuiCollection("HOST:"+pString);
        String cmd=c.Get_Element("HOST");
        c.Erase_Element("HOST");
        return app.HOST(cmd, c.toString());
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        compute(pString,pProp);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
     @Override
    public String quoteMask(String prefixString, String Value) {
        return Value.replace(";","#$");
    }    
}
