/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 * HTML:(Title:&lt;заголовок&gt;;Target:&lt;W/F/T/M&gt;;)&lt;html&gt;
 */
public class HTML implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return pString;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String title="";
        String target="";
        String html=pString;
        if (pString.charAt(0)=='(') { // если начинается со скобки
            // ищем где она закрывается
            int cb=pString.indexOf(")"); 
            if (cb>0){// и если она закрывается
                String cols=pString.substring(1,cb); // будем подозревать, что там между скобками спрятана коллекция
                LuiCollection col=new LuiCollection(cols);
                title=col.Get_Element("Title");
                target=col.Get_Element("Target");
                html=NVL(pString.substring(cb+1),"");
            }
        }
        title=NVL(title,"");
        target=NVL(target,"W");
        switch (target) {
            case "W":
                target="Window";
                break;
            case "T":
                target="Tab";
                break;
            case "F":
                target="Float";
                break;
            case "M":
                target="Modal";
                break;    
        }    
        if (!target.equals("Modal") && !target.equals("Float") && !target.equals("Tab") && !target.equals("Window")) {
            target="Window";
        }
        LuiClCommandGroup XMLcg=app.commandWriter.addGroup("HTML");
        LuiClCommand XMLcmd=XMLcg.addCommand("Info");
        XMLcmd.addScaPar("Code","Info");
        XMLcmd.addScaPar("Title",title.replace("•", "(").replace("†",")"));
        XMLcmd.addScaPar("Target",target);
        String cont=html;
        if (is_not_null(html)){
        if (html.charAt(0)!='{') {
        int dvoetochie=html.indexOf(":");
        if (dvoetochie>0) {
        String plg=html.substring(0, dvoetochie);
        if (app.parser.plugins.containsKey(plg)) {
        cont=app.parser.compute("{"+html+"}",pProp);
        } 
        }
        }}
        XMLcmd.addScaPar("Content",cont);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       // throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
