/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 Очистка содержимого поля или параметра от html-тегов
Execute отсутствует
Compute:
{HTML2PLAIN:ElementCode}
*/
package Standard;

import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.HashMap;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

/**
 *
 * @author aliubushkin
 */
public class HTML2PLAIN implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    return comp(pString,pProp,false);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
            comp(pString,pProp,true);
    }
   public String comp(String pString, LuiAppProp pProp,boolean pFindOnly) throws LuiException, SQLException {
    LuiAppForm frm=pProp.ownerObj.getForm();
    
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
      if (frm.elements.containsKey(pString)){ //если есть такой элемент
          if (frm.elements.get(pString).properties.containsKey("Value")) { // и у этого элемента есть свойство Value
             frm.elements.get(pString).properties.get("Value").setDepend(pProp);
              if (pFindOnly) return null;              
              if (frm.getType().equals("LIST") &&
                   NVL(frm.getVal("Is_QBE_Mode"),"N").equals("Y")){ // если QBE 
                   String currentRow=frm.getVal("CurrentRow"); 
                   if (frm.listQBE.containsKey(currentRow)){ // если есть строка QBE
                      HashMap<String,String> rowQBE;
                      rowQBE=frm.listQBE.get(currentRow);
                       if (rowQBE.containsKey(pString)) { // и в QBE есть условие на элемент формы
                           return html2plain(rowQBE.get(pString)); // то вернём то что лежит в QBE
                       }
                   }
                }
              String retval= NVL(frm.elements.get(pString).properties.get("Value").getComputedProperty(),"");
                if (frm.elements.get(pString).properties.containsKey("DATA_TYPE")){ // если у элемента есть DATA_TYPE
                   String ldt=frm.elements.get(pString).getProperty("DATA_TYPE"); 
                   if ("SPEC_SYMBOL_FOR_NULL".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)){
                      if  (app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol.equals(retval)) retval="";
                   }
                   if ("SPEC_SYNBOL_FOR_EMPTY_STRING".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)){
                      if  (app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol.equals(retval)) retval="";
                   }
                }
                return html2plain(retval);
          }
      }   
   return null;
   }
 String html2plain(String pString){
     Document doc = Jsoup.parse(pString);
     
     return doc.text();
 }
}
