/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import static LuiCollection.LuiString.Filter;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.like;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiPlugin;
import javax.script.ScriptContext;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;
import jdk.nashorn.api.scripting.ScriptObjectMirror;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiParser;

/**
 * вычисление выражения на JavaScript и выполнение программы на JavaSript
 * @author aliubushkin
 */
public class JS implements LuiPlugin {
 LuiApplication app;
 ScriptEngineManager factory;
 
    @Override
    public void setContext(LuiApplication pContext) {
         app=pContext;
         factory = new ScriptEngineManager();
         app.JSengine = factory.getEngineByName("nashorn");
         app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).put("App", app); 
         LuiApplication appJS=(LuiApplication)app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).get("App");
         
     try {
         app.JSengine.eval("Application = {}"); // Это пустая коллекция, куда будут помещаться новые и изменившиеся параметры кантента
     } catch (ScriptException ex) {
         //app.name=ex.getMessage();
     }
    app.JSContents=(ScriptObjectMirror) app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).get("Application");
    }
    
    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    if (like(pString,"/*aaa*/%")){
        String here="here";
    }
        // выясняем код формы
    if (pString.length()<10 || !pString.substring(0, 8).equals("/*NHJS*/"))
    return app.parser.plugins.get("rjs").compute(pString, pProp);
    
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    //статистика
    String stat="";
    int StatCount=0;
    long StatTime=0;
    long StatStart=System.currentTimeMillis();
    if (frm!=null){
    try{
    stat=frm.getProperty("StatJS");
    }catch(Exception ex){}
    
    if (is_not_null(stat)){
        StatCount=Integer.valueOf(stat.split(" ")[0]);
        StatTime=Integer.valueOf(stat.split(" ")[1]);
    }
    StatCount++;
    
    }
    //статистика
        pString=pString.replace("exit();", "");
        pString=LuiParser.reMask(pString);
        app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).put("Prop", pProp);
    try {
      Object bl = app.JSengine.eval(pString);//запускаем ввычислятор
      String v=String.valueOf(bl); //  и берём то что он вернул

         //статистика
      if (frm!=null)   frm.setProperty("StatJS",String.valueOf(StatCount)+" "+String.valueOf(StatTime+System.currentTimeMillis()-StatStart));   
         //статистика
      return v; // возвращаем значение
    } catch (final ScriptException se) { //ошибка вычисления значения
        if (frm!=null) {
            try {
                if (frm.getProperty("SuppressErrors").equals("Y")) return "";
            } catch (SQLException ex) {
               
            }
           } 
        app.msgWriter.write("LUI-00033",se.getMessage()+"("+pString+")"+" "+pProp.getGenesis4msg()); 
        return se.getLocalizedMessage();
     }
    
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     /*if (app.parser.plugins.containsKey("rjs")){
         app.parser.plugins.get("rjs").execute(pString, pProp);
         return;
     }*/
        pString=pString.replace("exit();", ""); // убираем слово exit(); чтобы не убить LUI
        pString=LuiParser.reMask(pString);
     app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).put("Prop", pProp);   // запихиваем в носорога объект проперть в которой хранится JS - программа это позволяет что-то...
                                                                                // может быть удалить?
     boolean fieldChanged=false; // признак изменённости полей
     LuiAppForm frm=pProp.ownerObj.getForm();                                   // берём форму
    if (frm==null) { // если форма не определена
    String curFrmID=app.getVal("FormID");      // определим по-другому 
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID); // если форма опять не определена уходим
    } else return ;
    }
     LuiAppElement el;
     jdk.nashorn.api.scripting.ScriptObjectMirror Properties; // обявляем массив св-в в этом вызове
     // передадим носорогу список кодов всех элементов и код формы что бы он знал в каких эелементах можно править св-ва
   
 app.JSContents.clear();  // очищаем объект  JSContents уровня приложения во время инициирования плагина делается:
 /*try {
         app.JSengine.eval("Application = {}"); // Это пустая коллекция, куда будут помещаться новые и изменившиеся параметры кантента
     } catch (ScriptException ex) {
         //app.name=ex.getMessage();
     }
    app.JSContents=(ScriptObjectMirror) app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).get("Application");*/
 // создаём в носороге перечень элементов формы
 String separ="";
 String JSelements="Elements = {";
 for (String elCode:frm.elements.keySet()){
     JSelements=JSelements+separ+"'"+elCode+"':{}"; // Рустам просил так: JSelements+=separ+elCode+":{}"; 
     separ=",";
 }
 JSelements=JSelements+"};Form={}"; // и даже добавляем элемент "Форма"
    try {
        app.JSengine.eval(JSelements);
    } catch (ScriptException ex) { // если перечень не создался генерируем ошибку
  app.msgWriter.write("LUI-00033",ex.getMessage()+"("+JSelements+")"+" "+pProp.getGenesis4msg());       
    }
 frm.JSElements =(ScriptObjectMirror) app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).get("Elements"); // создаём у формы зеркало JS-объекта Elements
 frm.JSFormProps=(ScriptObjectMirror) app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).get("Form");// создаём у формы зеркало JS-объекта Form
 
     // крутим элементы формы для того, чтобы в носороге вычистить переменные имена которых совпадают с именами элементов данной формы
     // это позволяет избежать пересечение пространств имён
     for (String ec:frm.elements.keySet()){
         el=frm.elements.get(ec);
         if (el.properties.containsKey("Value")){ // если у элемента есть св-во Value
         if (app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).containsKey(ec)) 
         app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).remove(ec); //удаляем этот элемент из массива JS-переменных
         }
     } 
    try { // пробуем выполнить программу  
      app.JSengine.eval(pString);
     for (String ElementCode: frm.JSElements.keySet()){ // исследование JSElements
       el=null;
       Properties=(ScriptObjectMirror) frm.JSElements.get(ElementCode);
       if (!(frm.elements.containsKey(ElementCode))){
           //элемента с кодом ElementCode - нет надо создать
           String EType=(String) Properties.get("EType");
           if (is_not_null(EType)){
           String Parent=(String) Properties.get("Parent");
           String Name=(String) Properties.get("Name");
           el=frm.addElement(ElementCode, EType, null, NVL(Name,""), Parent);
           fieldChanged=true;
                   } else continue;
       } else  el=frm.elements.get(ElementCode);
          // крутим новые или зменённые св-ва
          if (el!=null){
          for (String pc:Properties.keySet()){
              el.addProperty(pc,Properties.get(pc).toString());
              fieldChanged=true;
          }
          }
     Properties.clear();  
     }
     for (String frmPropCode:frm.JSFormProps.keySet()){ // исследование изменённостей св-в формы
        frm.addProperty(frmPropCode,frm.JSFormProps.get(frmPropCode).toString());
     }
     for (String appPropCode:app.JSContents.keySet()){// исследование изменённостей св-в приложения
        app.addProperty(appPropCode,app.JSContents.get(appPropCode).toString());
     }
     if (fieldChanged=true) {
//               frm.makeElList("Form");
           }
     // присваиваем элементам формы значения JS переменных если их имена совпадают с именами элементов
      for (String ekey:app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).keySet()) {
        if (frm.elements.containsKey(ekey)){
          LuiAppElement eel=frm.elements.get(ekey);
          if (eel.properties.containsKey("Value")){
          String v=app.JSengine.getBindings(ScriptContext.ENGINE_SCOPE).get(ekey).toString();
           app.changeSCN("NewValue");
           eel.newValue(v,null,null,"Y",false,false); 
           //eel.setValue(v, false, "N");
          }
           
        }  
      }
      
     } catch (ScriptException se) 
     { // ошибка выполнения скрипта
          if (frm.getProperty("SuppressErrors").equals("Y")) return;
        app.msgWriter.write("LUI-00033",se.getMessage()+"("+pString+")"+" "+pProp.getGenesis4msg()); 
        return;
     }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
/*@Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\"").length() % 2 == 1) return Value.replace("\"", "\\\"");
      if (Filter(prefixString, "\'").length() % 2 == 1) return Value.replace("\'", "\\\'");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }*/
/*@Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\"").length() % 2 == 1) return Value.replace("\\", "\\\\").replace("\"", "\\\"");
      if (Filter(prefixString, "\'").length() % 2 == 1) return Value.replace("\\", "\\\\").replace("\'", "\\\'");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }*/
@Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\"").length() % 2 == 1) return Value.replace("\\", "\\\\").replace("\"", "\\\"").replace("\n", "\\n").replace("\r"," ");
      if (Filter(prefixString, "\'").length() % 2 == 1) return Value.replace("\\", "\\\\").replace("\'", "\\\'").replace("\n", "\\n").replace("\r"," ");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }
    

}
