/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.like;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiPlugin;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiClEvent;
import luiserver.LuiClEventReader;

/**
 * LOVC:"Заголовок LOV";Y:Да;N:Нет;U:Не знаю;...
 * или LOVC:TITLE:"Заголовок LOV";Y:Да;N:Нет;U:Не знаю;...
 * @author aliubushkin
 */
public class LOVC implements LuiPlugin{
LuiApplication app;
LuiClCommandWriter cw;
LuiClEventReader er;
    @Override
    public void setContext(LuiApplication pContext) {
               app=pContext;  
               //er=new LuiClEventReader(app.eventReader.getReader(),app.msgWriter,app.TotalTimer);
               er=app.eventReader;
               cw=app.commandWriter; 
               //er=app.eventReader;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
//        app.LastLOVchoice.clear();
String CaseSens=NVL(app.getProperty("LOV_CASESENSITIVE"),"Y");
LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
        LuiClCommand XMLcmd;
        String title;
        LuiCollection q;
        
        if (like(pString,"TITLE:%")) {
        q=new LuiCollection(pString);
        title=q.Get_Element("TITLE");
        q.Erase_Element("TITLE");
             } else {
        q=new LuiCollection("LOVC:"+pString);
        title=q.Get_Element("LOVC");
        q.Erase_Element("LOVC");
            }
        if (q.containsKey("CaseSensitive")){
            CaseSens=q.Get_Element("CaseSensitive");
            q.Erase_Element("CaseSensitive");
        }
        LuiClCommandGroup XMLcg=cw.addGroup("LOVC");
        XMLcmd=XMLcg.addCommand("LOV");
        XMLcmd.addScaParameter("Title", title, "");
        XMLcmd.addScaParameter("HeadLines","COL1:;COL2:;", "");
        XMLcmd.addScaParameter("CaseSensitive",CaseSens,"Y");
        //String lastKey="";
        //for (String key:q.keySet()){lastKey=key;}
        for (String key:q.keySet()){
            XMLcmd=XMLcg.addCommand("RowLOV");
            XMLcmd.addScaParameter("Type", "Leaf", "Leaf");
            XMLcmd.addScaParameter("ID",key, "");
            XMLcmd.addScaParameter("Context","COL1:"+key+";COL2:"+q.Get_Element(key)+";","");
          //  if (key.equals(lastKey)){
          //  XMLcmd.addScaParameter("IsLast","Y", "");    
          //  }
        }
        XMLcmd.addScaParameter("IsLast","Y", "");    
        app.changes();
        app.getSeance().remZeroCmd();
        app.getSeance().remFrmWinApp();
        LuiClEvent ev;
        String v=null;
        boolean b=true;
        while (b){   
        cw.flush();
        er.readEvents();
        while (true){
        ev=er.getEvent();
        if (ev==null)break;
        switch (ev.name){
            case "CancelLOV":
            b=false;
              //app.changeSCN("CancellLOV");  
              //app.eventReader.eventList.clear(); // читим хвост событий т.к. юзер ескапе нажал
              /*String FormID=app.getVal("FormID");
              if (is_not_null("FormID")){
                  if (app.forms.containsKey(FormID)){
                      if (is_not_null(app.forms.get(FormID).getVal("CurrentAction"))){
                              throw new LuiException("break","","",null,"",app);
                      }
                  }
              } */
                     if (is_not_null(frm.getVal("CurrentAction"))){
                              throw new LuiException("break","","","",null,"",app);
                      }  
              return v;
            case "ChoiceLOV":
              b=false;
              //app.changeSCN("ChoicelLOV");  
              v= ev.getParValue("ID");
//              app.LastLOVchoice.Add_Element("COL1", v);
//              app.LastLOVchoice.Add_Element("COL2", q.Get_Element(v));
              return v;
            case "Interval":
            app.interval();
            break;
            default:
             if (!ev.name.equals("Interval") && !ev.name.equals("ChoiceLOV") && !ev.name.equals("CancelLOV")
                     &&
                    !ev.name.equals("Activate")){   
              app.eventReader.eventList.add(0,ev);
                if (v==null){
                  throw new LuiException("break","","","",null,"",app);
                }
                return v;
                 }
                break;
             }
        }
    }
        if (v==null){
                  throw new LuiException("break","","","",null,"",app);
        }

      return v;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    compute(pString,pProp);    
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       // throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
