/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.compareString;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiAppWFE;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiClEvent;
import luiserver.LuiClEventReader;

import luiserver.LuiPlugin;

/**
 * LOVD:Y:Да;N:Нет;U:Не знаю;...
 * применяется для отбражение drop-down списка значений поля
 * @author aliubushkin
 */
public class LOVD implements LuiPlugin{
LuiApplication app;
LuiClCommandWriter cw;
LuiClEventReader er;

    @Override
    public void setContext(LuiApplication pContext) {
               app=pContext;  
 //              er=new LuiClEventReader(app.eventReader.getReader(),app.msgWriter,app.TotalTimer);
 //              er.app=app;
               er=app.eventReader;
               //cw=new LuiClCommandWriter(app.commandWriter.getWriter(),app.TotalTimer); 
               cw=app.commandWriter;
               
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
//        app.LastLOVchoice.clear();
        if (pProp!=null){
        LuiAppWFE el=pProp.ownerObj;
        // установим зависимость от LastRunSCN чтобы LOV появился опять при выполнении действия
        if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        } else {
          el=el.ownerObj;  
          if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        }
          }
        }
        }
        }

        if (is_null(pString)) return "";
        String v=null; 
        String frmc=app.getVal("FormID");
        if (!app.forms.containsKey(frmc)) return null;
        LuiAppForm frm=app.forms.get(frmc);
        String fieldCode="";
        switch(frm.getType()){
             case "BLANK":    
        fieldCode=frm.getVal("CurrentField");
        if (!frm.elements.containsKey(fieldCode)) return null;
        if (!frm.elements.get(fieldCode).getType().equals("FIELD"))return null;
        break;
             case "LIST":
        fieldCode=frm.getVal("CurrentColumn");
        if (!frm.elements.containsKey(fieldCode)) return null;
        if (!frm.elements.get(fieldCode).getType().equals("ITEM"))return null;
        break;     
         }
        
        LuiClCommand XMLcmd = null;
        LuiCollection col=new LuiCollection(pString);
        
        if (col.size()<1) {
          col.Add_Element("","");
        }
           
       
        LuiClCommandGroup XMLcg=cw.addGroup("LOVD");
        if (frm.getType().equals("BLANK")){
        XMLcmd=XMLcg.addCommand("DropDown");
        XMLcmd.addScaPar("FormID",frmc);
        XMLcmd.addScaPar("Field",fieldCode);
        if (frm.elements.get(fieldCode).properties.containsKey("Value"))
        XMLcmd.addScaPar("Selected", frm.elements.get(fieldCode).getProperty("Value"));
        for (String key:col.keySet()){
            if (is_null(col.Get_Element(key))){
                col.replace(key,key);
            }
        }
         v=col.toString();
        XMLcmd.addScaPar("Contents",v);}
        else {
        XMLcmd=XMLcg.addCommand("LOV");            
        XMLcmd.addScaPar("Title",app.NLS.NLS("RUS:Выберите;ENG:Choose;"));
        XMLcmd.addScaPar("HeadLines","COL1:;COL2:;");
        for (String key:col.keySet()){
        XMLcmd=XMLcg.addCommand("RowLOV");
        XMLcmd.addScaPar("Type", "Leaf");
        XMLcmd.addScaPar("ID",key);
        LuiCollection rc=new LuiCollection("");
        rc.Add_Element("COL1",key);
        rc.Add_Element("COL2",col.get(key));
        XMLcmd.addScaPar("Context",rc.toString());
        }
        XMLcmd.addScaPar("IsLast", "Y");
        }
        app.changes();
        app.getSeance().remZeroCmd();
        app.getSeance().remFrmWinApp();
        LuiClEvent ev;
        boolean b=true;      
        v=null;
        while (b){
        cw.flush();
        er.readEvents();
        while (true){
        ev=er.getEvent();
        if (ev==null) break;
        switch (ev.name){
          case "ChoiceLOV": // пользователь сделал выбор  
          b=false;
          v=ev.getParValue("ID");  
//              app.LastLOVchoice.Add_Element("COL1", v);
//              app.LastLOVchoice.Add_Element("COL2", col.Get_Element(v));
          break;    
          case "CancelLOV": // пользователь отказался от выбора и значит прервал выполнение текущего действия
          b=false;
                //app.changeSCN("CancelLOV");
                String FormID=app.getVal("FormID");
                if (is_not_null("FormID")){
                  if (app.forms.containsKey(FormID)){
                      if (is_not_null(app.forms.get(FormID).getVal("CurrentAction"))){
                              throw new LuiException("break","","","",null,"",app);
                      }
                  }
                }
          break;
          case "DropDown": // пользователь сделал выбор
          b=false;
          String evfrmc=ev.getParValue("FormID");
              String evfieldCode=ev.getParValue("Field");
              if (compareString(frmc,evfrmc) && compareString(fieldCode,evfieldCode)){
               v=NVL(ev.getParValue("Value"),"");
//              app.LastLOVchoice.Add_Element("COL1", v);
//              app.LastLOVchoice.Add_Element("COL2", col.Get_Element(v));
              }              
          break;
          case "Interval":
          app.interval();
          break;
          default:
                if ( !ev.name.equals("Interval") && !ev.name.equals("ChoiceLOV") && !ev.name.equals("CancelLOV")&& !ev.name.equals("DropDown")
                        &&  !ev.name.equals("Activate")
                        ){   
                
                app.eventReader.eventList.add(0,ev);
                    if (v==null){
                      throw new LuiException("break","","","",null,"",app);
                    }
                    return v;
                     }
                    break;
            }                
        }
    }
              if (v==null){
                  throw new LuiException("break","","","",null,"",app);
        }
  
       return v; 
    
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        compute(pString,pProp);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
