/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;

import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import luiserver.LuiAppConn;

import luiserver.LuiPlugin;
import luiserver.LuiAppProp;
import luiserver.LuiAppWFE;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiClEvent;
import luiserver.LuiClEventReader;
import static luiserver.LuiParser.reMask;

/**
 * LOVQ:(CONN)Select /*CaseSensitive=N*//*[TITLE:Заголовок]*\/c1 "code" c2 "name" from table order by 1
 * @author aliubushkin
 * 
 */
public class LOVQ implements LuiPlugin{
private static final int PAGESIZE=1000;
public static final String OFF$SET="off$set";
LuiApplication app;
LuiClEvent ev;
LuiClCommandWriter cw;
LuiClEventReader er;
Integer cursor=null; 
LuiAppConn appConn;
LuiDbConn lc=null;
int rowsFetched=0;
int rowsInPage=0;
Integer rowStatusIndex=null;
boolean notLastRow = false;
boolean         notDisplayIfOneRow=false;
boolean         notDisplayifNoRows=false;
boolean notDisplayifNoRowsAndReturnEmpty=false;
ArrayList<String> row=null;
    @Override
    public void setContext(LuiApplication pContext) {
               app=pContext;     
               //er=new LuiClEventReader(app.eventReader.getReader(),app.msgWriter,app.TotalTimer);
               er=app.eventReader;
              // cw=new LuiClCommandWriter(app.commandWriter.getWriter(),app.TotalTimer); 
              cw=app.commandWriter;
               
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String CaseSens=NVL(app.getProperty("LOV_CASESENSITIVE"),"Y");
        if (CaseSens.equals("Y")) {
        if (like(pString,"%/*%CaseSensitive=N%*/%"))CaseSens="N";
        } else {
        if (like(pString,"%/*%CaseSensitive=Y%*/%"))CaseSens="Y";    
        }
        rowStatusIndex=null;
        notLastRow=false;
        notDisplayIfOneRow=false;
        notDisplayifNoRows=false;
        notDisplayifNoRowsAndReturnEmpty=false;
        rowsFetched=0;
        rowsInPage=0;
        String frmID="";
        String OrderByClause="";
        String whereClause="";
        if (pProp!=null){
        LuiAppWFE el=pProp.ownerObj;
        if (el.getForm()==null)return "";
        frmID=el.getForm().getFormID();
        // установим зависимость от LastRunSCN чтобы LOV появился опять при выполнении действия
     //   if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        } else {
          el=el.ownerObj;  
          if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        }
          }
        }
      //  }
        }
        String parent_node="";
        if (is_null(pString)) return "";
        
        LuiClCommand XMLcmd = null;
        LuiClCommandGroup XMLcg = null;
//        app.LastLOVchoice.clear();
        String stmt;
        String title="";
        LuiCollection headline=new LuiCollection("");
        String v=null;
        int cols;
        ArrayList<ColInfo> ColsInfo;
        ColInfo cf = null;
        ArrayList<String> acstmt=app.getAppConnAndStmt(pString, "",frmID);
        stmt=reMask(acstmt.get(1));
        
        stmt=stmt.replace("{PARENT_NODE}", parent_node);
        if (like(stmt,"%notDisplayIfOneRow%"))notDisplayIfOneRow=true;
        if (like(stmt,"%notDisplayifNoRows%"))notDisplayifNoRows=true;                
        if (like(stmt,"%notDisplayifNoRowsAndReturnEmpty%"))notDisplayifNoRowsAndReturnEmpty=true;
        
        app.log.addRecord("LOV", 
                app.NLS.NLS("RUS:Вызов списка значений для;ENG:List of values for;")+" "+
                pProp.getGenesis()
                ,stmt,frmID);
        appConn=app.userDbConnections.get(acstmt.get(0));
        if (appConn.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=appConn.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=appConn.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        }
        try{
        cursor=lc.CursorOpen(stmt); //открываем курсор
        cols=lc.CursorGetCols(cursor); // узнаём количество столбцов
        ColsInfo=lc.CursorGetColsInfo(cursor); // получаем информацию о столбцах
        if (is_not_null(lc.getOffsetColumn(OFF$SET))) { // если СУбд не может offset
          if (appConn.getSessionMode()=='C')  { // и соединение коммунальное, то
              // то в запрос надо вставить столбец rownum
              // причём надо чтобы он стал последним
              // тогда его не заметит вся эта программа
           stmt="select q$O.*,"+lc.getOffsetColumn(OFF$SET)+" from ("+stmt+")q$O";
           lc.CursorClose(cursor); // закрываем старый курсор
           cursor=lc.CursorOpen(stmt); //открываем курсор
        
          }
            
        }
        // вычисляем заголовки и видимость столбцов
        boolean aliasy_est=false;
            for (int i=0;i<cols;i++){
            cf=ColsInfo.get(i);
            cf.columnClassName=NVL(cf.alias,cf.name); // на всякий случай сохраним алиас еслиесть или имя в columnClassName

          if (is_null(cf.name) && is_not_null(cf.alias)){
           ColsInfo.get(i).name=cf.alias;
          }  
        if (ColsInfo.get(i).alias.toUpperCase().equals("ROW_STATUS")){ // если столбец называется ROW_STATUS
            ColsInfo.get(i).name=""; // делаем его невилмкой
            rowStatusIndex=i;//и запомним индекс
        }
       Pattern pattern = Pattern.compile("\""+cf.alias+"[^\"]*\"", Pattern.MULTILINE);
Matcher matcher = pattern.matcher(stmt);
       if (matcher.find(1)) { // в тексте запроса есть явно заданный алиас
      // if (stmt.indexOf("\""+cf.alias+"\"")!=-1) { // в тексте запроса есть явно заданный алиас
      
                aliasy_est=true;
            } else {
                ColsInfo.get(i).alias=""; // программист алиас не задал значит заголовка у столбца не будет
            }
          if (ColsInfo.get(i).LuiDATATYPE.equals("NUMBER")){
            if (ColsInfo.get(i).alias.equals("")){ // и у него нет алиаса
            ColsInfo.get(i).name=""; // делаем его невидимым
            }
        }
        }
        for (int i=0;i<cols;i++){
        // если первый столбец имеет тип NUMBER
        if (i<1) {
          if (ColsInfo.get(i).LuiDATATYPE.equals("NUMBER")){
            if (ColsInfo.get(i).alias.equals("")){ // и у него нет алиаса
            ColsInfo.get(i).name=""; // делаем его невидимым
            }
        } 
        }
          if (aliasy_est) { // алиасы в приципе программистом используются
             if (ColsInfo.get(i).alias.equals("")){ // но не в этом столбце
               ColsInfo.get(i).name=""; // делаем его невидимым  
             } 
          }  
        
         
        }
        // готовим команды заголовка
        XMLcg=cw.addGroup("LOVQ");
        XMLcmd=XMLcg.addCommand("LOV");
        XMLcmd.addScaParameter("CaseSensitive",CaseSens,"Y");
         int startTitle=stmt.indexOf("[TITLE:");
         int endTitle=stmt.indexOf("]");
         if (startTitle!=-1 && endTitle!=-1 && startTitle+7<endTitle){
         title=stmt.substring(startTitle+7, endTitle);
         }
         XMLcmd.addScaPar("Title",NVL(title,app.NLS.NLS("RUS:Выберите;ENG:Choose;")));
         headline.clear();
         for (int i=0;i<cols;i++){
          cf=ColsInfo.get(i);
          if (!cf.name.equals("")) { // для видимых столбцов готовим заголовки
            headline.Add_Element("COL"+String.valueOf(i), app.NLS.NLS(ColsInfo.get(i).alias));
           
        } 
         }
         XMLcmd.addScaPar("HeadLines",headline.toString());
        // извлекаем первую порцию и готовим команды для отображения её строк
        rowsInPage=0;
        for (int pr=0;pr<PAGESIZE;pr++) {
          notLastRow=lc.CursorNextRow(cursor);
          if (!notLastRow && rowsFetched==0 && notDisplayifNoRows) { 
             // если строк нет совсем - уходим если задан режим ни чего не показывать при отсутствии строк
              cw.removeGroup("LOVQ");
              if (notDisplayifNoRowsAndReturnEmpty) return "";
              String FormID=app.getVal("FormID");
                if (is_not_null("FormID")){
                  if (app.forms.containsKey(FormID)){
                      if (is_not_null(app.forms.get(FormID).getVal("CurrentAction"))){
                              throw new LuiException("break","","","",null,"",app);
                      }
                  }
                }
              return "";
          }
          if (notLastRow) { // если строка извлечена
              rowsFetched++; // нарастим счётчик строк 
              rowsInPage++; // и счётчик строк страницы
              // и подготовим команду отправки строки
              row=lc.CursorGetRow(cursor);
              XMLcmd=XMLcg.addCommand("RowLOV");
              XMLcmd.addScaPar("Type", getRowType());
              XMLcmd.addScaPar("ID",row.get(0));
              headline.clear();
              for (int i=0;i<cols;i++){
                cf=ColsInfo.get(i);
                if (!cf.name.equals("")) { // для видимых столбцов готовим строку  
                headline.Add_Element("COL"+String.valueOf(i), /*app.NLS.NLS(*/row.get(i)/*)*/);
                    }
                }
              XMLcmd.addScaPar("Context",headline.toString()); 
          } else { // если строка не извлечена
              // добавим к предыдущей строке is_last, если предыдущаяя была
              if (rowsInPage>0){
               XMLcmd.addScaPar("IsLast", "Y");
              }
            break;  
          }
        }
        if (!notLastRow && rowsFetched==1 && notDisplayIfOneRow) { // если извлечена лишь одна и
         //задан режим автовыбора единственной строки -- выбираем и уходим
        cw.removeGroup("LOVQ");
        return NVL(lc.CursorGetRow(cursor).get(0),"");
    }
        // в этом месте извлечена первая порция строк
        if (appConn.getSessionMode()=='C') { // если соединение коммунальное, 
            lc.CursorClose(cursor); //то закроем курсор
            appConn.connPool.SetFree(lc); // и освободим соединение
            lc=null;
            cursor=null;
        }
    
        app.changes();
        app.getSeance().remZeroCmd();
        app.getSeance().remFrmWinApp();
        boolean b=true;
        while (b){
        // передаём команды клиенту
        cw.flush();
        er.readEvents();    
        // цикл чтения событий клиента
        while(true) {
           ev=er.getEvent(); 
            if (ev==null) { 
                break;
            }
            switch (ev.name){
                case "CancelLOV": // пользователь отказался от выбора и значит прервал выполнение текущего действия
                b=false;
                String FormID=app.getVal("FormID");
                if (is_not_null("FormID")){
                  if (app.forms.containsKey(FormID)){
                      if (is_not_null(app.forms.get(FormID).getVal("CurrentAction"))){
                              throw new LuiException("break","","","",null,"",app);
                      }
                  }
                }
                break;
                case "NextPartLOV": // клиент захотел ещё порцию строк
                if (notLastRow){ // если последняя не достигнута
                //читаем очердную порцию
                 if (appConn.getSessionMode()=='C') { // /если соединение комунальное, то в начале
                    lc=appConn.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser()); // получим свободное 
                    if (lc==null){ // если соединение так и не нашлось, то
                          app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
                                 }
                    String stmt2=lc.setOffsetClause(stmt,OFF$SET,"",rowsFetched); // модифицируем запрос для извлечения следующей порции
                    cursor=lc.CursorOpen(stmt2); //открываем курсор
                 }  
                // начинаем извлекать строки очередной порции 
                 rowsInPage=0;
                 for (int pr=0;pr<PAGESIZE;pr++) {
                  notLastRow=lc.CursorNextRow(cursor); 
                  if (notLastRow){ //если строка извлечена
                  if (rowsInPage==0) { // для первой строки порции формируем группу команд
                    XMLcg=cw.addGroup("LOVQ_NEXTPART");  
                  }
                  rowsFetched++; // нарастим счётчик строк 
                  rowsInPage++; // и счётчик строк страницы
                        // и подготовим команду отправки строки
                    row=lc.CursorGetRow(cursor);
                    XMLcmd=XMLcg.addCommand("RowLOV");
                    XMLcmd.addScaPar("Type",getRowType());
                    
                    XMLcmd.addScaPar("ID",row.get(0));
                    headline.clear();
                    for (int i=0;i<cols;i++){
                      cf=ColsInfo.get(i);
                      if (!cf.name.equals("")) { // для видимых столбцов готовим строку  
                      headline.Add_Element("COL"+String.valueOf(i), app.NLS.NLS(row.get(i)));
                          }
                      }
                    XMLcmd.addScaPar("Context",headline.toString()); 
                  } else { //если строка НЕ извлечена
                   if (rowsInPage>0){ // добавим к предыдущей строке is_last, если предыдущаяя была
                    XMLcmd.addScaPar("IsLast", "Y");
                     }   
                   break;   
                  }
                 }
                 if (appConn.getSessionMode()=='C') { // /если соединение комунальное, то
                     lc.CursorClose(cursor); //закрываем курсор
                     appConn.connPool.SetFree(lc); // возвращаем соединение в пул свободных
                     lc=null;
                     cursor=null;
                 }
                }// если последняя не достигнута
                break;
                case "ExpandLOV": // открытие узла
                case "SetSortLOV": // изменение режима сортировки
                case "LivePickLOV": // изменение условий отбора
                if (appConn.getSessionMode()=='C') { // если сессия коммунальная
                    lc=appConn.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser()); // берём свободное соединение
                    if (lc==null){ // если соединение так и не нашлось, то
                          app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
                                 }
                } else { // если сессия приватная
                   lc.CursorClose(cursor); // закрываем старый курсор
                }                    
                if (ev.name.equals("ExpandLOV")) {
                  parent_node=ev.getParValue("ID"); 
                  stmt=reMask(acstmt.get(1));
                  stmt=stmt.replace("{PARENT_NODE}",parent_node);
                  if (is_not_null(lc.getOffsetColumn(OFF$SET))) { // если СУбд не может offset
          if (appConn.getSessionMode()=='C')  { // и соединение коммунальное, то
              stmt="select q$O.*,"+lc.getOffsetColumn(OFF$SET)+" from ("+stmt+")q$O";
          }}
                }  else 
                if (ev.name.equals("SetSortLOV")){   
                 String OrderBy=ev.getParValue("OrderBy"); // сдесь нам датут [-]COLn
                 OrderByClause="";
                 if (like(OrderBy,"-%")){
                 OrderByClause=" order by ";    
                 OrderByClause=OrderByClause+String.valueOf(Integer.valueOf(OrderBy.substring(4))+1)+" desc";
                 } else {
                 OrderByClause=" order by ";    
                     OrderByClause=OrderByClause+String.valueOf(Integer.valueOf(OrderBy.substring(3))+1);
                 }

                } else {
                 whereClause="";  
                 int wheremembers=0;
                 for (int i=0;i<cols;i++){
                     cf=ColsInfo.get(i);
                     if (!cf.name.equals("")) {// условие м.б. только для видимых столбцов
                       String Cond=ev.getParKeyValue("Conditions","COL"+String.valueOf(i));
                       if (is_not_null(Cond)) {
                           Cond=Cond.replace("'","''");
                           if (wheremembers>0) {whereClause=whereClause+" and ";}
                           if (is_not_null(cf.alias)){
                               if (CaseSens.equals("Y"))
                               whereClause=whereClause+"\""+cf.alias+"\""+" like '"+Cond+"%'";
                               else whereClause=whereClause+"\""+cf.alias+"\""+" ilike '"+Cond+"%'";
                           } else {
                          if (CaseSens.equals("Y"))
                          whereClause=whereClause+cf.name+" like '"+Cond+"%'";
                          else whereClause=whereClause+cf.name+" ilike '"+Cond+"%'";
                           }
                          wheremembers++; 
                       }
                     }
                 }
                 if (is_not_null(whereClause)){
                 whereClause=" where "+whereClause;    
                 } else {
                 }
                }
                XMLcg=cw.addGroup("LOVQ_SORTorFILTERorEXPAND");
                if (!ev.name.equals("ExpandLOV")) {
                XMLcmd=XMLcg.addCommand("ClearLOV");
                }
                if (is_not_null(whereClause) || is_not_null(OrderByClause)){
                    stmt="select q$1.*";
                 if (is_not_null(lc.getOffsetColumn(OFF$SET))) { // если СУбд не может offset
                 if (appConn.getSessionMode()=='C')  { // и соединение коммунальное, то
                  stmt=stmt+","+lc.getOffsetColumn(OFF$SET);   
                 }
                 }
                 stmt=stmt+" from ("+reMask(acstmt.get(1))+")q$1"+whereClause+OrderByClause;// переделанный select
                } else {
                    stmt=reMask(acstmt.get(1));
                    stmt=stmt.replace("{PARENT_NODE}",parent_node);
                    
                     if (is_not_null(lc.getOffsetColumn(OFF$SET))) { // если СУбд не может offset
                 if (appConn.getSessionMode()=='C')  { // и соединение коммунальное, то
                     stmt="select q$O.*,"+lc.getOffsetColumn(OFF$SET)+" from ("+stmt+")q$O";
                 }
                     }
                }
                 cursor=lc.CursorOpen(stmt); // открываем новый курсор
                 rowsFetched=0;
                 rowsInPage=0;
                 for (int pr=0;pr<PAGESIZE;pr++) {
                    notLastRow=lc.CursorNextRow(cursor);
                    if (notLastRow) { // если строка извлечена
                        rowsFetched++; // нарастим счётчик строк 
                        rowsInPage++; // и счётчик строк страницы
                        // и подготовим команду отправки строки
                        row=lc.CursorGetRow(cursor);
                        XMLcmd=XMLcg.addCommand("RowLOV");
                        XMLcmd.addScaPar("Type", getRowType());
                        XMLcmd.addScaPar("ID",row.get(0));
                        
                        headline.clear();
                        for (int i=0;i<cols;i++){
                          cf=ColsInfo.get(i);
                          if (!cf.name.equals("")) { // для видимых столбцов готовим строку  
                          headline.Add_Element("COL"+String.valueOf(i), app.NLS.NLS(row.get(i)));
                              }
                          }
                        XMLcmd.addScaPar("Context",headline.toString()); 
                        if (is_not_null(parent_node)){
                        XMLcmd.addScaPar("Parent",parent_node);    
                        }
                    } else { // если строка не извлечена
                        // добавим к предыдущей строке is_last, если предыдущаяя была
                        if (rowsInPage>0){
                         XMLcmd.addScaPar("IsLast", "Y");
                        }
                      break;  
                    }
                }
                // в этом месте извлечена первая порция уже иначе отсортированных и отфильтрованных строк
                if (appConn.getSessionMode()=='C') { // если соединение коммунальное, 
                    lc.CursorClose(cursor); //то закроем курсор
                    appConn.connPool.SetFree(lc); // и освободим соединение
                    lc=null;
                    cursor=null;
                }
                        break;
                
                case "ChoiceLOV": // пользователь сделал выбор
                 // app.changeSCN("ChicelLOV");
                  b=false;
                  v=ev.getParValue("ID");  
                  return v;
                case "Interval":
                app.interval();
                break;
                default:
                    if (
                    !ev.name.equals("ExpandLOV") && 
                    !ev.name.equals("SetSortLOV") && 
                    !ev.name.equals("LivePickLOV") && 
                    !ev.name.equals("NextPartLOV") && 
                    !ev.name.equals("Interval") && 
                    !ev.name.equals("ChoiceLOV") && 
                    !ev.name.equals("ChoiceLOV") && 
                    !ev.name.equals("CancelLOV") &&
                    !ev.name.equals("Activate")
                            ){   
                app.eventReader.eventList.add(0,ev);
                 }
                break;
                
            }
        }// цикл чтения событий клиента
        }
        } 
         catch (SQLException ex){
            app.msgWriter.sqlError(lc, ex, pProp, NVL(stmt,pString));
             //app.msgWriter.write("LUI-00034","State:"+ex.getSQLState()+"\n"+ex.getLocalizedMessage()+" ("+NVL(stmt,pString)+") ",pProp.getGenesis4msg() );
            return "";
        }
        finally { // в конце
            if (lc!=null){ // если есть коннект
         if (cursor!=null) { // и курсор есть
           if (lc.CursorisOpen(cursor)) // и он открыт 
          lc.CursorClose(cursor);// закроем курсор
         }
          if (appConn.getSessionMode()=='C')  { // и если сеанс с короткими транзакциями - закроем коннект
              appConn.connPool.SetFree(lc);
        }    
        }
        }
        
       return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     compute(pString,pProp);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     //   throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    private int fetch_portion(){
     return 0;   
    }
private String getRowType(){
if (rowStatusIndex==null) return "Leaf";
switch (row.get(rowStatusIndex)){
    case "0": return "Text";
    case "2": return "Tree";
    case "3": return "Combo";
}
return "Leaf";
}
}
