/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 * Установка текущего языка (практически не используется)
 * @author aliubushkin
 */
public class Language implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        app.setCurrentLANG(pString);
        return app.NLS.currentLang.name;
    }
    /**
     * Выполнение программы на языке "Language" - на входе должна быть строка равная коду языка пример RUS. А ваще программист в действии должен кодировать так: Language:RUS
     * @param pString -язык
     * @param pProp - проперть элемента типа ACTION
     */
    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        app.setCurrentLANG(pString);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      //  throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
