/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Формирует XSLX-файл output.xslx из данных списка во временном каталоге сеанса
 Compute возвращает url на этот файл
 Execute шлёт команды клиенту для открытия файла
 синтаксис List2XSSF:nnnn;TOTALS:Y;
 */
package Standard;

import LuiCollection.LuiCollection;

import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import luiserver.LuiAppConn;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClEvent;
import luiserver.LuiPlugin;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Color;

import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.IndexedColors;
import org.apache.poi.ss.util.WorkbookUtil;
import org.apache.poi.xssf.streaming.SXSSFCell;
import org.apache.poi.xssf.streaming.SXSSFRow;
import org.apache.poi.xssf.streaming.SXSSFSheet;
import org.apache.poi.xssf.streaming.SXSSFWorkbook;
import org.apache.poi.xssf.usermodel.DefaultIndexedColorMap;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;






/**
 *
 * @author aliubushkin
 */
public class List2XSSF implements LuiPlugin{
String s160=" ";
LuiApplication app;
String filename;
FileOutputStream filew=null;
SXSSFWorkbook workbook=null;
LuiAppForm frmInd=null;
LuiAppElement elInd=null;
LuiAppElement elIndOK=null;
LuiClCommandGroup XMLcg=null;
LuiClCommand XMLcmd=null;

    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    app.eventReader.eventList.clear();
        boolean needTot=false;
        HashMap<String,String> tot=null;
        int realCol=1;
        int totalRows=0;
        int tot4Ind=0;
        filew=null;
        workbook=null;
        LuiCollection cs=new LuiCollection("Print:"+pString);
        String maxRowsS=cs.Get_Element("Print");
        String needTotS=cs.Get_Element("TOTALS");
        int maxRows=Integer.valueOf(NVL(maxRowsS,"1000"));
        totalRows=maxRows;
        tot4Ind=maxRows;
        String fc=app.getVal("FormID");
        if (is_not_null(cs.Get_Element("FormID"))) fc=cs.Get_Element("FormID");
        if (is_null(fc))return "";
        if  (!app.forms.containsKey(fc)) return "";
        // content=new StringBuilder();
        LuiAppForm frm=app.forms.get(fc);
        filename=app.getTmpDir()+"output.xlsx";
        LuiDbConn lc=null;
        workbook =null;
        // форма для прогресс - индикатора
        frmInd=null;
        elInd=null;
        elIndOK=null;
        fc=app.getVal("FormID");
        if (app.forms.containsKey(fc)){
           frmInd=app.forms.get(fc);
           if (frmInd.elements.containsKey("PROGRESS$INDICATOR")) {
               elInd=frmInd.elements.get("PROGRESS$INDICATOR");
               if (frmInd.elements.containsKey("OK")) {
                   elIndOK=frmInd.elements.get("OK");
               }
           } else {
               frmInd=null;
           }
        }
    try {    
        filew=new FileOutputStream(new File(filename));
        workbook = new SXSSFWorkbook(100);
        
        SXSSFSheet sheet = workbook.createSheet(
WorkbookUtil.createSafeSheetName(frm.getProperty("HEADER"))
        );
        sheet.createFreezePane(0, 1);
        
        SXSSFRow row;
        SXSSFCell  cell;
        
        String queryText=frm.getVal("MainQuery");
        if (is_not_null(queryText)){
            String acc=frm.getProperty("Connection");
          if (is_not_null(acc)){
           if (app.userDbConnections.containsKey(acc)){
               LuiAppConn ac=app.userDbConnections.get(acc);
                    lc=null;
                    Integer cursor=null;
                    
                    if (ac.getSessionMode()=='C'){
                        lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                    } else {
                        lc=ac.currentConnection;
                    }
                    // формируем жирную ячейку с заголовком списка
                    int r=0;

                     try{
                       cursor=lc.CursorOpen(queryText);
                        int cols=lc.CursorGetCols(cursor); // курсор
                        ArrayList<ColInfo> colList=lc.CursorGetColsInfo(cursor);
                        row=sheet.createRow(r);
                        // формирование заголовков столбцов
                    CellStyle headerColumnStyle=workbook.createCellStyle();
                    Font headerColumnFont = workbook.createFont();    
                    headerColumnFont = workbook.createFont();
                    headerColumnFont.setBold(true);
                    headerColumnFont.setFontHeightInPoints((short) 12);
                    headerColumnFont.setColor(IndexedColors.BLACK.index);
                    headerColumnStyle.setFont(headerColumnFont);
                    headerColumnStyle.setAlignment(HorizontalAlignment.CENTER);
                    //headerColumnStyle.setFillForegroundColor(new XSSFColor(new java.awt.Color(128, 0, 128), new DefaultIndexedColorMap()).getIndex());
                    headerColumnStyle.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
                    DefaultIndexedColorMap cm=new DefaultIndexedColorMap();
                   
                    headerColumnStyle.setFillPattern(FillPatternType.SOLID_FOREGROUND);
                   
                        for(int i=0;i<colList.size();i++){
                            String colCode="";
                            colCode=colList.get(i).alias;
                            if (!frm.elements.containsKey(colCode))continue;
                            LuiAppElement el=frm.elements.get(colCode);
                            String colWidth=frm.getVisualPref(colCode,"ColWidth","");
                            if (is_null(colWidth)){
                                colWidth=el.getProperty("WIDTH");
                            }
                            if (colWidth.equals("0")){
                                colList.get(i).alias="";
                            } else {
                                if (el.getProperty("VISIBLE").equals("Y")){
                                    if (el.getProperty("Read").equals("Y")){
                                        cell=row.createCell(realCol-1);        
                                                      String colNam=     el.getName4show();
                                                if (!el.getParent().equals("Form")){
                                                    colNam=frm.elements.get(el.getParent()).getName4show()+" "+colNam;
                                                }
                                        cell.setCellValue(colNam);
                                        cell.setCellStyle(headerColumnStyle);
                                        realCol++;
                                        if (is_not_null(el.getProperty("TOTAL"))) needTot=true;               
                                    } else colList.get(i).alias="";
                                }else colList.get(i).alias="";
                            }
                        }
                     ArrayList<String> srow;
                     CellStyle cellStyleL=workbook.createCellStyle();
                     cellStyleL.setAlignment(HorizontalAlignment.LEFT);    
                     CellStyle cellStyleR=workbook.createCellStyle();
                     cellStyleR.setAlignment(HorizontalAlignment.RIGHT);    
                     CellStyle cellStyleC=workbook.createCellStyle();
                     cellStyleC.setAlignment(HorizontalAlignment.CENTER);    
 // расчёт итогов
 if (needTotS.equals("Y")){
     if (app.NLS.currentLang.code.equals("RUS")){ 
    if(!progress("Подсчёт количества...",""))return "";
}
else {
    if(!progress("Calculating totals...",""))return ""; 
}
          queryText="count(*) \"row$cnt\"";
for (int i=0;i<cols;i++){
    if (is_not_null(colList.get(i).alias)){
         String colCode="";
         colCode=colList.get(i).alias;
         if (!frm.elements.containsKey(colCode))continue;
      LuiAppElement el=frm.elements.get(colCode);
       String totalExpr="";
       totalExpr=el.getProperty("TOTAL");
       
      if (is_not_null(totalExpr)){
        String format=el.getProperty("FORMAT");
            if (is_not_null(format)){
              totalExpr="to_char("+totalExpr+",'"+format+"')";
             }
           queryText=queryText+", "+totalExpr+" \""+el.getCode()+"\" \n";
      }
    }
}     
if (is_not_null(queryText)){
   queryText="select /*Total Row*/\n"+queryText+" from (\n"+frm.makeMainQuery()+"\n)q$total ";
   
   String qbewhere=frm.addWhere(lc,frm.getProperty("inner_qbe"),false);
   if (is_not_null(qbewhere)){
      if (frm.getProperty("inner_qbe").equals("Y")){
         if (queryText.indexOf("/*ADD_LUI$_INNER_QBE*/")>0) queryText=queryText.replace("/*ADD_LUI$_INNER_QBE*/"," and ("+qbewhere.substring(7)+")");
         else {
             if (queryText.indexOf("/*LUI$_INNER_QBE*/")>0) queryText=queryText.replace("/*LUI$_INNER_QBE*/",qbewhere);
         }
      } 
      else queryText=queryText+qbewhere+"\n";
   }
                           }
 tot=lc.getSelectFirstRowValMap(queryText);
 totalRows=Integer.valueOf(tot.get("row$cnt"));
 tot4Ind=totalRows;
 if (tot4Ind>maxRows)tot4Ind=maxRows;
 }
 //основной цикл
 // расчитаем сколько раз показывать progress-bar
//
  int delta=1;
             if (tot4Ind<200) {delta=20;} //5раз
             else if (tot4Ind<1000) {delta=10;} //10раз
             else if (tot4Ind<20000) {delta=5;} //20раз
             else if (tot4Ind<50000) {delta=2;} //50раз
             
                     int oldPct=0;
                     int newPct=0;
                     while (lc.CursorNextRow(cursor)){
                     r++;
                     if (r==98){
                       sheet.trackAllColumnsForAutoSizing();
                     }
                     newPct=(r-1)*100/tot4Ind;
                      if (newPct-oldPct>=delta){
                                oldPct=newPct;
                            if (!progress(String.valueOf(r)+"/"+String.valueOf(tot4Ind),String.valueOf(newPct))) return "";
                              }
                     row=sheet.createRow(r); 
                     if (r>maxRows){
                       cell=row.createCell(0);        
                       cell.setCellStyle(headerColumnStyle);
                           if (app.NLS.currentLang.code.equals("RUS")){
                       cell.setCellValue("...Превышено разрешённое количество выводимых строк!");
                           } else {
                       cell.setCellValue("...Exceeded the allowed number of output lines!");        
                           }
                       break;
                      }
                     srow=lc.CursorGetRow(cursor); 
                     // укажем форме текущую строку
                     frm.setVal("FetchedRows",String.valueOf(r));
                     frm.setVal("CurrentRow",String.valueOf(r));
                     //устанавливаем значения элементов
                            for (int i=0;i<cols;i++){
                                String colCode="";
                                colCode=colList.get(i).alias;
                                 if (!frm.elements.containsKey(colCode))continue;
                                LuiAppElement el=frm.elements.get(colCode);
                                
                                   String ldt=el.getProperty("DATA_TYPE");
                                String valBuffer=srow.get(i);
                                if (valBuffer==null){
              if ("EMPTY_STRING".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode) 
                      && is_not_null(app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol)){ //если есть особый режим работы с NULL
                  valBuffer=app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol;
              }
              }
              if ("".equals(valBuffer)){
              if ("NULL".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)
                      && is_not_null(app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol)){ //если есть особый режим работы с NULL
                  valBuffer=app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol;
              }
              }      
                
      el.setValue(valBuffer,false,"",false); // и запихиваем в значение столбца
                            }
                            // значения столбцов установлены       
                     int icn=0;
                     String dv="";
                     for (int i=0;i<cols;i++){
                                String colCode="";
                                colCode=colList.get(i).alias;
                                if (!frm.elements.containsKey(colCode))continue;
                                if (is_not_null(colList.get(i).alias)){
                                if (srow.get(i)==null) dv="";
                                else {
                                 if (srow.get(i).length()>32767) dv=srow.get(i).substring(0,32000);
                                 else  dv=srow.get(i);
                                }
                                cell=row.createCell(icn);icn++;
                                LuiAppElement el=frm.elements.get(colCode);
                                String ali=el.getProperty("ALIGNMENT");
                                switch (ali){
                                    case "RIGHT":
                                        cell.setCellStyle(cellStyleR);
                                    break;
                                    case "CENTER":
                                        cell.setCellStyle(cellStyleC);
                                    break;    
                                    default:
                                        cell.setCellStyle(cellStyleL);   
                                }
                                if (is_null(dv)){
                                    cell.setCellValue("");
                                } else{
                                String dt=el.getProperty("DATA_TYPE");
                                if (!el.getCode().equals("GG")||!frm.getCode().equals("LUI_L_DATA_GROUPING_SHOW")){
                                try{
                                  String dvn=dv.replaceAll("\\s+","");
                                  dvn=dvn.replaceAll(s160,"");
                                  /*double d=*/Double.valueOf(dvn);
                                  dt="NUMBER";
                                } catch (Exception e){}
                                
                                }
                                switch (dt) {
                                    case "DATETIME":
                                    cell.setCellValue(dv);
                                    break;
                                    case "NUMBER":
                                    dv=dv.replaceAll("\\s+","");
                                    dv=dv.replaceAll(s160,"");
                                    cell.setCellType(CellType.NUMERIC);
                                    cell.setCellValue(Double.valueOf(dv));    
                                    break;
                                    default:
                                    cell.setCellValue(dv);       
                                }}
                                }
                     }
                     }
     
   
if (!progress("","100")) return "";
                     
//итоги                     
   if (needTotS.equals("Y")){
r++;
     row=sheet.createRow(r); 
     cell=row.createCell(0);
     cell.setCellStyle(headerColumnStyle);
      if (app.NLS.currentLang.code.equals("RUS")){  
     cell.setCellValue("Всего строк:");}
     else {
     cell.setCellValue("Total rows:");
          }
     cell=row.createCell(1);
     cell.setCellStyle(headerColumnStyle);
     cell.setCellType(CellType.NUMERIC);
     
     cell.setCellValue(totalRows);
     cell.setAsActiveCell();
     
 CellStyle totStyleL=workbook.createCellStyle();
 totStyleL.setAlignment(HorizontalAlignment.LEFT);    
 CellStyle totStyleR=workbook.createCellStyle();
 totStyleR.setAlignment(HorizontalAlignment.RIGHT);    
 CellStyle totStyleC=workbook.createCellStyle();
 totStyleC.setAlignment(HorizontalAlignment.CENTER);    

 totStyleL.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
 totStyleC.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
 totStyleR.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
 totStyleL.setFillPattern(FillPatternType.SOLID_FOREGROUND);
 totStyleC.setFillPattern(FillPatternType.SOLID_FOREGROUND);
 totStyleR.setFillPattern(FillPatternType.SOLID_FOREGROUND);
 
 r++;
 row=sheet.createRow(r);
 
 int icn=0; 
 
 for (int i=0;i<cols;i++){
     if (is_not_null(colList.get(i).alias)){
     String colCode=colList.get(i).alias;
     if (!frm.elements.containsKey(colCode))continue;
     LuiAppElement el=frm.elements.get(colCode);
     cell=row.createCell(icn);icn++;
     String totalExpr="";
 
       totalExpr=el.getProperty("TOTAL");
 
     String dv="";
      if (tot!=null && tot.containsKey(colCode))dv=tot.get(colCode);
     if (is_not_null(totalExpr)){
 
        String ali=el.getProperty("ALIGNMENT");
                                switch (ali){
                                    case "RIGHT":
                                    cell.setCellStyle(totStyleR);    
                                    break;
                                    case "CENTER":
                                    cell.setCellStyle(totStyleC);    
                                    break;    
                                    default:
                                    cell.setCellStyle(totStyleL);    
                                }
                                if (is_null(tot.get(colCode))){
                                    cell.setCellValue("");
                                } else{
                                String dt=el.getProperty("DATA_TYPE");
                                try{
                                  String dvn=dv.replaceAll("\\s+","");
                                  dvn=dvn.replaceAll(s160,"");
                                  /*double d=*/Double.valueOf(dvn);
                                  dt="NUMBER";
                                } catch (Exception e){}
                                switch (dt) {
                                    case "DATETIME":
                                    cell.setCellValue(dv);
                                    break;
                                    case "NUMBER":
                                    dv=dv.replaceAll("\\s+","");
                                    dv=dv.replaceAll(s160,"");
                                    cell.setCellType(CellType.NUMERIC);
                                    cell.setCellValue(Double.valueOf(dv));    
                                    break;
                                    default:
                                    cell.setCellValue(tot.get(colCode));       
                                  }
                                }
      }  else {
     cell.setCellStyle(totStyleL);    
     cell.setCellValue("");
        }
     }
     }
    
     }
   // выравнивание
   int icn=0;
   sheet.trackAllColumnsForAutoSizing();
   for (int i=0;i<cols;i++){
     if (is_not_null(colList.get(i).alias)){
     String colCode=colList.get(i).alias;
     if (!frm.elements.containsKey(colCode))continue;
     try{
     sheet.autoSizeColumn(icn);icn++;
     } catch(Exception e){}
     }
 }

                     }finally {
                        if (lc!=null){
                            if (lc.CursorisOpen(cursor)) lc.CursorClose(cursor);
                            if (ac.getSessionMode()=='C') {
                                ac.connPool.SetFree(lc);
                            }
                        }
                        
                        
                    }
           }   
          }  
        }
 
        workbook.write(filew);
        workbook.close();
        workbook.dispose();
        filew.flush();
        filew.close();
    } catch (FileNotFoundException ex) {
        if (filew!=null){if (workbook!=null){
                           try { 
                            workbook.close();
                            workbook.dispose();
                           } catch(Exception wex){}
                        }
                          try{
                              filew.flush();
                              filew.close();
                              filew=null;
                          } catch(Exception ef) {}
                        }
        app.msgWriter.write("LUI-00097",filename,ex.getMessage());
    }catch (IOException ex) {
        if (workbook!=null){
                           try { 
                            workbook.close();
                            workbook.dispose();
                           } catch(Exception wex){}
                        }
        if (filew!=null){
                          try{
                              filew.flush();
                              filew.close();
                              filew=null;
                          } catch(Exception ef) {}
                        }
        app.msgWriter.write("LUI-00097",filename,ex.getMessage());
    }
    return app.getTmpDirURL()+"output.xlsx";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String fc=app.getVal("FormID");
          if (is_null(fc))return;
          if  (!app.forms.containsKey(fc)) return;
          String adr=compute(pString,pProp);
          if (is_not_null(adr)){
          LuiAppForm frm=app.forms.get(fc);
          LuiClCommandGroup XMLcg=app.commandWriter.addGroup("PRINT");
          LuiClCommand XMLcmd=XMLcg.addCommand("URL");
          XMLcmd.addScaPar("Address",adr);
          XMLcmd.addScaPar("Target","Tab");
          }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
private boolean progress(String pText,String pPct) throws LuiException, SQLException{
    boolean retVal=true;
    if (elInd!=null){
      elInd.setProperty("VISIBLE","1");
      if (elIndOK!=null){
          elIndOK.setProperty("ACTIVE","N");
      }
      if (is_not_null(pText)){
         elInd.setProperty("HELPER_TEXT","   "+pText);  
      } else {
         elInd.setProperty("HELPER_TEXT","");
      }
      if (is_not_null(pPct)){
          elInd.setProperty("VISUALIZATION","PROGRESS PROC"+pPct);
          elInd.setProperty("Value","   "+pPct+"%");
      }else {
          elInd.setProperty("VISUALIZATION","");
          elInd.setProperty("Value","");
      }
      elInd.properties.get("Value").setChangeFlag();
      elInd.properties.get("HELPER_TEXT").setChangeFlag();
      elInd.properties.get("VISUALIZATION").setChangeFlag();
      elInd.properties.get("Show").setChangeFlag();
      frmInd.changes();
      XMLcg=app.commandWriter.addGroup("CallBack");
      XMLcmd=XMLcg.addCommand("Event");
      XMLcmd.addScaPar("EventCode", "ProgressContinue");
      XMLcmd.addScaPar("MS","0");
      app.commandWriter.flush();
      app.eventReader.readEvents();
      while (true){
        LuiClEvent ev=app.eventReader.getEvent();
        if (ev==null) break;
        if (ev.name.equals("ProgressContinue") ||ev.name.equals("GotoField") )retVal=true;
        else retVal=false;
        
     }
    }
return retVal;
}
    
}
