/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class N implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
    }

    @Override
     public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       return comp(pString,pProp,false);
     }

    public String comp(String pString, LuiAppProp pProp,boolean pFindOnly) throws LuiException, SQLException {
        LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
    for (String ec:frm.elements.keySet()){
        String vN=null;
          if (frm.elements.get(ec).properties.containsKey("Value")) vN="Value"; 
          else  {if (frm.elements.get(ec).properties.containsKey("VALUE")) 
              vN="VALUE";
          }
            if (vN==null) continue;
        
        if (frm.elements.get(ec).getProperty("Name").equals(pString)){
            frm.elements.get(ec).properties.get(vN).setDepend(pProp);
              if (pFindOnly) return null;
            String retval= NVL(frm.elements.get(ec).properties.get(vN).getComputedProperty(),"");
                if (frm.elements.get(ec).properties.containsKey("DATA_TYPE")){ // если у элемента есть DATA_TYPE
                   String ldt=frm.elements.get(ec).getProperty("DATA_TYPE"); 
                   if ("SPEC_SYMBOL_FOR_NULL".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)){
                      if  (app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol.equals(retval)) retval="";
                   }
                   if ("SPEC_SYNBOL_FOR_EMPTY_STRING".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)){
                      if  (app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol.equals(retval)) retval="";
                   }
                }
                return retval;
        }
    }
    return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return;
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        comp(pString,pProp,true);
    }
    
}
