/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Вычисление текста на текущем языке из исходной мультиязыковой коллекции строк
* Синтаксис:
NLS:[(КодЯзыка)]<КодЯзыка1><Текст1>;<КодЯзыка1><Текст1>;
 */
package Standard;

import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class NLS implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        if (is_null(pString)) return "";
        String curL=app.NLS.currentLang.code;
        if (pString.charAt(0)=='(') { // если начинается со скобки
          int cb=pString.indexOf(")"); 
            if (cb>0){// и если она закрывается
                String lCode=pString.substring(1,cb); // будем подозревать, что там между скобками спрятан код языка
                if (app.NLS.langList.containsKey(lCode)) { // и да! это так!
                    curL=lCode;
                    pString=pString.substring(cb+1);
                }
            }  
        }
        String retVal=null;
        retVal=app.NLS.NLS(pString,curL);
        return retVal;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
