/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import luiserver.LuiAppConn;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiParser;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class OraCLOB implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    LuiAppConn ac=null;
    LuiDbConn lc=null;
    String stmt;
    String rc="";
    // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }   
    if (frm==null) return "";
      ArrayList<String> acs=app.getAppConnAndStmt(pString,"",frm.getFormID());
        ac=app.userDbConnections.get(acs.get(0));
        stmt=LuiParser.reMask(acs.get(1));
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=ac.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        return "";
        }
        try {
           String sLen=lc.getSelectResult("select length(("+stmt+")) from dual");
           if (is_null(sLen))return "";
           String maxI=lc.getSelectResult("select ceil("+sLen+"/4000) from dual");
           for (int i=1;i<=Integer.valueOf(maxI);i++) {
           String piece=lc.getSelectResult("select to_char(substr(("+stmt+"),("+String.valueOf(i)+"-1)*4000+1,4000)) from dual");
           rc=rc+piece;
           } 
        } catch (SQLException ex){
           //if (frm!=null) {
               if (frm.getProperty("SuppressErrors").equals("Y")) return "";
          // } 
            app.msgWriter.sqlError(lc, ex, pProp, stmt);
            return "";
        }
        finally {
            if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            }
        }
        return rc;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
