/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
* Создание массива JSON из столбцов указанного списка по которым есть сортировка
* Execute отсутствует
* Compute:
OrderBy2JSONArray:<FormID> */
package Standard;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class OrderBy2JSONArray implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      LuiAppForm frm=null;
    pString=LuiString.RTrim(NVL(pString,""));
        if (pString.charAt(pString.length()-1)!=';'){
            pString=pString+";";
        }
    LuiCollection pcol=new LuiCollection("OrderBy2JSONArray:"+pString);
    String mode=NVL(pcol.Get_Element("MODE"),"SORT");
    String frmID=pcol.Get_Element("OrderBy2JSONArray");
    String retVal="";
    String sort="";
        if (is_not_null(frmID)) {
            
            if (!app.forms.containsKey(frmID))return "";
            frm=app.forms.get(frmID);;
        } else {
                frm=pProp.ownerObj.getForm();
                if (frm==null) {
                pString=app.getVal("FormID");        
                if (app.forms.containsKey(pString)){
                   frm=app.forms.get(pString);
                } else return "";
                } 
        }
        LuiAppElement el=null;
        LuiCollection elCol=null;
        for (String elcode:frm.elements.keySet()){
          el=frm.elements.get(elcode);
          if (el.getType().equals("ITEM")){
             if (el.getProperty("Read").equals("Y")) { // если показывается
             sort=el.getProperty("SORT").trim();
                if ((is_not_null(sort)&& mode.equals("SORT")) ||
                    (is_null(sort)&& mode.equals("NOT_SORT")) ||
                     mode.equals("ALL")    
                        ) {
                    
                   elCol=new LuiCollection(""); 
                   elCol.Add_Element("code", el.getCode());
                   String name=el.getName4show();
                   if (!el.getParent().equals("Form")){
                       name=frm.elements.get(el.getParent()).getName4show()+' '+name;
                   }
                   elCol.Add_Element("name", name); 
                   elCol.Add_Element("seq", el.getProperty("Seq"));
                   elCol.Add_Element("visible",el.getProperty("VISIBLE"));
                   elCol.Add_Element("datatype", el.getProperty("DATA_TYPE"));
                   elCol.Add_Element("width",el.getProperty("WIDTH"));
                   elCol.Add_Element("sort",el.getProperty("SORT"));
                   if (is_not_null(el.getProperty("SORT"))) {
                   if (like(sort,"-%")) {
                   elCol.Add_Element("ad","desc");
                    if (like(sort,"-0%")){
                        elCol.Add_Element("sort_nulls","last");
                    } else {
                        elCol.Add_Element("sort_nulls","first");
                    }
                   } else {
                  elCol.Add_Element("ad","asc");
                    if (like(sort,"0%")){
                        elCol.Add_Element("sort_nulls","first");
                    } else {
                        elCol.Add_Element("sort_nulls","last");
                    }
      } }else {elCol.Add_Element("ad","");
               elCol.Add_Element("sort_nulls","");
                   }
                   
                   
                   if (is_not_null(retVal))retVal=retVal+",";
                    retVal=retVal+elCol.ToJSON();
                }
             } 
          }
        }
    return "["+retVal+"]";   
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      
    }
    
}
