/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.Filter;
import static LuiCollection.LuiString.LTrim;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.String2Integer;
import static LuiCollection.LuiString.is_not_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import luiserver.LuiAppConn;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;

import luiserver.LuiApplication;
import luiserver.LuiParser;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class PLPGSQL implements LuiPlugin{
LuiApplication app;
LuiDbConn lc=null;
String stmt="";
String to_var=null;
String error="exception";
static final boolean VANIL=true;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        try {
              return exe('C',pString,pProp);
        } catch(SQLException sex){
            if (error.equals("exception")) throw(sex);
            if (error.equals("info")){
                app.msgWriter.ClearMsgArray();
                   return "ERROR! "+sex.getMessage();
            }
            return error;
        }
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
              exe('E',pString,pProp);
    }
private String exe(char executeOrCompute,String pString,LuiAppProp pProp) throws  LuiException,SQLException{
    LuiAppConn ac=null;
    
    boolean fieldChanged=false;
    String dbType="";
    // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return "";
     /***статистика***/
    String stat="";
    try{
    stat=frm.getProperty("StatPLPGSQL");
    }catch(Exception ex){}
    int StatCount=0;
    long StatTime=0;
    if (is_not_null(stat)){
        StatCount=Integer.valueOf(stat.split(" ")[0]);
        StatTime=Integer.valueOf(stat.split(" ")[1]);
    }
    StatCount++;
    long StatStart=System.currentTimeMillis();
    /***статистика***/
    if (pString.indexOf("(error=")==0){
         error=pString.substring(7,pString.indexOf(")"));
         pString=pString.substring(pString.indexOf(")")+1);
        }
    ArrayList<String> acs=app.getAppConnAndStmt(pString,"",frm.getFormID());
        ac=app.userDbConnections.get(acs.get(0));
        
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=ac.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        }
        dbType=lc.getDBvendor();
        /*if (like(ac.dbURL.toLowerCase(),"%postgresql%")) { // если это Postgres
                      dbType="PG";
        }*/
        try { // попытка выполнить код
        if (executeOrCompute=='C'){ // если Compute
          if (dbType.equals("PG")) { // если это Postgres
            if (VANIL) this.removePKG("LUI.RETVAL"); // удаляем переменную LUI_RETVAL
            else this.removePKG("LUI_RETVAL"); // удаляем пакет LUI_RETVAL
          }
            String res="";
            stmt=LuiParser.reMask(acs.get(1));
            error="exception";
            to_var=null;
      
        if (stmt.indexOf("(error=")==0){
         error=stmt.substring(7,stmt.indexOf(")"));
         stmt=stmt.substring(stmt.indexOf(")")+1);
        }
        if (stmt.indexOf("(=>")==0){
            to_var=stmt.substring(3,stmt.indexOf(")"));
            stmt=stmt.substring(stmt.indexOf(")")+1);
        }

            stmt="do $lui2$ "+stmt+"$lui2$;";
            lc.executeDML(stmt);
            //lc.executeIfNoLocks(stmt);
            
          if (dbType.equals("PG")) {// если это Postgres
            if (VANIL) stmt="select /*readig returned conf_variable*/ current_setting('LUI.RETVAL',true)";
            else stmt="select /*readig returned pg_variable*/ pgv_get_text('LUI_RETVAL','TEXT_VALUE',false)";  
            res=lc.getSelectResult(stmt);  // читаем переменную с именем 'TEXT_VALUE' из пакета LUI_RETVAL
          }
            if (to_var!=null){
               frm.setVal(to_var,"");
               frm.properties.get("Var "+to_var).currentValue=res;
               return "<="+to_var;
            }
            return NVL(res,""); // и возвращаем LUI_RETVAL
        } else { // если Execute
        if (dbType.equals("PG")) { // и если это Postgres очистим пакеты переменных
          if (VANIL){
          this.removePKG("LUI.ELEMENTS");
          this.removePKG("LUI.APP_PROPERTIES");  
          this.removePKG("LUI.FORM_PROPERTIES");    
          } else 
          {
          this.removePKG("LUI_ELEMENTS");
          this.removePKG("LUI_APPLICATION");  
          this.removePKG("LUI_FORM");        
          }
          
        } // если это Postgres чистка окончена
        
        stmt=LuiParser.reMask(acs.get(1));
        stmt="do $lui2$ "+stmt+"$lui2$;";
        
        lc.executeDML(stmt);
        //lc.executeIfNoLocks(stmt);
        if (dbType.equals("PG")) { // если это постгрес читаем пакеты переменных
           LuiAppElement el;
           LuiCollection props=null;
            // читаем элементы
            //String cs=lc.getSelectResult("select current_setting('LUI.ELEMENTS',true)");
           ArrayList<ArrayList<String>> elems = new ArrayList<>();
           if (VANIL) stmt="SELECT /*reading changed form elements*/ lui_f_api_get_elements() \"code\"";
           else stmt="select /*reading changed form elements*/ name from pgv_list() where package='LUI_ELEMENTS' order by 1";
           try{
           elems =  lc.getSelectAllRowsValList(stmt);
           } catch(SQLException terr){
               if (terr.getSQLState().equals("42883")) 
               {
                   elems=null;
               }
               else throw terr;
           }
          if (elems!=null) {
           for (int i=0;i<elems.size();i++) {
            el=null;
             String ec=elems.get(i).get(0); // извлекаем код элемента
             props=null;
             //извлекаем св-ва элемента
             if (VANIL) stmt="select /* reading changed element properties*/ CODE,VALUE from lui_f_api_get_element_properties('"+ec+"')";
             else stmt="select /* reading changed element properties*/ CODE,VALUE from pgv_select('LUI_ELEMENTS','"+ec+"') as (CODE text,VALUE text)";
             props=lc.getSelectAllRowsTwoColsValMap(stmt); 
            
             if (!frm.elements.containsKey(ec)) { // если элемента нет в текущей форме
              String EType=props.get("EType"); // тип элемента
              if (is_not_null(EType)){ // если тип задан 
           String Parent=props.get("Parent");
           String Name=props.get("Name");
           String SeqStr=props.get("Seq"); // берём св-во Seq
           //Integer Seq=String2Integer(SeqStr,null); // преобразовываем к целому
           Double Seq=null;
           try{
           Seq=Double.valueOf(SeqStr);
           } catch (Exception ex){
               Seq=null;
           }
           if (Seq==null) { // если пусто
               Seq=frm.getNewSeq(EType); // берём очередное
           } else { // не пусто
               if (LTrim(SeqStr).charAt(0)=='+') { // и начинается с '+'
                   Seq=frm.getNewSeq(EType)-1+Seq; // добавим к максимуму
               }
           }
           boolean pYes=frm.elements.containsKey(NVL(Parent,""));
           el=frm.addElement(ec, EType,Seq, NVL(Name,""), NVL(Parent,"")); // создаём новый эелемент
           el.addProperty("Metadata","N");
           //el.metadata=false;
           if (is_not_null(Parent) && !pYes && frm.elements.containsKey(Parent)){
              //frm.elements.get(Parent).metadata=false;
              frm.elements.get(Parent).addProperty("Metadata","N");
           }
           fieldChanged=true;
                   } else continue; // нет типа - уходим на след. элемент
             } else el=frm.elements.get(ec); // элемент есть - извлекаем его
             // крутим св-ва элемента
            if (el!=null) { // если элемент известен
                for (String pc:props.keySet()){ // крутим изменяемые (добавляемые св-ва)
             if (pc.equals("Seq") && //!el.metadata
                     el.getProperty("Metadata").equals("N")
                     ){
                 String EType=props.get("EType"); // тип элемента
                 String SeqStr=props.get("Seq"); // берём св-во Seq
                 //Integer Seq=String2Integer(SeqStr,null); // преобразовываем к целому
                 Double Seq=null;
           try{
           Seq=Double.valueOf(SeqStr);
           } catch (Exception ex){
               Seq=null;
           }
                 if (Seq==null) { // если пусто
               Seq=frm.getNewSeq(EType); // берём очередное
                    } else { // не пусто
               if (LTrim(SeqStr).charAt(0)=='+') { // и начинается с '+'
                   Seq=frm.getNewSeq(EType)-1+Seq; // добавим к максимуму
               }
           }
              el.sourceSeq=Seq;   
              el.mutSeq=Double.valueOf(Seq);
              el.addProperty("Seq",String.valueOf(Seq));
             }
             if (!pc.equals("Seq") && !pc.equals("EType") ) {      // если св-во не Seq  и не EType
              if (pc.equals("Value")&& (!el.getType().equals("PARAM") || frm.getType().equals("TASK"))) {
               el.addProperty("DEFINITION", LuiParser.mask(props.get(pc)));
              }   else {
              el.addProperty(pc,props.get(pc)); // то меняем или добавляем
              }
              
              fieldChanged=true; 
             }
                 }
            } 
           } // конец цикла по изменяемым (новым элементам)
        frm.elSortedList.clear();
        frm.elSort(0);
          }
           // читаем св-ва формы
           
           elems = null;
           if (VANIL){props=null;
           stmt="select /*reading changed form properties*/ code,value from lui_f_api_get_form_properties()";
           try{
           props =  lc.getSelectAllRowsTwoColsValMap(stmt);
           } catch(SQLException terr){
               if (terr.getSQLState().equals("42883")) 
               {
                   props=null;
               }
               else throw terr;
           }
            if (props!=null){
              for (String pc:props.keySet()){ // крутим изменяемые (добавляемые св-ва)
               frm.addProperty(pc,props.Get_Element(pc));
              }
              }
           }
           else {elems = null;
           stmt="select /*reading changed form properties*/ name from pgv_list() where package='LUI_FORM'";
           try{
           elems =  lc.getSelectAllRowsValList(stmt);
           } catch(SQLException terr){
               if (terr.getSQLState().equals("42883")) 
               {
                   elems=null;
               }
               else throw terr;
           }
           if (elems!=null){
             for (int i=0;i<elems.size();i++) {
                String pc=elems.get(i).get(0); // извлекаем код св-ва
              stmt="select /*reading changed form property*/ pgv_get_text('LUI_FORM','"+pc+"')";
              String pv=lc.getSelectResult(stmt);
              frm.addProperty(pc,pv);
             }  
           }
           }
           // читаем св-ва приложения
           if (VANIL){
           stmt="select /*reading changed application properties*/ code,value from lui_f_api_get_app_properties()";               
           props=null;
           try{
           props =  lc.getSelectAllRowsTwoColsValMap(stmt);
           } catch(SQLException terr){
               if (terr.getSQLState().equals("42883")) 
               {
                   props=null;
               }
               else throw terr;
           }
           if (props!=null){
              for (String pc:props.keySet()){ // крутим изменяемые (добавляемые св-ва)
               app.addProperty(pc,props.Get_Element(pc));
              }
           }
           } else {
           stmt="select /*reading changed application properties*/ name from pgv_list() where package='LUI_APPLICATION'";               
           elems = null; 
           try{
           elems =  lc.getSelectAllRowsValList(stmt);
           } catch(SQLException terr){
               if (terr.getSQLState().equals("42883")) 
               {
                   elems=null;
               }
               else throw terr;
           }
           if (elems!=null){
             for (int i=0;i<elems.size();i++) {
              String pc=elems.get(i).get(0); // извлекаем код св-ва
              stmt="select /*reading changed application property*/ pgv_get_text('LUI_APPLICATION','"+pc+"')";
              String pv=lc.getSelectResult(stmt);
              app.addProperty(pc,pv);
             }
            } 
           }
           
           } // если PG чтение пакетов переменных окончено
        return "";
         }
        }  // попытка выполнить код
        catch (SQLException ex){ // привела 
            //if (frm!=null) {
               if (frm.getProperty("SuppressErrors").equals("Y")) return "";
          //} 
            app.msgWriter.sqlError(lc, ex, pProp, NVL(stmt,pString));
            //app.msgWriter.write("LUI-00034","State:"+ex.getSQLState()+"\n"+ex.getLocalizedMessage()+" \n"+stmt+"\n ",pProp.getGenesis4msg() );
            return "";
        }
        finally {
            frm.setProperty("StatPLPGSQL",String.valueOf(StatCount)+" "+String.valueOf(StatTime+System.currentTimeMillis()-StatStart));   
            if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            }
        }

}
    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
@Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\'").length() % 2 == 1) return Value.replace("\'", "\'\'");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }

public void removePKG(String pPKG) throws SQLException{
 if (VANIL){
     stmt="select set_config('"+pPKG+"','',false)";
    lc.getSelectResult(stmt);
 } else {
    stmt="select 'Y' where pgv_exists('"+pPKG+"')";
    String exist=lc.getSelectResult(stmt);
    if (exist!=null) {
        //try {
        stmt="select pgv_remove('"+pPKG+"')";
        lc.getSelectResult(stmt);

        /*} catch (SQLException sexp){

        }*/
    }
 }
 }
}
