/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Вычислятор выражений
 * Ситаксис вычисления:
Parse:<строка>
 */
package Standard;


import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import static luiserver.LuiParser.reMask;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Parse implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      String error="exception";
      
        if (pString.indexOf("(error=")==0){
         error=pString.substring(7,pString.indexOf(")"));
         pString=pString.substring(pString.indexOf(")")+1);
         try{
         return app.parser.compute(reMask(pString), pProp);
         } catch (Exception ex){
             if (error.equals("exception")) throw(ex);
             if (error.equals("info")){
                 app.msgWriter.ClearMsgArray();
                 return "ERROR! "+ex.getMessage();
             } else {
                 return error;
             }
         }
       }
       return app.parser.compute(reMask(pString), pProp);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        app.parser.comp(pString, pProp, true);
    }
    
}
