/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Формирует html-файл output.htm из данных списка во временном каталоге сеанса
 Compute возвращает url на этот файл
 Execute шлёт команды клиенту (Жененому серверу) для открытия файла
 синтаксис Print:nnnn;TOTALS:Y;FormID:ID формы;
 */
package Standard;

import LuiCollection.LuiCollection;

import static LuiCollection.LuiString.MaskAncillaryChars;

import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import luiserver.LuiAppConn;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;

import static LuiCollection.LuiString.MaskXMLChars;
import static LuiCollection.LuiString.NVL;
import java.io.File;
import java.io.FileOutputStream;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import luiserver.LuiClEvent;


/**
 *
 * @author aliubushkin
 */
public class Print implements LuiPlugin{
LuiApplication app;
//String ls;
Writer filew=null;
String filename;
LuiAppForm frmInd=null;
LuiAppElement elInd=null;
LuiAppElement elIndOK=null;
LuiClCommandGroup XMLcg=null;
LuiClCommand XMLcmd=null;
//StringBuilder content;
@Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        //ls=System.getProperty("line.separator");
    }
/**
 * Формаирование страницы для печати 
 синтаксис Print:nnnn;TOTALS:Y;FormID:&lt;id формы&gt;
 * @param pString программа
 * @param pProp свойство
 * @return не известно
 * @throws LuiException логическая ошибка
 * @throws SQLException ошибка выполнения SQL-запроса
 */    
    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    try{
        int totalRows=0;
        int tot4Ind=0;
        filew=null;
        
        HashMap<String,String> tot=null;
        LuiCollection cs=new LuiCollection("Print:"+pString);
        boolean needTot=false;
        int realCol=1;
        String maxRowsS=cs.Get_Element("Print");
        String needTotS=cs.Get_Element("TOTALS");
        int maxRows=Integer.valueOf(NVL(maxRowsS,"1000"));
        totalRows=maxRows;
        tot4Ind=maxRows;
        String fc=app.getVal("FormID");
        if (is_not_null(cs.Get_Element("FormID"))) fc=cs.Get_Element("FormID");
        if (is_null(fc))return "";
        if  (!app.forms.containsKey(fc)) return "";
        
        // content=new StringBuilder();
        LuiAppForm frm=app.forms.get(fc);
        
        filename=app.getTmpDir()+"output.htm";
        //filew=new FileWriter(filename,false);
        File file = new File(filename);
        file.createNewFile(); // если файл существует - команда игнорируется
        FileOutputStream fileOutputStream = new FileOutputStream(file, false);
// false -> true, если надо продолжать писать в файл при его наличии, с false файл будет очищен 
        filew = new OutputStreamWriter(fileOutputStream, StandardCharsets.UTF_8);
        
        // форма для индикатора
        frmInd=null;
        elInd=null;
        elIndOK=null;
        fc=app.getVal("FormID");
        if (app.forms.containsKey(fc)){
           frmInd=app.forms.get(fc);
           if (frmInd.elements.containsKey("PROGRESS$INDICATOR")) {
               elInd=frmInd.elements.get("PROGRESS$INDICATOR");
               if (frmInd.elements.containsKey("OK")) {
                   elIndOK=frmInd.elements.get("OK");
               }
           } else {
               frmInd=null;
           }
        }
        line("<html>");
        line("<head>");
        // favicon
        String favicon="";
        favicon=app.getProperty("BROWSER_WINDOW_ICON");
        if (is_null(favicon)){
        favicon=app.getProperty("AppDirURL");
        int lui2ind=favicon.indexOf("lui2");
        if (lui2ind>0) {
        favicon=favicon.substring(0, lui2ind);
        favicon=favicon+"lui2/lui.ico";
        } else favicon="";
        }
        if (is_not_null(favicon))
        line("<link rel=\"shortcut icon\" href=\""+favicon+"\" type=\"image/x-icon\" />");
        line("<title>");line(frm.getProperty("HEADER"));line("</title>");
        line("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"/>");
        //line("<meta http-equiv=\"Content-Type\" content=\"text/html; charseе=windows-1251\"/>");
        //line("<meta http-equiv=\"Content-Type\" content=\"text/html;\"/>");
        String css="";
        LuiDbConn lc=null;
        try{
            lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
            css=lc.getSelectResult("select lui_f_get_application_property('"+app.code+"','PRINT_CSS','"+app.NLS.currentLang.code+"')");
        } finally {
            if (lc!=null) {
                app.metaConnPool.SetFree(lc);
                lc=null;
            }
        }
String queryText="";               
        //line(css);
        filew.write(css);
        line("</head>");
        line("<body>");
        line("<div class=\"Print_Title\" title=\"List Title\">");line(MaskAncillaryChars(frm.getProperty("HEADER")));line("</div>");
        line("<table class=\"Print\">");
        
        queryText=frm.getVal("MainQuery");
        if (is_not_null(queryText)){
            line("<tr class=\"Print_Titles\"><th class=\"Print_RowNum\">№</th>");
            String acc=frm.getProperty("Connection");
            if (is_not_null(acc)){
                if (app.userDbConnections.containsKey(acc)){
                    LuiAppConn ac=app.userDbConnections.get(acc);
                    lc=null;
                    Integer cursor=null;
                    
                    if (ac.getSessionMode()=='C'){
                        lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                    } else {
                        lc=ac.currentConnection;
                    }
                    if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        return "";
        }
                    try{
                        cursor=lc.CursorOpen(queryText);
                        int cols=lc.CursorGetCols(cursor);
                        ArrayList<ColInfo> colList=lc.CursorGetColsInfo(cursor);
                        
                        
                        for(int i=0;i<colList.size();i++){
                            String colCode="";
                            colCode=colList.get(i).alias;
                            if (!frm.elements.containsKey(colCode))continue;
                            LuiAppElement el=frm.elements.get(colCode);
                            String colWidth=frm.getVisualPref(colCode,"ColWidth","");
                            if (is_null(colWidth)){
                                colWidth=el.getProperty("WIDTH");
                            }
                            if (colWidth.equals("0")){
                                colList.get(i).alias="";
                            }else{
                                if (el.getProperty("VISIBLE").equals("Y")){
                                    if (el.getProperty("Read").equals("Y")){
                                        line("<th>");line(MaskAncillaryChars(el.getProperty("CAPTION")));line("</th>");
                                        colList.get(i).schemaName=el.getProperty("ALIGNMENT").substring(0,1).replace("L","");
                                        switch (el.getProperty("DATA_TYPE")){
                                            case "NUMBER": case "DATE":  case "DATETIME":
                                                colList.get(i).schemaName=colList.get(i).schemaName+" W";
                                        }
                                        colList.get(i).schemaName.trim();
                                        if (is_not_null(colList.get(i).schemaName)){
                                            colList.get(i).schemaName=" class=\""+colList.get(i).schemaName+"\"";
                                        }
                                        realCol++;
                                        if (is_not_null(el.getProperty("TOTAL"))) needTot=true;
                                    } else colList.get(i).alias="";
                                }else colList.get(i).alias="";
                            }
                            
                        }
                        
                        line("</tr>");
                        
        //Итоги   
if (needTotS.equals("Y")){
if (app.NLS.currentLang.code.equals("RUS")){ 
    if(!progress("Подсчёт количества...",""))return "";
}
else {
    if(!progress("Calculating totals...",""))return ""; 
}
    
queryText="count(*) \"row$cnt\"";
                            for (int i=0;i<cols;i++){
                                if (is_not_null(colList.get(i).alias)){
                                    String colCode="";
                                    colCode=colList.get(i).alias;
                                    if (!frm.elements.containsKey(colCode))continue;
                                    LuiAppElement el=frm.elements.get(colCode);
                                    String totalExpr="";
                                    totalExpr=el.getProperty("TOTAL");
                                    
                                    if (is_not_null(totalExpr)){
                                        String format=el.getProperty("FORMAT");
                                        if (is_not_null(format)){
                                            totalExpr="to_char("+totalExpr+",'"+format+"')";
                                        }
                                        queryText=queryText+", "+totalExpr+" \""+el.getCode()+"\" \n";
                                    }
                                }
                            }
                            if (is_not_null(queryText)){
                                //queryText=LTrim(queryText,",");
                                queryText="select /*Total Row*/\n"+queryText+" from (\n"+frm.makeMainQuery()+"\n)q$total ";

   String qbewhere=frm.addWhere(lc,frm.getProperty("inner_qbe"),false);
   if (is_not_null(qbewhere)){
      if (frm.getProperty("inner_qbe").equals("Y")){
         if (queryText.indexOf("/*ADD_LUI$_INNER_QBE*/")>0) queryText=queryText.replace("/*ADD_LUI$_INNER_QBE*/"," and ("+qbewhere.substring(7)+")");
         else {
             if (queryText.indexOf("/*LUI$_INNER_QBE*/")>0) queryText=queryText.replace("/*LUI$_INNER_QBE*/",qbewhere);
         }
      } 
      else queryText=queryText+qbewhere+"\n";
   }
                            }
                            
                            tot=lc.getSelectFirstRowValMap(queryText);
                            totalRows=Integer.valueOf(tot.get("row$cnt"));
                            tot4Ind=totalRows;
                            if (tot4Ind>maxRows)tot4Ind=maxRows;
}

//основной цикл    
// расчитаем сколько раз показывать progress-bar
// 
                        int delta=1;
             if (tot4Ind<200) {delta=20;} //5раз
             else if (tot4Ind<1000) {delta=10;} //10раз
             else if (tot4Ind<20000) {delta=5;} //20раз
             else if (tot4Ind<50000) {delta=2;} //50раз
             
                        int r=0;
                        int oldPct=0;
                        int newPct=0;
                        ArrayList<String> row;
                        while (lc.CursorNextRow(cursor)){
                            r++; //увеличим счётчик строк
                            frm.setVal("FetchedRows",String.valueOf(r));
                            frm.setVal("CurrentRow",String.valueOf(r));
                             row=lc.CursorGetRow(cursor);
                            //устанавливаем значения элементов
                            for (int i=0;i<cols;i++){
                                String colCode="";
                                colCode=colList.get(i).alias;
                                 if (!frm.elements.containsKey(colCode))continue;
                                LuiAppElement el=frm.elements.get(colCode);
                                
                                   String ldt=el.getProperty("DATA_TYPE");
                                String valBuffer=row.get(i);
                                if (valBuffer==null){
              if ("EMPTY_STRING".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode) 
                      && is_not_null(app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol)){ //если есть особый режим работы с NULL
                  valBuffer=app.dataConverter.LuiDataTypes.get(ldt).nullSpecialSymbol;
              }
              }
              if ("".equals(valBuffer)){
              if ("NULL".equals(app.dataConverter.LuiDataTypes.get(ldt).emptyStringFromLuiMode)
                      && is_not_null(app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol)){ //если есть особый режим работы с NULL
                  valBuffer=app.dataConverter.LuiDataTypes.get(ldt).emptyStringSpecialSymbol;
              }
              }      
                
      el.setValue(valBuffer,false,"",false); // и запихиваем в значение столбца
                            }
                            // значения столбцов установлены
                            newPct=r*100/tot4Ind;
                            if (newPct-oldPct>=delta){
                                oldPct=newPct;
                            if (!progress(String.valueOf(r)+"/"+String.valueOf(tot4Ind),String.valueOf(newPct))) return "";
                              }
                            if (r>maxRows){
                                line("<tr class=\"Print_LastRow\"><td colspan=\"");line(String.valueOf(realCol));
                                if (app.NLS.currentLang.code.equals("RUS")){
                                    line("\">...Превышено разрешённое количество выводимых строк!</td></tr>");
                                } else {
                                    line("\">...Exceeded the allowed number of output lines!</td></tr>");
                                }
                                break;
                            }
                            line("<tr><th>"+String.valueOf(r)+"</th>");
                           
                            for (int i=0;i<cols;i++){
                                String colCode="";
                                colCode=colList.get(i).alias;
                                if (!frm.elements.containsKey(colCode))continue;
                                if (is_not_null(colList.get(i).alias)){
                                    line("<td"+colList.get(i).schemaName+">"+MaskXMLChars(NVL(row.get(i),""))+"</td>");
                                }
                            }
                            line("</tr>");
                        }
                        if (!progress("","100")) return "";
//Итоги                        
                        if (needTotS.equals("Y")){
                            
                            if (app.NLS.currentLang.code.equals("RUS")){
                                line("<tr><th>Всего строк:"+String.valueOf(totalRows)+"</th>");
                            } else {
                                line("<tr><th>Total "+String.valueOf(totalRows)+" rows</th>");
                            }
                            for (int i=0;i<cols;i++){
                                if (is_not_null(colList.get(i).alias)){
                                    String colCode=colList.get(i).alias;
                                    if (!frm.elements.containsKey(colCode))continue;
                                    LuiAppElement el=frm.elements.get(colCode);
                                    String totalExpr="";
                                    totalExpr=el.getProperty("TOTAL");
                                    if (tot!=null && tot.containsKey(colCode)&& is_not_null(totalExpr)){
                                        line("<td"+colList.get(i).schemaName+">"+MaskAncillaryChars(tot.get(colCode))+"</td>");
                                    }  else {
                                        line("<td></td>");
                                    }
                                }
                            }
                            line("</tr>");
                        }
                    } 
                    finally {
                     //   if (lc!=null){
                            if (cursor!=null && lc.CursorisOpen(cursor)) lc.CursorClose(cursor);
                            if (ac.getSessionMode()=='C') {
                                ac.connPool.SetFree(lc);
                            }
                     //   }
                        
                    }
                    
                }
            }
        }
        line("</table>");
        line("</body>");
        line("</html>");
        
     filew.flush();
     filew.close();
        
    } catch (IOException ex) {
        if (filew!=null){
                          try{
                              filew.flush();
                              filew.close();
                              filew=null;
                          } catch(Exception ef) {}
                        }
        app.msgWriter.write("LUI-00097",filename,ex.getMessage());
        
    }
           return app.getTmpDirURL()+"output.htm";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
          String fc=app.getVal("FormID");
          if (is_null(fc))return;
          if  (!app.forms.containsKey(fc)) return;
          String adr=compute(pString,pProp);
          if (is_not_null(adr)){
          LuiAppForm frm=app.forms.get(fc);
          LuiClCommandGroup XMLcg=app.commandWriter.addGroup("PRINT");
          LuiClCommand XMLcmd=XMLcg.addCommand("URL");
          XMLcmd.addScaPar("Address",adr);
          XMLcmd.addScaPar("Target","Tab");
          /*LuiClCommand XMLcmd=XMLcg.addCommand("Info");
          XMLcmd.addScaParameter("Code",fc,"");
          XMLcmd.addScaParameter("Title",frm.getProperty("HEADER"),"");
          XMLcmd.addScaParameter("Target","Tab","");
          String cont=compute(pString,pProp);
          XMLcmd.addScaPar("Content",cont);*/
          }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       
    }
private void line(String pString) throws IOException{
    filew.write(pString.replace("\n","<BR>").replace("[[[","<span class=Dynamic>").replace("]]]","</span>").replace("[[","<span>").replace("]]","</span>"));
    //content.append(pString.replace("\n","<BR>").replace("[[[","<span class=Dynamic>").replace("]]]","</span>").replace("[[","<span>").replace("]]","</span>"));
}
private boolean progress(String pText,String pPct) throws LuiException, SQLException{
    boolean retVal=true;
    if (elInd!=null){
      elInd.setProperty("VISIBLE","1");
      if (elIndOK!=null){
          elIndOK.setProperty("ACTIVE","N");
      }
      if (is_not_null(pText)){
         elInd.setProperty("HELPER_TEXT","   "+pText);  
      } else {
         elInd.setProperty("HELPER_TEXT","");
      }
      if (is_not_null(pPct)){
          elInd.setProperty("VISUALIZATION","PROGRESS PROC"+pPct);
          elInd.setProperty("Value","   "+pPct+"%");
      }else {
          elInd.setProperty("VISUALIZATION","");
          elInd.setProperty("Value","");
      }
      elInd.properties.get("Value").setChangeFlag();
      elInd.properties.get("HELPER_TEXT").setChangeFlag();
      elInd.properties.get("VISUALIZATION").setChangeFlag();
      elInd.properties.get("Show").setChangeFlag();
      frmInd.changes();
      XMLcg=app.commandWriter.addGroup("CallBack");
      XMLcmd=XMLcg.addCommand("Event");
      XMLcmd.addScaPar("EventCode", "ProgressContinue");
      XMLcmd.addScaPar("MS","0");
      app.commandWriter.flush();
      app.eventReader.readEvents();
      while (true){
        LuiClEvent ev=app.eventReader.getEvent();
        if (ev==null) break;
                if (ev.name.equals("ProgressContinue") ||ev.name.equals("GotoField") )retVal=true;
        else retVal=false;

        
        
     }
    }
return retVal;
}
}
