/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Выполнение действий над строками запроса
 * Compute отсутствует
 * Синтаксис Execute:
ProcQueryRows:<Имя свойства содержащего запрос>;<Коллекция параметров>

ActionBefore:<Имя свойства содержащего программу выполняемую перед запросом>;
ActionRow:<Имя свойства содержащего программу выполняемую для каждой строки запроса>;
ActionRowEx:<Имя свойства содержащего программу обработки ошибок строки>;
ActionAfter:<Имя свойства содержащего программу выполняемую в конце>;
Cancelable:Y/N; можно ли будет прерывать 
Title:<Имя свойства содержащего заголовок прогресс-бара>;
PercentText:<Имя свойства содержащего текст на прогресс-баре>;
WorkText:<Имя свойства содержащего текст под прогресс-баром>;

Имена свойств задаются в виде:
<ID формы>.<Код элемента или "Form">.<Код свойства>
Пример:
ProcQueryRows:{Property:FormID}.Form.QUERY_TEXT;ActionRow:{Property:FormID}.Form.MyAction;Title:{Property:FormID}.Form.MyActionName;
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;
import luiserver.LuiTask;

/**
 *
 * @author aliubushkin
 */
public class ProcQueryRows implements LuiPlugin{
LuiApplication app;
LuiTask task;
LuiAppForm frm;   
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return;
    }
    LuiCollection pCol= new LuiCollection("ProcQueryRows:"+pString);
    task=new LuiTask(frm);
    task.procQueryRows(pCol.Get_Element("ActionBefore"), 
            pCol.Get_Element("ProcQueryRows"),
            pCol.Get_Element("ActionRow"),
            pCol.Get_Element("ActionRowEx"),
            pCol.Get_Element("ActionAfter"),
            pCol.Get_Element("Cancelable"),
            pCol.Get_Element("Title"), 
            pCol.Get_Element("PercentText"), 
            pCol.Get_Element("WorkText"));
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
