/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/* Compute - вычисление значение столбца запроса задачи
Синтаксис Compute:{QC:<имя столбца>}
 * Execute отсутствует
 
 */
package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class QC implements LuiPlugin{
LuiApplication app;
LuiAppForm frm;        
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return null;
    }
    if (!frm.properties.containsKey("QC "+pString)) return null;
       frm.properties.get("QC "+pString).setDepend(pProp);
       return frm.getProperty("QC "+pString);
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
