/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/**
Подгружаемый класс, который вычисляет ответ на вопрос
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;

import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiPlugin;
import luiserver.LuiAppProp;
import luiserver.LuiAppWFE;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiClEvent;
import luiserver.LuiClEventReader;

/**
 * Question:Вопрос;Title:&lt;Заголовок окна&gt;;OK:Да;CANCEL:Нет;...;IfQuestionEmpty:Что возвращать если вопрос пуст;
 * @author aliubushkin
 */
public class Question implements LuiPlugin{
LuiApplication app;
LuiClCommandWriter cw;
LuiClEventReader er;
    @Override
    public void setContext(LuiApplication pContext) {
               app=pContext;  
               er=app.eventReader;
                       //new LuiClEventReader(app.eventReader.getReader(),app.msgWriter,app.TotalTimer);
               //cw=new LuiClCommandWriter(app.commandWriter.getWriter(),app.TotalTimer); 
               cw=app.commandWriter;
               
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        // установим зависимость от LastRunSCN чтобы LOV появился опять при выполнении действия
        if (pProp!=null){
        LuiAppWFE el=pProp.ownerObj;
        if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            el.properties.get("LastRunSCN").setDepend(pProp);
        } else {
          el=el.ownerObj;  
          if (el!=null){
        if (el.properties.containsKey("LastRunSCN")){
            if (pProp!=null)
            el.properties.get("LastRunSCN").setDepend(pProp);
        }
          }
        }
        }
        }
         LuiAppForm frm=null;
         if (pProp!=null) frm=pProp.ownerObj.getForm();
              if (frm==null) {
              String curFrmID=app.getVal("FormID");        
              if (app.forms.containsKey(curFrmID)){
              frm=app.forms.get(curFrmID);
              } else {
        //          System.out.println("Форма не нашлась!");
                 throw new LuiException("break","","","",null,"",app);
                  
              }}
        LuiClCommand XMLcmd;
        LuiCollection q=new LuiCollection("Question:"+pString);
        String question=q.Get_Element("Question");
        String title=NVL(q.Get_Element("Title"),app.NLS.NLS("RUS:Внимание;ENG:Attention;"));
        String ifQempty=q.Get_Element("IfQuestionEmpty");
        if (is_not_null(ifQempty) && is_null(question))return ifQempty;
        q.Erase_Element("Question");
        q.Erase_Element("Title");
        q.Erase_Element("IfQuestionEmpty");
        LuiCollection col=new LuiCollection("");
        for (String k:q.keySet()){
            if (is_not_null(q.get(k))){
                col.Add_Element(k,q.get(k));
            }
        }
        LuiClCommandGroup XMLcg=cw.addGroup("Question");
        XMLcmd=XMLcg.addCommand("ShowQuestion");
        XMLcmd.addScaPar("Question",question);
        XMLcmd.addScaPar("Title",title);
        XMLcmd.addScaPar("Buttons",col.toString());
        app.changes();
        app.getSeance().remZeroCmd();
        app.getSeance().remFrmWinApp();
        //app.pingRunTimer();
        
        LuiClEvent ev;
        String v=null;
        boolean b=true;      
        while (b){
        cw.flush();
        er.readEvents();
        while(true){
        ev=er.getEvent();
        if (ev==null)break;
        switch (ev.name){
            case "CancelLOV":
              b=false;
              if (q.size()>1){  // если кнопок больше одной - т.е. у пользователя есть выбор
                
              
                  
                      if (is_not_null(frm.getVal("CurrentAction"))){
                              throw new LuiException("break","","","",null,"",app);
                      }
                  
              
              break;}
              else { // меньше двух кнопок - выбора практически нет
                return "";
              }
            case "ChoiceLOV":
               b=false; 
              v= ev.getParValue("ID");
              break;
            case "Interval":
            app.interval(); 
            break;
            default:
             if (!ev.name.equals("ChoiceLOV") && !ev.name.equals("CancelLOV") && !ev.name.equals("Interval")
                ){   
              app.eventReader.eventList.add(0,ev);
              return "";
             }
            
        }
        }}
      if (v==null) { // если ответ остался пуст
          if (q.size()>1){  // если кнопок больше одной - т.е. у пользователя есть выбор
                
             
                  
                      if (is_not_null(frm.getVal("CurrentAction"))){
                              throw new LuiException("break","","","",null,"",app);
                      }
                  
              
              }
      }
      return v;
    }
    
    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     compute(pString, pProp); 
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      //  throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
 @Override
    public String quoteMask(String prefixString, String Value) {
        return Value.replace(";","#$");
    }        
}
