/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class RC implements LuiPlugin{
LuiApplication app;

    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       
       return comp(pString,pProp,false,false,null);
    }

    

   @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String lq=pString.split("=",2)[0];
        String rq="";
        if (pString.split("=",2).length>1)
        rq=pString.split("=",2)[1];
          comp(lq,pProp,false,true,rq);
    
     }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        comp(pString,pProp,true,false,null);
    }
     public String comp(String pString, LuiAppProp pProp,boolean pFindOnly,boolean exe,String pPropValue) throws LuiException, SQLException {
       LuiAppForm frm=pProp.ownerObj.getForm();
      ArrayList<Object> array=null;
      String semCond=null;
      String sem=null;
      String semval=null;
      boolean bs;
      boolean is_it_range=false; 
      String safeP=pString;
      pString=pString.replace(" ","");
      // отрежем и отложим в сторону условие на семантику
      int oci=pString.indexOf("(");
      if (oci>2){
        if (pString.indexOf(")")>oci){  
       semCond=pString.substring(oci);
       semCond=semCond.replace("(","").replace(")","").replace(" ","");
       pString=pString.substring(0, oci);
       if (semCond.indexOf("=")>1){
           sem=semCond.split("=",2)[0];
           semval=semCond.split("=",2)[1];
       }
      }
      }
    if (pString.indexOf(".")!=-1) {
        String frmID=pString.split("\\.",2)[0];
        if (app.forms.containsKey(frmID)){
           frm=app.forms.get(frmID);
           pString=pString.split("\\.",2)[1];
        }
    }
     if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "{RC:"+safeP+"}";
    }
     /***статистика***/
    String stat="";
    String innerStat="";
    try{
    stat=frm.getProperty("StatRC");
    }catch(Exception ex){}
    int StatCount=0;
    long StatTime=0;
    if (is_not_null(stat)){
        StatCount=Integer.valueOf(stat.split(" ")[0]);
        StatTime=Integer.valueOf(stat.split(" ")[1]);
    }
    try{
    innerStat=frm.getProperty("StatRCInnerComp");
    }catch(Exception ex){}
    int innerStatCount=0;
    long innerStatTime=0;
    if (is_not_null(innerStat)){
        innerStatCount=Integer.valueOf(innerStat.split(" ")[0]);
        innerStatTime=Integer.valueOf(innerStat.split(" ")[1]);
    }
    StatCount++;
    long StatStart=System.currentTimeMillis();
    /***статистика***/
    try{
     String PropCode="CELL_TEXT";
     if (pString.indexOf(".")!=-1) {
         PropCode=pString.split("\\.",2)[1];
         pString=pString.split("\\.",2)[0];
     }
     String r1c1=null;
     String r2c2=null;
     // диапазон?
     if (pString.indexOf(":")==-1){// нет 
         r1c1=getRC(pString,pProp,frm);
         r2c2=r1c1;
         is_it_range=false;
     } else {
         is_it_range=true;
         r1c1=getRC(pString.split(":")[0],pProp,frm);
         if (pString.split(":").length>1)
         r2c2=getRC(pString.split(":")[1],pProp,frm);  
         else r2c2="";
     }
     if (is_not_null(r1c1)&& is_not_null(r2c2)){
         int r1=Math.min(Integer.valueOf(r1c1.split(":")[0]),Integer.valueOf(r2c2.split(":")[0]));
         int r2=Math.max(Integer.valueOf(r1c1.split(":")[0]),Integer.valueOf(r2c2.split(":")[0]));
         int c1=Math.min(Integer.valueOf(r1c1.split(":")[1]),Integer.valueOf(r2c2.split(":")[1]));
         int c2=Math.max(Integer.valueOf(r1c1.split(":")[1]),Integer.valueOf(r2c2.split(":")[1]));
         String mk;
         LuiAppProp p;
         ArrayList<String> acell;
         for (int r=r1;r<=r2;r++){
             for (int c=c1;c<=c2;c++){
                mk=String.valueOf(r)+":"+String.valueOf(c);
                p=frm.MatrixGetCellP(mk, PropCode);
                if (p==null) continue;
                bs=true;
                if (sem!=null && semval!=null){
                    String v=app.parser.plugins.get("MatrixSemantics").compute(frm.getFormID()+"."+((LuiAppElement)p.ownerObj).Code+"."+sem, pProp);
                    if (!semval.equals(v))bs=false;
                }
                if (bs){
                    if (!exe) {
                        p.setDepend(pProp);
                        if (!pFindOnly){
                           if (array==null)array=new ArrayList<>();
                           String v="";
                           if (p.recalculate==null || !p.recalculate){
                           v=NVL(p.currentValue,"");
                           } else {
                           innerStatCount++;
                           long ilt=System.currentTimeMillis();    
                           v=NVL(p.getComputedProperty(),"");
                           innerStatTime=innerStatTime+(System.currentTimeMillis()-ilt);
                           }
                           
                           array.add(v);  
                        }
                    } else {
                        p.ownerObj.addProperty(PropCode, pPropValue);
                    } 
                }
                
             }
         }
         if (array==null && !exe && !pFindOnly){
            // при вычислении значения адресат не найден
            if (is_it_range) return "[]";
            return "0"; // возвращаем ноль
         }
         if (array!=null && array.size()>0 && !exe && !pFindOnly){
       if (/*array.size()>1 ||*/ is_it_range) return app.toJSON(array);
       else return array.get(0).toString();
    }
     }
      return "{RC:"+safeP+"}";
     } finally {
         frm.setProperty("StatRC",String.valueOf(StatCount)+" "+String.valueOf(StatTime+System.currentTimeMillis()-StatStart));
         frm.setProperty("StatRCInnerComp",String.valueOf(innerStatCount)+" "+String.valueOf(innerStatTime));
    }
     }
    public String getRC(String pString,LuiAppProp pProp,LuiAppForm pFrm) throws LuiException, SQLException{
        String c="c";
        if (pString.indexOf(",")>=0)c=",";
        else {if (pString.indexOf("c")==-1)return"";}
        String row="";
        if (pString.split(c).length>0)
                row=pString.split(c)[0].replace("r","");
        String col="";
        if (pString.split(c).length>1)
        col=pString.split(c)[1];
        
        Integer rn=getNo(row,pProp,pFrm,"ROW");
        Integer cn=getNo(col,pProp,pFrm,"COL");
        if (rn!=null && cn!=null) {
            return rn.toString()+":"+cn.toString();
        }
        return "";
    }
    public Integer getNo(String pNo,LuiAppProp pProp,LuiAppForm pFrm, String pTupleType) throws LuiException, SQLException{
       
       String sshift="0";
       int shift;
        if (pNo.indexOf("-")!=-1){
            sshift="-"+pNo.split("-")[1];
            pNo=pNo.split("-")[0];
        }
        if (pNo.indexOf("+")!=-1){
            sshift=pNo.split("\\+")[1];
            pNo=pNo.split("\\+")[0];
        }
        try {
            shift=Integer.valueOf(sshift);
        }catch(Exception ex){
            return null;
        }
        if (pNo.equals("X")||pNo.equals("T")){
            try {
               return Integer.valueOf(pFrm.getProperty("Current"+pTupleType+"N"))+shift;
            }catch(Exception ex){
            return null;
        }
            
        }
        if (pNo.equals("0")||pNo.equals("L")){
            try{
            return Integer.valueOf(pFrm.getProperty("Last"+pTupleType))+shift;
            }catch(Exception ex){
            return null;
            }
        }
        if (is_null(pNo)) {
            LuiAppElement e=pProp.getParentElement("CELL");
            if (e!=null){
              try{
                if (pTupleType.equals("ROW")) return Integer.valueOf(e.getProperty("RowNo"))+shift;
                else return Integer.valueOf(e.getProperty("ColNo"))+shift;
              } catch (Exception ex){
                  // ошибка преобразования номеров к целому, т.е. нечто странное
                  return null;
              }
            } else {
               String crc="Current"; if (pTupleType.equals("ROW")) crc=crc+"ROWN";else crc=crc+"COLN";
               if (pFrm.properties.containsKey(crc) && is_not_null(pFrm.properties.get(crc).currentValue)) {
                   return Integer.valueOf(pFrm.properties.get(crc).currentValue)+shift;
               } else
                e=pProp.getParentElement(pTupleType);
                if (e!=null)return Integer.valueOf(e.getProperty("ltn"))+shift;
            }
        }else {
           try { 
            return Integer.valueOf(pNo)+shift;
           }catch(Exception ex){
            return null;
            }
        }
        return null;
    }
}
