/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;

import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class RTeditor implements LuiPlugin {
LuiApplication app;
LuiClCommandWriter cw;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        cw=app.commandWriter;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
        return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return;
    if (frm.elements.containsKey(pString)){
     LuiAppElement el=frm.elements.get(pString);
     if (el.getType().equals("FIELD") || el.getType().equals("ITEM") ){   
       LuiClCommandGroup XMLcg=cw.addGroup("RTeditor for "+pString);
       LuiClCommand XMLcmd=XMLcg.addCommand("Editor");
       XMLcmd.addScaPar("FormID", frm.getFormID());
       XMLcmd.addScaPar("Field",el.getCode()) ;
     }
    }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       
    }
    
}
