/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Открыть приложение
 */
package Standard;
import LuiCollection.LuiCollection;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;
/**
 *
 * @author aliubushkin
 */
public class RunApplication implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       return app.name; 
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        LuiCollection c= new LuiCollection("RunApplication:"+pString);
        LuiClCommandGroup XMLcg=app.commandWriter.addGroup("RunApplication");
        LuiClCommand XMLcmd=XMLcg.addCommand("Event");
        XMLcmd.addScaPar("EventCode","Open");
        LuiCollection params=new LuiCollection("");
        params.Add_Element("AppCode", c.Get_Element("RunApplication"));
        params.Add_Element("Lang", c.Get_Element("LANG"));
        params.Add_Element("HostName", app.getProperty("ClientHostName"));
        params.Add_Element("URL", app.getProperty("ApplicationURL"));
        XMLcmd.addScaPar("Params",params.toString());
        XMLcmd.addScaPar("MS","1");
        return;           
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      //  throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
