/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;


import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.Filter;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.like;

import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import luiserver.LuiPlugin;
import java.sql.SQLException;
import java.util.ArrayList;

import luiserver.LuiAppConn;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiParser;

/**
 *
 * @author aliubushkin
 */
public class SQL implements LuiPlugin{
    LuiApplication app;

    @Override
    public void setContext(LuiApplication pContext) {
      app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws  LuiException,SQLException {
    
        return exe('C',pString,pProp);
        
    }
        
    
    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException,SQLException {
       
        exe('E',pString,pProp);
    }
    
    private String exe(char executeOrCompute,String pString,LuiAppProp pProp) throws  LuiException,SQLException{
    
    LuiAppConn ac=null;
    LuiDbConn lc=null;
    Integer cursor=null;
    String stmt;
    String mode="";
    StringBuilder sb=new StringBuilder();
    String res="";
    
   // if (like(pString,"%SPLITSHOW%")){
   //  String here="here";   
   // }
    // выясняем код формы
    LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return "";
    /*********статистика************/
    
    String stat=frm.getProperty("StatSQL");
    int StatCount=0;
    long StatTime=0;
    if (is_not_null(stat)){
        StatCount=Integer.valueOf(stat.split(" ")[0]);
        StatTime=Integer.valueOf(stat.split(" ")[1]);
    }
    StatCount++;
    long StatStart=System.currentTimeMillis();
    /*********статистика************/
    ArrayList<String> acs=app.getAppConnAndStmt(pString,"",frm.getFormID());
        
        ac=app.userDbConnections.get(acs.get(0));
        stmt=LuiParser.reMask(acs.get(1));
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=ac.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        }
        if (stmt.indexOf("(<=")==0){
            String from_var=stmt.substring(3,stmt.indexOf(")"));
            stmt=stmt.substring(stmt.indexOf(")")+1);
            
            if (frm.properties.containsKey("Var "+from_var)){
                stmt=stmt.replace("<="+from_var,frm.getVal(from_var));
                frm.properties.remove("Var "+from_var);
            }
        }
        try {
        
        if (executeOrCompute=='C'){
              
           if (stmt.indexOf("/*2JSONARRAY*/")>-1)mode="JSARRAY";
             //генерировать массив кажжый элемент тоже массив 
             // ['1',1],['2',2]
            if (stmt.indexOf("/*2JSONARRAY_NAME-VALUE*/")>-1)mode="JSARRAYNV";
            //генерировать массив кажжый элемент объект name:,value:[]
             // name в value входит
            if (stmt.indexOf("/*2JSONARRAY_NAME-VALUENN*/")>-1)mode="JSARRAYNVNN";
            //генерировать массив кажжый элемент объект name:,value:[]
             // name в value НЕ входит
            if (!mode.equals("")){
            /*  if (pString.charAt(0)=='⁞') {
                return "{SQL:"+pString+'}'; // отложенное выполнение???
              }*/
              int colcnt=0;
               cursor=lc.CursorOpen(stmt);
               ArrayList<ColInfo> ColsInfo= lc.CursorGetColsInfo(cursor);
               int cols=lc.CursorGetCols(cursor);
               ArrayList<String> row;
               String dbtype=lc.getDBvendor();
               int i;
               int rowcount=0;
               while(lc.CursorNextRow(cursor)){
                row=lc.CursorGetRow(cursor);
                if (row!=null){
                 rowcount++;
                 if (rowcount>1){
                   sb.append(",");
                 }
                 
                  colcnt=0;
                  for(i=0;i<cols;i++){
                   if (i==0){
                      if (mode.equals("JSARRAYNV")||mode.equals("JSARRAYNVNN")){
                          sb.append("{name:");
                          sb.append(app.str2JSON(row.get(0)));
                          sb.append(",value:");
                      } 
                      sb.append("[");
                       // очередной элемент всего массива 
                      if (mode.equals("JSARRAYNVNN")) continue;
                   }   
                   if (colcnt>0)sb.append(",");
                   colcnt++;
                   ColsInfo.get(i).LuiDATATYPE="CHAR";
                   if (app.dataConverter.dbmsTypes.containsKey(dbtype)){
                       if (app.dataConverter.dbmsTypes.get(dbtype).dataTypes.containsKey(ColsInfo.get(i).columnTypeName)){
                          ColsInfo.get(i).LuiDATATYPE=app.dataConverter.dbmsTypes.get(dbtype).dataTypes.get(ColsInfo.get(i).columnTypeName).LuiDataType;
                       }
                   }
                   if (ColsInfo.get(i).LuiDATATYPE.equals("NUMBER")){   
                       sb.append(row.get(i));
                   } else {
                       sb.append(app.str2JSON(row.get(i)));
                   }
                  }  
                 sb.append("]"); // завершение элемента всего массива 
                 if (mode.equals("JSARRAYNV")||mode.equals("JSARRAYNVNN")){sb.append("}");}
                } 
               }
            res=sb.toString();
            } else {
            res=lc.getSelectResult(stmt,0);
            }
            return NVL(res,"");
        }
        
        else {
            //lc.executeDML(stmt);
            res=lc.getSelectResult(stmt,0);
            return "";
        }
        } catch (SQLException ex){
           //if (frm!=null) {
               if (frm.getProperty("SuppressErrors").equals("Y")) return "";
           //} 
            app.msgWriter.sqlError(lc, ex, pProp, stmt);
            //app.msgWriter.write("LUI-00034","State:"+ex.getSQLState()+"\n"+ex.getLocalizedMessage()+" ("+pString+") ",pProp.getGenesis4msg() );
            return "";
        }
        finally {
         /*********статистика************/   
         frm.setProperty("StatSQL",String.valueOf(StatCount)+" "+String.valueOf(StatTime+System.currentTimeMillis()-StatStart));   
         /*********статистика************/
            if (cursor!=null){
                lc.CursorClose(cursor);
            }
            if (ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            }
        }
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {

    }
    
    @Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\'").length() % 2 == 1) Value=Value.replace("\'", "\'\'");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }

}