/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Запись строк запроса в массив JSON доступный для обращения из JS
*  Compute отсутствует
Execute
SQL2JSARRAY:(ARRAY:<ArrayName>;MODE:O/NV/NVNN;CONN:<код соединения>;)select c1,c2 from ...

 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.script.ScriptException;
import luiserver.LuiAppConn;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiParser;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class SQL2JSARRAY implements LuiPlugin{
LuiApplication app;


    @Override
    public void setContext(LuiApplication pContext) {
       app=pContext;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
    StringBuilder sb=new StringBuilder();
    int portion=2000;
        
        sb.setLength(0);
        LuiAppConn ac=null;
    LuiDbConn lc=null;
    Integer cursor=null;    
        String arrayName="JSARRAY";
        String mode="O";
        String stmt=pString;
        LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    if (frm==null)return;
    String conn="";
    if (pString.charAt(0)=='(') { // если начинается со скобки
            // ищем где она закрывается
            int cb=pString.indexOf(")"); 
            if (cb>0){// и если она закрывается
                String cols=pString.substring(1,cb); // будем подозревать, что там между скобками спрятана коллекция
                LuiCollection col=new LuiCollection(cols);
                arrayName=NVL(col.Get_Element("ARRAY"),arrayName);
                mode=NVL(col.Get_Element("MODE"),mode);
                conn=col.Get_Element("CONN");
                stmt=NVL(pString.substring(cb+1),"");
                if (is_null(stmt))return;
                if (is_not_null(conn))stmt="("+conn+")"+stmt;
            }
        }
    try {
    
    ArrayList<String> acs=app.getAppConnAndStmt(stmt,"",frm.getFormID()); 
    ac=app.userDbConnections.get(acs.get(0));
        stmt=LuiParser.reMask(acs.get(1));
        if (ac.getSessionMode()=='C') { // если соединение коммунальное, то получим из пула свободное
            lc=ac.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
        }
        else {//в противном случае возьмём текущее 
            lc=ac.currentConnection;
        }
        if (lc==null){ // если соединение так и не нашлось, то
        app.msgWriter.write("LUI-00020",". Lui:Null pointer detected!");
        }  
    int colcnt=0;
    
    cursor=lc.CursorOpen(stmt);    
                   ArrayList<ColInfo> ColsInfo= lc.CursorGetColsInfo(cursor);
               int cols=lc.CursorGetCols(cursor);
               ArrayList<String> row;
               String dbtype=lc.getDBvendor();
               int i;
               int rowcount=0;
               int pcount=0;
               sb.append(arrayName);
               sb.append(".push(");
               while(lc.CursorNextRow(cursor)){
                 row=lc.CursorGetRow(cursor);
                 if (row!=null){
                     if (rowcount==0) {
                          app.JSengine.eval("if ( typeof "+arrayName+"=='undefined')"+arrayName+"=[];");
                     } 
                     if (pcount>0) sb.append(",");
                     rowcount++;
                     pcount++;
                     colcnt=0;
                     for(i=0;i<cols;i++){
                       if (i==0){
                           if (mode.equals("NV")||mode.equals("NVNN")){
                          sb.append("{name:");
                          sb.append(app.str2JSON(row.get(0)));
                          sb.append(",value:");
                      } 
                      sb.append("[");
                       // очередной элемент всего массива 
                      if (mode.equals("NVNN")) continue;
                       }
                       if (colcnt>0)sb.append(",");
                       colcnt++;
                       ColsInfo.get(i).LuiDATATYPE="CHAR";
                       if (app.dataConverter.dbmsTypes.containsKey(dbtype)){
                       if (app.dataConverter.dbmsTypes.get(dbtype).dataTypes.containsKey(ColsInfo.get(i).columnTypeName)){
                          ColsInfo.get(i).LuiDATATYPE=app.dataConverter.dbmsTypes.get(dbtype).dataTypes.get(ColsInfo.get(i).columnTypeName).LuiDataType;
                       }
                          }
                       if (ColsInfo.get(i).LuiDATATYPE.equals("NUMBER")){   
                       sb.append(row.get(i));
                        } else {
                       sb.append(app.str2JSON(row.get(i)));
                           }
                     }
                     sb.append("]"); // завершение элемента всего массива 
                     if (mode.equals("NV")||mode.equals("NVNN")){sb.append("}");}
                   //  app.JSengine.eval(arrayName+".push("+sb.toString()+");");
                 }
                 if (pcount>=portion){
                     sb.append(");");
                     app.JSengine.eval(sb.toString());
                     pcount=0;
                     sb.setLength(0);
                     sb.append(arrayName);
                     sb.append(".push(");
                 }
               }
     if (pcount>0){
                     sb.append(");");
                     app.JSengine.eval(sb.toString());
                     pcount=0;
                     sb.append(arrayName);
                     sb.append(".push(");
                 }
    }catch(ScriptException jse){
        if (frm.getProperty("SuppressErrors").equals("Y")) return ;
        app.msgWriter.write("LUI-00033",jse.getMessage()+"("+pString+")"+" "+pProp.getGenesis4msg()); 
    }catch(SQLException sqle){
        if (frm.getProperty("SuppressErrors").equals("Y")) return ;
        app.msgWriter.sqlError(lc, sqle, pProp, stmt); return ;
    }finally {
        sb.setLength(0);
        if (lc!=null){
            if (cursor!=null){
                lc.CursorClose(cursor);
            }
            if (ac!=null && ac.getSessionMode()=='C') { // если соединение коммунальное, то вернём соединение в пул свободных
                ac.connPool.SetFree(lc);
            }
        }}
    }
    
    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}
