/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Вычисление значения проперти Series элемента диаграммы
 */
package Standard;

import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class Series  implements LuiPlugin{
   LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
     public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       return comp(pString,pProp,false);
     }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        comp(pString,pProp,true);
    }
     public String comp(String pString, LuiAppProp pProp,boolean pFindOnly) throws LuiException, SQLException {
         LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return "";
    }
     if (frm.elements.containsKey(pString)){ //если есть такой элемент
         if (frm.elements.get(pString).properties.containsKey("Series")) { // и у этого элемента есть свойство Series
              frm.elements.get(pString).properties.get("Series").setDepend(pProp);
              if (pFindOnly) return null;
              String retval= NVL(frm.elements.get(pString).properties.get("Series").getComputedProperty(),"");
              return retval;
         }
     }
    return null;
     }
}
