/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/* 
Выдача сообщений на клиента
Синтаксис вычисления:
ShowMwssage:<код сообщения>;[REMOVE:Y/N;];p1:<значение параметра1>;p2:<значение параметра2>;...
REMOVE:N-- сообщение не удаляется из стека и будет показано на экране
REMOVE:Y-- сообщение удаляется из стека и не будет показано на экране

Синтаксис выполнения:
ShowMwssage:<код сообщения>;p1:<значение параметра1>;p2:<значение параметра2>;...


 */
package Standard;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class ShowMessage implements LuiPlugin{
    LuiApplication app;
    

    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String remove="Y";
        pString=LuiString.RTrim(pString);
        if (pString.charAt(pString.length()-1)!=';'){
            pString=pString+";";
        }
        LuiCollection msg=new LuiCollection("ShowMessage:"+pString);
        String msgCode=msg.Get_Element("ShowMessage");
        msg.Erase_Element("ShowMessage");
        if (msg.containsKey("REMOVE")){
          remove=NVL(msg.get("REMOVE"),"N");
          msg.Erase_Element("REMOVE");
        }
        String params[]=null;
        int s=msg.size();
        params=new String[s];
        int i=0;
        for (String pke:msg.keySet()){
          
           params[i]=msg.get(pke);
          
           i++; 
        }
        app.msgWriter.write(msgCode,params);
        i=app.msgWriter.msgArray.size();
        String msgtxt="";
        if (i>0) {
                msgtxt=app.msgWriter.msgArray.get(i-1).toString();
                if (!"N".equals(remove))
                app.msgWriter.msgArray.remove(i-1);
        }
        return msgtxt;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        pString=LuiString.RTrim(pString);
        if (pString.charAt(pString.length()-1)!=';'){
            pString=pString+";";
        }
        LuiCollection msg=new LuiCollection("ShowMessage:"+pString);
        String msgCode=msg.Get_Element("ShowMessage");
        msg.Erase_Element("ShowMessage");
        if (msg.containsKey("REMOVE")){
          msg.Erase_Element("REMOVE");
        }
        String params[]=null;
        int s=msg.size();
        params=new String[s];
        int i=0;
        for (String pke:msg.keySet()){
            
           params[i]=msg.get(pke);
            
           i++; 
        }
        app.msgWriter.write(msgCode,  params);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
 @Override
    public String quoteMask(String prefixString, String Value) {
        return Value.replace(";","#$");
    }    
 
}
