/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Генерация статистики открытых форм
 * Синтаксис действия Statistic:<Заголовок>
 * and open the template in the editor.
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.like;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.Connection;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import luiserver.LuiAppConn;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;

import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;
import static LuiCollection.LuiString.Add_If_Not_Null;
import static LuiCollection.LuiString.MaskXMLChars;
import static LuiCollection.LuiString.NVL;
import luiserver.LuiParser;
import static luiserver.LuiParser.reMask;

/**
 * Генерация страницы со статистикой приложения 
 Statistic:&lt;заголовок&gt;
 * @author aliubushkin
 */
public class Statistic implements LuiPlugin{
LuiApplication app;
StringBuilder content;
Integer allTotalStatComp=0;
Integer allTotalStatTime=0;
int di=0;

    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
Integer totalStatComp;
Integer totalStatTime;
content=new StringBuilder();
        line("<html>");
        line("<head>");
        Date currentDate = new Date();
        line("<title>");line(pString+" "+currentDate);line("</title>");
       // line("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1251\"/>");
        line("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"/>");
        String css="";
        LuiDbConn lc=null;
    try{
    lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());  
    css=lc.getSelectResult("select lui_f_get_application_property('"+app.code+"','STATISTIC_CSS','"+app.NLS.currentLang.code+"')");
    } finally {
        if (lc!=null) {
        app.metaConnPool.SetFree(lc);
        lc=null;
        }
    }
        content.append(css);
        line("</head>");
        line("<body class=\"AAA\">");
        line("<div id=\"InfoRoot\" class=\"Container Hidable\">");    
        line("<div class=\"Title\">"+pString+" "+currentDate+",SCN="+app.getCurrentSCN()+"</div>");
        line("<div class=\"Variables\" onclick=\"Set($('InfoRoot'),'-Hidable')\">"+app.NLS.NLS("RUS:Показать всё;ENG:Display all;")+"</div>");
        // приложение
        line("<div class=\"Hided\">");
        totalStatComp=0;
        totalStatTime=0;
        line("<div id=\"Info"+app.code+"\" class=\"Container Hide Property Variable\">");
        line("<div class=\"TitleShow\" onclick=\"Hide($('Info"+
             app.code+
             "'))\">"+
             app.NLS.NLS(app.name)+
             "</div>");   
        line("<div class=\"TitleHidden\" onclick=\"Show($('Info"+
             app.code+
             "'))\">"+
             app.NLS.NLS(app.name)+   
             "</div>");
        line("<div class=\"Hided\">");
        // соединения с БД
        line("<div id=\"Info"+app.code+"_Connections\" class=\"Container Hide\">");
        line("<div class=\"TitleShow\" onclick=\"Hide($('Info"+app.code+"_Connections'))\">"+app.NLS.NLS("RUS:Соединения с базами данных;ENG:Database connections;")+"</div>");
        line("<div class=\"TitleHidden\" onclick=\"Show($('Info"+app.code+"_Connections'))\">"+app.NLS.NLS("RUS:Соединения с базами данных;ENG:Database connections;")+"</div>");
        line("<div class=\"Hided\">");
        line("<Table class=\"TabInfo\">");
         // заголовок таблицы соединений
         
         line("<tr class=\"Title\">"+                   
                "<th>"+app.NLS.NLS("RUS:Код;ENG:Code;")+"</th>"+
                 "<th>"+app.NLS.NLS("RUS:Название;ENG:Name;")+"</th>"+
                 "<th>"+app.NLS.NLS("RUS:Режим;ENG:Mode;")+"</th>"+
                 "<th>"+app.NLS.NLS("RUS:Имя пользователя;ENG:Username;")+"</th>"+
                 "<th>"+app.NLS.NLS("RUS:URL;ENG:URL;")+"</th>"+
                 "<th>"+app.NLS.NLS("RUS:Схема;ENG:Schema;")+"</th>"+
                 "<th>"+app.NLS.NLS("RUS:Состояние;ENG:Status;")+"</th></tr>");
        // строки таблицы соединений
        for (String connCode:app.userDbConnections.keySet()){
            line("<tr>");
            LuiAppConn ac=app.userDbConnections.get(connCode);
             line("<td>"+connCode+"</td>");
             line("<td>"+ac.name+"</td>");
             line("<td>"+ac.mode+"</td>");
             line("<td>"+ac.username+"</td>");
             line("<td>"+ac.dbURL+"</td>");
             line("<td>"+ac.schema+"</td>");
            if (ac.currentConnection==null) {
             line("<td>"+"disconnect"+"</td>"); 
            } else {
               lc=ac.currentConnection; 
               Connection c=lc.getConnection();
               if (c.isValid(0)){
                   line("<td>"+"valid\n");
                   try{
                   if (lc.isTransaction()) line("transactions:Y\n");
                   else line("transactions:N\n");
                   } catch (Exception ex){
                      line("transactions: \n");     
                           }
                   Date dt = new Date(lc.getLastActivity());
                   SimpleDateFormat df = new SimpleDateFormat("dd.MM.yyyy HH:mm:ss SSS");
                   String s=df.format(dt);
                   line("Last activity:"+s+"\n");
                   line("Opened cursors:"+lc.CursorOpenedCount()+"\n");
                   line("</td>");
               } else {
                   line("<td>"+"invalid"+"</td>"); 
               }
            }
            line("</tr>");
        }
        line("</Table>");
        line("</div>");
        line("</div>");
        
        //свойства и переменые                
        line("<div class=\"Title\">"+app.NLS.NLS("RUS:Свойства и переменные приложения;ENG:Application properies and variables;")+"</div>");
        line("<div class=\"Variables\" onclick=\"Set($('Info'"+app.code+"'),'+Property +Variable +HC +Depends')\">"+app.NLS.NLS("RUS:Показать всё;ENG:Display all;")+"</div>");
        addSwitch("Info"+app.code,"Property",app.NLS.NLS("RUS:Показать свойства;ENG:Display properties;"),app.NLS.NLS("RUS:Скрыть свойства;ENG:Hide properies;"));
        addSwitch("Info"+app.code,"Variable",app.NLS.NLS("RUS:Показать переменные;ENG:Display variables;"),app.NLS.NLS("RUS:Скрыть переменные;ENG:Hide variables;"));
        addSwitch("Info"+app.code,"HC",app.NLS.NLS("RUS:Показать статистику вычислений;ENG:Dispay calculation statistics;"),app.NLS.NLS("RUS:Скрыть статистику вычислений;ENG:Hide calculation statistics;"));
        addSwitch("Info"+app.code,"Depends",app.NLS.NLS("RUS:Показать зависимости;ENG:Dispay dependencies;"),app.NLS.NLS("RUS:Скрыть зависимости;ENG:Hide dependencies;"));
        line("<Table class=\"TabInfo\">");
        line("<tr class=\"Title\">"+                   
                "<th>"+app.NLS.NLS("RUS:Свойство;ENG:Property;")+"</th>"+
                "<th>"+app.NLS.NLS("RUS:Исходное значение;ENG:Source value;")+"</th>"+
                "<th>"+app.NLS.NLS("RUS:Текущее значение;ENG:Current value;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Разм.;ENG:Size;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Обр.;ENG:Get;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Выч.;ENG:Сalc;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Врем.;ENG:Time;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:NCF;ENG:NCF;")+"</th>"+
                "<th class=\"Switchable Depends\">"+app.NLS.NLS("RUS:Зависимости;ENG:Dependencies;")+"</th></tr>");
        for (String key:app.getSortedProps().keySet()){
         if (key.equals("CALCULATOR_HTM")) continue;
         if (key.equals("HELP_CSS")) continue;
         if (key.equals("PRINT_CSS")) continue;
         if (key.equals("STATISTIC_CSS")) continue;
         if (like(key,"Var%")){
            line("<tr class=\"Switchable Variable\">");
         } else {
             line("<tr class=\"Switchable Property\">");
         }
         LuiAppProp p=app.properties.get(key);
             line("<td>"+key+"</td>");
             line("<td>"+LuiParser.reMask(NVL(p.startedValue,""))+"</td>");
             //line("<td>"+p.startedValue+"</td>");
             line("<td>"+LuiParser.reMask(NVL(p.currentValue,""))+"</td>");
             line("<td class=\"Switchable HC\">"+LuiParser.reMask(NVL(p.currentValue,"")).length()+"</td>");
             line("<td class=\"Switchable HC\">"+p.statGet+"</td>");
             line("<td class=\"Switchable HC\">"+p.statComp+"</td>");
             line("<td class=\"Switchable HC\">"+p.statTime+"</td>");
             if (p.recalculate==null) {
             line("<td class=\"Switchable HC\"></td>");    
             } else
             line("<td class=\"Switchable HC\">"+NVL(p.recalculate.toString(),"")+"</td>");
             line("<td class=\"Switchable Depends\">");
             di=0;
             for (LuiAppProp dp:p.depends.keySet()){
              if (di==0) line(app.NLS.NLS("RUS:Определяет:;ENG:Define: ;")+"<br>");
              di++;
              line(dp.getGenesis()+"<br>");
             }
             di=0;
             for (LuiAppProp dp:p.dependsFrom.keySet()){
              if (di==0) line(app.NLS.NLS("RUS:Зависит от:;ENG:Depends from: ;")+"<br>");
              di++;
              line(dp.getGenesis4dmp()+"<br>");
             }
             totalStatComp=totalStatComp+p.statComp;
             totalStatTime=totalStatTime+p.statTime;
             line("</td>");
             line("</tr>");
        }
        line("<tr class=\"Switchable HC\"><td>"+app.NLS.NLS("RUS:Итого;ENG:Total;")+":</td><td></td><td></td><td></td><td></td>"+
                   "<td>"+totalStatComp+"</td><td>"+totalStatTime+"</td><td></td><td class=\"Switchable Depends\"></td></tr>");
        line("</Table>");
        line("</div>");
        line("</div>");
        allTotalStatComp=allTotalStatComp+totalStatComp;
        allTotalStatTime=allTotalStatTime+totalStatTime;

        // формы
        for (String FrmID:app.forms.keySet()){
//            if (!FrmID.equals("FRM9+PROPERTY")) continue;
             totalStatComp=0;
             totalStatTime=0;
             LuiAppForm frm=app.forms.get(FrmID);
             line("<div id=\"Info"+FrmID+"\" class=\"Container Hide Property Variable\">");
             line("<div class=\"TitleShow\" onclick=\"Hide($('Info"+FrmID+"'))\">"+
                     frm.getName4Report()+" ("+frm.properties.get("HEADER").startedValue+")</div>");
             line("<div class=\"TitleHidden\" onclick=\"Show($('Info"+FrmID+"'))\">"+
                     frm.getName4Report()+Add_If_Not_Null(frm.getProperty("ConfigName")," (",")")+"</div>");
             line("<div class=\"Hided\">");                     
          elements(frm,"PARAM","Form",allTotalStatComp,allTotalStatTime);
             line("<div class=\"Title\">"+app.NLS.NLS("RUS:Свойства и переменные;ENG:Properties and variables;")+" ");
             switch (frm.getType()){
                 case "LIST":
                  line(app.NLS.NLS("RUS:cписка;ENG:of list;"));
                 break;
                 case "BLANK":
                  line(app.NLS.NLS("RUS:бланка;ENG:of blank;"));   
                 break;
                 case "TREE":
                  line(app.NLS.NLS("RUS:дерева;ENG:of tree;"));
                  break;
                 case "MENU":
                  line(app.NLS.NLS("RUS:меню;ENG:of menu;"));
                  break;
                 case "HOST":
                  line(app.NLS.NLS("RUS:команды ОС;ENG:of OS command;"));  
                 break;
                 case "CHART":
                  line(app.NLS.NLS("RUS:диаграммы;ENG:of chart;"));  
                 break;

                 default:
                  line(app.NLS.NLS("RUS:формы;ENG:of form;"));    
             }
             line("</div>");
             line("<div class=\"Variables\" onclick=\"Set($('Info"+FrmID+"'),''+Property +Variable +HC +Depends')\">"+app.NLS.NLS("RUS:Показать всё;ENG:Dispay all;")+"</div>");
             addSwitch("Info"+FrmID,"Property",app.NLS.NLS("RUS:Показать свойства;ENG:Dispay properties;"),app.NLS.NLS("RUS:Скрыть свойства;ENG:Hide properties;"));
             addSwitch("Info"+FrmID,"Variable",app.NLS.NLS("RUS:Показать переменные;ENG:Dispay variables;"),app.NLS.NLS("RUS:Скрыть переменные;ENG:Hide variables;"));
             addSwitch("Info"+FrmID,"HC",app.NLS.NLS("RUS:Показать статистику;ENG:Dispay calculation statistics;"),app.NLS.NLS("RUS:Скрыть статистику;ENG:Hide calculation statistics;"));
             addSwitch("Info"+FrmID,"Depends",app.NLS.NLS("RUS:Показать зависимости;ENG:Dispay dependencies;"),app.NLS.NLS("RUS:Скрыть зависимости;ENG:Hide dependencies;"));
             line("<Table class=\"TabInfo\">");
             line("<tr class=\"Title\">"+                   
                "<th>"+app.NLS.NLS("RUS:Свойство;ENG:Property;")+"</th>"+
                "<th>"+app.NLS.NLS("RUS:Исходное значение;ENG:Source value;")+"</th>"+
                "<th>"+app.NLS.NLS("RUS:Текущее значение;ENG:Current value;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Разм.;ENG:Size;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Обр.;ENG:Get;")+"</th>"+                     
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Выч.;ENG:Сalc;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Врем.;ENG:Time;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:NCF;ENG:NCF;")+"</th>"+
                "<th class=\"Switchable Depends\">"+app.NLS.NLS("RUS:Зависимости;ENG:Dependencies;")+"</th></tr>");
             for (String key:frm.getSortedProps().keySet()){
         if (like(key,"Var%")){
            line("<tr class=\"Switchable Variable\">");
         } else {
             line("<tr class=\"Switchable Property\">");
         }
         LuiAppProp p=frm.properties.get(key);
             line("<td>"+key+"</td>");
             //line("<td>"+LuiParser.reMask(NVL(p.startedValue,""))+"</td>");
             line("<td>"+MaskXMLChars(LuiParser.reMask(NVL(p.startedValue,"")))+"</td>");
             String v=MaskXMLChars(LuiParser.reMask(NVL(p.currentValue,"")));
             line("<td>"+NVL(v,"")+"</td>");
             int l=v.length();
             line("<td class=\"Switchable HC\">"+l+"</td>");
             line("<td class=\"Switchable HC\">"+p.statGet+"</td>");
             line("<td class=\"Switchable HC\">"+p.statComp+"</td>");
             line("<td class=\"Switchable HC\">"+p.statTime+"</td>");
             if (p.recalculate==null) {
             line("<td class=\"Switchable HC\"></td>");    
             } else
             line("<td class=\"Switchable HC\">"+NVL(p.recalculate.toString(),"")+"</td>");
             line("<td class=\"Switchable Depends\">");
             di=0;
             for (LuiAppProp dp:p.depends.keySet()){
              if (di==0) line(app.NLS.NLS("RUS:Определяет:;ENG:Define: ;")+"<br>");
              di++;
              line(dp.getGenesis4dmp()+"<br>");
             }
             di=0;
             for (LuiAppProp dp:p.dependsFrom.keySet()){
              if (di==0) line(app.NLS.NLS("RUS:Зависит от:;ENG:Depends from: ;")+"<br>");
              di++;
              line(dp.getGenesis4dmp()+"<br>");
             }
             totalStatComp=totalStatComp+p.statComp;
             totalStatTime=totalStatTime+p.statTime;
             line("</td>");
             line("</tr>");
        } //конец цикла по св-вам формы
        line("<tr class=\"Switchable HC\"><td>"+app.NLS.NLS("RUS:Итого;ENG:Total;")+":</td><td></td><td></td><td></td><td></td>"+
                   "<td>"+totalStatComp+"</td><td>"+totalStatTime+"</td><td></td><td class=\"Switchable Depends\"></td></tr>");
            line("</Table>");    
         
         if(frm.getType().equals("LIST")||frm.getType().equals("TREE")||frm.getType().equals("MENU")) {
             line("<div id=\""+FrmID+"$CheckedRows\" class=\"Container Hide\">");
             line("<div class=\"TitleShow\" onclick=\"Hide($('"+FrmID+"$CheckedRows'))\">"+app.NLS.NLS("RUS:Отмеченные строки (режим = ;ENG:Marked rows (mode = ;")+
                     frm.getProperty("SelectionMode")+
                     app.NLS.NLS("RUS:, инверсия = ;ENG:, inversion = ;")+frm.getProperty("Inversion")+")</div>");
             
             //line("<div class=\"TitleHidden\" onclick=\"Show($('"+FrmID+"$CheckedRows'))\">"+app.NLS.NLS("RUS:Отмеченные строки ;ENG:Marked rows ;(")+String.valueOf(frm.checkRows.size())+")</div>");
             line("<div class=\"TitleHidden\" onclick=\"Show($('"+FrmID+"$CheckedRows'))\">"+app.NLS.NLS("RUS:Отмеченные строки;ENG:Marked rows;") + " (" + String.valueOf(frm.checkRows.size())+")</div>");
             line("<div class=\"Hided\">");
             line("<Table class=\"TabInfo\">");
             line("<tr class=\"Title\">");
             line("<th>"+app.NLS.NLS("RUS:Ключи строк;ENG:Rows keys;")+"</th>");   
             line("</tr>");
             for (LuiCollection UK:frm.checkRows.keySet()){
             line("<tr>");    
             line("<td>"+UK.toString()+"</td>");
             line("</tr>");
             }
             line("</Table>");
             line("</div>");
             line("</div>");
         }

    elements(frm,"","Form",allTotalStatComp,allTotalStatTime);
         allTotalStatComp=allTotalStatComp+totalStatComp;
         allTotalStatTime=allTotalStatTime+totalStatTime;
         line("<div>"+app.NLS.NLS("RUS:Вычислений;ENG:Calculations;")+":"+allTotalStatComp+", "+
            app.NLS.NLS("RUS:Общее время;ENG:Total time;")+": "+allTotalStatTime+"</div>");
         line("</div>"); //hided
         line("</div>");// Conteainer
        } // конец цикла по формам

        line("</div>"); //hided
         line("</div>");// Conteainer
        line("</body>");
        line("</html>");
        return content.toString();
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        LuiClCommandGroup XMLcg=app.commandWriter.addGroup("STATISTIC");
        LuiClCommand XMLcmd=XMLcg.addCommand("Info");
        XMLcmd.addScaPar("Code",app.code);
        XMLcmd.addScaPar("Title",NVL(pString,"Statistics"));
        XMLcmd.addScaPar("Target","Tab");
        //XMLcmd.addScaPar("Target","Float");
        String cont=compute(pString,pProp);
        XMLcmd.addScaPar("Content",cont);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     //   throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
private void elements(LuiAppForm pFrm,String pElType,String pElParent,Integer totalComp,Integer totalTime) throws LuiException, SQLException{
    
    // крутим элементы по порядку
    int cnt=0;
    String parentTypeName="";
    String typeName="";
    String parentType="";
    String ID="";
    LuiAppElement el=null;
    Integer totalStatComp=0;
    Integer totalStatTime=0;
    Integer allTotalStatComp=0;
    Integer allTotalStatTime=0;
    pFrm.elSort(0);
    for (int i=0;i<pFrm.elements.size();i++){
        el=pFrm.elSortedList.get(i);
        if (!(el.getParent().equals(pElParent))) continue;
        if(is_not_null(pElType)){
        if (!(el.getType().equals(pElType))) continue;
        } else {
         if (pElParent.equals("Form") && el.getParent().equals("Form") && el.getType().equals("PARAM")) continue;
        }
        if (cnt==0){
        if (!pElParent.equals("Form")){
            parentType=pFrm.elements.get(pElParent).getType();
            switch (parentType){
                case "ACTION":
                  if (pFrm.getType().equals("MENU"))  
                   parentTypeName=app.NLS.NLS("RUS:Параметры действия и подчинённые действия;ENG:Action output parameters and sub-actions;");    
                  else parentTypeName=app.NLS.NLS("RUS:Параметры действия;ENG:Action output parameters;");
                break;
                case "ITEM":
                    parentTypeName=app.NLS.NLS("RUS:Локальные действия столбца;ENG:Column local actions;");
                break;
                case "FIELD":
                    parentTypeName=app.NLS.NLS("RUS:Локальные действия поля;ENG:Field local actions;");
                break;
                case "GROUP":
                    parentTypeName=app.NLS.NLS("RUS:Элементы группы;ENG:Group elements;");
                break;
                default :
                    parentTypeName=app.NLS.NLS("RUS:Подчинённые элементы;ENG:Subelements;");
            }
        } else {
           if (pElType.equals("PARAM")) {
               parentTypeName=app.NLS.NLS("RUS:Входные параметры формы;ENG:Form input parameters;");
           } else {
               parentTypeName=app.NLS.NLS("RUS:Элементы формы;ENG:Form elements;");
               
           }
        }
        ID="Info"+pFrm.getFormID()+"$"+pElParent+"_"+pElType;
        line("<div id=\""+ID+"\" class=\"Container Hide\">");
        line("<div class=\"TitleShow\" onclick=\"Hide($('"+ID+"'))\">"+parentTypeName+"</div>");
        line("<div class=\"TitleHidden\" onclick=\"Show($('"+ID+"'))\">"+parentTypeName+"</div>");
        line("<div class=\"Hided\">");
        }
        
        cnt++;
        totalStatComp=0;
        totalStatTime=0;
        el=pFrm.elSortedList.get(i);
        ID="Info"+pFrm.getFormID()+"$_"+el.getCode();
        line("<div id=\""+ID+"\" class=\"Container Hide\">");
        switch (el.getType()){
            case "PARAM":
                typeName=app.NLS.NLS("RUS:Параметр;ENG:Parameter;");
                break;
            case "ACTION":
                typeName=app.NLS.NLS("RUS:Действие;ENG:Action;");
                break;
            case "ITEM":
                typeName=app.NLS.NLS("RUS:Столбец;ENG:Column;");
                break;    
            case "FIELD":
                typeName=app.NLS.NLS("RUS:Поле;ENG:Field;");
                break;
            case "GROUP":
                typeName=app.NLS.NLS("RUS:Группа;ENG:Group;");
                break;
            default:
                typeName=app.NLS.NLS("RUS:Элемент;ENG:Element;");
        }
        //typeName=typeName+" "+el.getName4show();
            typeName=typeName+" "+el.getCode()+" "+el.getName4show();
            line("<div class=\"TitleShow\" onclick=\"Hide($('"+ID+"'))\">"+typeName+"</div>");
            line("<div class=\"TitleHidden\" onclick=\"Show($('"+ID+"'))\">"+typeName+"</div>");
            line("<div class=\"Hided\">");
           addSwitch(ID,"HC",app.NLS.NLS("RUS:Показать статистику;ENG:Display statistic;"),app.NLS.NLS("RUS:Скрыть статистику;ENG:Hide statistic;"));
            addSwitch(ID,"Depends",app.NLS.NLS("RUS:Показать зависимости;ENG:Dispay dependencies;"),app.NLS.NLS("RUS:Скрыть зависимости;ENG:Hide dependencies;"));
            line("<Table class=\"TabInfo\">");
            line("<tr class=\"Title\">"+                   
                "<th>"+app.NLS.NLS("RUS:Свойство;ENG:Property;")+"</th>"+
                "<th>"+app.NLS.NLS("RUS:Исходное значение;ENG:Source value;")+"</th>"+
                "<th>"+app.NLS.NLS("RUS:Текущее значение;ENG:Current value;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Разм.;ENG:Size;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Обр.;ENG:Get;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Выч.;ENG:Сalc;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:Врем.;ENG:Time;")+"</th>"+
                "<th class=\"Switchable HC\">"+app.NLS.NLS("RUS:NCF;ENG:NCF;")+"</th>"+
                "<th class=\"Switchable Depends\">"+app.NLS.NLS("RUS:Зависимости;ENG:Dependencies;")+"</th></tr>");
            for (String key:el.getSortedProps().keySet()){
         if (like(key,"Var%")){
        line("<tr class=\"Switchable Variable\">");
         } else {
             line("<tr class=\"Switchable Property\">");
         }
         LuiAppProp p=el.properties.get(key);
             line("<td>"+key+"</td>");
             if ("Value".equals(key)) {
               if (el.properties.containsKey("CHANGING")) {
                 if (el.properties.get("CHANGING").currentValue.equals("H")){
                     p.startedValue="******";
                     p.currentValue="******";
                 }  
               }   
             } 
             line("<td>"+LuiString.MaskXMLChars(reMask(NVL(p.startedValue,"")))+"</td>");
             line("<td>"+LuiString.MaskXMLChars(reMask(p.currentValue))+"</td>");
             line("<td class=\"Switchable HC\">"+LuiParser.reMask(NVL(p.currentValue,"")).length()+"</td>");
             line("<td class=\"Switchable HC\">"+p.statGet+"</td>");
             line("<td class=\"Switchable HC\">"+p.statComp+"</td>");
             line("<td class=\"Switchable HC\">"+p.statTime+"</td>");
             if (p.recalculate==null) {
             line("<td class=\"Switchable HC\"></td>");    
             } else
             line("<td class=\"Switchable HC\">"+NVL(p.recalculate.toString(),"")+"</td>");
             line("<td class=\"Switchable Depends\">");
             di=0;
             for (LuiAppProp dp:p.depends.keySet()){
              if (di==0) line(app.NLS.NLS("RUS:Определяет:;ENG:Define: ;")+"<br>");
              di++;
              line(dp.getGenesis4dmp()+"<br>");
             }
             di=0;
             for (LuiAppProp dp:p.dependsFrom.keySet()){
              if (di==0) line(app.NLS.NLS("RUS:Зависит от:;ENG:Depends from: ;")+"<br>");
              di++;
              line(dp.getGenesis4dmp()+"<br>");
             }
             totalStatComp=totalStatComp+p.statComp;
             totalStatTime=totalStatTime+p.statTime;
             line("</td>");
             line("</tr>");
        }
        line("<tr class=\"Switchable HC\"><td>"+app.NLS.NLS("RUS:Итого;ENG:Total;")+":</td><td></td><td></td><td></td><td></td>"+
                     "<td>"+totalStatComp+"</td><td>"+totalStatTime+"</td><td></td><td class=\"Switchable Depends\"></td></tr>");
              line("</Table>");

        elements(pFrm,"",el.getCode(),allTotalStatComp,allTotalStatTime);
        allTotalStatComp=allTotalStatComp+totalStatComp;
        allTotalStatTime=allTotalStatTime+totalStatTime;
        line("</div>"); // Hided
        line("</div>"); // Container
      
    }
    line("<div class=\"Switchable HC\">"+app.NLS.NLS("RUS:Вычислений;ENG:Calculations;")+":"+allTotalStatComp+", "+
          app.NLS.NLS("RUS:Общее время;ENG:Total time;")+": "+allTotalStatTime+"</div>");
  if (cnt>0){  // если выводились какие - либо элементы, то закроем области заголовка
    line("</div>"); // Hided
    line("</div>"); // Container
  }
    totalComp=totalComp+allTotalStatComp;
    totalTime=totalTime+allTotalStatTime;
}
private void line(String pString){
  content.append(pString.replace("\n","<BR>").replace("[[[","<span class=Dynamic>").replace("]]]","</span>").replace("[[","<span>").replace("]]","</span>"));
  content.append("\n");
}
private void addSwitch(String pElementID,String pCode,String pTitleOn,String pTitleOff){
  line("<div class=\"Variables UnSwitch"+pCode+"\" onclick=\"Set($('"+pElementID+"'),'+"+pCode+"')\">"+pTitleOn+"</div>");
  line("<div class=\"Variables Switchable "+pCode+"\" onclick=\"Set($('"+pElementID+"'),'-"+pCode+"')\">"+pTitleOff+"</div>");
}
}
