/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Применение указанного набора стилей
* Синтаксис Execute:
* StyleSheet:<Стиль>;
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;


public class StyleSheet implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
     return app.getProperty("STYLE_CURRENT");
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
        LuiClCommandGroup XMLcg=app.commandWriter.addGroup("Init");
        LuiClCommand XMLcmd=XMLcg.addCommand("Init");
        XMLcmd.addScaPar("Skin",NVL(pString,"default")); 
        app.setProperty("STYLE_CURRENT",NVL(pString,"default"));
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
}