/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Открытие указанной URL
Синтаксис Execute:
URL:(Target:<W/F/T>;<код_пароаметра1>:<значение параметра1>;...<код_пароаметра1>:<значение параметра1>;)<адрес>
 */
package Standard;

import LuiCollection.LuiCollection;
import LuiExceptionMsg.LuiException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URLConnection;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class URL implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
      int rc;
      StringBuilder sb = new StringBuilder();
      char[] buffer = new char[250];
      InputStream is=null;
      InputStreamReader reader=null;
      try {
        URLConnection connection = new java.net.URL(pString).openConnection();
        is = connection.getInputStream();
        reader = new InputStreamReader(is);
       while ((rc = reader.read(buffer)) != -1) sb.append(buffer, 0, rc);
        
      } catch (MalformedURLException ex) {
        app.msgWriter.write("LUI-00110", ex.getMessage());
      } catch (IOException ex) {
        app.msgWriter.write("LUI-00110", ex.getMessage());
    }finally{
          if (reader!=null)try{reader.close();}catch(Exception ex){}
          if (is!=null)try{is.close();}catch(Exception ex){}
      }
      return sb.toString();
    }


    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        LuiClCommandGroup XMLcg;
        LuiClCommand XMLcmd;
        String target="T";
        LuiCollection col=null;
        String adr=null;
        if (pString.charAt(0)=='(') { // если начинается со скобки
            // ищем где она закрывается
            int cb=pString.indexOf(")"); 
            if (cb>0){// и если она закрывается
                String cols=pString.substring(1,cb); // будем подозревать, что там между скобками спрятана коллекция
                col=new LuiCollection(cols);
                if (col.Exists_Element("Target")){
                target=col.Get_Element("Target");
                col.Erase_Element("Target");
                }
                adr=pString.substring(cb+1);
            }
        }
       if (adr==null)adr=pString; 
       XMLcg=app.commandWriter.addGroup("OpenURL");
       XMLcmd=XMLcg.addCommand("URL");
       XMLcmd.addScaPar("Address", adr);
       if (col!=null) {
        if (col.size()>0){   
       XMLcmd.addScaPar("Params", col.toString());
        }
       }
       switch (target) {
           case "T":
           target="Tab";
           break;
           case "W":
           target="Window";
           break;
           case "F":
           target="Float";
           break;
       }
       XMLcmd.addScaPar("Target",target);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
       
    }
    
}
