/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/* Загрузка файла с клиентского браузера в каталог LUI-сервера
Execute:
UploadFile:<Заголовок>;[Коллекция параметров загрузки]
*/
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiClCommand;
import luiserver.LuiClCommandGroup;
import luiserver.LuiClCommandWriter;
import luiserver.LuiClEvent;
import luiserver.LuiClEventReader;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class UploadFile implements LuiPlugin{
LuiApplication app;
LuiClEvent ev;
LuiClCommandWriter cw;
LuiClEventReader er;

    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        //er=new LuiClEventReader(app.eventReader.getReader(),app.msgWriter,app.TotalTimer);
        er=app.eventReader;
              // cw=new LuiClCommandWriter(app.commandWriter.getWriter(),app.TotalTimer); 
              cw=app.commandWriter;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        String retVal="";
        LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    } else return retVal;
    }
    LuiCollection col=new LuiCollection(pString);
    String multiple=NVL(col.Get_Element("Multiple"),"Y");
    
        LuiClCommand XMLcmd = null;
        LuiClCommandGroup XMLcg = null;
        String tmpdir=app.getTmpDir();
        XMLcg=cw.addGroup("UploadFile");
        XMLcmd=XMLcg.addCommand("UploadFile");
        XMLcmd.addScaPar("FormID", frm.getFormID());
        XMLcmd.addScaPar("Title", col.Get_Element("UploadFile"));
        XMLcmd.addScaPar("Multiple", multiple);
        XMLcmd.addScaPar("Path", tmpdir);
        col.Erase_Element("UploadFile");
        col.Erase_Element("Multiple");
        XMLcmd.addScaPar("Params",col.toString());
        
        app.changes();
        app.getSeance().remZeroCmd();
        app.getSeance().remFrmWinApp();
             boolean b=true;         
        LuiClEvent ev;
        while (b){
        cw.flush();
        er.readEvents();
        while (true){
        ev=er.getEvent();
        if (ev==null) break;
        switch (ev.name){
          case "UploadCancel":
          b=false;
          break;
          case "UploadOk":
          b=false;
          retVal=ev.getParValue("Files");
          break;
          case "Interval":
          //app.interval();     //пока не получается загружать большие файлы и одновременно тикать таймером
          break;
          default:
               if (!ev.name.equals("UploadCancel") && !ev.name.equals("UploadOk") && !ev.name.equals("Interval")
                    ){   
                app.eventReader.eventList.add(0,ev);
                return "";
                 }
                break;   
        }
        }
    }
        
        return retVal;
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        compute(pString,pProp);
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        
    }
    
}
