/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package Standard;



import static LuiCollection.LuiString.Filter;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import luiserver.LuiAppElement;
import luiserver.LuiAppForm;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiParser;
import luiserver.LuiPlugin;
import org.mozilla.javascript.Context;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.EvaluatorException;
import org.mozilla.javascript.JavaScriptException;
import org.mozilla.javascript.NativeObject;
import org.mozilla.javascript.ScriptableObject;
import org.mozilla.javascript.WrappedException;



/**
 *
 * @author aliubushkin
 */
public class rjs implements LuiPlugin {
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
        app.RhinoContext = Context.enter();
        app.RhinoContext.setOptimizationLevel(-1); // только интерпретация!!!
        app.RhinoScope = app.RhinoContext.initStandardObjects();
        Object jsOut = Context.javaToJS(app, app.RhinoScope);
        ScriptableObject.putProperty(app.RhinoScope, "App", jsOut);
        
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException{
        String retval=null;
        Object objretval;
        LuiAppForm frm=pProp.ownerObj.getForm();
    if (frm==null) {
    String curFrmID=app.getVal("FormID");        
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID);
    }
    }
    String error="exception";
    
      
        if (pString.indexOf("(error=")==0){
         error=pString.substring(7,pString.indexOf(")"));
         pString=pString.substring(pString.indexOf(")")+1);
        }
        /***статистика***/
    String stat="";
    int StatCount=0;
    long StatTime=0;
    long StatStart=System.currentTimeMillis();
    try{
    if (frm!=null)
    stat=frm.getProperty("StatRhinoJS");
    }catch(Exception ex){}
    
    if (is_not_null(stat)){
        StatCount=Integer.valueOf(stat.split(" ")[0]);
        StatTime=Integer.valueOf(stat.split(" ")[1]);
    }
    StatCount++;
    
    /***статистика***/
        pString=pString.replace("exit();", "");
        pString=LuiParser.reMask(pString);

        try {
        objretval=app.RhinoContext.evaluateString(app.RhinoScope, pString, "", 1, null);
        retval=Context.toString(objretval);
        
        /*********статистика************/   
    
       if (frm!=null)  frm.setProperty("StatRhinoJS",String.valueOf(StatCount)+" "+String.valueOf(StatTime+System.currentTimeMillis()-StatStart));   
         /*********статистика************/
         
      return retval;
        }  catch (Exception se){
            if (!error.equals("exception")) {
               if (error.equals("info")) {
                   app.msgWriter.ClearMsgArray();
                   return "ERROR! "+se.getMessage();
               } 
               return error;
            }
            if (frm!=null) {
            try {
                if (frm.getProperty("SuppressErrors").equals("Y")) return "";
            } catch (SQLException ex) {
               
            }
           } 
        app.msgWriter.write("LUI-00033",se.getMessage()+"("+pString+")"+" "+pProp.getGenesis4msg()); 
        return se.getLocalizedMessage();
            
        }
                /*catch (ReferenceError ce){
                    System.err.println(ce.getWrappedException().toString());
                   ce.printStackTrace();
                }
                catch (WrappedException we) {
                    // Some form of exception was caught by JavaScript and
                    // propagated up.
                  System.err.println(we.getWrappedException().toString());
                  we.printStackTrace();
                }
                catch (EvaluatorException ee) {
                    // Some form of JavaScript error.
                    System.err.println("js: " + ee.getMessage());
                }
                catch (JavaScriptException jse) {
                    // Some form of JavaScript error.
                    System.err.println("js: " + jse.getMessage());
                }*/
        /*finally{
        Context.exit();
        }*/
        
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        pString=pString.replace("exit();", ""); // убираем слово exit(); чтобы не убить LUI
        pString=LuiParser.reMask(pString);
        boolean fieldChanged=false; // признак изменённости полей
     LuiAppForm frm=pProp.ownerObj.getForm();                                   // берём форму
    if (frm==null) { // если форма не определена
    String curFrmID=app.getVal("FormID");      // определим по-другому 
    if (app.forms.containsKey(curFrmID)){
       frm=app.forms.get(curFrmID); // если форма опять не определена уходим
    } else return ;
    }
    // создаём в носороге перечень элементов формы
 String separ="";
 String JSelements="Elements = {";
 for (String elCode:frm.elements.keySet()){
     JSelements=JSelements+separ+"'"+elCode+"':{}"; // Рустам просил так: JSelements+=separ+elCode+":{}"; 
     separ=",";
 }
 JSelements=JSelements+"};Form={}"; // и даже добавляем элемент "Форма"
    try {
        app.RhinoContext.evaluateString(app.RhinoScope, JSelements, "", 1, null);
    } catch (Exception ex) { // если перечень не создался генерируем ошибку
  app.msgWriter.write("LUI-00033",ex.getMessage()+"("+JSelements+")"+" "+pProp.getGenesis4msg());       
    }
    // крутим элементы формы для того, чтобы в рино вычистить переменные имена которых совпадают с именами элементов данной формы
     // это позволяет избежать пересечение пространств имён
    JSelements=""; 
    for (String ec:frm.elements.keySet()){
        LuiAppElement el=frm.elements.get(ec);
         if (el.properties.containsKey("Value")){ // если у элемента есть св-во Value
          JSelements=JSelements+"delete "+el.Code+";";   
         }
    }
    if (JSelements!="") // если прграмма удаления глобальных не пуста
    try {
        app.RhinoContext.evaluateString(app.RhinoScope, JSelements, "", 1, null);
    } catch (Exception ex) { // если перечень не создался генерируем ошибку
  app.msgWriter.write("LUI-00033",ex.getMessage()+"("+JSelements+")"+" "+pProp.getGenesis4msg());       
    }
    try {
        app.RhinoContext.evaluateString(app.RhinoScope, pString, "", 1, null);
        // изучаем объект Elements
      Object e= app.RhinoScope.get("Elements",app.RhinoScope);
      if (e!=Scriptable.NOT_FOUND){
          LuiAppElement el=null;
          NativeObject elems=(NativeObject) e;
          for (Object oec:elems.keySet()){
              
              String ec=oec.toString(); // берём код элемента
              NativeObject oepr=(NativeObject) elems.get(oec); // и его свойства
              if (ec.equals("Form")){ //если это форма
                  
              } else{
              if (!frm.elements.containsKey(ec)){ // если элемента нет надо создать
                  String EType=oepr.get((Object) "Etype").toString();
                  if (is_not_null(EType)){
                      String Parent=oepr.get((Object) "Parent").toString();
                      String Name=oepr.get((Object) "Name").toString();
                      el=frm.addElement(ec, EType, null, NVL(Name,""), Parent);
                  }
              } else { // если есть
                 el=frm.elements.get(ec);
              }
               if (el!=null){ // если элемент найден или создан
                   for(Object opk:oepr.keySet()){
                       
                   }
               }
              }
          }
      }
        // крутим опять элементы пытаяст найти такие переменные в рино
     for (String ec:frm.elements.keySet()){
        LuiAppElement el=frm.elements.get(ec);
         if (el.properties.containsKey("Value")){ // если у элемента есть св-во Value
          Object x=app.RhinoScope.get(ec,app.RhinoScope);
          if (x!=Scriptable.NOT_FOUND){
           app.changeSCN("NewValue");
           el.newValue(Context.toString(x),null,null,"Y",false,false); 
          }
         }
    }   
    }  catch (Exception se){
           // if (frm!=null) {
            try {
                if (frm.getProperty("SuppressErrors").equals("Y")) return;
            } catch (SQLException ex) {
               
            }
           //} 
        app.msgWriter.write("LUI-00033",se.getMessage()+"("+pString+")"+" "+pProp.getGenesis4msg()); 
        
            
        }
          
    }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
@Override
    public String quoteMask(String prefixString, String Value) {
      if (Filter(prefixString, "\"").length() % 2 == 1) return Value.replace("\\", "\\\\").replace("\"", "\\\"").replace("\n", "\\n").replace("\r"," ");
      if (Filter(prefixString, "\'").length() % 2 == 1) return Value.replace("\\", "\\\\").replace("\'", "\\\'").replace("\n", "\\n").replace("\r"," ");
      return LuiPlugin.super.quoteMask(prefixString, Value);
    }    
}
