/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Раззиповыватель файла в указанный каталог
 * Compute отсутствует
* Синтаксис Execute:
* unZipFile:<имя файла;TO/To/to/tO:<каталог>;
* Если каталог не указан, то разэипливание выполняется в ApplicationProperty:TmpDir
 */
package Standard;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.is_null;
import LuiExceptionMsg.LuiException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.SQLException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import luiserver.LuiAppProp;
import luiserver.LuiApplication;
import luiserver.LuiPlugin;

/**
 *
 * @author aliubushkin
 */
public class unZipFile implements LuiPlugin{
LuiApplication app;
    @Override
    public void setContext(LuiApplication pContext) {
        app=pContext;
    }

    @Override
    public String compute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        return "";
    }

    @Override
    public void execute(String pString, LuiAppProp pProp) throws LuiException, SQLException {
        byte[] buffer = new byte[1024];
        LuiCollection col=new LuiCollection("unZipFile:"+pString);
        String srcFile=col.Get_Element("unZipFile");
        String toDir=col.Get_Element("TO");
        if (is_null(toDir)) {
        toDir=col.Get_Element("To");            
        }
        if (is_null(toDir)) {
        toDir=col.Get_Element("to");            
        }
        if (is_null(toDir)) {
        toDir=col.Get_Element("tO");            
        }
        if (is_null(toDir)) {
        toDir=app.getProperty("TmpDir");
        }
        //toDir=toDir+File.separator+srcFile.substring(0, srcFile.lastIndexOf("."));
        // создаём каталог если его нет
        File dstDir = new File(toDir);
        if (!dstDir.exists()) {
            dstDir.mkdir();
        } 
  FileInputStream FIS=null;
  ZipInputStream zis=null;
  FileOutputStream fos=null;
try {
    // Получаем содержимое ZIP архива в виде потока
    FIS=new FileInputStream(srcFile);
zis = new ZipInputStream(FIS);
ZipEntry ze = zis.getNextEntry();
String nextFileName;
while (ze != null) {
        nextFileName = ze.getName();
        File nextFile = new File(toDir + File.separator + nextFileName);
        // Если мы имеем дело с каталогом - надо его создать. Если/ этого не сделать, то не будут созданы пустые каталоги архива
        if (ze.isDirectory()) {
             nextFile.mkdir();
        }else {
            // Создаем все родительские каталоги
            new File(nextFile.getParent()).mkdirs();
            // Записываем содержимое файла
            fos=null;
            try{
                fos=new FileOutputStream(nextFile);
                int length;
                while((length = zis.read(buffer)) > 0) {
                    fos.write(buffer, 0, length);
                }
            }catch(Exception ex){}
            finally{
                if (fos!=null)try{fos.close();}catch(Exception ex){}
            }
            
        }
        ze = zis.getNextEntry();
}
zis.closeEntry();
 zis.close();
}   catch (FileNotFoundException ex) {
        app.msgWriter.write("LUI-00113",srcFile,ex.toString());
    } catch (IOException ex) {
        app.msgWriter.write("LUI-00113",srcFile,ex.toString());
    } finally {
    if (fos!=null)try{fos.close();}catch(Exception ex){}
    if (zis!=null)try{zis.close();}catch(Exception ex){}
    if (FIS!=null)try{FIS.close();}catch(Exception ex){}
}
 }

    @Override
    public void findDependency(String pString, LuiAppProp pProp) throws LuiException, SQLException {

    }
@Override
    public String quoteMask(String prefixString, String Value) {
        return Value.replace(";","#$");
    }    
}
