/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
Класс для поддержки журнала выполнения приложения
*/
package luiserver;

import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 *
 * @author aliubushkin
 */
public class LuiAppLog {
  LuiApplication app;
  private String sID;
  public LuiAppLog(LuiApplication pApp){
      app=pApp;
  }
  public void setSID(String psid){
   sID=psid;
  } 
  public void addRecord(String pEventType,String pEventText,String pEventProperty,String pFrmID) throws LuiException{
      String stmt;
      //if (pEventProperty.length()>4096) pEventProperty=pEventProperty.substring(0,4095);
      if (app.luiSession==null)return;
       if ("Y".equals(app.properties.get("DEBUG_MODE").currentValue) || "ERROR".equals(pEventType)){
       String form=NVL(pFrmID,app.getVal("FormID"));
        if (is_not_null(form)){
            if (app.forms.containsKey(form)){
              LuiAppForm frm=app.forms.get(form);
              try{
              if ("N".equals(frm.getVal("Logging"))) return;
              form=frm.getCode();
              if (is_null(form))form=pFrmID;
              if (!"DEFAULT".equals(frm.getConfigCode()))
              form=form+"("+frm.getConfigCode()+")";
              
              } catch (Exception ex){}
            }
        }
       LuiDbConn lc=null;
       try{
       lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
       if (lc!=null){
        //место установки ловущки
        String bug="";
        if (!app.luiSession.id.equals(sID)) bug="!!!***app.luiSession.id="+app.luiSession.id+"; sID="+sID+"***!!!";
        stmt="insert into lui_t_session_log(ID,SESSION_ID,EVENT_TYPE,EVENT_DATETIME,EVENT_TEXT,EVENT_PROPERTY,form) values (nextval('lui_q_session_log'),"+
        NVL(this.sID,app.luiSession.id)+
        ",'"+
        pEventType+        
        "',clock_timestamp(),'"+bug+
        pEventText.replace("'","''")+"','"+
        pEventProperty.replace("'","''")+"','"+
        form.replace("'","''")
                +"')";
        lc.executeDML(stmt);
       }
       } catch (SQLException ex){
         stmt=ex.toString();
       }
       finally {
           if (lc!=null){
               try{
               app.metaConnPool.SetFree(lc);
               } catch (SQLException ex){
           
       }
           }
       }
      }
      //if (is_null(pMessageText) && is_not_null(pMessageHelp) &&
      //  "Y".equals(app.getVal("DEBUG_MODE"))){
      //LuiAppLogRecord r=new LuiAppLogRecord(++lastSeq,pMessageType,pMessageTitle,pMessageHelp,"");      
      //log.add(r);
      //  }
      //else {
      //LuiAppLogRecord r=new LuiAppLogRecord(++lastSeq,pMessageType,pMessageTitle,pMessageText,pMessageHelp);
      //log.add(r);
      //}
  }
}
