/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Класс для создания и модификации параметрами команд отправляемых на клиента
 */
package luiserver;

import java.util.HashMap;

/**
 *
 * @author aliubushkin
 */
public class LuiClCommand extends LuiClEvCo {
    
    public boolean really;
    /**
     * Конструктор команды
     * @param pName - имя команды
     */
    public LuiClCommand(String pName){
      super(pName);
      really=true;
    }
    public void addMapParameter(String pName,String pKey,String pValue){
        super.addParameter(pName, pKey, LuiParser.reMask(pValue));
    }
    public void addScaPar(String pName,String pValue){
        super.addParameter(pName, LuiParser.reMask(pValue));
    }
    public void addJPar(String pName,String pValue){
        super.addJparameter(pName, pValue);
    }
    public void addScaParameter(String pName,String pValue,String pDef){
        if (pDef!=null && pValue!=null){
        if (pValue.equals(pDef)) return;
        }
        if (pDef==null && pValue==null) return;
        if (pDef==null && (pValue.equals(""))) return;
        if (pValue==null && (pDef.equals(""))) return;
        
        super.addParameter(pName, LuiParser.reMask(pValue));
    }
            
}