/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package luiserver;

import java.util.HashMap;
import java.util.LinkedHashMap;


/*
 * Класс для создания и получения значений параметров события
 */

/**
 *
 * @author aliubushkin
 */

public class LuiClParameter {
public char type; // тип 'C' - коллекция  'S' - просто строка 'J' - JSON.stringify
public LinkedHashMap<String,String> value; // массив ключ-значение. Если параметр типа 'S', то хранится один элемент с ключом="V"
//public LuiClParameter

/**
 * Конструктор
 * @param pType // тип 'C' - коллекция  'S' - просто строка
 */

public LuiClParameter(char pType){
    type=pType;
    value=new LinkedHashMap<String,String>();
}
/** 
* Добавление значения параметра
* @param pKey - ключ
* @param pValue - значение
*/
public void add_value(String pKey,String pValue){
if (this.type=='C') value.put(pKey, pValue);
if (this.type=='S') value.put("V", pValue);
if (this.type=='J') value.put("V", pValue);
}

/**
 * Извлечение значения по ключу
 * @param pKey ключ
 * @return - значение
 */
public String get_value(String pKey){
    return value.get(pKey);
}
/**
 * Извлечение значения параметра, если он не коллекция. 
 * Если коллекция, то вернётся ерунда
 * @return - значение
 */
public String get_value(){
    if (type=='S' || type=='J') return get_value("V");
    return value.toString();
}
}
