/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package luiserver;

import LuiCollection.LuiCollection;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.RTrim;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import com.google.gson.JsonArray;
import com.google.gson.JsonElement;
import java.io.ByteArrayInputStream;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map.Entry;

/**
 *
 * @author aliubushkin
 */
public class LuiGmap {
  LuiApplication app;
  public  HashMap<String,map> maps;
  geojson GEOJSON;
  LuiCollection featuresHM;
 public class map{
   String nameProperty;
   String appCode;
   String name;
   geojson GEOJSON;
   HashMap<String,LuiCollection> labels;
   LuiCollection featuresHM;
  public String getNames(){
      String rc="";
      if (GEOJSON==null)return rc;
      for (int i=0;i<GEOJSON.features.size();i++){
          rc=rc+GEOJSON.features.get(i).properties.get(NVL(nameProperty,"name"))+";";
      }
      return rc;
  } 
   //String url;
   //String filename;
   
 }
 public class geojson{
   String type;
   gcrs crs;   
   ArrayList<gfeature> features;
 } 
 public class gfeature{
   String type;
   HashMap<String,String> properties;
   ggeometry geometry;
 }
 public class ggeometry{
     String type;
     //gMultiPolygon coordinates;
     Object coordinates;
     //ArrayList<ArrayList<ArrayList<Double[]>>> coordinates;
 }
public Double[] gpoint;
 
 /*private class gmultipoint{
     ArrayList<gpoint> coordinates;
 }
 private class gLinearRing{
     ArrayList<gpoint> coordinates;
 }
 private class gPolygon{
     ArrayList<gLinearRing> coordinates;
 }
 private class gMultiPolygon{
     ArrayList<gPolygon> coordinates;
 }*/
 public class gcrs{
     String type;
     HashMap<String,String> properties;
 }
    public LuiGmap(LuiApplication pApp) {
        app=pApp;
        maps=new HashMap<>();
        /*LuiDbConn lc=null;
        try{
        lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());               
         for (String cfk:app.commonForms.keySet()){
           if (app.commonForms.Get_Element(cfk).equals("GMAP")){
               map m=new map();
               m.appCode="LUI";
               m.nameProperty=lc.getSelectResult("select lui_f_get_value('LUI','"+cfk+"','DEFAULT','GEOJSON_NAMEPROP')");
               m.url=app.getProperty("ApplicationURL")+"LUI/"+cfk+".geojson";
               m.filename=app.getProperty("APP_FILES_PATH")+"LUI"+app.getProperty("PathSeparator")+cfk+".geojson";
               maps.put(cfk, m);
           }
         }
        
         LuiCollection mlist=lc.getSelectAllRowsTwoColsValMap("select code,code from lui_t_form f  where f.app_code='"+app.code+
                 "' and f.version_number is null and f.formtype_code = 'GMAP'");
         if (mlist!=null){
             for (String cfk:app.commonForms.keySet()){
                if (maps.containsKey(cfk)){
                    maps.remove(cfk);
                }
                map m=new map();
               m.appCode=app.code;
               m.nameProperty=lc.getSelectResult("select lui_f_get_value('"+app.code+"','"+cfk+"','DEFAULT','GEOJSON_NAMEPROP')");
               m.url=app.getProperty("ApplicationURL")+app.code+"/"+cfk+".geojson";
               m.filename=app.getProperty("APP_FILES_PATH")+app.code+app.getProperty("PathSeparator")+cfk+".geojson";
               maps.put(cfk, m);
             }
         }
         
        }finally{
          if (lc!=null) app.metaConnPool.SetFree(lc);
      } */
    }

public void reloadLabelsSettings(String pMapCode) throws LuiException, SQLException{
LuiDbConn lc=null;        
if (!maps.containsKey(pMapCode)) return;
map m=maps.get(pMapCode);
m.labels=null;
      try{
    lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser()); 
    String labels=lc.getSelectResult("select lui_f_get_application_property('"+app.code+"','MAP_LB_"+pMapCode+"');");
     if (is_null(labels)){
         labels=lc.getSelectResult("select lui_f_get_value('"+m.appCode+"','"+pMapCode+"','DEFAULT','GEOJSON_LABELS')");
     }
     if (is_not_null(labels)){
       LuiCollection labelsCollection=new LuiCollection(labels);
       for (String key:labelsCollection.keySet()){
           if (m.labels==null) m.labels=new HashMap<>();
           String key2=key.replace("MAP_LABEL(","");
           key2=key2.substring(0, key2.length()-1);
           m.labels.put(key2,new LuiCollection(labelsCollection.Get_Element(key)));
       }
     }
      } finally{
          if (lc!=null) app.metaConnPool.SetFree(lc);
      }    
} 
/**
 * Регистрация карты в приложении сеанса пользователя и в браузере пользователя
 * @param pMapCode -- код формы карты
 * @param pReplace -- признак необходимости замены уже зарегистрированной карты
 * @throws LuiException
 * @throws SQLException 
 */
    public void registerMap(String pMapCode,boolean pReplace,String pAppCode) throws LuiException, SQLException{
        String appc=app.code;
        if (is_not_null(pAppCode))appc=pAppCode;
        if (!pReplace && maps.containsKey(pMapCode))return;
        if (maps.containsKey(pMapCode))maps.remove(pMapCode);
                map m=new map();
LuiDbConn lc=null;        
      try{
    lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());                     
    // ищем в приложении
     m.appCode=lc.getSelectResult("select app_code from lui_t_form where formtype_code='GMAP' and app_code='"+
                 appc+"' and version_number is null and code='"+pMapCode+"'");
        if (m.appCode==null && is_null(pAppCode)){ // не нашли - ищем в LUI
            appc="LUI";
     m.appCode=lc.getSelectResult("select app_code from lui_t_form where formtype_code='GMAP' and app_code='"+
                 appc+"' and version_number is null and code='"+pMapCode+"'");       
         
        }
     if (is_null(m.appCode)) return;
     m.nameProperty=lc.getSelectResult("select lui_f_get_value('"+m.appCode+"','"+pMapCode+"','DEFAULT','GEOJSON_NAMEPROP')");
     m.name=lc.getSelectResult("select nls(name) from lui_t_config where app_code='"+m.appCode+"' and form_code='"+pMapCode+"'and code='DEFAULT'");
     String labels=lc.getSelectResult("select lui_f_get_application_property('"+app.code+"','MAP_LB_"+pMapCode+"');");
     if (is_null(labels)){
         labels=lc.getSelectResult("select lui_f_get_value('"+m.appCode+"','"+pMapCode+"','DEFAULT','GEOJSON_LABELS')");
     }
     if (is_not_null(labels)){
       LuiCollection labelsCollection=new LuiCollection(labels);
       for (String key:labelsCollection.keySet()){
           if (m.labels==null) m.labels=new HashMap<>();
           String key2=key.replace("MAP_LABEL(","");
           key2=key2.substring(0, key2.length()-1);
           m.labels.put(key2,new LuiCollection(labelsCollection.Get_Element(key)));
       }
     }
//     m.filename=m.filename=app.getProperty("APP_FILES_PATH")+app.code+app.getProperty("PathSeparator")+pMapCode+".geojson";
//     m.url=app.getProperty("AppDirURL")+"/"+pMapCode+".geojson";  
/*     try{
     lc.readBlobToFile("select valueb from lui_t_value v\n" +
"where v.app_code='"+m.appCode+"' and\n" +
" v.config_code='DEFAULT' and\n" +
" v.element_code is null and\n" +
" v.form_code='"+pMapCode+"' and\n" +
" v.property_code='GEOJSON'", m.filename);
     } catch (IOException ioex){
         
     }
*/
     maps.put(pMapCode, m);
     LuiClCommandWriter cw;
     //cw=app.commandWriter;
     cw=new LuiClCommandWriter(app.commandWriter.getWriter(),app.TotalTimer); 
     cw.setJSengine(app.JSengine);
        LuiClCommandGroup XMLcg=cw.addGroup("Register map "+pMapCode);
        LuiClCommand XMLcmd=XMLcg.addCommand("RegisterMap");
        XMLcmd.addScaPar("Code", pMapCode);
  //      XMLcmd.addScaPar("Data", m.url);
  if (is_null(pAppCode))
  XMLcmd.addJPar("Data", "App.gMap.getMapJSON(\""+pMapCode+"\",\"\",\"\")");
  else
  XMLcmd.addJPar("Data", "App.gMap.getMapJSON(\""+pMapCode+"\",\""+pAppCode+"\",\"\")");
  XMLcmd=XMLcg.addCommand("Event");
  XMLcmd.addScaPar("EventCode","Registred");
  //XMLcmd.addJPar("MS", "100");
   LuiClEvent ev;
    //app.changes();
    //app.getSeance().remZeroCmd();
    //app.getSeance().remFrmWinApp();
    cw.flush();
    app.eventReader.readEvents(); // читаем события
            while (true){ // цикл обработки событий
                ev=app.eventReader.getEvent();
                if (ev==null)break;
                if (ev.name.equals("Registred")){
                }
            }   
      }finally{
          if (lc!=null) app.metaConnPool.SetFree(lc);
      } 
// тест нахождения центра
ArrayList<Double[]> ring=new ArrayList<>();
Double[] p1=new Double[2];
Double[] p2=new Double[2];
Double[] p3=new Double[2];
Double[] p4=new Double[2];
p1[0]=2.0;p1[1]=4.0;
p2[0]=5.0;p2[1]=6.0;
p3[0]=7.0;p3[1]=3.0;
p4[0]=4.0;p4[1]=2.0;
ring.add(p1);ring.add(p2);ring.add(p3);ring.add(p4);
ArrayList<ArrayList<Double[]>> poly=new ArrayList<>();
poly.add(ring);
p1=getPolygonCenter(poly);
    }
    public String getMapJSON(String pMapCode,String pAppCode,String doFHM) throws LuiException, SQLException{
      String appc=app.code;
        if (is_not_null(pAppCode))appc=pAppCode;
      String rc = null;
      LuiDbConn lc=null;
      try{
              lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
         // ищем в приложении
         String mapp=lc.getSelectResult("select app_code from lui_t_form where formtype_code='GMAP' and app_code='"+
                 appc+"' and code='"+pMapCode+"'");
         if (mapp==null && is_null(pAppCode)){ // не нашли - ищем в LUI
          appc="LUI";
         mapp=lc.getSelectResult("select app_code from lui_t_form where formtype_code='GMAP' and app_code='"+
                 appc+"' and code='"+pMapCode+"' and formgroup_code='LUI_COMMON'");
         
         }
         if (mapp==null) return null;
         String propName=lc.getSelectResult("select lui_f_get_value('"+mapp+"','"+pMapCode+"','DEFAULT','GEOJSON_NAMEPROP')");
                 
         rc=lc.getSelectResult("select convert_from(valueb,'UTF8') from lui_t_value where app_code='"+
                 mapp+"' and form_code='"+pMapCode+"' and config_code='DEFAULT' and element_code is null "+
                 "and property_code='GEOJSON'");
       
        makeGeoJson(rc,0.0,0.0,false,pMapCode,lc,mapp,doFHM); 
        if (maps!=null && maps.containsKey(pMapCode)){
        maps.get(pMapCode).GEOJSON=this.GEOJSON;
        String fhm=lc.getSelectResult("select lui_f_get_value('"+mapp+"','"+pMapCode+"','DEFAULT','GEOJSON_FL')");
        if (is_not_null(fhm) || NVL(doFHM,"N").equals("Y")) maps.get(pMapCode).featuresHM=new LuiCollection(fhm);
        else
        maps.get(pMapCode).featuresHM=this.featuresHM;
        }
       // makeGeoJson(rc,-12.0,0.0);
       // String rc2=app.toJSON(GEOJSON);
       // rc2=rc2.replace(",{\"type\":\"Feature\",",",\n{\"type\":\"Feature\",");
       // FileOutputStream fos = new FileOutputStream("C:\\temp\\"+pMapCode+".geojson");
       // fos.write(rc2.getBytes());
       // fos.close();
//        saveGeoJson(mapp,pMapCode);
         return rc;
      } finally{
          if (lc!=null) app.metaConnPool.SetFree(lc);
      }        
      //return rc;
    }
public void saveGeoJson(String pApp,String pMapCode) throws SQLException, LuiException{
    LuiDbConn lc=null;
    PreparedStatement ps=null;
      try{
              lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
       Connection c=lc.getConnection();
       ps=c.prepareStatement("update lui_t_value set valueb=? where app_code='"+pApp+"' and form_code='"+
               pMapCode+"' and config_code='DEFAULT' and element_code is null and property_code='GEOJSON'");
        String rc=app.toJSON(GEOJSON);
        rc=rc.replace(",{\"type\":\"Feature\",",",\n{\"type\":\"Feature\",");
   
       ps.setBinaryStream(1, new ByteArrayInputStream(rc.getBytes()));
       ps.execute();
       
       
      }catch (SQLException sex){
          String er=sex.getLocalizedMessage();
          throw sex;
      }
      finally{
          if (ps!=null && !ps.isClosed())try{ps.close();}catch(Exception ex){}
          if (lc!=null) app.metaConnPool.SetFree(lc);
      } 
}    
public void makeGeoJson(String pString,Double pDolgotaShift,Double pShirotaShift,boolean pMakeGeometry,String pMapCode,LuiDbConn mlc,String mapp,String doFHM) throws LuiException, SQLException{
//if (is_null(pString))return;
Integer maxLabel=0;
PreparedStatement ps=null;
String nameprop=mlc.getSelectResult("select lui_f_get_value('"+mapp+"','"+pMapCode+"','DEFAULT','GEOJSON_NAMEPROP')");
try{
    JsonElement JSONRoot = app.JSONparser.parse(pString);
    GEOJSON=new geojson();
    featuresHM = new LuiCollection("");    
    for (Entry e:JSONRoot.getAsJsonObject().entrySet()){
                 String ek=e.getKey().toString();
                 JsonElement ev=(JsonElement)e.getValue();
               switch (ek) {
                   case "type":
                    GEOJSON.type=ev.getAsString();
                    break;
                   case "crs":
                    GEOJSON.crs=new gcrs();
                    for (Entry ecrs:ev.getAsJsonObject().entrySet()){
                       String ecrsk=ecrs.getKey().toString();
                       JsonElement ecrsv=(JsonElement)ecrs.getValue();
                       switch (ecrsk){
                           case "type":
                           GEOJSON.crs.type=ecrsv.getAsString();
                           break;
                           case "properties":
                           GEOJSON.crs.properties=new HashMap<>();
                           for (Entry ecrsp:ecrsv.getAsJsonObject().entrySet()){
                               String ecrspk=ecrsp.getKey().toString();
                               JsonElement ecrspv=(JsonElement)ecrsp.getValue();
                               GEOJSON.crs.properties.put(ecrspk, ecrspv.getAsString());
                           }
                           break;
                       }
                    }
                    break;
                   case "features":
                    GEOJSON.features=new ArrayList<>();
                    JsonArray jfarray=ev.getAsJsonArray();
                    for(int i=0;i<jfarray.size();i++){
                       JsonElement jf=jfarray.get(i);
                       gfeature gf=new gfeature();
                           for (Entry ef:jf.getAsJsonObject().entrySet()){
                               String efk=ef.getKey().toString();
                               JsonElement efv=(JsonElement)ef.getValue();
                               switch (efk){
                                   case "type":
                                   gf.type=efv.getAsString();
                                   break;
                                   case "properties":
                                   gf.properties=new HashMap<>();
                                   for (Entry efp:efv.getAsJsonObject().entrySet()){
                                       
                                       String efpk=efp.getKey().toString();
                                       JsonElement efpv=(JsonElement)efp.getValue();
                                       if (!efp.getValue().toString().equals("null"))
                                       {
                                       gf.properties.put(efpk, efpv.getAsString());
                                       }
                                       else {
                                       gf.properties.put(efpk, "");
                                       }
                                   }
                                   break;
                                   case "geometry":
                                   if (!pMakeGeometry)break;
                                   gf.geometry=new ggeometry();
                                   for (Entry efg:efv.getAsJsonObject().entrySet()){
                                       String efgk=efg.getKey().toString();
                                       JsonElement efgv=(JsonElement)efg.getValue();
                                    switch (efgk){
                                        case "type":
                                        gf.geometry.type=efgv.getAsString();
                                        break;
                                        case "coordinates":
                                         switch (NVL(gf.geometry.type,"MultiPolygon")){
                                             case "Polygon":
                                             gf.geometry.coordinates=this.makePolygon(efgv.getAsJsonArray(), pDolgotaShift, pShirotaShift);
                                             break;
                                             case "MultiPolygon":
/*массив полигонов*/                         ArrayList<ArrayList<ArrayList<Double[]>>> gmp=new ArrayList<>();
                                             JsonArray jmp=efgv.getAsJsonArray();
                                             for (int i1=0;i1<jmp.size();i1++){
                                              gmp.add(makePolygon(jmp.get(i1).getAsJsonArray(), pDolgotaShift, pShirotaShift));
                                             }
                                             gf.geometry.coordinates=gmp;
                                             break;
                                         }
                                        break;    
                                    }   
                                   }
                                   break;
                               }
                           }
                    GEOJSON.features.add(gf);
                    
                    if (gf.properties.containsKey(nameprop)){
                    if (gf.properties.containsKey("label")){
                    featuresHM.Add_Element(gf.properties.get(nameprop),gf.properties.get("label"));
                    try{
                     int labelN=Integer.valueOf(gf.properties.get("label"));
                     if (maxLabel<labelN) maxLabel=labelN;
                    }catch(Exception nex){}
                    }
                    else
                    featuresHM.Add_Element(gf.properties.get(nameprop),"");
                    }
                    }
                    break;   
               }  
              }
     
     if (NVL(doFHM,"N").equals("Y") && featuresHM!=null && featuresHM.size()>0){
     LuiCollection fhm=mlc.getSelectAllRowsTwoColsValMap("select * from json_each_text('"+app.toJSON(featuresHM)+"') order by 1");
     for (String key:fhm.keySet()){
         if (is_null(fhm.get(key))){
         maxLabel++;
         featuresHM.Add_Element(key,maxLabel.toString());
         }
     }
      String stmt="select lui_r_save_value(?,?,'DEFAULT','GEOJSON_FL',null,?,'N')";
         try{
     ps=mlc.getConnection().prepareStatement(stmt);
     ps.setString(1, mapp);
     ps.setString(2, pMapCode);
     ps.setString(3, featuresHM.toString());
     ps.execute();
     ps.close();
     }catch(SQLException sex){
            if (ps!=null)ps.close();
         app.msgWriter.sqlError(mlc, sex, null, stmt);
     }
             }
        } 
            catch (Exception ex){
         
            maps.remove(pMapCode);
            app.msgWriter.write("LUI-00142", pMapCode);
        }
}
private ArrayList<ArrayList<Double[]>> makePolygon(JsonArray jp,Double pDolgotaShift,Double pShirotaShift){
 ArrayList<ArrayList<Double[]>> gp=new ArrayList<>();
                                                for (int i2=0;i2<jp.size();i2++){
/*кольцо - массив точек*/                      ArrayList<Double[]> glr=new ArrayList<>();
                                                 JsonArray jlr=jp.get(i2).getAsJsonArray();
                                                 for (int i3=0;i3<jlr.size();i3++){
                                                  JsonArray jpoint=jlr.get(i3).getAsJsonArray();   
/*точка - пара или триплет*/                      Double[] gpoint =new Double[jpoint.size()];
                                                  for (int i4=0;i4<jpoint.size();i4++)
                                                      gpoint[i4]=jpoint.get(i4).getAsDouble();
                                                  Double d=gpoint[0]+pDolgotaShift;
                                                  boolean ds=true;
                                                  if (d<0){ds=false;d=0-d;}
                                                  while (true){
                                                      if (d<360)break;
                                                      d=d-360;
                                                  }
                                                  if (d>180){
                                                      d=360-d;
                                                      if (ds) d=0-d;
                                                  } else {
                                                      if (!ds) d=0-d;
                                                  }
                                                  gpoint[0]=d;
                                                  Double s=gpoint[1]+pShirotaShift;
                                                  boolean ss=true;
                                                  if (s<0){ss=false;s=0-s;}
                                                  while (true){
                                                      if (s<180)break;
                                                      s=s-180;
                                                  }
                                                  if (s>90){
                                                      s=180-d;
                                                      if (ss) s=0-s;
                                                  } else {
                                                      if (!ss) s=0-s;
                                                  }
                                                 gpoint[1]=s;
                                                 
                                                 glr.add(gpoint);//точку ->кольцо
                                                 } 
                                               gp.add(glr);//кольцо->полигон
                                               } 

 return gp;
}
public Double[] getPolygonCenter(ArrayList<ArrayList<Double[]>> pPolygon){
    Double[] center=new Double[2];
    // 1-е кольцо
    ArrayList<Double[]> ring=pPolygon.get(0);
    // описывающий прямоугольник ориентированный по вертикали и горизонтали
    // он задаётся не 8-ю а 4-мя числами
     // 0 - max(Д) 1-min(Д) 2=max(Ш) 3=min(Ш)
    Double[] R=new Double[4];
    // в начале он сжат в первую точку кольца
     R[0]=ring.get(0)[0];
     R[1]=ring.get(0)[0];
     R[2]=ring.get(0)[1];
     R[3]=ring.get(0)[1];
     // крутим вершины кольца
    for (int i=0;i<ring.size();i++){
       double rx=ring.get(i)[0];
       double ry=ring.get(i)[1];
       if (R[0]<rx)R[0]=rx;
       if (R[1]>rx)R[1]=rx;
       if (R[2]<ry)R[2]=ry;
       if (R[3]>ry)R[3]=ry;
    }
    // выбираем минимальную сторону прямоугольника
    Double s=R[0]-R[1];
    if ((R[2]-R[3])<s)s=R[2]-R[3];
    s=s/23; //делим её на 23 это шаг аппроксимации
    Double M = 0.0; // максимальное найденное расстояние от точки до границы полигона.
    for (double y = R[2]; y > R[3]; y-=s) { // протыкиваем описывающий многоугольник по вертикали с шагом s
       for (double x = R[1]; x<R[0];x+=s) {
           double m=distanceBorder(ring,x,y);
           if (m>M){
               M=m;
               center[0]=x;
               center[1]=y;
           }
       }
    }   
    
    return center;
}
public double distancePoint(ArrayList<Double[]> ring, double x, double y){
  Double pmin=null;
 for (int i=0;i<ring.size();i++){
     Double[] C=ring.get(i);
     Double D=Math.sqrt((x-C[0])*(x-C[0]) + (y-C[1])*(y-C[1]));
     if (pmin==null) pmin=D;
     else {
         if (pmin>D)pmin=D;
     }
 }
 return pmin;
}
public double distanceBorder(ArrayList<Double[]> ring, double x, double y){
    Double pmin=null;
    Double[] n = new Double[4];
    n[0]=0.0;n[1]=0.0;n[2]=0.0;n[3]=0.0; // бужем считать количество пересечений лучей, испущенных из точки p влево, вправо, вверх и вниз - с границами кольца
    for (int i=1;i<ring.size();i++){// цикл по всем вершинам кольца. Цикл начнётся со второй точки 
      Double[] R=ring.get(i-1);//предыдущая точка при обходе кольца
      Double[] C=ring.get(i);//текущая точка при обходе кольца
      if (Math.abs(C[1] - R[1]) >= Math.abs(C[1] - y) + Math.abs(y - R[1])) {// Проверям отрезок  RC. Верхняя точка отрезка RC должна быть выше точки p, 
          //а нижняя точка отрезка RC должна быть ниже точки p (отрезок слева или справа от точки)
        double H = (y - R[1]) * (C[0] - R[0]) / (C[1] - R[1]) - x + R[0]; // Если это так, то считаем H - расстояние от точки p до отрезка RC по горизонтали   
    if (H>0) { // Если найденное расстояние положительное - отрезок RC находится справа от точки p
       if (pmin==null)pmin=H;
       else pmin=Math.min(pmin, H); // Обновляем минимум до границы кольца
       n[0]++; // увеличиваем счётчик пересечений справа
      } else { // Если найденное расстояние отрицательное - отрезок RC находится слева от точки p
       if (pmin==null)pmin=-H;
       else pmin=Math.min(pmin, -H); // Обновляем минимум до границы кольца
       n[1]++; // увеличиваем счётчик пересечений слева
      }
      }
     if (Math.abs(C[0] - R[0]) >= Math.abs(C[0] - x) + Math.abs(x - R[0])) {//Проверям отрезок RC. Левая точка отрезка RC должна быть левее точки p, 
         //а правая точка отрезка RC должна быть правее точки p (отрезок над или под точкой)
        double V = (x - R[0]) * (C[1] - R[1]) / (C[0] - R[0]) - y + R[1]; // Если это так, то считаем V - расстояние от точки p до отрезка RC по вертикали  
         if (V>0) { // Если найденное расстояние положительное - отрезок RC находится сверху от точки p
          if (pmin==null)pmin=V;
          else pmin=Math.min(pmin, V); // Обновляем минимум до границы полигона
          n[2]++; // увеличиваем счётчик пересечений сверху
              } else {// Если найденное расстояние отрицательное - отрезок RC находится снизу от точки p
             if (pmin==null)pmin=-V;       
             else pmin=Math.min(pmin, -V); // Обновляем минимум до границы полигона
           n[3]++; // увеличиваем счётчик пересечений снизу
         }
     } 
    }
    // если во все 4 стороны от точки p есть хотя бы одно перечечение (все числа массива n больше нуля)
   // и хотя бы одно количество пересечений четырёх лучей со сторонами полигона нечётное,
   // то точка находится внутри полигона и мы вернём минимум расстония от точки до строн полигона и до вершин полигона.
   // иначе точка находится вне полтигона и вернём -1
   if (n[0]>0 && n[1]>0 && n[2]>0 && n[3]>0) {
      if (n[0]%2==1 || n[1]%2==1 || n[2]%2==1 || n[3]%2==1){
          double dp=distancePoint(ring,  x,  y);
          return Math.min(pmin,dp );
      }
   }
    return -1;
    
}
}
