/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Разыскивает в метаданных значение свойства
 */
package luiserver;

import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import java.sql.SQLException;
import java.util.ArrayList;

/**
 *
 * @author aliubushkin
 */
public class LuiMetaDataValue {
public static char genesis='D';
private static final String STMT4LOAD="Select value,is_multilang from lui_t_value where property_code='<prop_code>' and app_code='<app_code>' and form_code <form_code> and config_code <config_code> and element_code <element_code>";
private static final String STMT4PARENTCONF="select config_code from lui_t_config where app_code='<app_code>' and form_code='<form_code>' and code='<config_code>'";
static String get(String pApp4Find,LuiApplication pApp,LuiDbConn pConn,String pFormCode,String pFormType,String pConfigCode,String pElementCode,String pElementType,String pItemTemplate, String pPropCode,String pFormTemplate)throws SQLException{
    return NVL(gett(NVL(pApp4Find,pApp.code),pApp,pConn,pFormCode,pFormType,pConfigCode,pElementCode,pElementType,pItemTemplate,pPropCode,pFormTemplate),"");
}
/**
 * 
 * @param pApp4Find - код приложения в метаданных которого хранится искомое
 * @param pApp - целевое приложение
 * @param pConn - соединение
 * @param pFormCode - код формы
 * @param pFormType - тип формы
 * @param pConfigCode - код конфигурации
 * @param pElementCode - код элемента
 * @param pElementType - тип элемента
 * @param pPropCode - код св-ва формы или элемента
 * @param pItemTemplate - шаблон элемента
 * @return неизвестно что
 * @throws SQLException ошибка выполнения SQL-запроса
 */
public static String gett(String pApp4Find,LuiApplication pApp,LuiDbConn pConn,String pFormCode,String pFormType,String pConfigCode,String pElementCode,String pElementType,String pItemTemplate, String pPropCode,String pFormTemplate) throws SQLException{
 String stmt;
 genesis='D';
 stmt=STMT4LOAD;
 stmt=stmt.replace("<app_code>", pApp4Find);
 stmt=stmt.replace("<prop_code>", pPropCode);
 
 if (is_null(pFormCode)){stmt=stmt.replace("<form_code>", "is null");}
 else {stmt=stmt.replace("<form_code>","='"+pFormCode+"'");}
 if (is_null(pConfigCode)){stmt=stmt.replace("<config_code>", "is null");}
 else {stmt=stmt.replace("<config_code>","='"+pConfigCode+"'");}
 if (is_null(pElementCode)){stmt=stmt.replace("<element_code>", "is null");}
 else {stmt=stmt.replace("<element_code>","='"+pElementCode+"'");}
    
        ArrayList<String>vl=pConn.getSelectFirstRowValList(stmt);
      if (vl!=null){  
        genesis='M';
        if ("Y".equals(vl.get(1))){
          return pApp.NLS.NLS(vl.get(0));
        }
        else {
            return vl.get(0);
        } }
      else{ // значение не найдено
        if (is_not_null(pFormCode) & is_not_null(pConfigCode)){ //и если задана конфигурация и форма
          stmt=STMT4PARENTCONF.replace("<app_code>", pApp4Find);
          stmt=stmt.replace("<form_code>", pFormCode);
          stmt=stmt.replace("<config_code>", pConfigCode);
          String parentConf=pConn.getSelectResult(stmt);
          if (is_not_null(parentConf)){ // и если найдена родительская конфигурация ищем в ней
              return get(pApp4Find,pApp,pConn,pFormCode,pFormType,parentConf,pElementCode,pElementType,pItemTemplate, pPropCode,pFormTemplate);
          } else { // если нет в родительской конфигурации надо порыться в сначала в докальной шаблонной
            if(is_not_null(pElementCode)&& is_not_null(pPropCode) && is_not_null(pItemTemplate)
                    //&& !((pFormType+"_TEMPLATE").equals(pFormCode))
                    ) {
             if (pApp.formTemplates.containsKey(pFormTemplate)){
               LuiAppForm frm=pApp.formTemplates.get(pFormTemplate);
               if (frm.elements.containsKey(pItemTemplate)){
                   LuiAppElement tel=frm.elements.get(pItemTemplate);
                   if (tel.properties.containsKey(pPropCode)) {
                       
                       //if (is_not_null(tel.properties.get(pPropCode).currentValue))
                       //    return tel.properties.get(pPropCode).currentValue;
                       //else {if (is_not_null(tel.properties.get(pPropCode).startedValue))
                           genesis='T';
                           return tel.properties.get(pPropCode).startedValue;
                       //}
                   }
               }
             } 
            }
            if(is_null(pElementCode)&& is_not_null(pPropCode) && is_null(pItemTemplate)
                    //&& !((pFormType+"_TEMPLATE").equals(pFormCode))
                    ) {
                if (!pPropCode.equals("FEATURE")){
                    if (pApp.formTemplates.containsKey(pFormTemplate)){
                    LuiAppForm frm=pApp.formTemplates.get(pFormTemplate);
                    if (frm.properties.containsKey(pPropCode)) {
                        genesis='T';
                        return frm.properties.get(pPropCode).startedValue;
                    }
                    }
                }
                
            }
          }
        }
      }
    
 return null;    
}

}
