/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package luiserver;

import java.util.HashMap;

/**
 *
 * @author aliubushkin
 */
public class LuiPerformance {
  public class stat {
     long cnt; 
     long totalTime;   // для пропертей это = totalCalcTime
                       // для элементов, форм и сеанса это общее время выполнения
                       // включая время простоя из пользователя (смотрит, вводит)
     long avgTime;
     long hwmTime;
     long lwmTime;
     long lastStart;
     long lastEnd;
     long totalCalcTime;// общее время вычислений исключая простои по вине юзера
  }
 public class elStat{
   stat el;  
   HashMap<String,stat> elProps;
 } 
 public class frmStat{
   stat frm;
   HashMap<String,stat> frmProps;
   HashMap<String,elStat> elStats;
   
 }
 public class sesStat{
   stat ses;
   String AppCode;
   String userName;
   long start;
   long end;
   HashMap<String,stat> appProps;
   HashMap<String,frmStat> frmStats;
   
 }
 HashMap<String,sesStat> sesStats;
public void start(String pLevel,String pSesID,String pAppCode,String pUserName, 
        String pFrmCode, String pElCode, String pPropCode){
 if (pLevel.charAt(0)=='N')return;
  if (sesStats==null) sesStats=new HashMap<>();
  sesStat ses;
  frmStat frm = null;
  elStat el = null;
  stat prs;
  if (!sesStats.containsKey(pSesID)) {
    ses=new sesStat();
    ses.AppCode=pAppCode;
    ses.userName=pUserName;
    ses.start=System.currentTimeMillis();
    ses.end=-1;
    sesStats.put(pSesID, ses);
  } else {
      ses = sesStats.get(pSesID);
  }
  if (pFrmCode!=null){
    if (ses.frmStats==null) ses.frmStats=new HashMap<>();
    if (!ses.frmStats.containsKey(pFrmCode)){
    frm =new frmStat();
    frm.frm=new stat();
    frm.frm.cnt=0;
    ses.frmStats.put(pFrmCode, frm);
    } else {
        frm=ses.frmStats.get(pFrmCode);
    }
    if (pElCode==null && pPropCode==null){
      frm.frm.cnt++;
      frm.frm.lastStart=System.currentTimeMillis();
      frm.frm.lastEnd=-1;
    }
    if (pLevel.charAt(0)=='F')return;
    if (pElCode!=null){
      if (frm.elStats==null) frm.elStats=new HashMap<>();  
      if (!frm.elStats.containsKey(pElCode)){
        el=new elStat();
        el.el=new stat();
        el.el.cnt=0;
        frm.elStats.put(pElCode, el);
      } else el=frm.elStats.get(pElCode);
      if (pPropCode==null){
         el.el.cnt++;
         el.el.lastStart=System.currentTimeMillis();
         el.el.lastEnd=-1;
      }
    }
  }
  if (pLevel.charAt(0)=='E')return;
 if (pPropCode!=null){
  if (pFrmCode==null) {
    if (ses.appProps==null) ses.appProps=new HashMap<>();
    if (!ses.appProps.containsKey(pPropCode)){
       prs = new stat();
       prs.cnt=0;
       ses.appProps.put(pPropCode, prs);
    } else prs=ses.appProps.get(pPropCode);
    prs.cnt++;
    prs.lastStart=System.currentTimeMillis();
    if (frm!=null && frm.frm!=null){
    frm.frm.lastEnd=-1;}
  } else {
      if (pElCode==null){
        if (frm.frmProps==null) frm.frmProps=new HashMap<>();
        if (!frm.frmProps.containsKey(pPropCode)){
            prs = new stat();
            prs.cnt=0;
            frm.frmProps.put(pPropCode, prs);
        } else prs=frm.frmProps.get(pPropCode);
        prs.cnt++;
        prs.lastStart=System.currentTimeMillis();
        prs.lastEnd=-1;
      } else {
          if (el.elProps==null) el.elProps=new HashMap<>();
          if (!el.elProps.containsKey(pPropCode)){
             prs = new stat();
             prs.cnt=0;
             el.elProps.put(pPropCode, prs); 
          }else prs=el.elProps.get(pPropCode);
        prs.cnt++;
        prs.lastStart=System.currentTimeMillis();
        prs.lastEnd=-1;
      }
  }  
 } 
}
public void end(String pSesID,String pAppCode,String pUserName, String pFrmCode, String pElCode, String pPropCode){
   if (!sesStats.containsKey(pSesID)) return;
   sesStat ses=sesStats.get(pSesID);
   if (pFrmCode==null){
     if (ses.end!=-1) return;
     ses.end=System.currentTimeMillis();
     return;
   }
   if (!ses.frmStats.containsKey(pFrmCode)) return;
   frmStat frm=ses.frmStats.get(pFrmCode);
   if (pElCode==null){
      if (frm.frm.lastEnd!=-1)return;
      frm.frm.lastEnd=System.currentTimeMillis();
      long dur=frm.frm.lastEnd-frm.frm.lastStart;
      frm.frm.totalTime=frm.frm.totalTime+dur;
      frm.frm.avgTime=frm.frm.totalTime/frm.frm.cnt;
      if (dur<frm.frm.lwmTime)frm.frm.lwmTime=dur;
      if (dur>frm.frm.hwmTime)frm.frm.hwmTime=dur;
      return;
   }
   if (!frm.elStats.containsKey(pElCode))return;
   elStat el=frm.elStats.get(pElCode);
   if (pPropCode==null){
      if (el.el.lastEnd!=-1)return; 
      el.el.lastEnd=System.currentTimeMillis();
      long dur=el.el.lastEnd-el.el.lastStart;
      el.el.totalTime=el.el.totalTime+dur;
      el.el.avgTime=el.el.totalTime/el.el.cnt;
      if (dur<el.el.lwmTime)el.el.lwmTime=dur;
      if (dur>el.el.hwmTime)el.el.hwmTime=dur;
      return;
   }
   if (!el.elProps.containsKey(pPropCode))return;
   stat prs=el.elProps.get(pPropCode);
   if (prs.lastEnd!=-1) return;
   prs.lastEnd=System.currentTimeMillis();
      long dur=prs.lastEnd-prs.lastStart;
      prs.totalTime=prs.totalTime+dur;
      prs.totalCalcTime=prs.totalTime;
      prs.avgTime=prs.totalTime/prs.cnt;
      //if (el!=null){
      el.el.totalCalcTime=el.el.totalCalcTime+dur;
      //}
      //if (frm!=null){
      frm.frm.totalCalcTime=frm.frm.totalCalcTime+dur;
      //}
      if (dur<prs.lwmTime)prs.lwmTime=dur;
      if (dur>prs.hwmTime)prs.hwmTime=dur;
   
}
}
