/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Интерфейсный класс для интерпретаторов
 */
package luiserver;


import LuiExceptionMsg.LuiException;
import java.sql.SQLException;


/**
 *
 * @author aliubushkin
 */
public interface LuiPlugin {
public void setContext(LuiApplication pContext);
public String compute(String pString,LuiAppProp pProp) throws LuiException,SQLException;
public void execute(String pString,LuiAppProp pProp)throws LuiException,SQLException;
public void findDependency(String pString,LuiAppProp pProp)throws LuiException,SQLException;
// Интерфейс (с дефолтным методом) для грамотного маскирования кавычек
default public String quoteMask(String prefixString, String Value) {
  return Value; 
  //return LuiParser.reMask(Value); //делели так но вредит при ссылка на не существующие элементы {F:XXXX}
}
// Интерфейс (с дефолтным методом) для провеки необходимости маскирования того  что вернёт этот плагин
default public boolean needRunImplant() {
  return true;
}

}
