/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package luiserver;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.LTrim;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.ConcurrentModificationException;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;

/**
 *
 * @author aliubushkin
 */
public class LuiRTdashboard extends Thread {
/* Классы для echarts*/
      
 public class option{
//  ArrayList<String> color;
   
  Boolean animation;
  Long animationDurationUpdate;
  Long animationDuration;
  String animationEasingUpdate;
  String animationEasing;
  eToolTip tooltip;
  ArrayList<eLegend> legend;
  ArrayList<eGrid> grid;
  ArrayList<eAxis> xAxis;
  ArrayList<eAxis> yAxis;
  ArrayList<eSerie> series;
  ArrayList<eGraphic> graphic;
  ArrayList<eTitle> title;
  
 } 
 //
 
 // заголовок грида
 private class eGrTxtStyle{
    String text;
    String textAlign; //center
    String font; //1px или 2px
    String fill; //color
 }
 private class eGraphic{
     String type;
     String left;
     String top;
     eGrTxtStyle style;
     String onclick;
 }
 private class eTitle{
     String text;
     Boolean triggerEvent;
     String left;
     String top;
     String textAlign;
     textStyle textStyle;
 }
         // legend
  private class eLegendData{
      String name;
      String icon;
  }  
  private class eLegend{
    String orient;
    String left;
    String top;
    String icon;
    ArrayList<eLegendData> data;
  }  
 // toolTip
  private class eToolTip{
    Boolean show;
    String trigger;
  }
  
  // grid
  private class eGrid{
     Integer id;
     String left;
     String top;
     String right;
     String width;
     String height;
     
  }
  // атрибуты оси
  private class eAxisLine{
    elStyle lineStyle;  
  }
  private class plitLine{
      Boolean show;
      String  length;
      elStyle lineStyle;
  }
  private class textStyle{
      String color;
      Integer fontSize;
  }
  private class eAxisLabel{
      Integer fontSize;
      Boolean show;
      String color;
   }  
  private class eAxisTick{
      elStyle lineStyle;
      Boolean show;
  }
// ось
  private class eAxis {
      Integer id;
      Integer gridIndex;
      String type;
      eAxisLabel axisLabel;
      plitLine splitLine;
      Integer nameGap;
      textStyle nameTextStyle;
      eAxisTick axisTick;
      String name;
      String position;
      eAxisLine axisLine;
      Boolean show;
      Boolean triggerEvent;
      Boolean inverse;
 Boolean animation;
  Long animationDurationUpdate;
  Long animationDuration;
  String animationEasingUpdate;
  String animationEasing;
  }
  // стиль линии
  private class elStyle{
      Integer width;
      String color;
      Integer shadowBlur;
      String shadowColor;
      Integer shadowOffsetX;
      Integer shadowOffsetY;
  }
  // элемент данных кривой
  
  private  class dataElement {
    String name;  
    Object[] value=new Object[2];
        public dataElement(String pName,Double pValue) {
           name=pName;
           value[0]=pName;
           value[1]=pValue;
        }
        public dataElement(String pName,Object pValue) { // оверлоадинг
           name=pName;
           value[0]=pName;
           value[1]=pValue;
        }
   eItemStyle itemStyle;  
  }
  private class eGauDetail{
    Boolean show;
  }
  private class eGauTitle{
    Boolean show;
  }

  private class eGauAxisTick{
    Boolean show;  
  }
  private class eGauPointer{
    Integer width;  
  }
  private class eGauAxisLine {
    elStyle lineStyle;
    
  }
  private class eLabel{
    Boolean show;
  }
  private class eAreaStyle{
    String color;  
    Double opacity;
  }
  private class eColorStop{
      Double offset;
      String color;
  }
  
  private class eExtColor{
     String type; // linear,radial
     Double x;
     Double y;
     Double x2;
     Double y2;
     Double r;
     ArrayList<eColorStop> colorStops;
     Boolean global;
  }
  private class eItemStyle{
    Object color;
    Double opacity;
    Integer shadowBlur;
    Integer shadowOffsetY;
    Integer shadowOffsetX;
    String  shadowColor;
  }
  // кривуля
  private class eSerie{
      
      eToolTip tooltip;
      Integer id;
      Integer xAxisIndex;
      Integer yAxisIndex;
      String name;
      String type;
      Boolean smooth;
      String smoothMonotone;
      Boolean step;
      Boolean showSymbol;
      Boolean hoverAnimation;
      elStyle lineStyle;
      eItemStyle itemStyle;
      eAreaStyle areaStyle;
      ArrayList<dataElement> data;
      eGauDetail detail;
      eGauAxisTick axisTick;
      eGauPointer pointer;
      eGauAxisLine axisLine;
      String[] center;
      String radius;
      String right;
      String left;
      String top;
      String width;
      String height;
      Double min;
      Double max;
      String barWidth;
      eAxisLabel axisLabel;
      plitLine splitLine;
      eGauTitle title;
//      Boolean silent;
      eLabel  label;
      Integer splitNumber;
      Integer symbolSize;
  }

 
/* Кдассы из БД*/    
  private class Baxi{
      String id;
      Integer    xIndex;
      Integer    yIndex;
      Integer    gridIndex;
      String axis_type;
      String data_type;
      String name;
      String chart_id;
      String color_name;
      String color_tick;
      String color_label;
      String color_line;
      String auto_color;
      String position;
      Integer name_fontsize;
      Integer label_fontsize;

  }
  private class Bchart{
      String id;
      int seq;
      Integer gridIndex;
      String name;
      String notes;
      int dur;
      int size;
      String rt_indicator;
      Double rt_indicator_max;
      Double rt_indicator_min;
      Integer indicatorGridIndex;
      Integer indicatorXindex;
      Integer indicatorYindex;
      String name_font;
      String name_fill;
      int top;
      int height;
      String x_inversion;
  }
  public class BdataSource{
      String id;
      String db_connect;
      String main_query;
      String key_collection;
      String name;
      String queryText="";
      PreparedStatement pStmt;
      String genesis;
      String column_collection;
      String column_collection4time;
  }
  private class Bserie{
      String id;
      String type;
      String y_axis_id;
      String x_axis_id;
      Integer yAxisIndex;
      Integer xAxisIndex;
      String chart_id;
      String dataSource_id;
      String key_collection;
      String key_where;
      String measure;
      Double opacity;
      String color;
      String data_type;
      String expression;
      String expression4time;
      String name;
      String notes;
      Double lastRawValue;
      Double newValue2show;
      Double min;
      Double max;
      Integer width;
      Integer indicatorSerieIndex;
      ArrayList<dataElement> data=new ArrayList<>();
      ArrayList<dataElement> dataSnap=new ArrayList<>();
      Double minSnap;
      Double maxSnap;
      Double newValue2showSnap;
      String lastTime;
  }
  private class Barithm{
      String id;
      String series_id;
      String dataSource_id;
      String expression;
      String measure;
      String key_collection;
      String key_where;
      Double lastRawValue;
      Double newValue2add;
      String name;
  }
    public Integer id;
    String name;
    String notes;
    Integer frequency=60;
    String run_from_main_menu="N";
    LuiApplication app;
    LuiDbConn lc;
    Boolean changed=true;
    Boolean clear=false;
    LinkedHashMap<String,Bchart> Bcharts=new LinkedHashMap<>();
    LinkedHashMap<String,BdataSource> BdataSources=new LinkedHashMap<>();
    LinkedHashMap<String,Bserie> Bseries=new LinkedHashMap<>();
    LinkedHashMap<String,Baxi> Baxis=new LinkedHashMap<>();
    LinkedHashMap<String,Barithm> Barithmetics=new LinkedHashMap<>();
    HashMap<String,LuiDbConn> Bconnections=new HashMap<>();
    LuiAppForm frm;
    public option opt;
    Long lastUpdate=null;
    ArrayList<Long> delayArray=new ArrayList<>();
    long lastD=0; // последняя паразитная задержка
    int  lastSignD=0; // последний знак производной от паразитной задержки
    int  countSignD=0; // сколько раз подряд производная от паразитной задержки сохраняет свой знак
    boolean showtooltip=false;
    Long updateCount=null;
    Long TotUpdTime=null;
    long timertick=0;
    String status="";
    Date d=new Date();
    Long parazit=Long.valueOf(0);
    //SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.ms");
    SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
    Long currentTime;
    Boolean getRunning=false;
    Long skipGet=null;
   public LuiRTdashboard(Integer pId,LuiApplication pApp,String pFormID) throws SQLException, LuiException{
        this.changed = true;
      id=pId; 
      app=pApp;
      frm=app.forms.get(pFormID);
      
      load();
   }
   public String get(Long pAnimationDurationUpdate) throws LuiException, SQLException{
    boolean timer=true;
    if (frm.getProperty("rtTimer").equals("N"))timer=false;
    synchronized(getRunning){
     if (getRunning) return "{}";
     getRunning=true;
    }

    long freq;
    if (frequency==null)return "{}";
    synchronized(this.frequency){     
    freq=Long.valueOf(frequency);
    }
    if (freq>60)freq=1000;
    else freq=1000*60/freq;
   
    synchronized(clear){
    synchronized(changed){
      //long cTu=System.currentTimeMillis();
      long cTu;
      if (currentTime==null)return "{}";
      synchronized(currentTime){
      cTu=currentTime;
      }
      opt=new option();
      
      if (clear) {changed=true;}
      if (changed){
      opt.animation=true;
      opt.animationEasingUpdate="linear";
      opt.animationEasing="linear";
      opt.animationDuration=Long.valueOf(0);
      }
      if (pAnimationDurationUpdate==null){
      if (skipGet!=null){
          if (cTu<skipGet)
          try{
          Thread.sleep(skipGet-cTu);
          } catch (Exception ex){}
          skipGet=null;
          
      }
      if (lastUpdate==null){
        
        opt.animationDurationUpdate=freq;
        
        lastUpdate=cTu;
        updateCount=Long.valueOf(0);
        TotUpdTime=Long.valueOf(0);
        
      } else {
        updateCount++;
        if (cTu-lastUpdate>0) { // время от последнего get
        long d=cTu-lastUpdate-freq; // паразитная задержка
        
        TotUpdTime=TotUpdTime+d; // сумма паразитных задержек
        
        // коэфф. адаптации
        int k=4;
        int newSignD=0; // новый знак производной
        if (lastD<d) {// время задержки увеличилось
          newSignD=1;  
        } 
        if (lastD>d){// время задержки умешьшилось
          newSignD=-1;     
        }
        if (lastSignD==newSignD) {
            countSignD++;
        } else {
            countSignD=0;
        }
        k=k-countSignD;
        if (k<1)k=1;
         long dK=lastD+(d-lastD)/k;
        
        // конец коэфф-та адаптации
        
        // среднее за последние N мгновений
        long dA=0;
        int delaySize=delayArray.size();
        if (delaySize<15) {
            delayArray.add(d);
        } else {
            delayArray.remove(0);
            delayArray.add(d);
        }
            for(int i=0;i<delaySize;i++) dA=dA+delayArray.get(i);
            dA=dA/15;
        d=dA;//+dK/2;
        opt.animationDurationUpdate=freq+d;//+ dA;
                //TotUpdTime/updateCount;
        lastD=d;
        synchronized(parazit){
          parazit=d;  
        }
        }
                //cTu-lastUpdate;
               //Long.valueOf(1225);
               //TotUpdTime/updateCount;
               //Long.valueOf(2000);
         
        lastUpdate=cTu;
      } 
    } else {
           opt.animationDurationUpdate=pAnimationDurationUpdate;
           skipGet=cTu+pAnimationDurationUpdate;
          }
      opt.grid=null;
      opt.legend=null;
      opt.graphic=null;
      opt.title=null;
      opt.xAxis=null;
      opt.yAxis=null;
      opt.series=null;
      opt.tooltip=null;
      if (Bcharts==null)return "{}";
      if (Bcharts.size()==0)return "{}";
      int h=100/Bcharts.size();// %% под каждый грид
   //   int cr=0;
      // крутим чарты 
      for (String chid:Bcharts.keySet()){
          eLegend eLeg=null; // обнулим легенду грида
        // заголовок грида
        if (changed) { // если общие изменения, то сделаем заголовки,гриды и оси
      if (this.showtooltip){
      eToolTip ett=new eToolTip();
      ett.show=true;
      ett.trigger="axis";
      opt.tooltip=ett; }  
         if (is_not_null(Bcharts.get(chid).name)){
          /*if (opt.graphic==null)opt.graphic=new ArrayList<>();
          eGrTxtStyle graphStl=new eGrTxtStyle();
          graphStl.font=Bcharts.get(chid).name_font+" Arial";
          graphStl.fill=this.getColor(Bcharts.get(chid).name_fill);
          graphStl.textAlign="center";
          graphStl.text=Bcharts.get(chid).name;
          eGraphic graph=new eGraphic();
          graph.left="15%";
          graph.type="text";
          graph.top=String.valueOf((Bcharts.get(chid).seq-1)*h+0) + "%";
          graph.style=graphStl;
          //graph.onclick="chartOnClick()";
          //graph.onclick="chartOnClick(\""+frm.getFormID()+"\","+chid+")";
          opt.graphic.add(graph);
          */
          if (opt.title==null)opt.title=new ArrayList<>();
          textStyle titTextStyle=new textStyle();
          titTextStyle.color=this.getColor(Bcharts.get(chid).name_fill);
          titTextStyle.fontSize=Integer.valueOf(Bcharts.get(chid).name_font.replace("px",""));
          eTitle titl=new eTitle();
          titl.textStyle=titTextStyle;
          titl.text=Bcharts.get(chid).name;
          titl.triggerEvent=true;
          titl.left="15%";
          titl.top=String.valueOf((Bcharts.get(chid).seq-1)*h+0) + "%";
          opt.title.add(titl);
         } // конец заголовка грида
         // грид
        
        if (opt.grid==null){
            opt.grid=new ArrayList<>();
        }   
        // добавляем грид
        eGrid eGr=new eGrid();
        
        eGr.id=Integer.valueOf(chid);
        // ширина грида
        eGr.width="70%";
        eGr.top = String.valueOf((Bcharts.get(chid).seq-1)*h+6) + "%";
        eGr.left="5%";
        // высота грида в %%
        eGr.height=String.valueOf(h-12)+"%";
        // запомним высоту и положение грида в окне
        Bcharts.get(chid).top=(Bcharts.get(chid).seq-1)*h+6;
        Bcharts.get(chid).height=h-12;
        opt.grid.add(eGr); // добавляем грид
        // оси гридов
        for (String axid:Baxis.keySet()){
         if (!Baxis.get(axid).chart_id.equals(chid)) continue;
         eAxis ya=new eAxis();
         ya.triggerEvent=true;
         ya.id=Integer.valueOf(axid);
         ya.gridIndex=Integer.valueOf(Baxis.get(axid).gridIndex);
         eAxisLabel yal=new eAxisLabel();
         yal.fontSize=Baxis.get(axid).label_fontsize;   //8;
         yal.color=this.getColor(Baxis.get(axid).color_label);
         ya.axisLabel=yal;
         ya.nameGap=5;
         ya.position=Baxis.get(axid).position;
         textStyle nts=new textStyle();
         nts.color=this.getColor(Baxis.get(axid).color_name);
         nts.fontSize=Baxis.get(axid).name_fontsize;
         ya.nameTextStyle=nts;
         eAxisTick atick=new eAxisTick();
         elStyle atickls=new elStyle();
         atickls.color=this.getColor(Baxis.get(axid).color_tick);
         atick.lineStyle=atickls;
         ya.axisTick=atick;
         elStyle als=new elStyle();
         als.color=this.getColor(Baxis.get(axid).color_line);
         eAxisLine al=new eAxisLine();
         al.lineStyle=als;
         ya.axisLine=al;
         ya.name=Baxis.get(axid).name;
         ya.type=Baxis.get(axid).data_type;
         if (Baxis.get(axid).axis_type.equals("Y")) {
             //ya.animation=false;
            ya.animationDuration=Long.valueOf(0);
            if(pAnimationDurationUpdate==null)
             ya.animationDurationUpdate=Long.valueOf(800);
            else
             ya.animationDurationUpdate=pAnimationDurationUpdate;
             ya.animationEasingUpdate="linear"; 
             if (opt.yAxis==null)opt.yAxis=new ArrayList<>();
             opt.yAxis.add(ya);
         }
         if (Baxis.get(axid).axis_type.equals("X")) {
             ya.animationDuration=Long.valueOf(0);
             ya.animationEasingUpdate="linear";
             if (opt.xAxis==null)opt.xAxis=new ArrayList<>();
             if (Bcharts.get(chid).x_inversion.equals("Y"))ya.inverse=true;
             else ya.inverse=false;
             opt.xAxis.add(ya);
         }
        } // кручение осей
        } // общие изменения - заголовки гриды и оси
        // кривые гридов
        for (String sid:Bseries.keySet()) {
        if (!Bseries.get(sid).chart_id.equals(chid)) continue;
         eSerie ser=new eSerie();
         if (changed) { // общие данные кривой
         ser.xAxisIndex=Integer.valueOf(Bseries.get(sid).xAxisIndex);
         ser.yAxisIndex=Integer.valueOf(Bseries.get(sid).yAxisIndex);
         if (Bseries.get(sid).type.equals("step")) {
          ser.type="line";
          ser.step=true;
         } else {
         ser.type=Bseries.get(sid).type;
         ser.step=false;
         }
         ser.smoothMonotone="x";
         ser.smooth=true;
         ser.showSymbol=false;
         ser.name=Bseries.get(sid).name;
         ser.hoverAnimation=false;
       if (ser.type.equals("line")){
       elStyle ls=new elStyle();
       ls.width=this.getSerWidth(sid);
       ls.color=getColor(Bseries.get(sid).color);
       ser.lineStyle=ls;
       //if (Bseries.get(sid).opacity!=0){
        eAreaStyle aS=new eAreaStyle();
        aS.opacity=Bseries.get(sid).opacity;
        aS.color=getColor(Bseries.get(sid).color);
        ser.areaStyle=aS;
       //}
       }
       
        eItemStyle iS=new eItemStyle();
        iS.color=getColor(Bseries.get(sid).color);
      if (ser.type.equals("bar")||ser.type.equals("scatter")){  
        iS.opacity=1-Bseries.get(sid).opacity;
        iS.shadowBlur=this.getSerWidth(sid)*5;
      }
        ser.itemStyle=iS;
       
       if (is_not_null(Bseries.get(sid).name)) { // если у кривой есть имя - имя в легенду
           if (eLeg==null){eLeg=new eLegend();
                       eLeg.orient="vertical";
            eLeg.left="right";
            eLeg.top=String.valueOf((Bcharts.get(chid).seq-1)*h+0) + "%";
            eLeg.icon="none";
            eLeg.data=null;
           }
           if (eLeg.data==null) eLeg.data=new ArrayList<>();
                         eLegendData elde=new eLegendData();
              elde.name=Bseries.get(sid).name;
              elde.icon=this.getColorImageURL(Bseries.get(sid).color);
              eLeg.data.add(elde);
       } // имя в легенду
        } // общие данные кривой
       ser.id=Integer.valueOf(sid);
       ser.data=new ArrayList<>();
       if (timer) {
       synchronized(Bseries.get(sid).data){
       ser.data=Bseries.get(sid).data;
       }} else ser.data=Bseries.get(sid).dataSnap;
       if (opt.series==null)opt.series=new ArrayList<>(); 
       opt.series.add(ser);
       
        } // конец кручения кривых
        if (eLeg!=null) { // если легенда оказалась не пустой
          if (opt.legend==null)  opt.legend=new ArrayList<>();
          opt.legend.add(eLeg);
        }// если легенда оказалась не пустой
        
      } //крутим чарты    
   //обработка индикаторов - если общее изменение то надо сгенерировать грибы баров и
   // общие данные серий индикаторов
   // если нет общих изменений то генерируем только данные серий
   eSerie iser;
   int bari=Bcharts.size();
   for (String cid:Bcharts.keySet()){
  // if (is_null(Bcharts.get(cid).rt_indicator)){ // если нет индикатора, то тупо тнарисуем белый pie
       iser=new eSerie(); 
                  if (changed){
                  iser.type="pie";
                  
                  iser.name="LUI$GrID:"+cid;
//                  iser.silent=true;
                  eLabel lb=new eLabel();
                  lb.show=false;
                  iser.label=lb;
                        int rp=Bcharts.get(cid).height/2;
                            iser.left="73%";
                        
                        if (rp>40) rp=40;
                        
                            iser.top=String.valueOf(Bcharts.get(cid).top+Bcharts.get(cid).height-rp)+"%";
                        iser.height=String.valueOf(rp)+"%";
                            iser.width="35%";
                        iser.radius="100%";
                  iser.hoverAnimation=false;
                  }
                  dataElement dei=new dataElement("LUI$GrID:"+cid+";",100);   
                    dei.itemStyle=new eItemStyle();
                    dei.itemStyle.color="#fff";
                    dei.itemStyle.opacity=0.0;
                    
                    dei.value[0]=100;
                    iser.data=new ArrayList<>();
                    iser.data.add(dei);
                    if (opt.series==null)opt.series=new ArrayList<>();
                    opt.series.add(iser);
    //              continue;
   //}
    if(NVL(Bcharts.get(cid).rt_indicator,"").equals("bar") || NVL(Bcharts.get(cid).rt_indicator,"").equals("scatter")){
        if (changed){
                        eGrid eGr=new eGrid();
      //eGr.right="1%";
                        eGr.right="1.5%";
                        int hi=Bcharts.get(cid).height/2;
                        if (hi>30) hi=30;
                        eGr.top=String.valueOf(Bcharts.get(cid).top+Bcharts.get(cid).height-hi)+"%";
                        eGr.height=String.valueOf(hi)+"%";
                        eGr.width="15%";
//                        if (opt.grid==null)opt.grid=new ArrayList<>();
                        opt.grid.add(eGr);
                      //добавляем ось Х
                        eAxis xAx=new eAxis();
                        eAxisLabel eAl=new eAxisLabel();
                        eAl.show=false;
                        xAx.axisLabel=eAl;
                        eAxisTick xAxT=new eAxisTick();
                        xAxT.show=false;
                        xAx.axisTick=xAxT;
                        xAx.type="category";
                        xAx.gridIndex=bari;
                        //xAx.animation=false; -- есди так сделать, то в случае разнознаковых циллиндров 
                        // у них происходит отрыв жопки от оси Х
                        Bcharts.get(cid).indicatorXindex=opt.xAxis.size();
                        opt.xAxis.add(xAx);
                        // добавляем оcь Y
                        eAxis yAx=new eAxis();
                        yAx.axisLabel=eAl;
                        yAx.show=false;
                        yAx.type="value";
                        yAx.animation=false;
                        plitLine spl=new plitLine();
                        spl.show=false;
                        yAx.splitLine=spl;
                        yAx.gridIndex=bari;
                        Bcharts.get(cid).indicatorYindex=opt.yAxis.size();
                        opt.yAxis.add(yAx);
                        Bcharts.get(cid).indicatorGridIndex=bari;
        }         
                        bari++;
      for (String sid:Bseries.keySet()){
      if (!Bseries.get(sid).chart_id.equals(cid)) continue;  
      iser=new eSerie();    
      if (changed){
                        // серия про шары или bar
                        iser.type=Bcharts.get(cid).rt_indicator;
                        eToolTip itt=new eToolTip();
                        itt.show=false;
                        iser.tooltip=itt;
                        iser.name="LUI$GrID:"+cid+";SerID:"+sid+";";
//                        iser.silent=true;
                        eItemStyle iS=new eItemStyle();
                        
                        if (Bcharts.get(cid).rt_indicator.equals("scatter")) 
                        {   iser.symbolSize=20;
                            iS.shadowOffsetY=10;
                            iS.shadowBlur=10;
                            iS.shadowOffsetX=5;
                            iS.shadowColor="rgba(120, 36, 50, 0.5)";
                            eExtColor extC=new eExtColor();
                            extC.global=false;
                            extC.type="radial";
                            extC.x=0.22;
                            extC.y=0.28;
                            extC.x2=1.0;
                            extC.y2=0.0;
                            ArrayList<eColorStop> cSa=new ArrayList<>();
                            eColorStop cS1=new eColorStop();
                            cS1.color="#eee";
                            cS1.offset=0.0;
                            eColorStop cS2=new eColorStop();
                            cS2.color=this.getColor(Bseries.get(sid).color);
                            cS2.offset=0.99;
                            cSa.add(cS1);
                            cSa.add(cS2);
                            extC.colorStops=cSa;
                            iS.color=extC;
                        }
                        if (Bcharts.get(cid).rt_indicator.equals("bar")) 
                        {
                            iS.shadowOffsetY=0;
                            iS.shadowBlur=15;
                            iS.shadowOffsetX=15;
                            iS.shadowColor="#999";
                            eExtColor extC=new eExtColor();
                            extC.global=false;
                            extC.type="linear";
                            extC.x=-0.09;
                            extC.y=0.0;
                            extC.x2=1.0;
                            extC.y2=0.0;
                            ArrayList<eColorStop> cSa=new ArrayList<>();
                            eColorStop cS1=new eColorStop();
                            cS1.color=this.getColor(Bseries.get(sid).color);
                            cS1.offset=0.0;
                            eColorStop cS2=new eColorStop();
                            cS2.color="#ccc";
                            cS2.offset=0.35;
                            eColorStop cS3=new eColorStop();
                            cS3.color=this.getColor(Bseries.get(sid).color);
                            cS3.offset=0.8;
                            cSa.add(cS1);
                            cSa.add(cS2);
                            cSa.add(cS3);
                            extC.colorStops=cSa;
                            iS.color=extC;
                        }
                        iser.itemStyle=iS;
                        iser.hoverAnimation=false;
                        iser.xAxisIndex=Bcharts.get(cid).indicatorXindex;
                        iser.yAxisIndex=Bcharts.get(cid).indicatorYindex;
                        if (Bcharts.get(cid).rt_indicator.equals("bar"))iser.barWidth="30%";
                        // запомним ноиер серии в серии
                        if (opt.series==null) Bseries.get(sid).indicatorSerieIndex=0;
                        else
                        Bseries.get(sid).indicatorSerieIndex=opt.series.size();                        
      } 
        // надо добавить данные в индикаторные серии и серию в opt
      iser.data=new ArrayList<>();
      if (timer) dei=new dataElement("LUI$GrID:"+cid+";SerID:"+sid+";",Bseries.get(sid).newValue2show);   
      else dei=new dataElement("LUI$GrID:"+cid+";SerID:"+sid+";",Bseries.get(sid).newValue2showSnap);   
      iser.data.add(dei);
      if (opt.series==null)opt.series=new ArrayList<>();
      opt.series.add(iser);  
      }
    }
    if (NVL(Bcharts.get(cid).rt_indicator,"").equals("gauge")){
                  iser=new eSerie();    
                  
                  if (changed) {
                        iser.name="LUI$GrID:"+cid;
                        iser.type="gauge";
//                        iser.silent=true;
                        iser.splitNumber=4;
                        eAxisLabel eal=new eAxisLabel();
                        /*eal.fontSize=7;
                        eal.color="#000";*/
                        eal.show=false;
                        iser.axisLabel=eal;
                        eGauTitle eGt=new eGauTitle();
                        eGt.show=false;
                        iser.title=eGt;
                        eGauAxisLine al=new eGauAxisLine();
                        elStyle ls=new elStyle();
                        ls.width=5;
                        ls.shadowColor="#999";
                        ls.shadowBlur=5;
                        ls.shadowOffsetX=5;
                        ls.shadowOffsetY=5;
                        al.lineStyle=ls;
                        iser.axisLine=al;
                        plitLine gspl=new plitLine();
                        gspl.length="25%";
                        ls=new elStyle();
                        ls.color="auto";
                        ls.shadowColor="#999";
                        ls.shadowBlur=5;
                        ls.shadowOffsetX=5;
                        ls.shadowOffsetY=5;
                        gspl.lineStyle=ls;
                        iser.splitLine=gspl;
                        iser.axisLine=al;
                        iser.itemStyle=new eItemStyle();
                        iser.itemStyle.shadowBlur=5;
                        iser.itemStyle.shadowOffsetX=5;
                        iser.itemStyle.shadowOffsetY=5;
                        iser.itemStyle.shadowColor="#999";
                        eGauAxisTick gatk=new eGauAxisTick();
                        gatk.show=false;
                        iser.axisTick=gatk;
                        eGauDetail gade=new eGauDetail();
                        gade.show=false;
                        iser.detail=gade;
                        iser.hoverAnimation=false;
                        eGauPointer gapo=new eGauPointer();
                        gapo.width=3;
                        iser.pointer=gapo;
                        int r=Bcharts.get(cid).height/2;
                        if (r>40)r=40;
                        iser.radius=String.valueOf(r)+"%";
                        String ct=String.valueOf(Bcharts.get(cid).top+Bcharts.get(cid).height-r/4-2)+"%";
                        //iser.center=new String[]{"91.5%",ct};
                        iser.center=new String[]{"91%",ct};
                        iser.max=Bcharts.get(cid).rt_indicator_max;
                        iser.min=Bcharts.get(cid).rt_indicator_min;
                  }
                  /// надо добавить данные и серию
                Double mmin=null;
                Double mmax=null;
                for (String sid:Bseries.keySet()){
                 if (Bseries.get(sid).chart_id.equals(cid)){
                   Double sMax;
                   if (timer)sMax=Bseries.get(sid).max;
                   else sMax=Bseries.get(sid).maxSnap;
                    if (sMax!=null){  
                    if (mmax==null || mmax<sMax) mmax=sMax;
                    }
                   Double sMin; 
                   if (timer)sMin=Bseries.get(sid).min;
                   else sMin=Bseries.get(sid).minSnap;
                    if (sMin!=null){  
                    if (mmin==null || mmin>sMin)mmin=sMin;
                    }
                    if (timer) dei=new dataElement("LUI$GrID:"+cid+";SerID:"+sid+";",Bseries.get(sid).newValue2show);   
                    else  dei=new dataElement("LUI$GrID:"+cid+";SerID:"+sid+";",Bseries.get(sid).newValue2showSnap);   
                    dei.itemStyle=new eItemStyle();
                    dei.itemStyle.color=getColor(Bseries.get(sid).color);
                    
                    //dei.name=null;
                    if (timer) dei.value[0]=Bseries.get(sid).newValue2show;
                    else dei.value[0]=Bseries.get(sid).newValue2showSnap;
                    dei.value[1]=null;
                    if (iser.data==null)iser.data=new ArrayList<>();
                    iser.data.add(dei);
                 }   
                }           
                   if (Bcharts.get(cid).rt_indicator_max==null) iser.max=mmax;
                   if (Bcharts.get(cid).rt_indicator_min==null) iser.min=mmin;
                   if (opt.series==null)opt.series=new ArrayList<>();
                    opt.series.add(iser);
                  }
    
                  if (NVL(Bcharts.get(cid).rt_indicator,"").equals("pie")){
                  iser=new eSerie(); 
                  if (changed){
                  iser.type="pie";
                  iser.name="LUI$GrID:"+cid;
                  eItemStyle sis=new eItemStyle();
                  sis.opacity=0.7;
                  iser.itemStyle=sis;
//                  iser.silent=true;
                  eLabel lb=new eLabel();
                  lb.show=false;
                  iser.label=lb;
                        int rp=Bcharts.get(cid).height/2;
                        //iser.left="84%";
                        iser.left="83.5%";
                        if (rp>40) rp=40;
                        iser.top=String.valueOf(Bcharts.get(cid).top+Bcharts.get(cid).height-rp)+"%";
                        iser.height=String.valueOf(rp)+"%";
                        iser.width="15%";
                        iser.radius="100%";
                  iser.hoverAnimation=false;
                  }
                  // надо добавить данные и саму серию
                  for (String sid:Bseries.keySet()){
                    if (Bseries.get(sid).chart_id.equals(cid)){
                    if (timer) dei=new dataElement("LUI$GrID:"+cid+";SerID:"+sid+";",Bseries.get(sid).newValue2show);   
                    else dei=new dataElement("LUI$GrID:"+cid+";SerID:"+sid+";",Bseries.get(sid).newValue2showSnap);   
                    dei.itemStyle=new eItemStyle();
                    dei.itemStyle.color=getColor(Bseries.get(sid).color);
                    //dei.name=null;
                    if (timer){
                     if (Bseries.get(sid).newValue2show!=null){   
                     double dou=Bseries.get(sid).newValue2show;
                     dou=Math.abs(dou);
                     dei.value[0]=Double.valueOf(dou);
                     } else dei.value[0]=null;
                    } else {
                     if (Bseries.get(sid).newValue2showSnap!=null){   
                     double dou=Bseries.get(sid).newValue2showSnap;
                     dou=Math.abs(dou);
                     dei.value[0]=Double.valueOf(dou);   
                     } else dei.value[0]=null;
                    }

                   if (iser.data==null)iser.data=new ArrayList<>();
                    iser.data.add(dei);
                    }  
                  }
                    if (opt.series==null)opt.series=new ArrayList<>();
                    opt.series.add(iser);
                  }   
    }           
   //конец обработки индикаторов 
//   String s=app.gson.toJson(opt);
//   String s=app.gson.toJsonTree(opt).getAsString();
    
   changed=false;
    }  
    }
   synchronized(getRunning){ 
   getRunning=false;    
   try {
   return app.toJSON(opt);
   } catch (ConcurrentModificationException cex){
     return "{}";
   }
   }

   }
   public void load() throws SQLException, LuiException{
       int xi=0;
       int yi=0;       
       String stmt="";
       BdataSources.clear();
       Bcharts.clear();
       Baxis.clear();
       Bseries.clear();
       Barithmetics.clear();
       lc=null;
       try{
         lc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),
              app.getAppUser());  
       stmt="select name,notes,rt_frequency,run_from_main_menu from lui_t_dashboard where id="+String.valueOf(id);
       LuiCollection c=  lc.getSelectFirstRowValMap(stmt);
       if (c==null){
           status="stop";
           
           return;
       }
       name=c.Get_Element("name");
       notes=c.Get_Element("notes");
       run_from_main_menu=c.Get_Element("run_from_main_menu");
       frequency=Integer.valueOf(NVL(c.Get_Element("rt_frequency"),"60"));
       ArrayList<LuiCollection> ldc=lc.getSelectAllRowsValMap("select id,name,db_connect,main_query,key_collection,genesis,column_collection,column_collection4time from lui_t_dashboard_datasource where dashboard_id="+String.valueOf(id));
       if (ldc!=null){
       for (int i=0;i<ldc.size();i++){
           c=ldc.get(i);
           BdataSource ds=new BdataSource();
           ds.genesis=c.Get_Element("genesis");
           ds.column_collection=c.Get_Element("column_collection");
           ds.column_collection4time=c.Get_Element("column_collection4time");
           ds.db_connect=c.Get_Element("db_connect");
           ds.id=c.Get_Element("id");
           ds.name=c.Get_Element("name");
           ds.main_query=c.Get_Element("main_query");
           ds.key_collection=c.Get_Element("key_collection");
           BdataSources.put(ds.id, ds);
           if (!Bconnections.containsKey(ds.db_connect)){
             if (app.userDbConnections.containsKey(ds.db_connect)){
                 try{
                 LuiDbConn lc=app.userDbConnections.get(ds.db_connect).connPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                 Bconnections.put(ds.db_connect, lc);
                 } catch(SQLException sex){
                 Bconnections.put(ds.db_connect, null);    
                 }
                 
             }
           }
       }}
       stmt="select x_inversion,id,seq,name,notes,rt_duration,rt_indicator,rt_indicator_max,rt_indicator_min,name_font,name_fill from lui_t_dashboard_chart where dashboard_id="+String.valueOf(id)+"order by seq";
       ldc=lc.getSelectAllRowsValMap(stmt);
       for (int i=0;i<ldc.size();i++){
           c=ldc.get(i);
           Bchart cha=new Bchart();
           cha.x_inversion=c.Get_Element("x_inversion");
           cha.id=c.Get_Element("id");
           cha.seq=Integer.valueOf(c.Get_Element("seq"));
           cha.gridIndex=i;
           cha.dur=Integer.valueOf(NVL(c.Get_Element("rt_duration"),"1"));
           cha.size=cha.dur*frequency;
           cha.rt_indicator=c.Get_Element("rt_indicator");
           if (is_not_null(c.Get_Element("rt_indicator_max"))){
           cha.rt_indicator_max=Double.valueOf(c.Get_Element("rt_indicator_max"));
           }
           if (is_not_null(c.Get_Element("rt_indicator_min"))){
           cha.rt_indicator_min=Double.valueOf(c.Get_Element("rt_indicator_min"));
           }
           cha.name=c.Get_Element("name");
           cha.notes=c.Get_Element("notes");
           cha.name_fill=c.Get_Element("name_fill");
           cha.name_font=c.Get_Element("name_font");
           Bcharts.put(cha.id, cha);
           
       }
       for (String chid:Bcharts.keySet()){
        stmt="select id,axis_type,data_type,name,position,color_name,color_tick,color_label,color_line,auto_color,name_fontsize,label_fontsize from lui_t_dashboard_chart_axis where chart_id="+chid+"order by chart_id,axis_type,id";
        ldc=lc.getSelectAllRowsValMap(stmt);
        
        for (int ii=0;ii<ldc.size();ii++){
         c=ldc.get(ii);    
         Baxi ax=new Baxi();
         ax.id=c.Get_Element("id");
         ax.axis_type=c.Get_Element("axis_type");
         ax.data_type=c.Get_Element("data_type");
         ax.name=c.Get_Element("name");
         ax.chart_id=chid;
         ax.gridIndex=Bcharts.get(chid).gridIndex;
         if (ax.axis_type.equals("X")){
             ax.xIndex=xi;
             xi++;
         }
         if (ax.axis_type.equals("Y")){
             ax.yIndex=yi;
             yi++;
         }
         ax.auto_color=c.Get_Element("auto_color");
         ax.position=c.Get_Element("position");
         ax.color_label=c.Get_Element("color_label");
         ax.color_tick=c.Get_Element("color_tick");
         ax.color_name=c.Get_Element("color_name");
         ax.color_line=c.Get_Element("color_line");
         ax.name_fontsize=Integer.valueOf(c.Get_Element("name_fontsize"));
         ax.label_fontsize=Integer.valueOf(c.Get_Element("label_fontsize"));
         Baxis.put(ax.id, ax);
        }
       }
       for (String dsid:BdataSources.keySet()){
        stmt="select id,type,x_axis_id,y_axis_id,key_collection,data_type,expression,expression4time,name,notes,measure,opacity,color,key_where,width from lui_t_dashboard_series where datasource_id="+dsid+" order by id ";        
        ldc=lc.getSelectAllRowsValMap(stmt);
        if (ldc==null) continue;
        for (int ii=0;ii<ldc.size();ii++){
          c=ldc.get(ii);
          Bserie ser=new Bserie();
          ser.data_type=c.Get_Element("data_type");
          ser.dataSource_id=dsid;
          ser.expression=c.Get_Element("expression");
          ser.expression4time=c.Get_Element("expression4time");
          ser.id=c.Get_Element("id");
          ser.key_collection=c.Get_Element("key_collection");
          ser.name=c.Get_Element("name");
          ser.notes=c.Get_Element("notes");
          ser.type=c.Get_Element("type");
          ser.y_axis_id=c.Get_Element("y_axis_id");
          ser.x_axis_id=c.Get_Element("x_axis_id");
          ser.chart_id=Baxis.get(ser.y_axis_id).chart_id;
          ser.xAxisIndex=Baxis.get(ser.x_axis_id).xIndex;
          ser.yAxisIndex=Baxis.get(ser.y_axis_id).yIndex;
          ser.measure=c.Get_Element("measure");
          ser.opacity=Double.valueOf(c.Get_Element("opacity"));
          ser.color=c.Get_Element("color");
          ser.key_where=c.Get_Element("key_where");
          if (is_not_null(c.Get_Element("width"))){
          ser.width=Integer.valueOf(c.Get_Element("width"));
          }
          Bseries.put(ser.id, ser);
        }        
       }
       for (String sid:Bseries.keySet()){
       stmt="select name,id,series_id,datasource_id,expression,measure,key_collection,key_where"
               + " from lui_t_dashboard_arithmetica where series_id="+sid+"order by id";
       ldc=lc.getSelectAllRowsValMap(stmt);
       if (ldc==null)continue;
       for (int i=0;i<ldc.size();i++){
       c=ldc.get(i);
       Barithm ari=new Barithm();
       ari.id=c.Get_Element("id");
       ari.name=c.Get_Element("name");
       ari.dataSource_id=c.Get_Element("datasource_id");
       ari.expression=c.Get_Element("expression");
       ari.measure=c.Get_Element("measure");
       ari.key_collection=c.Get_Element("key_collection");
       ari.key_where=c.Get_Element("key_where");
       ari.series_id=sid;
       Barithmetics.put(ari.id, ari);
       }
       }
       // Окончательно формируем соединения и запросы
       for (String dsid:this.BdataSources.keySet()){
           if (is_not_null(BdataSources.get(dsid).db_connect)){
               BdataSource ds=BdataSources.get(dsid);
           if (!Bconnections.containsKey(ds.db_connect)) {
             if (app.userDbConnections.containsKey(ds.db_connect)){  
               LuiDbConn lc=app.userDbConnections.get(ds.db_connect).connPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
               Bconnections.put(ds.db_connect, lc);
               
             }
             
           }
             this.makeDsQuery(dsid);

           }
       }
       } catch(SQLException sex){
                    try {
         LuiAppProp p = null;
         if (frm.properties.containsKey("ON_LOAD")) {
            p=frm.properties.get("ON_LOAD");
         }
         app.msgWriter.sqlError(lc, sex,p, stmt);
         } catch (SQLException ex1) {
            
         }
       }
      catch (LuiException lex) {
       frm.setVal("Status","Closing");   
       throw lex;   
      }
      finally {
          try {
           if (lc!=null) app.metaConnPool.SetFree(lc);
          } catch(Exception ex){}
       }
  }
public void cleanCurve(String sid){
    String chid=this.Bseries.get(sid).chart_id;
    // ищем в сетке другой график
    synchronized (Bseries){
    for (String asid:Bseries.keySet()){
      if (!asid.equals(sid)&& Bseries.get(asid).chart_id.equals(chid)) {
       if (Bseries.get(asid).data.size()>0){   
      synchronized(Bseries.get(asid).data){
       for (int i=0;i<Bseries.get(asid).data.size();i++){
           dataElement de=new dataElement(Bseries.get(asid).data.get(i).name,null);
           Bseries.get(sid).data.add(de);
       }   
      }    
      return;    
      } }
    }
    }
    if (Bseries.get(sid).data.size()>0) {
      for (int i=0;i<Bseries.get(sid).data.size();i++)  {
          Bseries.get(sid).data.get(i).value[1]=null;
      }
        return;
    }
  synchronized (frequency){    
    synchronized (currentTime){  
    long s=currentTime-1000*Bcharts.get(chid).dur*60;
    for(int i=0;i<Bcharts.get(chid).size;i++){
        d.setTime(s);
        dataElement de=new dataElement(df.format(d),null);
        Bseries.get(sid).data.add(de);
        s=s+Long.valueOf(1000*60/frequency);
    }
  }
} 
}
@Override
public void run(){
dataElement de;    
currentTime=System.currentTimeMillis();
 for (String sid:Bseries.keySet()){
     this.cleanCurve(sid);
  }
 

setStatus("run");
frm.RTrunThread=Thread.currentThread();
        while ("run".equals(getStatus())) {     
        
 synchronized(currentTime) {
        currentTime=System.currentTimeMillis(); 
        d.setTime(currentTime);
 }
    try {
        this.getNewData();
    } catch (SQLException ex) {
        setStatus("stop");
    } catch (LuiException ex) {
        setStatus("stop");
    }
       for (String sid:Bseries.keySet()){
     synchronized(Bseries.get(sid).data){ 
     if (Bseries.get(sid).data.size()>=Bcharts.get(Bseries.get(sid).chart_id).size)    
     Bseries.get(sid).data.remove(0);
     if (Bseries.get(sid).lastTime==null)
     de=new dataElement(df.format(d),Bseries.get(sid).newValue2show);
     else
     de=new dataElement(Bseries.get(sid).lastTime,Bseries.get(sid).newValue2show);    
     Bseries.get(sid).data.add(de);
              }  
            } 
        try {
            Thread.sleep(getSleepTime());
            } catch (InterruptedException ignore) {
              break;  
            }      
        }
     setStatus("");
}
    public void setStatus(String pStatus){
        synchronized (status){
            status=pStatus;
        }
    }
    public String getStatus(){ 
     synchronized (status){
         return status;
     } 
  }
/** Подбор унакльного имени кривой
 * 
 */
public String getUniqueSeriesName(String pName,String pSid) {
 String newName=pName;
 boolean b=true;
 if (is_null(newName)){
     newName=" ";
  while (b){
   b=false;    
   for (String sid:Bseries.keySet()) {
     if (pSid!=null){
         if (pSid.equals(sid))continue;
     }
     if (newName.equals(Bseries.get(sid).name)) {
        b=true;
        newName=newName+" ";
        break;
     }   
   }
  }
  return newName;
 }
 
 int countg=0;
 while (b){
 b=false;    
 for (String sid:Bseries.keySet()) {
     if (pSid!=null){
         if (pSid.equals(sid))continue;
     }
    if (newName.equals(Bseries.get(sid).name)) {
        b=true;
        countg++;
        newName=pName+String.valueOf(countg+1);
        break;
    }
 }
 }
     
 return newName;
}
/** 
 * Добавление значения к кривой
 */
public void add_value2curve(String pFrmID,String pSid,String pMeasure,String pNewName,String pNameAri) throws LuiException, SQLException{
 if(!app.forms.containsKey(pFrmID)) return;//уходи если нет формы
 LuiAppForm pFrm=app.forms.get(pFrmID);
 String concode=pFrm.getProperty("Connection");
 if(!app.userDbConnections.containsKey(concode))return;//уходи если нет соединения
 synchronized(changed){ 
     changed=true;
    LuiDbConn mlc=null;
 PreparedStatement ps=null;
 String stmt="";
 Connection c=null;
 LuiDbConn lc=null;
 try{
 mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 if (!Bconnections.containsKey(concode)){ //если соединения ещё нет в массиве
                 // коннектимся 
                 lc=app.userDbConnections.get(concode).connPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                 // и добавляем в массив
                 Bconnections.put(concode, lc);
             
           } else lc=Bconnections.get(concode);
  //synchronized(changed){    
  //synchronized(Barithmetics){
  if (is_not_null(pNewName)){
      pNewName=this.getUniqueSeriesName(pNewName,pSid);
      Bseries.get(pSid).name=pNewName;
      stmt="update lui_t_dashboard_series set name=nullif(?,'') where id=?";
      ps=c.prepareStatement(stmt);
      ps.setString(1, pNewName);
      ps.setInt(2, Integer.valueOf(pSid));
      ps.execute();
      ps.close();
      ps=null;
  }
  
  // сформируем основное тело запроса
String qstmt=" from ("+pFrm.makeMainQuery()+")q1 where ";// и пустышку ключа
// String qstmt="Select \n"+
//         pFrm.makeMainExpression(lc,true)+"\n From (\n"+
//         pFrm.makeMainQuery()+")q1 where "; 
 
 LuiCollection keyCol=pFrm.getUK();
 LuiCollection eKeyCol=new LuiCollection("");
 for (String ke:keyCol.keySet()){eKeyCol.Add_Element(ke,"");}
 String dsFound=null;
 // ищем полученный запрос среди источников данных
 for(String ds:this.BdataSources.keySet()){
     if (is_null(BdataSources.get(ds).main_query)) continue;
     if (BdataSources.get(ds).main_query.equals(qstmt)){
      if (BdataSources.get(ds).key_collection.equals(eKeyCol.toString())){
         dsFound=ds;break;
      }
     }
 }
 if (dsFound==null){ // не нашли - создаём
    BdataSource newds=new BdataSource();
    newds.db_connect=concode;
    stmt="select nextval('lui_q_dashboard_datasource')";
    newds.id=mlc.getSelectResult(stmt);
    newds.main_query=qstmt;
    newds.key_collection=eKeyCol.toString();
    newds.name=NVL(pFrm.getProperty("HEADER"),"ConfigName");
    newds.name=NVL(pFrm.getProperty("HEADER"),"ConfigName");
    LuiCollection colcol=new LuiCollection("");
    LuiCollection colcol4time=new LuiCollection("");
    for (int i=0;i<pFrm.elements.size();i++){
        LuiAppElement el=pFrm.elSort(i);
        if (el.getType().equals("ITEM")){
          colcol.Add_Element(el.getCode(), el.getName4show());
          if (el.getProperty("DATA_TYPE").equals("DATETIME"))
          colcol4time.Add_Element(el.getCode(), el.getName4show());
        }
    }
    newds.column_collection=colcol.toString();
    newds.column_collection4time=colcol4time.toString();
    colcol.clear();
    colcol.Add_Element("FORM_CODE", pFrm.getCode());
    colcol.Add_Element("CONFIG_CODE", pFrm.getConfigCode());
    colcol.Add_Element("HEADER",newds.name);
    newds.genesis=colcol.toString();
    BdataSources.put(newds.id, newds);
 
    dsFound=newds.id;
    stmt="insert into lui_t_dashboard_datasource(id,dashboard_id,db_connect,main_query,name,key_collection,genesis,column_collection,column_collection4time)"+
    "values(?,?,?,?,?,?,?,?,?)";
    ps=c.prepareStatement(stmt);
    ps.setInt(1, Integer.valueOf(newds.id));
    ps.setInt(2, id);
    ps.setString(3,newds.db_connect);
    ps.setString(4,newds.main_query);
    ps.setString(5,newds.name);
    ps.setString(6,newds.key_collection);
    ps.setString(7,newds.genesis);
    ps.setString(8,newds.column_collection);
    ps.setString(9,newds.column_collection4time);
    ps.execute();
    ps.close();
    ps=null; 
 }
  // создаём арифметику
   Barithm ari=new Barithm();
  
   ari.dataSource_id=dsFound;
   ari.series_id=pSid;
   ari.measure=pMeasure;
   ari.name=pNameAri;
   ari.expression=pFrm.getVal("CurrentColumn");
     ari.key_collection=keyCol.toString();
     ari.key_where="";
     for(String ukcolcode:keyCol.keySet()){
   LuiAppElement el=pFrm.elements.get(ukcolcode);
   String condition=el.getSQLCondition(lc, '='+keyCol.Get_Element(ukcolcode),"N");
   if  (is_not_null(condition)){
    if (is_not_null(ari.key_where)){
   ari.key_where=ari.key_where+" and ";
           }        
   ari.key_where=ari.key_where+condition; 
   }
     }
   ari.key_where=LTrim(ari.key_where," and");
   // Поищем похожую арифметику зеркальной меры
   for(String oai:Barithmetics.keySet()){
     if (Barithmetics.get(oai).series_id.equals(ari.series_id)) {
       if (Barithmetics.get(oai).dataSource_id.equals(ari.dataSource_id)) {
           if (Barithmetics.get(oai).expression.equals(ari.expression)){
             if (Barithmetics.get(oai).key_collection.equals(ari.key_collection)){
                if (
                  (Barithmetics.get(oai).measure.equals("D") && ari.measure.equals("-D")) ||
                  (Barithmetics.get(oai).measure.equals("-D") && ari.measure.equals("D")) ||      
                  (Barithmetics.get(oai).measure.equals("-V") && ari.measure.equals("V")) ||      
                  (Barithmetics.get(oai).measure.equals("V") && ari.measure.equals("-V"))       
                    ){ 
                  delArithmetica(oai,mlc);
                  
                  return;
                }
             }  
           }
       }
     }  
   }
   stmt="select nextval('lui_q_dashboard_arithmetica')";
   ari.id=mlc.getSelectResult(stmt);
   stmt="insert into lui_t_dashboard_arithmetica(id,series_id,datasource_id,expression,key_collection,key_where,measure,name)"
             + "values(?,?,?,?,?,?,?,?)";
   ps=c.prepareStatement(stmt);
   ps.setInt(1,Integer.valueOf(ari.id));
   ps.setInt(2,Integer.valueOf(ari.series_id));
   ps.setInt(3,Integer.valueOf(ari.dataSource_id));
   ps.setString(4,ari.expression);
   ps.setString(5,ari.key_collection);
   ps.setString(6,ari.key_where);
   ps.setString(7,ari.measure);
   ps.setString(8,ari.name);
   ps.execute();
   ps.close();
   ps=null;
   Barithmetics.put(ari.id, ari);
   this.makeDsQuery(dsFound); // окончательное формирование запроса 
   
  
 }catch (SQLException sex){
  app.msgWriter.sqlError(mlc, sex, null, stmt);
  setStatus("stop");
 }
 finally {
     if (mlc!=null){
         if (ps!=null){
             if (!ps.isClosed()){
                 ps.close();
             }
         }
         app.metaConnPool.SetFree(mlc);
     }
 }
}
 }
public void delArithmetica(String pArid,LuiDbConn mlc) throws LuiException, SQLException{
    synchronized(changed){
    changed=true;
    mlc.executeDML("delete from lui_t_dashboard_arithmetica where id="+pArid);
    Barithmetics.remove(pArid);
    this.delUnusedDs(mlc);
}}
/**
 * Добавление новой кривой в набор диаграмм
 * @param pFrmID - форма для взятия данных
 * @param pName - название кривули
 * @param pMeasure - что изменять
 * @param pGridSeq - номер грида
 * @param pYaxis - номер оси в гриде 1-левая 2-правая
 * @param pType - тип bar/line
 * @param pColor -цвет
 * @param pOpacity - призрачность/закраска
 * 
 * 
 **/    
public void add_curve(String pFrmID,String pName, String pMeasure,String pGridSeq,String pYaxis,
        String pType,String pColor,String pOpacity,String pWidth) throws LuiException, SQLException
{
 if(!app.forms.containsKey(pFrmID)) return;//уходи если нет формы
 synchronized(changed){
     
 changed=true;
 LuiAppForm pFrm=app.forms.get(pFrmID);
 String concode=pFrm.getProperty("Connection");
 if(!app.userDbConnections.containsKey(concode))return;//уходи если нет соединения
 Baxi Yaxis;
 Baxi Xaxis;
 LuiDbConn mlc=null;
 PreparedStatement ps=null;
 String stmt="";
 Connection c=null;
 LuiDbConn lc=null;
 try{
 mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 if (!Bconnections.containsKey(concode)){ //если соединения ещё нет в массиве
                 // коннектимся 
                 lc=app.userDbConnections.get(concode).connPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                 // и добавляем в массив
                 Bconnections.put(concode, lc);
             
           } else lc=Bconnections.get(concode);
 // обеспечим уникальность имени
 //synchronized(changed){
 //synchronized(clear){    
 pName=this.getUniqueSeriesName(pName,null);
 // сформируем основное тело запроса
 
// String qstmt="Select \n"+
//         pFrm.makeMainExpression(lc,true)+"\n From (\n"+
//         pFrm.makeMainQuery()+")q1 where "; 
 String qstmt=" from ("+pFrm.makeMainQuery()+")q1 where ";
 // и пустышку ключа
 LuiCollection keyCol=pFrm.getUK();
 LuiCollection eKeyCol=new LuiCollection("");
 for (String ke:keyCol.keySet()){eKeyCol.Add_Element(ke,"");}


 String dsFound=null;
 
 // ищем полученный запрос среди источников данных
 for(String ds:this.BdataSources.keySet()){
     if (is_null(BdataSources.get(ds).main_query)) continue;
     if (BdataSources.get(ds).main_query.equals(qstmt)){
      if (BdataSources.get(ds).key_collection.equals(eKeyCol.toString())){
         dsFound=ds;break;
      }
     }
 }
 if (dsFound==null){ // не нашли - создаём
    BdataSource newds=new BdataSource();
    newds.name=NVL(pFrm.getProperty("HEADER"),"ConfigName");
    LuiCollection colcol=new LuiCollection("");
    LuiCollection colcol4time=new LuiCollection("");
    for (int i=0;i<pFrm.elements.size();i++){
        LuiAppElement el=pFrm.elSort(i);
        if (el.getType().equals("ITEM")){
          colcol.Add_Element(el.getCode(), el.getName4show());
          if (el.getProperty("DATA_TYPE").equals("DATETIME"))
          colcol4time.Add_Element(el.getCode(), el.getName4show());
        }
    }
    newds.column_collection=colcol.toString();
    newds.column_collection4time=colcol4time.toString();
    colcol.clear();
    colcol.Add_Element("FORM_CODE", pFrm.getCode());
    colcol.Add_Element("CONFIG_CODE", pFrm.getConfigCode());
    colcol.Add_Element("HEADER",newds.name);
    newds.genesis=colcol.toString();
    newds.db_connect=concode;
    stmt="select nextval('lui_q_dashboard_datasource')";
    newds.id=mlc.getSelectResult(stmt);
    newds.main_query=qstmt;
    newds.key_collection=eKeyCol.toString();
    
 
    BdataSources.put(newds.id, newds);
 
    dsFound=newds.id;
    stmt="insert into lui_t_dashboard_datasource(id,dashboard_id,db_connect,main_query,name,key_collection,genesis,column_collection,column_collection4time)"+
    "values(?,?,?,?,?,?,?,?,?)";
    ps=c.prepareStatement(stmt);
    ps.setInt(1, Integer.valueOf(newds.id));
    ps.setInt(2, id);
    ps.setString(3,newds.db_connect);
    ps.setString(4,newds.main_query);
    ps.setString(5,newds.name);
    ps.setString(6,newds.key_collection);
    ps.setString(7,newds.genesis);
    ps.setString(8,newds.column_collection);
    ps.setString(9,newds.column_collection4time);
    ps.execute();
    ps.close();
    ps=null; 
 } 
 
   // ищем грид и вычислим dur последнего грида если не найдём
   String chFound=null;
   int ldur=1;
   
   for(String cid:this.Bcharts.keySet()){
       if (Bcharts.get(cid).seq==Integer.valueOf(pGridSeq)){chFound=cid;break;}
   ldur=Bcharts.get(cid).dur;
   }
   if (chFound==null) { // если не нашли - создём нужное количество
   int curSize=Bcharts.size();
   clear=true; // полная очистка графиков нужна для перенумерации гридов 
   for (int i=curSize;i<Integer.valueOf(pGridSeq);i++){
       Bchart newchart=new Bchart();
       newchart.dur=ldur;
       newchart.x_inversion="N";
       //synchronized (frequency){
       newchart.size=newchart.dur*frequency;
       //}
       newchart.gridIndex=i;
       newchart.name_fill="r_black";
       newchart.name_font="8px";
       stmt="select nextval('lui_q_dashboard_chart')";
       newchart.id=mlc.getSelectResult(stmt);
       if (i==Integer.valueOf(pGridSeq)-1)
       newchart.name=NVL(pFrm.getProperty("HEADER"),"ConfigName");
       else
       newchart.name=".............";
       newchart.seq=i+1;
       stmt="insert into lui_t_dashboard_chart(id,dashboard_id,seq,name,rt_duration)values(?,?,?,nullif(?,''),?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1, Integer.valueOf(newchart.id));
       ps.setInt(2, id);
       ps.setInt(3, newchart.seq);
       ps.setString(4, newchart.name);
       ps.setInt(5, newchart.dur);
       ps.execute();
       ps.close();
       ps=null;
       Bcharts.put(newchart.id, newchart);
       chFound=newchart.id;
       //сразу создаём ось X
       Baxi newX=new Baxi();
       newX.axis_type="X";
       newX.auto_color="Y";
       newX.position="bottom";
       newX.chart_id=newchart.id;
       newX.data_type="time";
       newX.name_fontsize=12;
       newX.label_fontsize=8;
       newX.gridIndex=newchart.gridIndex;
       stmt="select nextval('lui_q_dashboard_chart_axis')";
       newX.id=mlc.getSelectResult(stmt);
       newX.xIndex=this.getNextXaxisIndex();
       Baxis.put(newX.id, newX);
       LuiCollection col=this.getAutoColors4axis(newX.id);
       Baxis.get(newX.id).color_label=col.Get_Element("label");
       Baxis.get(newX.id).color_line=col.Get_Element("line");;
       Baxis.get(newX.id).color_name=col.Get_Element("name");
       Baxis.get(newX.id).color_tick=col.Get_Element("tick");
       stmt="insert into lui_t_dashboard_chart_axis(id,chart_id,axis_type,data_type,"
               + "auto_color,color_label,color_line,color_name,color_tick,position)"
               + "values(?,?,?,?,?,?,?,?,?,?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1,Integer.valueOf(newX.id));
       ps.setInt(2,Integer.valueOf(newX.chart_id));
       ps.setString(3,newX.axis_type);
       ps.setString(4,newX.data_type);
       ps.setString(5,newX.auto_color);
       ps.setString(6,Baxis.get(newX.id).color_label);
       ps.setString(7,Baxis.get(newX.id).color_line);
       ps.setString(8,Baxis.get(newX.id).color_name);
       ps.setString(9,Baxis.get(newX.id).color_tick);
       ps.setString(10,newX.position);
       ps.execute();
       ps.close();
       ps=null;
       //сразу создаём ось Y если грид не наш
       if (i==Integer.valueOf(pGridSeq)-1)continue;
       Baxi newY=new Baxi();
       newY.axis_type="Y";
       newY.name="Y";
       newY.auto_color="Y";
       newY.position="left";
       newY.chart_id=newchart.id;
       newY.data_type="value";
       newY.name_fontsize=12;
       newY.label_fontsize=8;
       newY.gridIndex=newchart.gridIndex;
       stmt="select nextval('lui_q_dashboard_chart_axis')";
       newY.id=mlc.getSelectResult(stmt);
       newY.yIndex=this.getNextYaxisIndex();
       Baxis.put(newY.id, newY);
       LuiCollection colY=this.getAutoColors4axis(newY.id);
       Baxis.get(newY.id).color_label=colY.Get_Element("label");
       Baxis.get(newY.id).color_line=colY.Get_Element("line");;
       Baxis.get(newY.id).color_name=colY.Get_Element("name");
       Baxis.get(newY.id).color_tick=colY.Get_Element("tick");
       stmt="insert into lui_t_dashboard_chart_axis(id,chart_id,axis_type,data_type,"
               + "auto_color,color_label,color_line,color_name,color_tick,position,name)"
               + "values(?,?,?,?,?,?,?,?,?,?,?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1,Integer.valueOf(newY.id));
       ps.setInt(2,Integer.valueOf(newY.chart_id));
       ps.setString(3,newY.axis_type);
       ps.setString(4,newY.data_type);
       ps.setString(5,newY.auto_color);
       ps.setString(6,Baxis.get(newY.id).color_label);
       ps.setString(7,Baxis.get(newY.id).color_line);
       ps.setString(8,Baxis.get(newY.id).color_name);
       ps.setString(9,Baxis.get(newY.id).color_tick);
       ps.setString(10,newY.position);
       ps.setString(11,newY.name);
       ps.execute();
       ps.close();
       ps=null;
        
   }
    
 }// если не нашли - создаём гриды
   else { //если нашли такой грид
       if (is_null(Bcharts.get(chFound).name)){// и это пустышка
           // обновим имя
           Bcharts.get(chFound).name=NVL(pFrm.getProperty("HEADER"),"ConfigName");
           stmt="update lui_t_dashboard_chart set name=nullif(?,'') where id=?";
           ps=c.prepareStatement(stmt);
           ps.setString(1, Bcharts.get(chFound).name);
           ps.setInt(2, Integer.valueOf(chFound));
           ps.execute();
           ps.close();
           ps=null;
       }
       
   }
   
   // в этом месте id грида лежит в chFound 
   // сначала найдём в нём нужные оси
   Bchart chrt=Bcharts.get(chFound);
   // ищем X
   
   Xaxis=null;
   for (String aid:Baxis.keySet()){
     if (Baxis.get(aid).axis_type.equals("X")){
         if (Baxis.get(aid).chart_id.equals(chrt.id)){
            Xaxis=Baxis.get(aid); break;
         }
     }
   }
   if (Xaxis==null)return;
   // ищем Y
   Yaxis=null;
   for (String aid:Baxis.keySet()){
     if (Baxis.get(aid).axis_type.equals("Y")){         
         if (Baxis.get(aid).chart_id.equals(chrt.id)){
           if (Baxis.get(aid).position.equals(pYaxis)) {
            Yaxis=Baxis.get(aid); break;
           }
         }
     }
   }
   if (Yaxis==null){ // ось Y не нашли - добавляем 
/*!!!!!*/       clear=true; // это пришлось добавить т.к. генерировалось TYPE is UNDEFINED
       Yaxis=new Baxi();
       Yaxis.axis_type="Y";
       Yaxis.chart_id=chrt.id;
       Yaxis.data_type="value";
       Yaxis.auto_color="Y";
       Yaxis.name_fontsize=12;
       Yaxis.label_fontsize=8;
       Yaxis.position=pYaxis;
       if (pYaxis.equals("left")) Yaxis.name="Y";
       else Yaxis.name="Y'";
       Yaxis.gridIndex=chrt.gridIndex;
       stmt="select nextval('lui_q_dashboard_chart_axis')";
       Yaxis.id=mlc.getSelectResult(stmt);
       Yaxis.yIndex=this.getNextYaxisIndex();
       Baxis.put(Yaxis.id,Yaxis);
       LuiCollection colY=this.getAutoColors4axis(Yaxis.id);
       Baxis.get(Yaxis.id).color_label=colY.Get_Element("label");
       Baxis.get(Yaxis.id).color_line=colY.Get_Element("line");;
       Baxis.get(Yaxis.id).color_name=colY.Get_Element("name");
       Baxis.get(Yaxis.id).color_tick=colY.Get_Element("tick");
       stmt="insert into lui_t_dashboard_chart_axis(id,chart_id,axis_type,data_type,"
               + "auto_color,color_label,color_line,color_name,color_tick,position,name)"
               + "values(?,?,?,?,?,?,?,?,?,?,?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1,Integer.valueOf(Yaxis.id));
       ps.setInt(2,Integer.valueOf(Yaxis.chart_id));
       ps.setString(3,Yaxis.axis_type);
       ps.setString(4,Yaxis.data_type);
       ps.setString(5,Yaxis.auto_color);
       ps.setString(6,Baxis.get(Yaxis.id).color_label);
       ps.setString(7,Baxis.get(Yaxis.id).color_line);
       ps.setString(8,Baxis.get(Yaxis.id).color_name);
       ps.setString(9,Baxis.get(Yaxis.id).color_tick);
       ps.setString(10,Yaxis.position);
       ps.setString(11,Yaxis.name);
       ps.execute();
       ps.close();
       ps=null;     
   }
   Bserie ser=new Bserie();
   
     ser.chart_id=chrt.id;
     ser.color=pColor;
     ser.data_type="value";
     ser.dataSource_id=dsFound;
     if (!pWidth.equals("auto")) ser.width=Integer.valueOf(pWidth);
     //LuiAppElement el=pFrm.elements.get(pFrm.getProperty("CurrentColumn"));
     //ser.expression=app.dataConverter.getColumnSelectClause(el, lc);
     ser.expression=pFrm.getVal("CurrentColumn");
     ser.key_collection=keyCol.toString();
     ser.key_where="";
     for(String ukcolcode:keyCol.keySet()){
   LuiAppElement el=pFrm.elements.get(ukcolcode);
   String condition=el.getSQLCondition(lc, '='+keyCol.Get_Element(ukcolcode),"N");
   if  (is_not_null(condition)){
    if (is_not_null(ser.key_where)){
   ser.key_where=ser.key_where+" and ";
           }        
   ser.key_where=ser.key_where+condition; 
   }
     }
     ser.key_where=LTrim(ser.key_where," and");
     ser.measure=pMeasure;
     ser.name=pName;
     ser.opacity=Double.valueOf(pOpacity);
     ser.type=pType;
     ser.xAxisIndex=Xaxis.xIndex;
     ser.x_axis_id=Xaxis.id;
     ser.yAxisIndex=Yaxis.yIndex;
     ser.y_axis_id=Yaxis.id;
     if (is_null(ser.id)){
     stmt="select nextval('lui_q_dashboard_series')";
     ser.id=mlc.getSelectResult(stmt);
     stmt="insert into lui_t_dashboard_series(datasource_id,x_axis_id,y_axis_id,"
             + "key_collection,expression,type,data_type,measure,color,opacity,name,key_where,width,id)"
             + "values(?,?,?,?,?,?,?,?,?,?,?,?,nullif(?,'')::lui_d_id,?)";
     ps=c.prepareCall(stmt);    
     } else {
     stmt="update lui_t_dashboard_series set "
             + "datasource_id=?,"
             + "x_axis_id=?,"
             + "y_axis_id=?,"
             + "key_collection=?,"
             + "expression=?,"
             + "type=?,"
             + "data_type=?,"
             + "measure=?,"
             + "color=?,"
             + "opacity=?,"
             + "name=nullif(?,''),"
             + "key_where=?,"
             + "width=nullif(?,'') "
             + "where id=?";    
     ps=c.prepareCall(stmt);
     }
     ps.setInt(1,Integer.valueOf(ser.dataSource_id));
     ps.setInt(2,Integer.valueOf(ser.x_axis_id));
     ps.setInt(3,Integer.valueOf(ser.y_axis_id));
     ps.setString(4,ser.key_collection);
     ps.setString(5,ser.expression);
     ps.setString(6,ser.type);
     ps.setString(7,ser.data_type);
     ps.setString(8,ser.measure);
     ps.setString(9,ser.color);
     ps.setDouble(10,ser.opacity);
     ps.setString(11,ser.name);
     ps.setString(12,ser.key_where);
     if (ser.width==null)ps.setString(13,"");
     else ps.setString(13,ser.width.toString());
     ps.setInt(14,Integer.valueOf(ser.id));
     ps.execute();
     ps.close();
     ps=null;
     Bseries.put(ser.id, ser);
     this.cleanCurve(ser.id);
   
        
 
  this.makeDsQuery(dsFound); // окончательное формирование запроса     
   // удаляем липовую кривулю и источник
 dsFound=null;
 for(String ds:this.BdataSources.keySet()){
     if (is_null(BdataSources.get(ds).main_query)) {dsFound=ds;break;}
 }
 if (dsFound!=null){
 for (String sid:Bseries.keySet()){
    if (Bseries.get(sid).dataSource_id.equals(dsFound)){Bseries.remove(sid);break;}
 }
 BdataSources.remove(dsFound);
 stmt="delete from lui_t_dashboard_datasource where id="+dsFound;
 mlc.executeDML(stmt);
 clear=true;
 }
 
 
 changed=true;
 
 this.axisAutoColor(mlc,ser.y_axis_id);
 removeUnusedAxes(mlc);
 if (clear){
 this.renumAxes();
 }
 frm.changes();
 //}}
 } catch (SQLException sex){
  app.msgWriter.sqlError(mlc, sex, null, stmt);
  setStatus("stop");
 }
 finally {
     if (mlc!=null){
         if (ps!=null){
             if (!ps.isClosed()){
                 ps.close();
             }
         }
         app.metaConnPool.SetFree(mlc);
     }
 }
  
}
 }
public int getNextXaxisIndex(){
  int retVal=1;
    for(String aid:Baxis.keySet()){
     if (Baxis.get(aid).axis_type.equals("X")) {
        if (retVal<=Baxis.get(aid).xIndex) retVal=Baxis.get(aid).xIndex+1;
     }       
    }
   return retVal; 
}
public int getNextYaxisIndex(){
  int retVal=1;
    for(String aid:Baxis.keySet()){
     if (Baxis.get(aid).axis_type.equals("Y")) {
        if (retVal<=Baxis.get(aid).yIndex) retVal=Baxis.get(aid).yIndex+1;
     }       
    }
   return retVal; 
}
public void makeDsQuery(String pDsId) throws SQLException, LuiException{
  synchronized(changed){
    if (is_null(BdataSources.get(pDsId).db_connect)) return;
  changed=true;
  String Twhere="";
  String Tsel="";
  String concode=null;
  HashMap <String,Boolean> wmap = new HashMap<>();  
  HashMap <String,Boolean> smap = new HashMap<>();
  LuiCollection kc=new LuiCollection(BdataSources.get(pDsId).key_collection);
  for (String ke:kc.keySet()){
   if (!Tsel.equals(""))Tsel=Tsel+",";
   Tsel=Tsel+"\""+ke+"\"";
   smap.put(ke,true);
  }
//  synchronized (Bseries){
//  synchronized (Barithmetics){
  for (String sid:Bseries.keySet()){
      if (Bseries.get(sid).dataSource_id.equals(pDsId)){
       if (!smap.containsKey(Bseries.get(sid).expression)){
           Tsel=Tsel+",\""+Bseries.get(sid).expression+"\"";
           smap.put(Bseries.get(sid).expression,true);
       }
       if (is_not_null(Bseries.get(sid).expression4time)){
         if (!smap.containsKey(Bseries.get(sid).expression4time)){  
           Tsel=Tsel+",to_char(\""+Bseries.get(sid).expression4time+"\",'yyyy-mm-dd hh24:mi:ss') \""+Bseries.get(sid).expression4time+"\"";
           smap.put(Bseries.get(sid).expression4time,true);
         } 
       }
       if (wmap.size()==0 || !wmap.containsKey(Bseries.get(sid).key_where)) {   
        if (is_not_null(Twhere)) Twhere=Twhere+" or ";
        Twhere="("+Twhere+Bseries.get(sid).key_where+")";
        wmap.put(Bseries.get(sid).key_where,true);
      }
      }
  }
  for (String arid:Barithmetics.keySet()){
      if (!Barithmetics.get(arid).dataSource_id.equals(pDsId))continue;
      if (!smap.containsKey(Barithmetics.get(arid).expression)){
           Tsel=Tsel+",\""+Barithmetics.get(arid).expression+"\"";
           smap.put(Barithmetics.get(arid).expression,true);
       }
      if (wmap.size()==0 || !wmap.containsKey(Barithmetics.get(arid).key_where)) {   
          if (is_not_null(Twhere)) Twhere=Twhere+" or ";
        Twhere="("+Twhere+Barithmetics.get(arid).key_where+")";
        wmap.put(Barithmetics.get(arid).key_where,true);
      }
  }
  concode=null;  
  Twhere="select "+Tsel+BdataSources.get(pDsId).main_query+Twhere;
  if (is_null(BdataSources.get(pDsId).queryText) || !Twhere.equals(BdataSources.get(pDsId).queryText)) {
   BdataSources.get(pDsId).queryText=Twhere;
  try {
      concode=BdataSources.get(pDsId).db_connect;
      if (BdataSources.get(pDsId).pStmt!=null) {
          BdataSources.get(pDsId).pStmt.close();
          BdataSources.get(pDsId).pStmt=null;
      }    
      if (!Bconnections.containsKey(BdataSources.get(pDsId).db_connect)
          || Bconnections.get(BdataSources.get(pDsId).db_connect)==null
          || Bconnections.get(BdataSources.get(pDsId).db_connect).getConnection()==null              
              ){
      Bconnections.put(BdataSources.get(pDsId).db_connect, null);
      BdataSources.get(pDsId).pStmt=null;
      app.msgWriter.write("LUI-00139",BdataSources.get(pDsId).db_connect);    
      /*BdataSources.get(pDsId).db_connect=null;
      for (String sid:Bseries.keySet()){
         if (Bseries.get(sid).dataSource_id.equals(pDsId)) {
             Bseries.get(sid).expression=null;
             Bseries.get(sid).key_collection=null;
             Bseries.get(sid).key_where=null;
              }}
      for (String aid:Barithmetics.keySet()){
         if (Barithmetics.get(aid).dataSource_id.equals(pDsId)) {
             Barithmetics.get(aid).expression=null;
             Barithmetics.get(aid).key_collection=null;
             Barithmetics.get(aid).key_where=null;
              }}
      */  
      return; 
      
      }
      
      BdataSources.get(pDsId).pStmt=
              this.Bconnections.get(BdataSources.get(pDsId).db_connect).getConnection().prepareStatement(
                 BdataSources.get(pDsId).queryText     
              );
      
  }
  catch (SQLException sex){
   if (concode!=null) {
   LuiDbConn lc=this.Bconnections.get(concode);
   app.msgWriter.sqlError(lc, sex, null, BdataSources.get(pDsId).queryText);
   setStatus("stop");
   if (app.userDbConnections.containsKey(concode)){
   app.userDbConnections.get(concode).connPool.SetFree(lc);
   Bconnections.put(concode,null);
   }
          }
}
  }
  } 
}

public void getNewData() throws SQLException, LuiException{
   synchronized(this.BdataSources){
   BdataSource ds=null;    
   try {
   for (String dsid:this.BdataSources.keySet()){
       ds=BdataSources.get(dsid);
      synchronized(ds.queryText){ 
       if (is_null(ds.main_query)) continue;
       if (is_null(ds.queryText)) continue;
       if (ds.pStmt==null)continue;
       if (ds.pStmt.isClosed())continue;
       ResultSet rs=ds.pStmt.executeQuery();
       
       if (this.Bconnections.get(ds.db_connect).getDBvendor().equals("PG")){
         if  (!this.Bconnections.get(ds.db_connect).getConnection().getAutoCommit())
             this.Bconnections.get(ds.db_connect).commit();
       }
       ResultSetMetaData rsmd=ds.pStmt.getMetaData();
       int cols=rsmd.getColumnCount();
       LuiCollection eKeyCol=new LuiCollection(ds.key_collection);
       while(rs.next()){ // крутим строки запроса
          LuiCollection rowData=new LuiCollection(""); // коллекция значений столбцов за исключением ключей
          LuiCollection ukData=new LuiCollection("");  // коллекция значений ключей
          for (int i=1;i<=cols;i++){// крутим столбцы строки
             if (eKeyCol.containsKey(rsmd.getColumnLabel(i))){// если столбец член ключа
               ukData.Add_Element(rsmd.getColumnLabel(i),rs.getString(i));
             } else { // это обычный столбец
               rowData.Add_Element(rsmd.getColumnLabel(i),rs.getString(i));  
               
             }
          }
          // раскладываем данные по арифметикам
          for (String arid:this.Barithmetics.keySet()){// крутим их
              if (Barithmetics.get(arid).dataSource_id.equals(dsid)){// если из данного источника
                  if (Barithmetics.get(arid).key_collection.equals(ukData.toString())) {// если ключ строки совпал с ключём арифметики
                  Barithm ari=Barithmetics.get(arid);
                  Double v=Double.valueOf(rowData.Get_Element(ari.expression)); // берём значение запроса
                    switch (ari.measure){
                       case "V":
                        ari.newValue2add=v;
                        break;
                        case "-V":
                        ari.newValue2add=-v;
                        break;
                        case "D":
                        if (ari.lastRawValue!=null)    
                        ari.newValue2add=v-ari.lastRawValue;
                        break;
                        case "-D":
                        if (ari.lastRawValue!=null)    
                        ari.newValue2add=-(v-ari.lastRawValue);    
                        break; 
                    }
                    ari.lastRawValue=v;
                  }
              }
          }
          // и по сериям
          for (String sid:this.Bseries.keySet()){
              if (Bseries.get(sid).dataSource_id.equals(dsid)){
                if (Bseries.get(sid).key_collection.equals(ukData.toString())) {
                    Bserie ser=Bseries.get(sid);
                    if (ser.expression4time!=null && !ser.expression4time.equals("")) 
                     ser.lastTime=rowData.Get_Element(ser.expression4time);
                    synchronized(ser.data){
                    Double  v=Double.valueOf(rowData.Get_Element(ser.expression));
                  //                  if (ser.lastRawValue==null) ser.lastRawValue=v;
                    switch (ser.measure){
                        case "V":
                        ser.newValue2show=v;
                        break;
                        case "-V":
                        ser.newValue2show=-v;
                        break;
                        case "D":
                        if (ser.lastRawValue!=null)    
                        ser.newValue2show=v-ser.lastRawValue;
                        break;
                        case "-D":
                        if (ser.lastRawValue!=null)    
                        ser.newValue2show=-(v-ser.lastRawValue);    
                        break;
                    } 
                    ser.lastRawValue=v;
                    /*if (ser.max==null) ser.max=ser.newValue2show;
                    else if(ser.max<ser.newValue2show)ser.max=ser.newValue2show;
                    if (ser.min==null) ser.min=ser.newValue2show;
                    else if(ser.min>ser.newValue2show)ser.min=ser.newValue2show;*/
                    }
                }
              }
          }
       }
   }   
   }
   // цикл добавления арифметик к значениям серий и вычислений max/min
   for (String sid:Bseries.keySet()){
       Bserie ser=Bseries.get(sid);
       for (String arid:Barithmetics.keySet()){
          if (Barithmetics.get(arid).series_id.equals(sid)){
           if (Barithmetics.get(arid).newValue2add!=null)   
              ser.newValue2show=ser.newValue2show+Barithmetics.get(arid).newValue2add;
          }
       }
       if (ser.max==null) ser.max=ser.newValue2show;
       else if(ser.max<ser.newValue2show)ser.max=ser.newValue2show;
       if (ser.min==null) ser.min=ser.newValue2show;
       else if(ser.min>ser.newValue2show)ser.min=ser.newValue2show;
   }
} catch (SQLException sex) {
    if (ds!=null){
      app.msgWriter.sqlError(Bconnections.get(ds.db_connect), sex, null,ds.queryText);
      setStatus("stop");
    }
}
}
}
public String getCommand4ChartControl(){
 synchronized(clear){
  if (clear) {
      clear=false;
      return "clearAndSetOption";
      
  }
  return "setOption";
}
}
public String getColor(String pColor){
    
    if (pColor.equals("r_blue"))return "#3a70a3";
    if (pColor.equals("r_black"))return "#333333";
    if (pColor.equals("r_brown"))return "#aa5e2c";
    return pColor.substring(2);

}
public int getSerWidth(String pSid){
    int w=1;
    if (Bseries.get(pSid).width==null){
        w=0;
        for(String ari:Barithmetics.keySet()){
          if (Barithmetics.get(ari).series_id.equals(pSid)){
             w++; 
          }
        }
       if (Bseries.get(pSid).type.equals("line")||Bseries.get(pSid).type.equals("step")){
          return w+1; 
       }
       return w;
    }
    
    return Bseries.get(pSid).width;
}

public String getColorImageURL(String pColor) {
    try{
    String retVal="image://"+app.getProperty("ApplicationURL")+"/custom/"+app.getProperty("STYLE_CURRENT")+"-desktop/"+pColor+".ico";
    return retVal;
    } catch (Exception ex){
    return "none";
    }
    
}
/**
 * Автораскраска оси
 */
public void axisAutoColor(LuiDbConn mlc,String pAxid) throws SQLException{
  synchronized(Baxis.get(pAxid)){  
    if (!Baxis.get(pAxid).auto_color.equals("Y")) return;
    if (Baxis.get(pAxid).axis_type.equals("X")){
        Baxis.get(pAxid).color_name="r_black";
        Baxis.get(pAxid).color_label="r_black";
        Baxis.get(pAxid).color_tick="r_black";
        Baxis.get(pAxid).color_label="r_black";
    } else {
        Baxis.get(pAxid).color_name="r_black";
        Baxis.get(pAxid).color_label="r_black";
        Baxis.get(pAxid).color_tick="r_black";
        Baxis.get(pAxid).color_label="r_black";   
    LuiCollection col=this.getAutoColors4axis(pAxid);
    if (!col.Get_Element("name").equals(Baxis.get(pAxid).color_name)){
        Baxis.get(pAxid).color_name=col.Get_Element("name");
    }
    if (!col.Get_Element("line").equals(Baxis.get(pAxid).color_line)){
        Baxis.get(pAxid).color_line=col.Get_Element("line");
    }
    if (!col.Get_Element("label").equals(Baxis.get(pAxid).color_label)){
        Baxis.get(pAxid).color_label=col.Get_Element("label");
    }
    if (!col.Get_Element("tick").equals(Baxis.get(pAxid).color_tick)){
        Baxis.get(pAxid).color_tick=col.Get_Element("tick");
    }
    
   }
   
       mlc.executeDML("update lui_t_dashboard_chart_axis set "
               + "color_name='"+Baxis.get(pAxid).color_name+"',"
               + "color_line='"+Baxis.get(pAxid).color_line+"',"
               + "color_label='"+Baxis.get(pAxid).color_label+"',"
               + "color_tick='"+Baxis.get(pAxid).color_tick+"',"
               + "auto_color='"+Baxis.get(pAxid).auto_color+"' "
                       + "where id="+pAxid);
    
   }
}
public LuiCollection getAutoColors4axis(String pAxid){
    LuiCollection col=new LuiCollection("");
      col.Add_Element("name","r_black");
      col.Add_Element("tick","r_black");
      col.Add_Element("line","r_black");
      col.Add_Element("label","r_black");
    
    if (Baxis.get(pAxid).axis_type.equals("X")){
      return col;
    }
    int i=0;
    for (String sid:Bseries.keySet()){
      if (Bseries.get(sid).y_axis_id.equals(pAxid)) {
          //количество осей Y в чарте
/*          int aYcnt=0;
          for (String ax:Baxis.keySet()){
              if (Baxis.get(ax).chart_id.equals(Bseries.get(sid).chart_id)
                      && Baxis.get(ax).axis_type.equals("Y")) aYcnt++;
          }*/
          i++;
          switch(i){
              case 1: 
              col.Add_Element("name",Bseries.get(sid).color);
             // if (aYcnt>1)
              col.Add_Element("line",Bseries.get(sid).color);
              break;
              case 2: 
              col.Add_Element("line",Bseries.get(sid).color);
              break;
              case 3: 
              col.Add_Element("label",Bseries.get(sid).color);
              break;
              case 4: 
              col.Add_Element("tick",Bseries.get(sid).color);
              break;
          }
      }
    }
    return col;
}
public void setAxisColor(String pAxid,String pAutoColor,
                                      String pColorName,
                                      String pColorLine,
                                      String pColorTick,
                                      String pColorLabel
                                      ) throws LuiException, SQLException{
synchronized(changed){
     changed=true;    
     if (
     Baxis.get(pAxid).auto_color.equals(pAutoColor) &&
     Baxis.get(pAxid).color_name.equals(pColorName) &&
     Baxis.get(pAxid).color_line.equals(pColorLine) &&    
     Baxis.get(pAxid).color_tick.equals(pColorTick) &&        
     Baxis.get(pAxid).color_label.equals(pColorLabel)) return;   
LuiDbConn mlc=null;
Connection c=null;
PreparedStatement ps=null;
String stmt="";
try{
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
    c=mlc.getConnection(); 
 if (pAutoColor.equals("Y")){
     Baxis.get(pAxid).auto_color="Y";
     axisAutoColor(mlc, pAxid);
 }
 if (pAutoColor.equals("N")){
     Baxis.get(pAxid).auto_color="N";
     Baxis.get(pAxid).color_name=pColorName;
     Baxis.get(pAxid).color_line=pColorLine;
     Baxis.get(pAxid).color_tick=pColorTick;
     Baxis.get(pAxid).color_label=pColorLabel;
       mlc.executeDML("update lui_t_dashboard_chart_axis set "
               + "color_name='"+Baxis.get(pAxid).color_name+"',"
               + "color_line='"+Baxis.get(pAxid).color_line+"',"
               + "color_label='"+Baxis.get(pAxid).color_label+"',"
               + "color_tick='"+Baxis.get(pAxid).color_tick+"',"
               + "auto_color='"+Baxis.get(pAxid).auto_color+"' "
                       + "where id="+pAxid);

 }
    }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
    return;
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}         
}
}
public void delUnusedDs(LuiDbConn mlc) throws LuiException, SQLException{
 boolean b=true;
 boolean f;
 synchronized(changed){
 changed=true;
 while (b) {
     b=false;
   for (String dsid:BdataSources.keySet()){
       f=false;  
     for (String sid:Bseries.keySet()){
         if (Bseries.get(sid).dataSource_id.equals(dsid)){
             f=true;break;
         }
     }
     if (!f){
     for (String arid:Barithmetics.keySet()){    
         if (Barithmetics.get(arid).dataSource_id.equals(dsid)){
             f=true;break;
         }
     }
     }
     if (!f){
         BdataSources.remove(dsid);
            mlc.executeDML("delete from lui_t_dashboard_datasource where id="+dsid);


         b=true;
         break;
     }
   }
 }
 }
}
public void setDbProperty(String pName,String pFreq,String pNotes,String pRunFromMainMenu) throws SQLException, LuiException{
 synchronized(changed){   
    if (pName.equals(this.name) && this.frequency==Integer.valueOf(pFreq) && pNotes.equals(this.notes)
            && run_from_main_menu.equals(pRunFromMainMenu)) return;
changed=true;    
LuiDbConn mlc=null;
Connection c=null;
PreparedStatement ps=null;
String stmt="";
try{
 mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 stmt="update lui_t_dashboard set name=nullif(?,''),notes=nullif(?,''),rt_frequency=?,run_from_main_menu=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, pName);
 ps.setString(2, pNotes);
 ps.setInt(3, Integer.valueOf(pFreq));
 ps.setString(4,pRunFromMainMenu);
 ps.setInt(5, this.id);
 ps.execute();
 ps.close();
 ps=null;
 if (!pName.equals(this.name)) {
    this.name=pName;
    frm.addProperty("HEADER", pName);
 }
 if (!pNotes.equals(this.notes)) {
    this.notes=pNotes;
 }
 run_from_main_menu=pRunFromMainMenu;
 if (frequency!=Integer.valueOf(pFreq)) {
    
    //synchronized(changed){
    
    lastUpdate=null;    
    this.frequency=Integer.valueOf(pFreq); 
    for (String cid:Bcharts.keySet()){
      int newsize=Bcharts.get(cid).dur*frequency;
      if (newsize<Bcharts.get(cid).size){
        int points4del=Bcharts.get(cid).size-newsize;  
        int pointsMod=Bcharts.get(cid).size/newsize;
        for (String sid:Bseries.keySet()){
           if (Bseries.get(sid).chart_id.equals(cid)){
             /*for(int i=0;i<points4del;i++){
               Bseries.get(sid).data.remove(0);
             }*/
             ArrayList<dataElement> newData=new ArrayList<>();
//             for (int i=0;i<Bcharts.get(cid).size;i++){
       for (int i=0;i<Bseries.get(sid).data.size();i++){
               if (Math.floorMod(i, pointsMod)==0){
                   newData.add(Bseries.get(sid).data.get(i));
               }
             }
             Bseries.get(sid).data=newData;
           } 
        }
      
      }
      /*if (newsize>Bcharts.get(cid).size){
        int points2add=newsize-Bcharts.get(cid).size;    
        for (String sid:Bseries.keySet()){
         long s=currentTime-1000*Bcharts.get(cid).dur*60;   
           if (Bseries.get(sid).chart_id.equals(cid)){
             for(int i=0;i<points2add;i++){
               s=s-1000*60/frequency;
               d.setTime(s);
               dataElement de=new dataElement(df.format(d),null);
               Bseries.get(sid).data.add(0, de);
             }  
           } 
        }
      
      }*/
      Bcharts.get(cid).size=newsize;
    }
    
        if ("N".equals(frm.getProperty("rtTimer"))){
        this.makeSnap();
    }

    
    }
 //}
}catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void setAxisPosition(String pAxid,String pPos)throws SQLException, LuiException{
    if (Baxis.get(pAxid).position.equals(pPos))return;
    Baxi ax=Baxis.get(pAxid);
    LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
    try{
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 stmt="update lui_t_dashboard_chart_axis set position=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, pPos);
 ps.setInt(2, Integer.valueOf(pAxid));
 ps.execute();
 ps.close();
 ps=null;
    }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
    return;
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
 synchronized(changed){
   changed=true;
   String oldpos=ax.position;
   ax.position=pPos;
   if (ax.axis_type.equals("Y")) {
     for (String oaid:Baxis.keySet()) {
       if (oaid.equals(pAxid)) continue;
       if (!Baxis.get(oaid).chart_id.equals(ax.chart_id)) continue;
       if (!Baxis.get(oaid).axis_type.equals("Y")) continue;
       if (Baxis.get(oaid).position.equals(oldpos)) continue;
       this.setAxisPosition(oaid, oldpos);
     }
   }
 }
 
}
public void setAxisName(String pAxid,String pName,String pNameFontSize,String pLabelFontSize)throws SQLException, LuiException{
synchronized(changed){
    changed=true;
if (is_null(pNameFontSize)) pNameFontSize =  Baxis.get(pAxid).name_fontsize.toString();
if (is_null(pLabelFontSize)) pLabelFontSize =  Baxis.get(pAxid).label_fontsize.toString();
    if (pName.equals(Baxis.get(pAxid).name) &&
        Baxis.get(pAxid).name_fontsize==Integer.valueOf(pNameFontSize) &&
        Baxis.get(pAxid).label_fontsize==Integer.valueOf(pLabelFontSize)
            )return;
  LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
    try{
   Baxi ax=Baxis.get(pAxid);
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 stmt="update lui_t_dashboard_chart_axis set name=nullif(?,''),name_fontsize=?,label_fontsize=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, pName);
 ps.setInt(2, Integer.valueOf(pNameFontSize));
 ps.setInt(3, Integer.valueOf(pLabelFontSize));
 ps.setInt(4, Integer.valueOf(pAxid));
 ps.execute();
 ps.close();
 ps=null;
 //synchronized(changed){
   //changed=true;
   ax.name=pName;
   ax.name_fontsize=Integer.valueOf(pNameFontSize);
   ax.label_fontsize=Integer.valueOf(pLabelFontSize);
 //}
    }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void setGridDirection(String pChid,String pXinversion)throws SQLException, LuiException{
 synchronized(changed){
 if (Bcharts.get(pChid).x_inversion.equals(pXinversion)) return;
 changed=true;
 LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
    try{
    Bchart chrt=Bcharts.get(pChid);
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 stmt="update lui_t_dashboard_chart set x_inversion=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, pXinversion);
 ps.setInt(2, Integer.valueOf(pChid));
 ps.execute();
 ps.close();
 ps=null;
 //synchronized(changed){
   //changed=true;
    chrt.x_inversion=pXinversion; 
    
 //}
  }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
}}
public void setGridName(String pChid,String pName,String pNameFill, String pNameFont) throws SQLException, LuiException{
synchronized(changed){
    if (is_null(pNameFill))pNameFill=Bcharts.get(pChid).name_fill;
    if (is_null(pNameFont))pNameFont=Bcharts.get(pChid).name_font;
    if (LuiString.compareString(Bcharts.get(pChid).name,pName) && 
        Bcharts.get(pChid).name_fill.equals(pNameFill) &&
        Bcharts.get(pChid).name_font.equals(pNameFont)
            )return;
    changed=true;
  LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
  try{
    Bchart chrt=Bcharts.get(pChid);
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 stmt="update lui_t_dashboard_chart set name=nullif(?,''),name_fill=?,name_font=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, pName);
 ps.setString(2, pNameFill);
 ps.setString(3, pNameFont);
 ps.setInt(4, Integer.valueOf(pChid));
 ps.execute();
 ps.close();
 ps=null;
 //synchronized(changed){
   // changed=true;
    chrt.name=pName; 
    chrt.name_fill=pNameFill;
    chrt.name_font=pNameFont;
 //}
  }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void delSerie(String pSid) throws LuiException, SQLException{
    //synchronized(clear){
    synchronized(changed){
    if (!Bseries.containsKey(pSid))return;
    
      boolean b=true;
      while (b){
       b=false;
       for(String ari:Barithmetics.keySet()){
         if (Barithmetics.get(ari).series_id.equals(pSid)){
             Barithmetics.remove(ari);
             b=true;
             break;
         }
       }
      }
      Bseries.remove(pSid);
      changed=true;
      clear=true;
      
    //}
    //}
  LuiDbConn mlc=null;
  String stmt="";
    try{
          mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
    stmt="delete from lui_t_dashboard_series where id="+pSid;
    mlc.executeDML(stmt);
    removeUnusedAxes(mlc);
    delUnusedDs(mlc);
    }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
 }
  finally{
    if (mlc!=null){
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void moveGrid(String pChid,String pTo) throws LuiException, SQLException{
synchronized(changed){
    String chF=null; 
    
    int oseq=Bcharts.get(pChid).seq;
    
    if (pTo.equals("UP")){
      // ищем грид с seq=oseq-1
      for (String cid:Bcharts.keySet()){
          if (Bcharts.get(cid).seq==oseq-1) {chF=cid;break;}
      }
    } else {
       // ищем грид с seq=oseq+1
      for (String cid:Bcharts.keySet()){
          if (Bcharts.get(cid).seq==oseq+1) {chF=cid;break;}
      } 
    }
    if (chF==null) return;
    Bcharts.get(pChid).seq=Bcharts.get(chF).seq;
    Bcharts.get(chF).seq=oseq;
    changed=true;    
    
  LuiDbConn mlc=null;
  String stmt="";
    try{
          mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
    stmt="update lui_t_dashboard_chart set seq="+String.valueOf(Bcharts.get(pChid).seq)+"where id="+pChid;
    mlc.executeDML(stmt);
    stmt="update lui_t_dashboard_chart set seq="+String.valueOf(Bcharts.get(chF).seq)+"where id="+chF;
    mlc.executeDML(stmt);
    }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
 }
  finally{
    if (mlc!=null){
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void setGridIndicator(String pChid,String pIndicator,String pMin,String pMax) throws LuiException, SQLException{
synchronized(changed){
String dMin="";
String dMax="";

if (Bcharts.get(pChid).rt_indicator_max!=null)dMax=Bcharts.get(pChid).rt_indicator_max.toString();
if (Bcharts.get(pChid).rt_indicator_min!=null)dMin=Bcharts.get(pChid).rt_indicator_min.toString();
    if (!pIndicator.equals("gauge")){pMin="";pMax="";}
    //synchronized(clear){
    
     
    if (NVL(Bcharts.get(pChid).rt_indicator,"").equals(pIndicator) &&
        dMax.equals(pMax) &&
        dMin.equals(pMin))return;
    changed=true;
   /* if (((!pIndicator.equals("bar") && !pIndicator.equals("scatter"))
        && (NVL(Bcharts.get(pChid).rt_indicator,"").equals("bar")
          || NVL(Bcharts.get(pChid).rt_indicator,"").equals("scatter")) 
       )|| (NVL(Bcharts.get(pChid).rt_indicator,"").equals("pie"))
           || (NVL(Bcharts.get(pChid).rt_indicator,"").equals("gauge")) 
            ){ // если грид или pie индикатора исчезает, то надо очистить весь график
 */
  clear=true;
 
 //}
  LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
  try{
         Bchart chrt=Bcharts.get(pChid);
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 if (is_not_null(pIndicator)){
 stmt="update lui_t_dashboard_chart set rt_indicator=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, pIndicator);
 ps.setInt(2, Integer.valueOf(pChid));
 } else {
 stmt="update lui_t_dashboard_chart set rt_indicator=null where id=?";
 ps=c.prepareStatement(stmt);
 ps.setInt(1, Integer.valueOf(pChid));    
 }
 ps.execute();
 ps.close();
 ps=null;
 if (is_null(pMin)) {
     stmt="update lui_t_dashboard_chart set rt_indicator_min=null where id="+pChid;
     Bcharts.get(pChid).rt_indicator_min=null;
 } else {
     stmt="update lui_t_dashboard_chart set rt_indicator_min="+pMin
             + " where id="+pChid;
     Bcharts.get(pChid).rt_indicator_min=Double.valueOf(pMin);
 }
 mlc.executeDML(stmt);
 if (is_null(pMax)) {
     stmt="update lui_t_dashboard_chart set rt_indicator_max=null where id="+pChid;
     Bcharts.get(pChid).rt_indicator_max=null;
 } else {
     stmt="update lui_t_dashboard_chart set rt_indicator_max="+pMax
             + " where id="+pChid;
     Bcharts.get(pChid).rt_indicator_max=Double.valueOf(pMax);
 }
 mlc.executeDML(stmt);
 if (is_null(pIndicator))Bcharts.get(pChid).rt_indicator=null;
 else
 Bcharts.get(pChid).rt_indicator=pIndicator;
 
 for (String cid:Bcharts.keySet()){
     Bcharts.get(cid).indicatorGridIndex=null;
     Bcharts.get(cid).indicatorXindex=null;
     Bcharts.get(cid).indicatorYindex=null;
 }
  
// this.refreshIfNoTimer();
 }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
 }
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             try{ps.close();}catch(Exception ex){}
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void delGrid(String pChid) throws LuiException, SQLException{
 synchronized(changed){
 if (!Bcharts.containsKey(pChid)) return;
 if (Bcharts.size()<2)return;
 changed=true;
 LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
  try{
          Bchart chrt=Bcharts.get(pChid);
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();

 stmt="delete from lui_t_dashboard_chart where id=?";

 ps=c.prepareStatement(stmt);
 ps.setInt(1, Integer.valueOf(pChid));
 ps.execute();
 ps.close();
 ps=null;
// synchronized(clear){
 
   boolean b=true;
   while (b){
   b=false;
       for(String sid:Bseries.keySet()) {
      if (Bseries.get(sid).chart_id.equals(pChid)){
        boolean bb=true;
        while(bb){
        bb=false;
        for(String ari:Barithmetics.keySet()){
           if (Barithmetics.get(ari).series_id.equals(sid)){
               Barithmetics.remove(ari);
               bb=true;
               break;
           } 
        }
        }
        Bseries.remove(sid);
        b=true;break;
      }  
    }
   }
   
   b=true;
   while (b){
   b=false;
       for(String aid:Baxis.keySet()) {
      if (Baxis.get(aid).chart_id.equals(pChid)){
       Baxis.remove(aid);
        b=true;break;   
      }  
   }
   }
 Bcharts.remove(pChid);
 int gi=0;
 for(String chid:Bcharts.keySet()){
     Bcharts.get(chid).seq=gi+1;
     Bcharts.get(chid).gridIndex=gi;
     gi++;
     mlc.executeDML("update lui_t_dashboard_chart set seq="+String.valueOf(gi)+" where id="+chid);
     
 }
    renumAxes();
    
    clear=true;
    delUnusedDs(mlc);
 //}
 //}
 }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}     
}  } 
public void delArithm(String pSrc,String pId) throws LuiException, SQLException{
   synchronized(changed){
    changed=true;
    String stmt="";
  String dss=null;
  String dsa=null;
  LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
    try{
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
     c=mlc.getConnection();
    //synchronized(changed){
    //synchronized(Bseries){
    //synchronized(Barithmetics){
    //synchronized(BdataSources){
    if (pSrc.equals("0")){
      for (String arid:Barithmetics.keySet()){
        if (Barithmetics.get(arid).series_id.equals(pId)){
           dss=Bseries.get(pId).dataSource_id;
           dsa=Barithmetics.get(arid).dataSource_id;
           Bseries.get(pId).dataSource_id=Barithmetics.get(arid).dataSource_id;
           Bseries.get(pId).expression=Barithmetics.get(arid).expression;
           Bseries.get(pId).key_collection=Barithmetics.get(arid).key_collection;
           Bseries.get(pId).key_where=Barithmetics.get(arid).key_where;
           Bseries.get(pId).measure=Barithmetics.get(arid).measure;
           Bseries.get(pId).name=Barithmetics.get(arid).name;
           this.delArithmetica(arid, mlc);
           stmt="update lui_t_dashboard_series set datasource_id=?,"
                   + "expression=?,"
                   + "key_collection=?,"
                   + "key_where=?,"
                   + "measure=?,"
                   + "name=nullif(?,'') where id=?";
           ps=c.prepareStatement(stmt);
           ps.setInt(1,Integer.valueOf(Bseries.get(pId).dataSource_id));
           ps.setString(2, Bseries.get(pId).expression);
           ps.setString(3, Bseries.get(pId).key_collection);
           ps.setString(4, Bseries.get(pId).key_where);
           ps.setString(5, Bseries.get(pId).measure);
           ps.setString(6, Bseries.get(pId).name);
           ps.setInt(7,Integer.valueOf(pId));
           ps.execute();
           ps.close();
           ps=null;
           break;
        }   
      }
    } else {
        dsa=Barithmetics.get(pId).dataSource_id;
        this.delArithmetica(pId, mlc);
    } 
   this.delUnusedDs(mlc);
   if (dss!=null){
       if (BdataSources.containsKey(dss)){
           this.makeDsQuery(dss);
       }
   }
   if (dsa!=null){
      if (dss!=null && !dss.equals(dsa)) {
       if (BdataSources.containsKey(dsa)){
           this.makeDsQuery(dsa);
       }
      } 
   }
   //changed=true;
    //}}}}
  }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
       
        app.metaConnPool.SetFree(mlc);
    }
}
  }}
public void setArithmMeasure(String pArid,String pMeasure,LuiDbConn pMlc)throws SQLException, LuiException{
 synchronized(changed){
  changed=true;
  String stmt="";
  LuiDbConn mlc=null;
  
  try{
  if (pMlc==null)
      mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
  else mlc=pMlc;
 //synchronized(Barithmetics.get(pArid)){
 Barithmetics.get(pArid).measure=pMeasure;
 stmt="update lui_t_dashboard_arithmetica set measure='"+pMeasure+"' where id="+pArid;
 mlc.executeDML(stmt);
 //}   
}catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null && pMlc==null){
       
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public void setSeriesProperty(String pSid,String pProps) throws SQLException, LuiException{
 synchronized(changed){
 changed=true;
 
  LuiCollection col=new LuiCollection(pProps);
  String stmt="";
  LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  try{
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
  if (col.containsKey("name")){
    Bseries.get(pSid).name=col.Get_Element("name");
    // это имя уже есть?
    for(String sid:Bseries.keySet()){
        if (sid.equals(pSid))continue;
        if (!Bseries.get(sid).name.equals(col.Get_Element("name")))continue;
        // есть - подберём для найденной кривой иное имя
        Bseries.get(sid).name=this.getUniqueSeriesName(Bseries.get(sid).name,sid);
        stmt="update lui_t_dashboard_series set "
        + "name=nullif(?,'') "
        + "where id=?";
        ps=c.prepareStatement(stmt);
        ps.setString(1, Bseries.get(sid).name);
        ps.setInt(2, Integer.valueOf(sid));
        ps.execute();
        ps.close();
        ps=null; 
        break;
    }
    
  }
  if (col.containsKey("width")){
    if (is_null(col.Get_Element("width"))){
      Bseries.get(pSid).width=null;
    } else {
        if (col.Get_Element("width").equals("auto")) 
            Bseries.get(pSid).width=null;
        else 
        Bseries.get(pSid).width=Integer.valueOf(col.Get_Element("width"));
    }
  }
  if (col.containsKey("color")){
    Bseries.get(pSid).color=col.Get_Element("color");
    
  }
  if (col.containsKey("type")){
    Bseries.get(pSid).type=col.Get_Element("type");
    
  }
  if (col.containsKey("opacity")){
    Bseries.get(pSid).opacity=Double.valueOf(col.Get_Element("opacity"));
   
  }
  if (col.containsKey("measure")){
    Bseries.get(pSid).measure=col.Get_Element("measure");
   
  }
  if (col.containsKey("expression4time")){
     if (col.Get_Element("expression4time").equals("lui$system")){
      Bseries.get(pSid).lastTime=null;   
     } else
     Bseries.get(pSid).expression4time=col.Get_Element("expression4time");
     if (is_null(Bseries.get(pSid).expression4time))Bseries.get(pSid).lastTime=null;
  }
  if (col.containsKey("grid")){
    int newSeq=Integer.valueOf(col.Get_Element("grid"));
    int oldDur=Bcharts.get(Bseries.get(pSid).chart_id).dur;
    int oldSeq=Bcharts.get(Bseries.get(pSid).chart_id).seq;
    if (newSeq!=oldSeq){ // на другой грид!
     clear=true; // полная очистка графиков нужна для переотображения легенд и перенумераций гридов и осей
     String chFound=null; // ищем такой
      for (String cid:Bcharts.keySet()){
        if (Bcharts.get(cid).seq==newSeq){
           chFound=cid;break; 
        }
      }
      if (chFound==null){// не нашли - создаём нужное количество
          int curSize=Bcharts.size();
   
   for (int i=curSize;i<Integer.valueOf(newSeq);i++){
       Bchart newchart=new Bchart();
       newchart.x_inversion="N";
       newchart.dur=1;
       if (i==Integer.valueOf(newSeq)-1)newchart.dur=oldDur;
       synchronized (frequency){
       newchart.size=newchart.dur*frequency;
       }
       newchart.gridIndex=i;
       newchart.name_fill="r_black";
       newchart.name_font="8px";
       stmt="select nextval('lui_q_dashboard_chart')";
       newchart.id=mlc.getSelectResult(stmt);
       if (i==Integer.valueOf(newSeq)-1)
       newchart.name=Bseries.get(pSid).name;
       else
       newchart.name="..........";
       newchart.seq=i+1;
       stmt="insert into lui_t_dashboard_chart(id,dashboard_id,seq,name,rt_duration)values(?,?,?,nullif(?,''),?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1, Integer.valueOf(newchart.id));
       ps.setInt(2, id);
       ps.setInt(3, newchart.seq);
       ps.setString(4, newchart.name);
       ps.setInt(5, newchart.dur);
       ps.execute();
       ps.close();
       ps=null;
       Bcharts.put(newchart.id, newchart);
       chFound=newchart.id;
       //сразу создаём ось X
       Baxi newX=new Baxi();
       newX.axis_type="X";
       newX.auto_color="Y";
       newX.position="bottom";
       newX.chart_id=newchart.id;
       newX.data_type="time";
       newX.name_fontsize=12;
       newX.label_fontsize=8;
       newX.gridIndex=newchart.gridIndex;
       stmt="select nextval('lui_q_dashboard_chart_axis')";
       newX.id=mlc.getSelectResult(stmt);
       newX.xIndex=this.getNextXaxisIndex();
       Baxis.put(newX.id, newX);
       LuiCollection colr=this.getAutoColors4axis(newX.id);
       Baxis.get(newX.id).color_label=colr.Get_Element("label");
       Baxis.get(newX.id).color_line=colr.Get_Element("line");;
       Baxis.get(newX.id).color_name=colr.Get_Element("name");
       Baxis.get(newX.id).color_tick=colr.Get_Element("tick");
       stmt="insert into lui_t_dashboard_chart_axis(id,chart_id,axis_type,data_type,"
               + "auto_color,color_label,color_line,color_name,color_tick,position)"
               + "values(?,?,?,?,?,?,?,?,?,?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1,Integer.valueOf(newX.id));
       ps.setInt(2,Integer.valueOf(newX.chart_id));
       ps.setString(3,newX.axis_type);
       ps.setString(4,newX.data_type);
       ps.setString(5,newX.auto_color);
       ps.setString(6,Baxis.get(newX.id).color_label);
       ps.setString(7,Baxis.get(newX.id).color_line);
       ps.setString(8,Baxis.get(newX.id).color_name);
       ps.setString(9,Baxis.get(newX.id).color_tick);
       ps.setString(10,newX.position);
       ps.execute();
       ps.close();
       ps=null;
       //сразу создаём ось Y если грид не наш
       if (i==Integer.valueOf(newSeq)-1)continue;
       Baxi newY=new Baxi();
       newY.axis_type="Y";
       newY.name="Y";
       newY.auto_color="Y";
       newY.position="left";
       newY.chart_id=newchart.id;
       newY.data_type="value";
       newY.name_fontsize=12;
       newY.label_fontsize=8;
       newY.gridIndex=newchart.gridIndex;
       stmt="select nextval('lui_q_dashboard_chart_axis')";
       newY.id=mlc.getSelectResult(stmt);
       newY.yIndex=this.getNextYaxisIndex();
       Baxis.put(newY.id, newY);
       LuiCollection colY=this.getAutoColors4axis(newY.id);
       Baxis.get(newY.id).color_label=colY.Get_Element("label");
       Baxis.get(newY.id).color_line=colY.Get_Element("line");;
       Baxis.get(newY.id).color_name=colY.Get_Element("name");
       Baxis.get(newY.id).color_tick=colY.Get_Element("tick");
       stmt="insert into lui_t_dashboard_chart_axis(id,chart_id,axis_type,data_type,"
               + "auto_color,color_label,color_line,color_name,color_tick,position,name)"
               + "values(?,?,?,?,?,?,?,?,?,?,?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1,Integer.valueOf(newY.id));
       ps.setInt(2,Integer.valueOf(newY.chart_id));
       ps.setString(3,newY.axis_type);
       ps.setString(4,newY.data_type);
       ps.setString(5,newY.auto_color);
       ps.setString(6,Baxis.get(newY.id).color_label);
       ps.setString(7,Baxis.get(newY.id).color_line);
       ps.setString(8,Baxis.get(newY.id).color_name);
       ps.setString(9,Baxis.get(newY.id).color_tick);
       ps.setString(10,newY.position);
       ps.setString(11,newY.name);
       ps.execute();
       ps.close();
       ps=null;
        
   }
   
      }// не нащли создаём гриды
      // в этом месте chFound - это либо вновь созданный грид либо найденный
      // привязываем кривую к гриду
      Bseries.get(pSid).chart_id=chFound;
      // и к оси X грида
      // ищем эту ось Х 
      for (String axx:Baxis.keySet()){
       if (Baxis.get(axx).axis_type.equals("X") && Baxis.get(axx).chart_id.equals(chFound)) {
           // и привязываем
           Bseries.get(pSid).x_axis_id=axx;
           Bseries.get(pSid).xAxisIndex=Baxis.get(axx).xIndex;
           break;
       }
      }
      
      // и если коллекция параметров не содержит позицию оси - добавим этот элемент
      if (!col.containsKey("yaxis")){
          col.Add_Element("yaxis", Baxis.get(Bseries.get(pSid).y_axis_id).position);
      }
    }
  }
  if (col.containsKey("yaxis")){
    // ищем в гриде нужную ось Y
    Baxi Yaxis=null;
    for (String aix:Baxis.keySet()){
        if (Baxis.get(aix).chart_id.equals(Bseries.get(pSid).chart_id)) {
           if (Baxis.get(aix).axis_type.equals("Y")){
              if (Baxis.get(aix).position.equals(col.Get_Element("yaxis"))){ 
                 Yaxis=Baxis.get(aix);break;
              }
           }
        }
    }
    if (Yaxis==null){
       // ось не найдена - создаём 
/*!!!!!*/      clear=true; // это пришлось добавить т.к. генерировалось TYPE is UNDEFINED       
       Yaxis=new Baxi();
       Yaxis.axis_type="Y";
       Yaxis.chart_id=Bseries.get(pSid).chart_id;
       Yaxis.data_type="value";
       Yaxis.auto_color="Y";
       Yaxis.name_fontsize=12;
       Yaxis.label_fontsize=8;
       Yaxis.position=col.Get_Element("yaxis");
       if (Yaxis.position.equals("left")) Yaxis.name="Y";
       else Yaxis.name="Y'";
       Yaxis.gridIndex=Bcharts.get(Yaxis.chart_id).gridIndex;
       stmt="select nextval('lui_q_dashboard_chart_axis')";
       Yaxis.id=mlc.getSelectResult(stmt);
       Yaxis.yIndex=this.getNextYaxisIndex();
       Baxis.put(Yaxis.id,Yaxis);
       LuiCollection colY=this.getAutoColors4axis(Yaxis.id);
       Baxis.get(Yaxis.id).color_label=colY.Get_Element("label");
       Baxis.get(Yaxis.id).color_line=colY.Get_Element("line");;
       Baxis.get(Yaxis.id).color_name=colY.Get_Element("name");
       Baxis.get(Yaxis.id).color_tick=colY.Get_Element("tick");
       stmt="insert into lui_t_dashboard_chart_axis(id,chart_id,axis_type,data_type,"
               + "auto_color,color_label,color_line,color_name,color_tick,position,name)"
               + "values(?,?,?,?,?,?,?,?,?,?,?)";
       ps=c.prepareStatement(stmt);
       ps.setInt(1,Integer.valueOf(Yaxis.id));
       ps.setInt(2,Integer.valueOf(Yaxis.chart_id));
       ps.setString(3,Yaxis.axis_type);
       ps.setString(4,Yaxis.data_type);
       ps.setString(5,Yaxis.auto_color);
       ps.setString(6,Baxis.get(Yaxis.id).color_label);
       ps.setString(7,Baxis.get(Yaxis.id).color_line);
       ps.setString(8,Baxis.get(Yaxis.id).color_name);
       ps.setString(9,Baxis.get(Yaxis.id).color_tick);
       ps.setString(10,Yaxis.position);
       ps.setString(11,Yaxis.name);
       ps.execute();
       ps.close();
       ps=null;
    } 
    String oldY=Bseries.get(pSid).y_axis_id;
    Bseries.get(pSid).y_axis_id=Yaxis.id;
    Bseries.get(pSid).yAxisIndex=Yaxis.yIndex;
    axisAutoColor(mlc,Bseries.get(pSid).y_axis_id);
    axisAutoColor(mlc,oldY);
  }
if (col.containsKey("aux")){
    stmt="select id,measure,del_no from lui_t_dashboard_ari_aux where sort=1 and session_id="+app.getProperty("SessionID");
 ArrayList<LuiCollection> auxcols=   mlc.getSelectAllRowsValMap(stmt);
 if (auxcols!=null){
 for(int i=0;i<auxcols.size();i++){
   LuiCollection auxcol=auxcols.get(i);
   if (is_not_null(auxcol.get("del_no"))){
       this.delArithmetica(auxcol.Get_Element("id"), mlc);
   } else {
      String ari= auxcol.Get_Element("id");
      if (!Barithmetics.get(ari).measure.equals(auxcol.Get_Element("measure"))){
        this.setArithmMeasure(ari,auxcol.Get_Element("measure"),mlc );
      }
   }
 }}
 stmt="delete from lui_t_dashboard_ari_aux where sort=1 and session_id="+app.getProperty("SessionID");
 mlc.executeDML(stmt);
}
stmt="update lui_t_dashboard_series set "
        + "name=nullif(?,''),"
        + "type=?,"
        + "opacity=?,"
        + "y_axis_id=?,"
        + "x_axis_id=?,"
        + "color=?,"
        + "measure=?,"
        + "width=nullif(?,'')::lui_d_id, "
        + "expression4time=nullif(?,'') "
        + "where id=?";
 ps=c.prepareStatement(stmt);
 ps.setString(1, Bseries.get(pSid).name);
 ps.setString(2, Bseries.get(pSid).type);
 ps.setDouble(3, Bseries.get(pSid).opacity);
 ps.setInt(4, Integer.valueOf(Bseries.get(pSid).y_axis_id));
 ps.setInt(5, Integer.valueOf(Bseries.get(pSid).x_axis_id));
 ps.setString(6, Bseries.get(pSid).color);
 ps.setString(7, Bseries.get(pSid).measure);
 if (Bseries.get(pSid).width!=null)
 ps.setString(8, Bseries.get(pSid).width.toString());
 else ps.setString(8, "");
 ps.setString(9, Bseries.get(pSid).expression4time);
 ps.setInt(10, Integer.valueOf(pSid));
 ps.execute();
 ps.close();
 ps=null;
 axisAutoColor(mlc, Bseries.get(pSid).y_axis_id);
 if (col.containsKey("expression4time")){
 this.makeDsQuery(Bseries.get(pSid).dataSource_id);
 }
 removeUnusedAxes(mlc);
 delUnusedDs(mlc);
 renumAxes();
 //}
  }catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}                
}}
public void setGridInterval(String pChid,String pInterval) throws SQLException, LuiException{
    synchronized(changed){
    
    int newdur=Integer.valueOf(pInterval);
    if (Bcharts.get(pChid).dur==newdur)return;
    changed=true;
  LuiDbConn mlc=null;
  Connection c=null;
  PreparedStatement ps=null;
  String stmt="";
  try{
    Bchart chrt=Bcharts.get(pChid);
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
 c=mlc.getConnection();
 stmt="update lui_t_dashboard_chart set rt_duration=? where id=?";
 ps=c.prepareStatement(stmt);
 ps.setInt(1, newdur);
 ps.setInt(2, Integer.valueOf(pChid));
 ps.execute();
 ps.close();
 ps=null;

    
    int newsize=newdur*frequency;
    if (newsize>chrt.size) {
   /*  int points2add=newsize-chrt.size;  
     
     for (String sid:Bseries.keySet()){
     if (!Bseries.get(sid).chart_id.equals(pChid)) continue;
     long s=currentTime-1000*newdur*60;    
     for (int i=0;i<points2add;i++){
       s=s-1000*60/frequency;
               d.setTime(s);
               dataElement de=new dataElement(df.format(d),null);
               Bseries.get(sid).data.add(0, de);
       }
      }*/
    chrt.size=newsize; 
    chrt.dur=newdur;
    
    }
    if (newsize<chrt.size) {
     int points2del=chrt.size-newsize;   
     for (String sid:Bseries.keySet()){
     if (!Bseries.get(sid).chart_id.equals(pChid)) continue;    
     if (points2del<Bseries.get(sid).data.size()){
     for (int i=0;i<points2del;i++){
       Bseries.get(sid).data.remove(0);
       }
      }
     }
    chrt.size=newsize;
    chrt.dur=newdur;
    
     }
    if ("N".equals(frm.getProperty("rtTimer"))){
        this.makeSnap();
    }
    
    
    
}catch(SQLException sex){
    setStatus("stop");
    app.msgWriter.sqlError(mlc, sex, null, stmt);
}
  finally{
    if (mlc!=null){
       if (ps!=null){
         if (!ps.isClosed()){
             ps.close();
             ps=null;
         }
       } 
        app.metaConnPool.SetFree(mlc);
    }
}
}
}
public Integer getSleepTime(){
    synchronized(this.frequency){
    return 60*1000/frequency;
}
}
public Long getDelayTime(){
    synchronized(this.frequency){
    long delay=60*1000/frequency;
    if (delay<1000) delay=1000;
  
    synchronized (parazit){
    delay=delay-parazit;}
    if (delay<200)delay=200;
    
    
    return delay;}
    
}
public void removeUnusedAxes(LuiDbConn mlc) throws SQLException{
    boolean cl=false;
   synchronized(changed){
       changed=true;
       boolean b=true;
       while (b){
       b=false;
       for (String aid:Baxis.keySet()){
         if (Baxis.get(aid).axis_type.equals("X")) continue;
          boolean yes=false;
            // имеются ли кривые на этой оси?
          for (String sid:Bseries.keySet()){
              if (Bseries.get(sid).y_axis_id.equals(aid)){yes=true;break;}
          }
          if (!yes){// кривых нет
            // а имеются ли в этом гриде другие оси Y?
            for (String oaid:Baxis.keySet()){
               if (Baxis.get(oaid).axis_type.equals("X"))continue;
               if (oaid.equals(aid)) continue;
               if (Baxis.get(oaid).chart_id.equals(Baxis.get(aid).chart_id)){
               yes=true;break;
               }
            }
            if (yes){// да имеются
              // удаляем неиспользуемую ось aid
              Baxis.remove(aid);b=true;
              mlc.executeDML("delete from lui_t_dashboard_chart_axis where id="+aid);
              clear=true;
              cl=true;
              break;
            }
          }
       }
       }
   if (cl){
       // перенумеровываем оси 
 this.renumAxes();
   }
   }
}
public void renumAxes(){
   boolean cl=false;
   synchronized (changed){
   changed=true;
 int xi=0;
 int yi=0;
 
 for (String chid:Bcharts.keySet()){
   for (String axid:Baxis.keySet()){
     if (!Baxis.get(axid).chart_id.equals(chid)) continue;
     if (Baxis.get(axid).gridIndex!=Bcharts.get(chid).gridIndex){
        Baxis.get(axid).gridIndex=Bcharts.get(chid).gridIndex; 
     }
     if (Baxis.get(axid).axis_type.equals("X")){  
       if (Baxis.get(axid).xIndex!=xi) {
           Baxis.get(axid).xIndex=xi;
           for (String sid:Bseries.keySet()){
             if (Bseries.get(sid).x_axis_id.equals(axid)) {
                 Bseries.get(sid).xAxisIndex=xi;
             }
           }
           cl=true;
       }   
       xi++;
     }
     if (Baxis.get(axid).axis_type.equals("Y")){
       if (Baxis.get(axid).yIndex!=yi) {
           Baxis.get(axid).yIndex=yi;
           for (String sid:Bseries.keySet()){
             if (Bseries.get(sid).y_axis_id.equals(axid)) {
                 Bseries.get(sid).yAxisIndex=yi;
             }
           }
           cl=true;
       }   
       yi++;
     }
   }
   
 }
 if (cl){
         LinkedHashMap<String,Baxi> newBaxis=new LinkedHashMap<>();
      for (int i=0;i<xi;i++){
        for (String axid:Baxis.keySet()){
          if (!Baxis.get(axid).axis_type.equals("X"))continue;  
           if (Baxis.get(axid).xIndex==i){
             newBaxis.put(axid,Baxis.get(axid));
           }
        }  
      }
      for (int i=0;i<yi;i++){
        for (String axid:Baxis.keySet()){
          if (!Baxis.get(axid).axis_type.equals("Y"))continue;  
           if (Baxis.get(axid).yIndex==i){
             newBaxis.put(axid,Baxis.get(axid));
           }
        }  
      }
      Baxis=newBaxis;
      clear=cl;
   }
 }    
  
}
public String isAddValEnable(){
    if (Bseries.size()>1)    return "Y";
    for (String sid:Bseries.keySet()){
        if (is_not_null(Bseries.get(sid).expression)) return "Y";
    }
    return "N";
}
public String getClickedAxisID(String pComponentType,String pComponentID){
 String axisFnd="";   
  for (String axid:Baxis.keySet()){
    if (Baxis.get(axid).axis_type.equals("X") && pComponentType.equals("xAxis")){
       if (Baxis.get(axid).xIndex==Integer.valueOf(pComponentID)) {
       axisFnd=axid;
       break;}
    }
    if (Baxis.get(axid).axis_type.equals("Y") && pComponentType.equals("yAxis")){
       if (Baxis.get(axid).yIndex==Integer.valueOf(pComponentID)) {
       axisFnd=axid;
       break;}
    }
  }
  return axisFnd;
}
public String getClickedChartID(String pComponentType,String pComponentID){
 if (pComponentType.equals("xAxis") ||pComponentType.equals("yAxis")){
    String axisFnd=getClickedAxisID(pComponentType,pComponentID);   
    if (Baxis.containsKey(axisFnd))
    return Baxis.get(axisFnd).chart_id;
 } else {
     for (String chfnd:Bcharts.keySet()){
         if (Bcharts.get(chfnd).gridIndex==Integer.valueOf(pComponentID)) return chfnd; 
     }
 }  
 
  return "";
}
public void clearDB(){
    //synchronized(clear){
    synchronized(changed){    
        clear=true;
        changed=true;
        this.lastUpdate=null;
    }
    //}
}
public void refreshDetails(String pExceptOf) throws LuiException, SQLException{
  if (is_not_null(pExceptOf)){
  String chFrmCode= app.forms.get(pExceptOf).getCode();
  if (chFrmCode.equals("LUI_B_RT_DASHBOARD"))return;
  }
  /*String findFor="";
  if (chFrmCode.equals("LUI_B_RT_CHART"))findFor="LUI_L_RT_CHART";
  if (chFrmCode.equals("LUI_B_RT_AXIS"))findFor="LUI_L_RT_AXIS";
  if (chFrmCode.equals("LUI_B_RT_CURVE"))findFor="LUI_L_RT_SERIES";

  if (chFrmCode.equals("LUI_L_RT_CHART"))findFor="LUI_B_RT_CHART";
  if (chFrmCode.equals("LUI_L_RT_AXIS"))findFor="LUI_B_RT_AXIS";
  if (chFrmCode.equals("LUI_L_RT_SERIES"))findFor="LUI_L_RT_CURVE";
  */
  String myWin=frm.getVal("WindowID");
  
  for(String fc:app.forms.keySet()){
    if (fc.equals(pExceptOf))  continue;
    if (fc.equals(frm.getFormID())) continue;
    if (!app.forms.get(fc).getVal("WindowID").equals(myWin)) continue;
    //if (!app.forms.get(fc).getCode().equals(findFor))continue;
    if (is_not_null(pExceptOf) && fc.equals(pExceptOf))continue;
    if (app.forms.get(fc).getType().equals("LIST"))
    {app.forms.get(fc).requery();
     app.forms.get(fc).setVal("Changed","N");
    }
    else {
    switch (app.forms.get(fc).getCode()){
        case "LUI_B_RT_CHART":
        String chid=app.forms.get(fc).elements.get("P_CHART_ID").getProperty("Value");
        if (!Bcharts.containsKey(chid)){
         app.forms.get(fc).close("", "");      
         continue;
        }
        break;
        case "LUI_B_RT_AXIS":
        String aid=app.forms.get(fc).elements.get("P_AX_ID").getProperty("Value");
        if (!Baxis.containsKey(aid)){
         app.forms.get(fc).close("", "");      
         continue;
        }
        break;
        case "LUI_B_RT_CURVE":
        String sid=app.forms.get(fc).elements.get("P_SERIES_ID").getProperty("Value");
        if (!Bseries.containsKey(sid)){
         app.forms.get(fc).close("", "");      
         continue;
        }
        break;
    }
    app.forms.get(fc).reloadForm();   
    app.forms.get(fc).setVal("Changed","N");
    app.forms.get(fc).changeFlag=false;
    }
    if (is_not_null(pExceptOf) && app.forms.containsKey(pExceptOf)){
      LuiClCommandGroup XMLcg=null;
      XMLcg=app.commandWriter.addGroup("rtFocus");
      LuiClCommand XMLcmd=null;
      XMLcmd=XMLcg.addCommand("Focus");
      XMLcmd.addScaPar("FormID", pExceptOf);
    }
  }  
}
public void refreshIfNoTimer() throws LuiException, SQLException{
 //  if (frm.getProperty("rtTimer").equals("Y")) return; 
 //  clearDB();
 synchronized(changed){    
   changed=true;
  
 
   app.parser.execute("ChartControl:"+frm.getFormID()+";Command:"+this.getCommand4ChartControl()+
           ";Data:App.forms.get(\""+frm.getFormID()+"\").RTdashboard.get(100);"
           , frm.elements.get("SHIFT").properties.get("PROC_FINALLY"));
   
}
}
public int getBseriesSize(){
    return Bseries.size();
}
public void setShowToolTip(String pYN){
    synchronized(changed){ 
    if ("Y".equals(pYN)){
      if (!this.showtooltip){
          showtooltip=true;
          changed=true;
      }
    } else {
       if (this.showtooltip){
          showtooltip=false;
          changed=true;
      } 
    }
}}
public void tryReconnect() throws LuiException{
  for (String bc:Bconnections.keySet()){
      if (Bconnections.get(bc)==null){
        if (app.userDbConnections.containsKey(bc)){
                 LuiDbConn lc=null;
                 try{
                 lc=app.userDbConnections.get(bc).connPool.GetFree(app.NLS.currentLang.locale,
                         app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
                 Bconnections.put(bc, lc);
                 for (String ds:BdataSources.keySet()){
                   if (BdataSources.get(ds).db_connect.equals(bc)){
                      BdataSources.get(ds).queryText="";
                           
                      this.makeDsQuery(ds);
                   
                   }}
                 } catch(SQLException sex){
                 if (lc!=null){
                     try {
                     app.userDbConnections.get(bc).connPool.SetFree(lc);
                     } catch (SQLException sex2){}
                 }
                 Bconnections.put(bc, null);    
                 }
                 
             }           
          
      }
  }
}
public void makeSnap(){
 synchronized(Bseries){   
  for (String sid:Bseries.keySet()){
  synchronized(Bseries.get(sid).data){    
   if (Bseries.get(sid).min!=null){
   double min=Bseries.get(sid).min;
   Bseries.get(sid).minSnap=min;
   }else Bseries.get(sid).minSnap=null;
   
   if (Bseries.get(sid).max!=null){
   double max=Bseries.get(sid).max;
   Bseries.get(sid).maxSnap=max;
   }else Bseries.get(sid).maxSnap=null;
   
   if (Bseries.get(sid).newValue2show!=null){
   double nv4s=Bseries.get(sid).newValue2show;
   Bseries.get(sid).newValue2showSnap=nv4s;}
   else Bseries.get(sid).newValue2showSnap=null;
   
   for (int i=0;i<Bseries.get(sid).data.size();i++){
      Bseries.get(sid).dataSnap.add(Bseries.get(sid).data.get(i));
    }
   }
  }
}}
}