/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
Диспетчер задач
 */
package luiserver;

import LuiCollection.LuiCollection;
import LuiDbInterface.LuiDbConn;
import LuiDbInterface.LuiDbConnPool;
import LuiNLS.LuiNLS;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;

/**
 *
 * @author aliubushkin
 */
public class LuiTaskDispatcher implements Runnable{
int TaskDispatcherTimeOut;
LuiDbConnPool metaconnpool;   
String LuiSrvName;
public HashMap<String,LuiTaskAsync> asyncTasks;
public LuiDbConn lc=null;
ArrayList<String> al;
public Thread thread; // ссылка на работающий 
LuiNLS NLS;
LuiCrip crip;
LuiDbConnPoolArray connPoolArray;
HashMap<String, Class> stdPluginClasses; // множество стандартных плагинов
HashMap<String, String> stdPluginIsInter; // признаки интерактивности плагинов
HashMap<String, LuiAppForm> formTemplates;
LuiCollection commonForms;
LuiDataConverter LuiDatConv;
String AppFilePath;    
public LuiTaskDispatcher(LuiDbConnPool pMetaconnpool,LuiNLS pNLS,LuiCrip pCrip,LuiDbConnPoolArray pConnPoolArray,HashMap<String, Class> PstdPluginClasses,HashMap<String, String> PstdPluginIsInter,String pLuiSrvName,int pTaskDispatcherTimeOut,LuiCollection pCommonForms,HashMap<String, LuiAppForm> pFormTemplates,String pAppFilePath,LuiDataConverter pLuiDatConv) throws SQLException{
        this.asyncTasks = new HashMap<>();
        this.LuiDatConv = pLuiDatConv;
NLS=pNLS;
crip=pCrip;
LuiSrvName=pLuiSrvName;
metaconnpool=pMetaconnpool;
connPoolArray=pConnPoolArray;

stdPluginClasses=PstdPluginClasses;
stdPluginIsInter=PstdPluginIsInter;
lc=metaconnpool.GetFree(pNLS.currentLang.locale,pNLS.currentLang.code," Async tasks dispatcher", null, null);
TaskDispatcherTimeOut=pTaskDispatcherTimeOut;
commonForms=pCommonForms;
formTemplates=pFormTemplates;
AppFilePath=pAppFilePath;
}

    @Override
    public void run() {
        boolean b=true;
    try {
      while (true){  
       synchronized(thread){   
        thread.wait(TaskDispatcherTimeOut);
       }
       synchronized(this.asyncTasks){
       clearNotRunTask();
       b=true;
       while(b){
        b=false;
        LuiCollection appTask=lc.getSelectFirstRowValMap("select * from "
                + "lui_t_task where status='WAIT' "
                + "and next_start<=current_timestamp + interval '"+String.valueOf(TaskDispatcherTimeOut)+" millisecond' "
                + "and (lui_server_only4='"+LuiSrvName+"' or lui_server_only4 is null) order by next_start limit 1");
        if (appTask!=null){
        b=true;
        al=lc.executeIfNoLocks("update lui_t_task set status='PREPARE',next_start=null,last_start=null,last_session_id=null,lui_server='"+LuiSrvName+"' where status='WAIT' and app_code='"+
                appTask.Get_Element("app_code")+"' and code='"+appTask.Get_Element("code")+"' and (lui_server_only4='"+LuiSrvName+"' or lui_server_only4 is null)");
        if (al!=null){
        if (al.get(0).equals("success")){
        if (al.get(1).equals("1")){
        
        LuiTaskAsync ta=new LuiTaskAsync(appTask,NLS,this.metaconnpool,crip,this.connPoolArray,stdPluginClasses,stdPluginIsInter,LuiSrvName,commonForms,formTemplates,AppFilePath,LuiDatConv);
        ta.thread = new Thread(ta);
        ta.thread.setDaemon(true);
        ta.thread.setName("LUI async task dispatcher");
        String k=appTask.Get_Element("app_code")+"."+appTask.Get_Element("code");
        this.asyncTasks.put(k, ta);
        ta.thread.start();   
        }
        }
        }
        }
      }
      } 
      }  
    } catch (InterruptedException ex) { //в этом месте надо корректно прервать задачи
                                        //и дождаться их завершения
        clearNotRunTask();
        if (lc!=null) try {
        for(String tk:asyncTasks.keySet()){
         LuiTaskAsync tas=asyncTasks.get(tk);
          String stmt="select lui_r_stop_async_task('"+tas.app.code+"','"+tas.frm.code+"','BREAK','STOP')";
          System.out.println(stmt);
          lc.getSelectResult(stmt);
          System.out.println("Success");
          
          System.out.flush();
          
          
          
          //System.out.println(tas.app.code+"."+tas.frm.code);
        }    
        while (true){
         clearNotRunTask();
         if (asyncTasks.size()==0) {
             break;
         }
        }
        metaconnpool.SetFree(lc);
        } catch (SQLException ex1) {
                System.out.println("Error:"+ex1.getLocalizedMessage());
                System.out.flush();
        } catch (Exception ex1) {
            System.out.println("Error:"+ex1.getLocalizedMessage());
                System.out.flush();
        }
        return;
    } catch (SQLException ex) {

        if (lc!=null) try {
            metaconnpool.SetFree(lc);
        } catch (SQLException ex1) {
            System.out.println("Error:"+ex1.getLocalizedMessage());
                System.out.flush();
        }
        return;
    }   
    }   
/**
 * Чистильщик дохлых задач
 */    
public void clearNotRunTask(){
   if (this.asyncTasks!=null){
   boolean b=true;
   while(b){
       b=false;
    for(String tk:asyncTasks.keySet()){
     if (!this.asyncTasks.get(tk).thread.isAlive()) {  
         this.asyncTasks.remove(tk);
         b=true;
         break;
     }
    }
   } 
   }
}
}
