/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.common;


/**
 *
 * @author john
 */
public class HtmlProperties {
    
    private boolean leaf = false;
    private String parents = null;
    private int parentsCount = 0;
    private int colSpan = 0;
    private int rowSpan = 0;
    private String allChildren = null;
    private boolean occupied = false;
    
    public HtmlProperties() {
        clear();
    }
    
    public final void clear() {
        leaf = false;
        parents = null;
        colSpan = 0;
        rowSpan = 0;
        allChildren = null;
    }
    
    public void setLeaf() {
        this.leaf = true;
    }
    
    public void setLeaf(boolean leaf) {
        this.leaf = leaf;
    }
    
    public boolean isLeaf() {
        return leaf;
    }
    
    public void setParents(String parents) {
        this.parents = parents;
    }
    
    public String getParents() {
        return parents;
    }
    
    public void setParentsCount(int parentsCount) {
        this.parentsCount = parentsCount;
    }
    
    public int getParentsCount() {
        return parentsCount;
    }
    
    public void setColSpan(int span) {
        colSpan = span;
    }
    
    public int getColSpan() {
        return colSpan;
    }
    
    public void setRowSpan(int span) {
        rowSpan = span;
    }
    
    public int getRowSpan() {
        return rowSpan;
    }
    
    public void setAllChildren(String children) {
        allChildren = children;
    }
    
    public String getAllChildren() {
        return allChildren;
    }
    
    public void setOccupied() {
        occupied = true;
    }
    
    public boolean isOccupied() {
        return occupied;
    }
    
}
