/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.common;

import java.util.ArrayList;
import java.util.Date;

/**
 *
 * @author john
 */
public class ServerConfigEntry {

    private String description = null;
    private boolean loadUserList = false;
    private String userListGroup = "";
    private int userListValid = 10;
    private Date userListUpdate = null;
    private ArrayList<String> userList = new ArrayList<>();

    public ServerConfigEntry() {
    }

    public void setDescription(String d) {
        description = d;
    }

    public String getDescription() {
        return description;
    }

    public void setUserListGroup(String group) {
        userListGroup = group;
    }

    public String getUserListGroup() {
        return userListGroup;
    }

    public void setUserListValid(int interval) {
        userListValid = (interval >= 0) ? interval : 0;
    }

    public int getUserListValid() {
        return userListValid;
    }

    public void setLoadUserList(boolean load) {
        loadUserList = load;
    }

    public boolean isLoadUserList() {
        return loadUserList;
    }

    public void setUserList(ArrayList<String> list) {
        userListUpdate = new Date();
        userList = list;
    }

    public boolean needListUpdate() {
        if (userListValid == 0) {
            return true;
        } else if (userListUpdate == null) {
            return true;
        } else {
            Date d = new Date();
            return (d.getTime() - userListUpdate.getTime() > userListValid * 60000);
        }
    }

    public boolean checkUser(String user) {
        return userList.contains(user);
    }
}
