/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.common;

import java.util.ArrayList;

/**
 *
 * @author john
 */
public class UiCollection {

    private ArrayList<String> codes = null;
    private ArrayList<String> values = null;
    private boolean empty = true;
    private String maskString = Defaults.COLLECTION_MASK;
    private int position = 0;
    private String collect;

    public UiCollection() {
    }

    public UiCollection(String collection) {
        collect = collection;
        int i;
        if (!Utils.testEmptyString(collection)) {
            codes = new ArrayList<>();
            values = new ArrayList<>();
            if (!collection.substring(collection.length() - 1).equals(";")) {
                i = collection.lastIndexOf(";");
                maskString = collection.substring(i + 1);
                if (Utils.testEmptyString(maskString)) {
                    maskString = Defaults.COLLECTION_MASK;
                }
                collect = collection.substring(0, i + 1);
            }
            boolean isCode = true;
            String s;
            while (collect.length() > 0) {
                if (isCode) {
                    i = collect.indexOf(":");
                    s = collect.substring(0, i);
                    try {
                        codes.add(s.replace(maskString, ":"));
                    } catch (Exception e) {
                        codes.add("");
                    }
                    collect = collect.substring(i + 1);
                    isCode = false;
                } else {
                    i = collect.indexOf(";");
                    s = collect.substring(0, i);
                    try {
                        values.add(s.replace(maskString, ";"));
                    } catch (Exception e) {
                        values.add("");
                    }
                    collect = collect.substring(i + 1);
                    isCode = true;
                }
            }
            if (codes.size() > 0) {
                empty = false;
            }
        }
    }

    public void getNext() {
        position++;
    }

    public boolean isEmpty() {
        return empty;
    }

    public boolean isLast() {
        return (codes.size() == position);
    }

    public int getSize() {
        return codes.size();
    }
    
    public String getCode() {
        return codes.get(position);
    }

    public String getValue() {
        return values.get(position);
    }

}
