/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.event;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map.Entry;
import org.jdom2.Element;
import org.jdom2.Document;
import static ru.fors.telecom.webui.common.Defaults.XML_1_0_PATTERN;


/**
 *
 * @author john
 */
public class TotalEvent extends ArrayList<SingleEvent> {
    
    public Document xml() {
        Element rootElem = new Element("Events");
        Document eventXML = new Document(rootElem);
        Element elem;
        for (SingleEvent event : this) {
            Element eventElem = new Element("E").setAttribute("N", event.name());
            rootElem.addContent(eventElem);
            Iterator<Entry<String, EventParameter>> paramIter = event.parameters().entrySet().iterator();
            while (paramIter.hasNext()) {
                elem = new Element("P");
                Entry<String, EventParameter> paramEntry = paramIter.next();
                if (paramEntry.getValue() instanceof StringParameter) {
                    elem.setAttribute("N", paramEntry.getKey());
                    elem.setText(XML_1_0_PATTERN.matcher(paramEntry.getValue().value()).replaceAll(""));
                } else if (paramEntry.getValue() instanceof CollectionParameter) {
                    elem.setAttribute("N", paramEntry.getKey()).setAttribute("T", "Collection");
                    Element collElement;
                    Iterator<Entry<String, String>> collIter = ((CollectionParameter) paramEntry.getValue()).entrySet().iterator();
                    while (collIter.hasNext()) {
                        Entry<String, String> collEntry = collIter.next();
                        collElement = new Element("X");
                        collElement.setText(collEntry.getKey());
                        elem.addContent(collElement);
                        collElement = new Element("V");
                        collElement.setText(XML_1_0_PATTERN.matcher(collEntry.getValue()).replaceAll(""));
                        elem.addContent(collElement);
                    }
                }
                eventElem.addContent(elem); 
            }       
        }
        return eventXML;
    }
    
}
