/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.menu;

import ru.fors.telecom.webui.common.Utils;


/**
 *
 * @author john
 */
public class UiGroupMenuItem extends UiMenuObject {

    private UiSubMenu subMenu = null;

    public UiGroupMenuItem() {
        super();
    }

    public UiGroupMenuItem(String id) {
        super(id);
    }

    public UiGroupMenuItem(String id, String label) {
        super(id, label);
    }

    public void setSubMenu(UiSubMenu subMenu) {
        this.subMenu = subMenu;
        subMenu.setParent(this);
    }

    public UiSubMenu getSubMenu() {
        return subMenu;
    }
    
    public String HTMLstart() {
        String fi = getFirstIcon();
        String icon = Utils.testEmptyString(fi) ? "" : " lui2-show-icon";
        String ret = "<div id='" + uid + "' class='groupitem no-select" + icon + " lui2-unit'" + parent + "><div class='menuitem-icon first-icon " + fi + " lui2-unit'></div><div class='menuitem-layout lui2-unit'" + parent + ">";
        for (int i = 0; i < this.content.size(); i++) {
            UiMenuItemContent c = this.content.get(i);
            if (c instanceof UiMenuItemText) {
                ret = ret + "<div class='menuitem-label lui2-unit'>" + c.getValue() + "</div>";
            } else if (c instanceof UiMenuItemIcon) {
                ret = ret + "<div class='menuitem-icon ico-noicon " + c.getValue() + " lui2-unit'></div>";
            }
        }
        return ret + "<div class='submenu-icon lui2-unit'></div></div>";
    }
    
    public String HTMLend() {
        return "</div>";
    }

}
