/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.menu;

import ru.fors.telecom.webui.common.Utils;

/**
 *
 * @author john
 */
public class UiLocalMenuItem extends UiMenuObject {

    public UiLocalMenuItem() {
        super();
    }

    public UiLocalMenuItem(String id) {
        super(id);
    }

    public UiLocalMenuItem(String id, String label) {
        super(id, label);
    }

    public String HTML() {
        String disabled = enabled ? "" : " disabled='true'";
        String ripple = enabled ? " lui2-ripple ripple-black" : "";
        String fi = getFirstIcon();
        String icon = Utils.testEmptyString(fi) ? "" : " lui2-show-icon";
        String ret = "<div id='" + uid + "' class='menuitem no-select " + style + icon + ripple + " lui2-unit'" + parent + disabled + "><div class='menuitem-icon first-icon " + fi + " lui2-unit'></div><div class='menuitem-layout lui2-unit'" + parent + ">";
        for (int i = 0; i < this.content.size(); i++) {
            UiMenuItemContent c = this.content.get(i);
            if (c instanceof UiMenuItemText) {
                ret = ret + "<div class='menuitem-label lui2-unit'>" + c.getValue() + "</div>";
            } else if (c instanceof UiMenuItemIcon) {
                ret = ret + "<div class='menuitem-icon ico-noicon " + c.getValue() + " lui2-unit'></div>";
            }
        }
        return ret + "</div></div>";
    }
    
}
