/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

package ru.fors.telecom.webui.menu;

import java.util.ArrayList;

/**
 *
 * @author john
 */
public class UiSubMenu extends ArrayList<UiMenuObject> {

    private String id = null;
    private UiGroupMenuItem parent = null;

    public UiSubMenu() {
        super();
    }

    public UiSubMenu(String id) {
        super();
        setId(id);
    }

    public UiSubMenu(UiGroupMenuItem parent) {
        super();
        setParent(parent);
    }

    public UiSubMenu(String id, UiGroupMenuItem parent) {
        super();
        setId(id);
        setParent(parent);
    }

    public final void setId(String id) {
        this.id = id;
    }

    public final String getId() {
        return id;
    }

    public final void setParent(UiGroupMenuItem parent) {
        this.parent = parent;
        for (UiMenuObject obj : this) {
            obj.setParent(parent.uid);
        }
    }

    public final UiGroupMenuItem getParent() {
        return parent;
    }

    public UiMenuObject findObject(String id) {
        for (UiMenuObject obj : this) {
            if (obj.getId().equals(id)) {
                return obj;
            }
        }
        return null;
    }
    
    @Override
    public boolean add(UiMenuObject obj) {
        boolean b = super.add(obj);
        if (parent != null) obj.setParent(parent.uid);
        return b;
    }
    
    public String HTMLstart() {
        return (this.id).equals("@") ? "<div class='submenu rootmenu context-menu lui2-elevated-6 lui2-unit'><div class='submenu-scroll lui2-unit'>" : "<div class='submenu lui2-elevated-6 lui2-unit' parent='" + parent.uid + "'><div class='submenu-scroll lui2-unit'>";
    }

    public String HTMLend() {
        return "</div></div>";
    }
    
}
