/*
 * Copyright (c) 2021 «FORS Telecom» LLC.
 * All Rights Reserved.
 *
 * The code is published under the terms of the «FORS Telecom» LLC Licens,
 * published in file LICENSE of this package or at
 *
 * http://lui.fors.ru/license	- in Russian
 * http://lui.fors.com/license	- in English.
 *
 */

/*
 * Обеспечивает работу аналитических графиков 2-й версии
 */
package luiserver;

import LuiCollection.LuiCollection;
import LuiCollection.LuiString;
import static LuiCollection.LuiString.NVL;
import static LuiCollection.LuiString.is_not_null;
import static LuiCollection.LuiString.is_null;
import static LuiCollection.LuiString.like;
import LuiDbInterface.ColInfo;
import LuiDbInterface.LuiDbConn;
import LuiExceptionMsg.LuiException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;

import java.util.HashMap;
import java.util.Objects;

import javax.script.ScriptException;
import org.apache.commons.math3.stat.descriptive.DescriptiveStatistics;
import org.apache.commons.math3.stat.descriptive.rank.Percentile;



/**
 *
 * @author aliubushkin
 */
public class LuiDgV2 {
//private HashMap<String,mapLabel> mapLabels;
private String oldRegionSelected="";
private LuiAppForm frm; // код формы с графиками
private ArrayList<etitle> titles=null;
public String DgId;   // Id группировки
public String Level;  // номер диаграммы
private LuiApplication app;
private String usrConnCode;
private String defcolors;
private LuiAppConn appConn;
private String where;
public String ChartTitle;
private String Query;
public ArrayList<ColInfo> colsinfo;
public String chartType;
public String mapCode;
private String mapCodeParamValue;
private String defMapCode;
private edataset dataset;
private ArrayList<ArrayList<String>> axisDatas;
private String parWhere;
private String parTitle;
private ArrayList<eserie> series;
//private ArrayList<String> deselectedSeries;

public  Boolean autorotate3D=false;
public  ArrayList<String> colors;
public  LuiCollection datetimecol;
private String xAxis3DlastInversion="N";
private String yAxis3DlastInversion="N";
public  String CurCfg; // текущая конфигурация с которой надо делать NVL при ChangeConfig
public  boolean excSignShow=false; // признак надобности отображения легенды карты так как некоторые регионы желают показать свои метки вместо названий
ArrayList<LuiCollection> seriesProps;
ArrayList<LuiCollection> groupProps;
ArrayList<LuiCollection> groupOutput;
LuiCollection chartPref;
ArrayList<mapLegendItem> mapLegend=null;
boolean mapLegendSignIsNumeric=true;
//ArrayList<etitle> titles;
ArrayList<String> MAPVMcolorList;
ArrayList<Double> MAPpValues;
ArrayList<Double> MAPnValues;
Double sizeCoeff=1.0;
private class option{
  Boolean animation;
  ArrayList<String> color;
  ArrayList<etitle> title;
  elegend legend;
  //ArrayList<egraphic> graphic;
  etooltip tooltip;
  ArrayList<edataZoom> dataZoom;
  egrid grid;
  egrid grid3D;
  ArrayList<eaxis> xAxis;
  ArrayList<eaxis> yAxis;
  eaxis xAxis3D;
  eaxis yAxis3D;
  eaxis zAxis3D;
  edataset dataset;
  ArrayList<eserie> series;
  ArrayList<evisualMap> visualMap;
  //ArrayList<Object> visualMap;
  
//  egeo geo;
}

private class evisualMap{
    eTextStyle textStyle;
    String type;
    Boolean calculable;
    String top;
    String left;
    String bottom;
    Double itemHeight;
    Double itemWidth;
    Double itemGap;
    Double splitNumber;
    Double min;
    Double max;
    //ArrayList<Double> range;
    String range;
    Boolean show;
    String dimension;
    Integer seriesIndex;
    ArrayList<epiece> pieces;
    einRange inRange;
    einRange outOfRange;
    String orient;
    evisualMapController controller;
    //String borderColor;
    //Integer borderWidth;
}
private class evisualMapController{
    einRange inRange;
    einRange outOfRange;
}
private class einRange{
   //ArrayList<String> color;
   Object color;
   ArrayList<Double> colorLightness;
   ArrayList<Double> opacity;

}
private class epiece{
    Double gt;
    Double lte;
    Double min;
    Double max;
    String color;
    Double opacity;
    String label;
}
private class edataZoom{
    String type;
    //Integer height;
    Object height;
    //Integer width;
    Object width;
    Object yAxisIndex;
    Object xAxisIndex;
    Boolean show;
    String  right;
    String  left;
    String  bottom;
    String  top;
    String  orient;
}
private class elegendDataItem{
    String name;
    eTextStyle textStyle;
}
private class elegend{
    
    Boolean show;
    String type;
    String orient;
    String left;
    String right;
    String top;
    
    eTextStyle textStyle;
    String selected="$deselected series$";
    Double itemGap;
    Double itemWidth;
    Double itemHeight;
    String icon;
    ArrayList<elegendDataItem> data;
}
private class egrid{
  String left;
  Integer zlevel;
  String top;
  Boolean show;
  Boolean containLabel;
  etemporalSuperSampling temporalSuperSampling;
  Integer boxWidth;
  Integer boxDepth;
  Integer boxHeight;
  eviewControl viewControl;
  elight light;
  String width;
  String height;
  //eAxisLine axisLine; // для 3D!!!
}
private class elight{
    elightM main;
    elightM ambient;
}
private class elightM{
    String color;
    Double intensity;
    Boolean shadow;
    String quality;
}

private class eviewControl{
    Boolean autoRotate;
    Integer distance;
    Double dumping;
    ArrayList<Integer> rotateSensitivity;
    Integer panSensitivity;
    Integer alpha;
    Integer beta;
}
private class etemporalSuperSampling{
    Boolean enable;
}
private class eSplitLine{
    Boolean show;
    elineStyle lineStyle;
}
private class eAxisLine{
    Boolean show;
    Boolean onZero;
    elineStyle lineStyle;
}
private class eaxis{
    Boolean show;
    String type;
    String name;
    Object min;
    Object max;
    Object logBase;
    //String max;
    eTextStyle nameTextStyle;
    eAxisLabel axisLabel;
    String nameLocation;
    Double nameGap;
    Integer nameRotate;
    String position;
    eAxisLine axisLine;
    Boolean triggerEvent;
    eSplitLine splitLine;
    Boolean inverse;
    ArrayList<String> data;
}
private class eAxisLabel{
    Boolean show;
    Integer rotate;
    Double fontSize;
    String  fontStyle;
    String  fontWeight;
    String  color;
    Boolean showMaxLabel;
    Double margin;
    //Integer interval;
    Object interval;
}
private class eTextStyle{
    String color;
    String fontStyle;
    String fontWeight;
    String fontFamily;
    Double fontSize;
    Double lineHeight;
    String align;
    Double width;
    String backgroundColor;
    String vericalAlign;
    //Integer top;
    String borderColor;
    Double borderWidth;
    erich rich;
}
private class etooltip{
    Boolean show;
    String  trigger;
    eAxisPointer axisPointer;
    String formatter;
}
private class eAxisPointer{
    String type;
}
private class egraphicShape{
    Integer width;
    Integer height;
}
private class egraphicStyle{
    String font;
    String text;
    String fill;
}
/*private class egraphic{
  ArrayList<egraphicElement> elements;
}
private class egraphicElement{
    String id;
    String type;
    String top;
    String left;
    String bottom;
    Integer zlevel;
    Integer z;
    egraphicStyle style;
    egraphicShape shape;
    Boolean draggable;
    Boolean invisible;
}*/

private class egraphic{
    String id;
    String type;
    String top;
    String left;
    String bottom;
    Integer zlevel;
    Integer z;
    egraphicStyle style;
    egraphicShape shape;
    Boolean draggable;
    Boolean invisible;}
class erich{
    eTextStyle a;
    eTextStyle b;
    eTextStyle c;
    eTextStyle d;
} 
class etitle{
  Integer z;
  Integer zlevel;
  String text;
  eTextStyle textStyle;  
  //String left;
  Object left;
  //String right;
  Object right;
  //String bottom;
  Object bottom;
  String top;
  Boolean triggerEvent;
  String backgroundColor;
  String borderColor;
  Integer borderWidth;
  Integer borderRadius;
  Boolean show;
  String textAlign;
  Integer di; // в echarts не используется, но нам это надо для адерсации к данным карты при наведении на элемент легенды карты.
              // т.к. легенда карты построена на объекта типа etitle, и эти title могут быть поразному отсортированы
              // а это di - всегда указывает на элемент данных карты независимо от сортировок
}
    public class dimStats{
      String pmin;
      String min;
      String max;
      Double count;
      Double countDistinct;
      Double  avg;
      Double sum;
    }
    public HashMap<String,dimStats> dimsStats;
    public boolean bigData=false;
    public boolean is2dScatter=false;
    public class edim{
        String name;
        String type;
    }
    public class edataset {
       ArrayList<edim> dimensions;
       ArrayList<ArrayList<Object>> source;
    }
    public class elineStyle{
        String color;
        Double width;
        String type;
        Object shadowBlur;
        Object shadowOffsetY;
        Object shadowOffsetX;
        Object  shadowColor;
        Double opacity;
    }
    public class elabelLine{
        Boolean show;
        elineStyle lineStyle;
        String length;
        String length2;
    }
    public class elabel{
        Boolean show;
        String formatter;
        Double fontSize;
        String  fontStyle;
        String  fontWeight;
        String  fontFamily;
        String  color; 
        String  position;
        ArrayList<Double>  offset;
        Integer distance;
        Object  rotate;
        erich  rich;
        String alignTo;
        String margin;
    }
    
    
    public class eencode{
        String x;
        String y;
        String z;
        String itemName;
        String value;
    }
    public class eemphasis{
        elabel label;
        Integer shadowBlur;
        Integer shadowOffsetX;
        Integer shadowOffsetY;
        Integer borderWidth;
        String  shadowColor;
        String  color;
        String  areaColor;
        Double  opacity;
    }
private class eColorStop{
      Double offset;
      String color;
  }
  
  private class eExtColor{
     String type; // linear,radial
     Double x;
     Double y;
     Double x2;
     Double y2;
     Double r;
     ArrayList<eColorStop> colorStops;
     Boolean global;
  }    
    public class eitemStyle{
        Object color;
        String  areaColor;
        String myColor;
        Double opacity;
        Object shadowBlur;
        Object shadowOffsetY;
        Object shadowOffsetX;
        Object  shadowColor;
        eemphasis emphasis;
        Double borderWidth;
        String borderType;
        String borderColor;
    }
    public class eareaStyle{
        Double opacity;
        
    }
    public class eserie {
       Boolean animation;
       Integer zlevel;
       Integer z;
       String id;
       Boolean silent;
       String barWidth;
       elineStyle lineStyle;
       String left; // for pie
       String top;  // for pie
       elabelLine labelLine; //for pie
       Object roseType; //for pie: false/area/radius
       String type;
       String name;
       String stack;
       Object step;
       elabel label;
       String selectedMode;
       String radius;
       //ArrayList<String> center;
       Object center;
       String shading;
       ArrayList<Double> barSize;
       Double bevelSize;
       Double bevelSmoothness;
       eemphasis emphasis;
       etooltip tooltip;
       //eencode encode;
       Object encode;
       eitemStyle itemStyle;
       Boolean smooth;
       String smoothMonotone;
       Double symbolSize;
       Integer xAxisIndex;
       Integer yAxisIndex;
       eareaStyle areaStyle;
       Integer gridIndex;
       //Integer geoIndex;
       String map;
       String nameProperty;
       Boolean roam;
       //ArrayList<ArrayList<Double>>boundingCoords;
       Double aspectScale;
       //ArrayList<eMapData> data;
       Object data;
       Double zoom;
       String blendMode;
    }
  /*ящик с гвоздями*/  
private class eBoxData{
    String name;
    ArrayList<Double> value;  
    etooltip tooltip;
    //eemphasis emphasis;
    eitemStyle itemStyle;
}
  /*выпавшие гвозди из ящика*/  
private class eBoxOutData{
    String name;
    ArrayList<String> value;  
    etooltip tooltip;
    //eemphasis emphasis;
    eitemStyle itemStyle;
}
private class eWhrDataItem{ // шайба сегмент
    String name;
    Object value;
    eitemStyle itemStyle;
    //elabel label;
}
private class eWhrData{
   ArrayList<eWhrDataItem> data; // набор сегментов шайбы
   Double internalRatio; // доля дырки в бублике 1<->0
}
private class eMapData{
    String name;
    Object value;
    elabel label;    
    etooltip tooltip;
    eemphasis emphasis;
    Boolean selected ;
    eitemStyle itemStyle;
}
private class mapLegendItem{
    String sign;
    Double value;
    String name;
    String color;
    Integer di; // индекс в данных карты
}
/*private class egeo{
    String map;
    Boolean roam;
    String nameProperty;
    Double aspectScale;
    elabel label;
} */
ArrayList<eaxis> xBoxAxis;
ArrayList<eaxis> yBoxAxis;
eWhrData WHR;
        public LuiDgV2(LuiAppForm pfrm,String pDgId,String pLevel,String pWhere,String pTitle) throws LuiException, SQLException{
        
        frm=pfrm;
        parTitle=pTitle;
        parWhere=pWhere;
        //pwhere=frm.elements.get(pWhere).getValue();
        
        where=frm.elements.get(parWhere).getValue();
        ChartTitle=frm.elements.get(parTitle).getValue();
//        if (pwhere.equals("null"))pwhere="''";
        app=frm.application;
        DgId=pDgId;
        Level=pLevel;
        
      //  ArrayList<String> testColors=new ArrayList<>();
      //  testColors.add("rgb(255,255,255)");
      //  testColors.add("rgba(58,112,163,1)");
      //  String testColor=this.getColor4value(190.9,100.0,200.0,testColors);
        
   /* colors.add("rgba(58,112,163,1)");//    o.color.add("#3a70a3");
    colors.add("rgba(91,166,236,1)");//o.color.add("#5ba6ec");
    colors.add("rgba(48,90,129,1)");//o.color.add("#305a81");
    colors.add("rgba(97,160,168,1)");//o.color.add("#61a0a8");
    colors.add("rgba(212,130,101,1)");//o.color.add("#d48265");
    colors.add("rgba(145,199,174,1)");//o.color.add("#91c7ae");
    colors.add("rgba(116,159,131,1)");//o.color.add("#749f83");
    colors.add("rgba(202,134,34,1)");//o.color.add("#ca8622");
    colors.add("rgba(189,162,154,1)");// o.color.add("#bda29a");
    colors.add("rgba(110,112,116,1)");//o.color.add("#6e7074");
    colors.add("rgba(84,101,112,1)");//o.color.add("#546570");
    colors.add("rgba(196,204,211,1)");//o.color.add("#c4ccd3");
    */
        LuiDbConn mlc=null;
        LuiDbConn lc=null;
        Integer cursor=null;
        //Connection c=null;
        //PreparedStatement ps=null;
        try {
        mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());        
        colors=new ArrayList<>();
        defcolors=mlc.getSelectResult("select lui_f_dg_get_chart_colors('"+app.code+"',"+DgId+","+Level+")");
        
        if (is_null(defcolors)){
            defcolors="rgb(58,112,163);rgb(62,156,208);rgb(58,163,62);rgb(163,160,58);rgb(150,0,0);rgb(163,58,58);rgb(163,58,157);rgb(0,0,0);\n" +
"rgb(0,112,192);rgb(0,152,188);rgb(0,176,80);rgb(204,233,0);rgb(255,55,0);rgb(205,0,0);rgb(255,55,255);rgb(157,157,157);\n" +
"rgb(0,102,255);rgb(0,204,255);rgb(0,204,0);rgb(234,255,0);rgb(255,155,55);rgb(255,55,55);rgb(255,102,255);rgb(217,217,217);\n" +
"rgb(0,0,255);rgb(0,255,255);rgb(0,255,0);rgb(255,255,0);rgb(255,128,0);rgb(255,0,0);rgb(255,0,255);rgb(255,255,255);";
        }
        colors=this.makeColorsArray(defcolors,false);
        if (Level.equals("1") && frm.elements.containsKey("P_COL4ROOT")){
            LuiAppElement col4root=frm.elements.get("P_COL4ROOT");
            if (col4root.getParent().equals("Form") && col4root.getType().equals("PARAM")){
                if (like(col4root.getProperty("Value"),"%:%;%")) {
                LuiCollection Col4Root=new LuiCollection(col4root.getProperty("Value"));
                int col4rootN=1;
                mlc.executeDML("delete from lui_t_data_grouping_output where grouping_id="+DgId+" and chart_seq=0");
                for (String pName:Col4Root.keySet()) {
                  
                  mlc.executeDML("insert into lui_t_data_grouping_output(datatype,grouping_id,chart_seq,code,name,value,predicat4show)values('CHAR',"
                          + DgId+","+"0"+",'P$"+String.valueOf(col4rootN)+"GC0','"+pName.replace("'","''")+"','"+
                          Col4Root.Get_Element(pName).replace("'","''")+"','"+pName.replace("'","''")+": "+Col4Root.Get_Element(pName).replace("'","''")+"')");
                col4rootN++;
                  if (pName.equals("Период")) {
                     String mesyac="";
                     
                     try{
                     int mesyacN=Integer.valueOf(Col4Root.Get_Element(pName));
                     if (mesyacN==1)mesyac="январь"; 
                     if (mesyacN==2)mesyac="февраль";
                     if (mesyacN==3)mesyac="март"; 
                     if (mesyacN==4)mesyac="апрель"; 
                     if (mesyacN==5)mesyac="май";
                     if (mesyacN==6)mesyac="июнь"; 
                     if (mesyacN==7)mesyac="июль"; 
                     if (mesyacN==8)mesyac="август"; 
                     if (mesyacN==9)mesyac="сентябрь";
                     if (mesyacN==10)mesyac="октябрь"; 
                     if (mesyacN==11)mesyac="ноябрь"; 
                     if (mesyacN==12)mesyac="декабь"; 
                     } catch(Exception epx){}
                     if (is_not_null(mesyac)){
                       mlc.executeDML("insert into lui_t_data_grouping_output(datatype,grouping_id,chart_seq,code,name,value,predicat4show)values('CHAR',"
                          + DgId+","+"0"+",'P$"+String.valueOf(col4rootN)+"GC0','Месяц','"+
                          mesyac+"',null)");
                col4rootN++;   
                     }
                  }
                }
                    }
            }
        }
        mlc.executeDML("delete from lui_t_data_group_chart_pref_val where prop_code like 'Deselect_%' and grouping_id="+DgId+" and chart_seq="+Level);
        LuiCollection co=new LuiCollection(mlc.getSelectResult("select db_connect from lui_t_data_grouping where id="+DgId));
        usrConnCode=co.Get_Element("CODE");
        frm.addProperty("Connection",usrConnCode);
        if (app.userDbConnections.containsKey(usrConnCode)){
        appConn=app.userDbConnections.get(usrConnCode);
        } else {
            String name=mlc.getSelectResult("select name from lui_t_data_grouping where id="+DgId);
          
          app.msgWriter.write("LUI-00141",usrConnCode,name);
          return;
        }
        Query=mlc.getSelectResult("select lui_f_dgv2_get_query("+DgId+","+Level+",'"+where.replace("'","''")+"')");
        //c= mlc.getConnection();
        //ps=c.prepareStatement("select lui_f_dgv2_get_query(?,?,?)");
        //ps.setInt(1, Integer.valueOf(DgId));
        //ps.setInt(2, Integer.valueOf(Level));
        //ps.setString(3, pwhere);
        //ResultSet rs=ps.executeQuery();
        datetimecol=mlc.getSelectFirstRowValMap("select to_char(current_timestamp,'yyyy') yyyy, to_char(current_timestamp,'mm') mm,to_char(current_timestamp,'dd') dd, to_char(current_timestamp,'hh24') hh,to_char(current_timestamp,'mi') mi");
        chartType=mlc.getSelectResult("select lui_f_dg_get_chart_type(grouping_id,seq) from lui_t_data_group_chart_pref where grouping_id="+DgId+" and seq="+Level);
        ///шаблоныchartPref=mlc.getSelectAllRowsTwoColsValMap("select prop_code,value from lui_t_data_group_chart_pref_val where grouping_id="+DgId+" and  chart_seq="+Level);
        chartPref=new LuiCollection(mlc.getSelectResult("select lui_f_dg_get_chart_pref_vals("+DgId+","+Level+")"));
        groupOutput=mlc.getSelectAllRowsValMap("select chart_seq,code,name,value,hint,predicat4show from lui_t_data_grouping_output where grouping_id="+DgId+" order by chart_seq");
        if (chartPref==null) chartPref=new LuiCollection("");
         if (is_not_null(chartPref.Get_Element("CHART_TYPE"))){
             chartType=chartPref.Get_Element("CHART_TYPE");
         }
        if (chartType.equals("BAR")||chartType.equals("BARG")||chartType.equals("LINE")||chartType.equals("SCT")){
        if (is_not_null(chartPref.Get_Element("2DCHART_TYPE"))){
            chartType=chartPref.Get_Element("2DCHART_TYPE");
        }
        }
        if (chartType.equals("BOX")||chartType.equals("BOXG")){
        if (is_not_null(chartPref.Get_Element("BOXCHART_TYPE"))){
            chartType=chartPref.Get_Element("BOXCHART_TYPE");
        }
        }
        if (chartType.equals("MAP")||chartType.equals("PIE")||chartType.equals("WHR")){ // если карта или pie -- они тока одну серию рисуют
         // frm.setVal("UserChartDGConfiguration","0");  
            String cfg=NVL(chartPref.Get_Element("CFG"),"0");
            if (!Level.equals("1")) {
            if (frm.elements.containsKey("P_SERIES_ID")){
              LuiAppElement el=frm.elements.get("P_SERIES_ID");
              if (el.getType().equals("PARAM") && el.getParent().equals("Form")){
                cfg= NVL(el.getProperty("Value"),"0");  
              }
            }
            }
                  //if (is_not_null(el.getProperty("Value"))){
                    String oldv=mlc.getSelectResult("select value from lui_t_data_group_chart_pref_val where prop_code='CFG' and grouping_id="+DgId+" and chart_seq="+Level);
                     if (oldv==null || !NVL(oldv,"0").equals(cfg)){   
                     mlc.executeDML("delete from lui_t_data_group_chart_pref_val where prop_code='CFG' and grouping_id="+DgId+" and chart_seq="+Level);
                     mlc.executeDML("insert into lui_t_data_group_chart_pref_val(grouping_id,chart_seq,prop_code,value) values("+DgId+","+Level+",'CFG','"+
                             cfg+"')");         
                     }
                     chartPref.Add_Element("CFG", cfg);
                     frm.setVal("UserChartDGConfiguration",cfg);                     
                  //} 
            
        }
        
        if (chartType.equals("MAP")){
          defMapCode=mlc.getSelectResult("select coalesce(lui_f_dg_get_chart_pref_val(grouping_id,seq,'MAP_FORM_CODE',null),map_form_code) from lui_t_data_group_chart_pref where grouping_id="+DgId+" and seq="+Level);
          mapCode=defMapCode;
          mapCodeParamValue="";
          if (chartPref.containsKey("MAP_CODE")){
             
             String mapName=this.getValueFromOuotputByCode(chartPref.get("MAP_CODE"));
                     //mlc.getSelectResult("select value from lui_t_data_grouping_output where grouping_id="+DgId+" and code='"+chartPref.get("MAP_CODE")+"'"); 
             if (is_not_null(mapName)){
                
                 //*ищем карту по её имени в родном приложении
          mapCode=mlc.getSelectResult("select f.code from lui_t_form f,lui_t_config c where formtype_code='GMAP' and c.app_code=f.app_code" +
          " and f.code=c.form_code and f.version_number is null and c.code='DEFAULT' and nls(NAME)='"+mapName+"' and f.app_code='"+app.code+"'");
          if (is_null(mapCode)){
              //*ищем карту по её имени в lui
               mapCode=mlc.getSelectResult("select f.code from lui_t_form f,lui_t_config c where formtype_code='GMAP' and c.app_code=f.app_code" +
          " and f.code=c.form_code and f.version_number is null and c.code='DEFAULT' and nls(NAME)='"+mapName+"' and f.app_code='LUI' and f.formgroup_code='LUI_COMMON'");
               if (is_null(mapCode)){
                mapCode=defMapCode; 
                
             } else mapCodeParamValue=mapName;
          } else mapCodeParamValue=mapName;
             }
          }
         /* app.gMap.registerMap(mapCode, false);
          frm.addProperty("MAP_FORM_CODE",mapCode);
          frm.addProperty("MAP_APP_CODE",app.gMap.maps.get(mapCode).appCode);
          frm.addProperty("MAP_NAME",app.gMap.maps.get(mapCode).name);*/
        }
        seriesProps=mlc.getSelectAllRowsValMap("select name,/*color,*/opacity,format,res_datatype,coalesce(hint,notes) \"hint\",func from lui_t_data_group_function where grouping_id="+DgId+" order by seq");
        // уникальность имёнкривых
        for(int i=0;i<seriesProps.size();i++){
            if (i==0)continue;
            String sname=seriesProps.get(i).Get_Element("name");
            boolean b=true;
            while(b){
                b=false;
                for(int j=0;j<i;j++){
                    if (sname.equals(seriesProps.get(j).Get_Element("name"))){
                        sname=sname+" ";
                        b=true;
                    }
                }
            }
        }
        int s=0;        
        ArrayList<LuiCollection> charts=mlc.getSelectAllRowsValMap("select lui_f_dg_get_chart_type(grouping_id,seq) \"chart_type\" from lui_t_data_group_chart_pref where grouping_id="+DgId+" and seq<"+Level+" order by seq");
        if (charts!=null){
        for (int i=0;i<charts.size();i++){
             s++;
         if (like(charts.get(i).Get_Element("chart_type"),"%3D")){
             s++;
         }   
        }
        }        
        int s2=s+2;
        if (like(chartType,"%3D"))s2++;
        groupProps=mlc.getSelectAllRowsValMap("select coalesce(lui_f_dg_get_chart_pref_val("+DgId+",1,'DIMENSION_NAME'||seq::text,null),name) \"name\",format,res_datatype,hint from lui_t_data_group_column where grouping_id="+DgId+" and seq> "+String.valueOf(s)+"and seq<"+String.valueOf(s2)+" order by seq");
        // уникальность имён измерений
        for(int i=0;i<groupProps.size();i++){
            if (i==0)continue;
            String gname=groupProps.get(i).Get_Element("name");
            boolean b=true;
            while(b){
                b=false;
                for(int j=0;j<i;j++){
                    if (gname.equals(groupProps.get(j).Get_Element("name"))){
                        gname=gname+" ";
                        b=true;
                    }
                }
            }
        }
        if (groupProps.size()<2)chartType=chartType.replace("3D","");
        
        
        if (chartType.equals("MAP")||chartType.equals("PIE")||chartType.equals("WHR")){
        if (is_null(frm.getVal("UserChartDGConfiguration"))){
         if (is_not_null(chartPref.Get_Element("CFG"))){
          frm.setVal("UserChartDGConfiguration",chartPref.Get_Element("CFG"));     
         }   
        }
        }
        if (like(chartType,"%3D")){
            if (!chartPref.containsKey("CFG3D")){
                chartPref.Add_Element("CFG3D","1");
                frm.setVal("UserChartDGConfiguration","1");
                 mlc.executeDML("insert into lui_t_data_group_chart_pref_val(grouping_id,chart_seq,prop_code,value) values("+DgId+","+Level+",'CFG3D','1')");         
                //this.sendConfigList();
            }
        }
        if(appConn.getSessionMode()=='C') { // если работаем через пул коммунальных
              lc=appConn.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
              } else lc=appConn.currentConnection;
        try {
        cursor=lc.CursorOpen(Query);
        colsinfo=lc.CursorGetColsInfo(cursor);
        } catch (SQLException qex){
            app.msgWriter.sqlError(lc,qex,null,Query);
        }
        String stmt="select ";
        int ci=0;
        if (colsinfo!=null){
        for (int i=0;i<groupProps.size();i++){
            colsinfo.get(ci).LuiDATATYPE=groupProps.get(i).Get_Element("res_datatype");
            if (i>0) stmt=stmt+",";
            if (is_not_null(groupProps.get(i).Get_Element("format")) && colsinfo.get(i).LuiDATATYPE.equals("NUMBER")){
            stmt=stmt+"to_char(\"GC"+String.valueOf(i+1)+"\",'"+groupProps.get(i).Get_Element("format")+"') \"GC"+String.valueOf(i+1)+"\"";
            }else
             stmt=stmt+"\"GC"+String.valueOf(i+1)+"\"";
        ci++;
        }
        for (int i=0;i<seriesProps.size();i++){
            colsinfo.get(ci).LuiDATATYPE=seriesProps.get(i).Get_Element("res_datatype");
            stmt=stmt+",";
            if (is_not_null(seriesProps.get(i).Get_Element("format"))){
            // stmt=stmt+"to_char(\"SF"+String.valueOf(i+1)+"\",'"+seriesProps.get(i).Get_Element("format")+"') \"SF"+String.valueOf(i+1)+"\"";
            // Форматное преобразование чисел оказалось очень опасным могут быть пробелы, всякие E и т.п. что не позволит строку корректно перевести в 
          // JAVA-тип Double и не позволит сосчитать dimstat - стптистику измерений
          // поэтому оставим без форматного преобразрвания
             stmt=stmt+"\"SF"+String.valueOf(i+1)+"\"";
            }else
             stmt=stmt+"\"SF"+String.valueOf(i+1)+"\"";
            ci++;
        }
        while (colsinfo.size()>ci){
            colsinfo.remove(colsinfo.size()-1);
        }
        }
        stmt=stmt+" from ("+Query+")q$f";
        if (is_not_null(chartPref.get("QBE"))){
           Query=stmt+" "+chartPref.get("QBE"); 
           PreparedStatement ps=null;
            try {
                ps=lc.getConnection().prepareStatement(Query);
                ps.getMetaData();
                stmt=Query;
                ps.close();
            } catch(SQLException sex){
                if (ps!=null)ps.close();chartPref.remove("QBE");
                if(appConn.getSessionMode()!='C'){ 
                lc.rollback();
                }
                mlc.executeDML("delete from lui_t_data_group_chart_pref_val where grouping_id="+DgId+" and  chart_seq="+Level+" and prop_code='QBE'");
            }
        }
        if (is_not_null(chartPref.get("ORDER_BY"))){
            Query=stmt+chartPref.get("ORDER_BY");
            PreparedStatement ps=null;
            try {
                ps=lc.getConnection().prepareStatement(Query);
                ps.getMetaData();
                stmt=Query;
                ps.close();
            } catch(SQLException sex){
            if (ps!=null)ps.close();
            if(appConn.getSessionMode()!='C'){ 
                lc.rollback();
            }
            chartPref.remove("ORDER_BY");
            mlc.executeDML("delete from lui_t_data_group_chart_pref_val where grouping_id="+DgId+" and  chart_seq="+Level+" and prop_code='ORDER_BY'");
            }
        }
        Query=stmt;
        
        }finally {
      if (mlc!=null){
          app.metaConnPool.SetFree(mlc);
      }
      if (lc!=null){
          if (cursor!=null && lc.CursorisOpen(cursor))lc.CursorClose(cursor);
          if (appConn!=null && appConn.getSessionMode()=='C')  appConn.connPool.SetFree(lc);
      }
  }
    //makeDataSet();
    //makeSeries();
    }
 /**
  * генератор цветов для непрерывного visual map карты
  * @param si -- id кривой
  * @param myColor -- верхний цвет
  * @return 
  */
  private void makeColorsArray4Map(int si,String myColor){
      MAPVMcolorList =new ArrayList<>();
             
             MAPVMcolorList.add("rgb(255,255,255)");
             MAPVMcolorList.add(myColor);
             
            if (chartPref.containsKey("MAPVM("+String.valueOf(si+1)+")_COLORS")){
                String vmcolors=chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_COLORS");
                if (is_not_null(vmcolors))
                MAPVMcolorList=this.makeColorsArray(vmcolors,true);
            }  
            
  }  
  /**
   * Изготовление массива цветов для visualMap
   * @param pColors
   * @param inverse
   * @return 
   */  
  public ArrayList<String> makeColorsArray(String pColors,boolean inverse){
      ArrayList<String> rc=new ArrayList<>();
      String crows[]=pColors.split("\n");
     for (int r=0;r<crows.length;r++){
         String ccols[]=crows[r].split(";");
         for (int c=0;c<ccols.length;c++){
             if (is_not_null(ccols[c]))
             rc.add(ccols[c]);
         }
     }
     if (inverse){
         ArrayList<String> rc2=new ArrayList<>();
         for (int i=rc.size()-1;i>=0;i--){
             rc2.add(rc.get(i));
         }
         return rc2;
     }
     return rc;
  }
  public  String getMapLableTuneTitle() throws LuiException, SQLException{
      option o=new option();
      o.title=new ArrayList<>();
      etitle ttit=new etitle();
      ttit.show=false;
      o.title.add(ttit);
      o.title.add(ttit);
      addLabelTuneTitles(o.title);
      return app.toJSON(o);
  }
  public void addPieModeTitle(ArrayList<etitle> titles){
     if (!chartType.equals("PIE") && !chartType.equals("WHR")) return;
     int pSi=Integer.valueOf(NVL(chartPref.get("CFG"),"0"));
     String sname=seriesProps.get(pSi).Get_Element("name");
     Double min=null;
     Double max=null;
     try{
         min=Double.valueOf(this.dimsStats.get(sname).min);
         max=Double.valueOf(this.dimsStats.get(sname).max);
     } catch (Exception ex){}
     
     etitle ltitle =new etitle();
    ltitle.show=false;
    if ((min==null || max==null || (min>=0 && max>=0) || (min<=0 && max<=0))==false){
    ltitle.show=true;
    ltitle.bottom="0%"; 
    ltitle.right="0%";
    ltitle.triggerEvent=true;
    ltitle.textStyle=new eTextStyle();
    ltitle.textStyle.fontWeight="normal";
    ltitle.textStyle.rich=new erich();
    ltitle.backgroundColor="rgba(51,51,51,0.5)";
    ltitle.borderRadius=3;
    ltitle.textStyle.rich.a=new eTextStyle();
    ltitle.textStyle.rich.a.fontWeight="bold";
    ltitle.textStyle.rich.a.fontSize=14.0*sizeCoeff;
    ltitle.textStyle.fontSize=14.0*sizeCoeff;
    ltitle.textStyle.color="rgb(255,255,255)";
    String preferVal=NVL(chartPref.Get_Element(chartType+"_PREFVAL"),"+");// предпочитаемые значения
    if (preferVal.equals("+")) {
     ltitle.text=app.NLS.NLS("RUS:Отображаются значения >=0;ENG:Values >=0 are displayed;");
    }else {
     ltitle.text=app.NLS.NLS("RUS:Отображаются значения <=0;ENG:Values <=0 are displayed;");   
    } 
    }
    titles.add(ltitle);
  }
  public void addLabelTuneTitles(ArrayList<etitle> titles) throws LuiException, SQLException{
    if (chartType.equals("MAP")){  
    etitle ltitle =new etitle();
    ltitle.show=false;
    etitle ltitleup=new etitle();
    ltitleup.show=false;
    etitle ltitledown=new etitle();
    ltitledown.show=false;
    if (!frm.getProperty("CurrentLabelSize").equals("")){
    titles.get(0).show=false;
        ltitle.top="0%";
    ltitle.right="0%";
    ltitle.show=true;
    ltitle.triggerEvent=false;
    ltitle.textStyle=new eTextStyle();
    ltitle.textStyle.fontWeight="normal";
    ltitle.textStyle.rich=new erich();
    ltitle.backgroundColor="rgba(51,51,51,0.5)";
    ltitle.borderRadius=3;
    ltitle.textStyle.rich.a=new eTextStyle();
    ltitle.textStyle.rich.a.fontWeight="bold";
    ltitle.textStyle.rich.a.fontSize=14.0;
    ltitle.textStyle.fontSize=14.0;
    ltitle.textStyle.color="rgb(255,255,255)";
    Double scale=Double.valueOf(frm.getProperty("MapScale"));
    scale=Double.valueOf(Math.round(scale*100.0))/100;
    if (app.NLS.currentLang.code.equals("RUS")){
      ltitle.text="Режим настройки названий\n"+
                  "Масштаб: {a|"+scale.toString()+"}\n"+
                  "Размер шрифта: {a|"+frm.getProperty("CurrentLabelSize")+"}";
    } else {
      ltitle.text="Labels tune mode\n"+
                  "Scale: {a|"+scale.toString()+"}\n"+
                  "Font size: {a|"+frm.getProperty("CurrenitLabelSize")+"}";
    }
    
    ltitleup.show=true;
    ltitleup.z=3;
    ltitleup.zlevel=10;
    ltitleup.top="25";
    ltitleup.right="43";
    ltitleup.triggerEvent=true;
    ltitleup.textStyle=new eTextStyle();
    ltitleup.textStyle.fontSize=14.0;
    ltitleup.textStyle.fontWeight="bold";
    ltitleup.textStyle.color="rgb(255,255,255)";
    ltitleup.textStyle.fontFamily="monospace";
    ltitleup.backgroundColor="rgba(61,61,61,0.3)";
    ltitleup.borderColor="rgb(200,200,200)";
    ltitleup.borderRadius=3;
    ltitleup.borderWidth=1;
    ltitleup.text="+";
    ltitledown.show=true;
    ltitledown.z=3;
    ltitledown.zlevel=10;
    ltitledown.top="25";
    ltitledown.right="24";
    ltitledown.triggerEvent=true;
    ltitledown.textStyle=new eTextStyle();
    ltitledown.textStyle.fontSize=14.0;
    ltitledown.textStyle.fontWeight="bold";
    ltitledown.textStyle.color="rgb(255,255,255)";
    ltitledown.textStyle.fontFamily="monospace";
    ltitledown.backgroundColor="rgba(61,61,61,0.3)";
    ltitledown.borderColor="rgb(200,200,200)";
    ltitledown.borderRadius=3;
    ltitledown.borderWidth=1;
    ltitledown.text="-";
    }
    titles.add(ltitle);
    titles.add(ltitleup);
    titles.add(ltitledown);
    }  
  }
public String getNewData() throws LuiException, SQLException{
    where=frm.elements.get(parWhere).getValue();
        ChartTitle=frm.elements.get(parTitle).getValue();
        LuiDbConn mlc=null;
        LuiDbConn lc=null;
        Integer cursor=null;
        try {
        mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
//        mlc.executeDML("delete from lui_t_data_group_chart_pref_val where prop_code like 'Deselect_%' and grouping_id="+DgId+" and chart_seq="+Level);        
        groupOutput=mlc.getSelectAllRowsValMap("select chart_seq,code,name,value,hint,predicat4show from lui_t_data_grouping_output where grouping_id="+DgId+" order by chart_seq,code");
                                                       
        if (chartType.equals("MAP")||chartType.equals("PIE")||chartType.equals("WHR")){ // если карта или pie -- они тока одну серию рисуют
          frm.setVal("UserChartDGConfiguration","0");  
            if (frm.elements.containsKey("P_SERIES_ID")){
              LuiAppElement el=frm.elements.get("P_SERIES_ID");
              if (el.getType().equals("PARAM") && el.getParent().equals("Form")){
                  if (is_not_null(el.getProperty("Value"))){
                  
                  String oldv=mlc.getSelectResult("select value from lui_t_data_group_chart_pref_val where prop_code='CFG' and grouping_id="+DgId+" and chart_seq="+Level);
                     if (!NVL(oldv,"").equals(el.getProperty("Value"))){
                     mlc.executeDML("delete from lui_t_data_group_chart_pref_val where prop_code='CFG' and grouping_id="+DgId+" and chart_seq="+Level);
                     mlc.executeDML("insert into lui_t_data_group_chart_pref_val(grouping_id,chart_seq,prop_code,value) values("+DgId+","+Level+",'CFG','"+el.getProperty("Value")+"')");         
                     }
                     chartPref.Add_Element("CFG", el.getProperty("Value"));
                     frm.setVal("UserChartDGConfiguration",el.getProperty("Value"));                     
                  }
                  
              }
            }
        this.sendConfigList();
        }
        Query=mlc.getSelectResult("select lui_f_dgv2_get_query("+DgId+","+Level+",'"+where.replace("'","''")+"')");
        if(appConn.getSessionMode()=='C') { // если работаем через пул коммунальных
              lc=appConn.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
              } else lc=appConn.currentConnection;
        try{
        cursor=lc.CursorOpen(Query);
        colsinfo=lc.CursorGetColsInfo(cursor);
        }catch (SQLException qex){
            app.msgWriter.sqlError(lc,qex,null,Query);
        }
        String stmt="select ";
        int ci=0;
        for (int i=0;i<groupProps.size();i++){
            colsinfo.get(ci).LuiDATATYPE=groupProps.get(i).Get_Element("res_datatype");
            if (i>0) stmt=stmt+",";
            if (is_not_null(groupProps.get(i).Get_Element("format")) && colsinfo.get(i).LuiDATATYPE.equals("NUMBER")){
             stmt=stmt+"to_char(\"GC"+String.valueOf(i+1)+"\",'"+groupProps.get(i).Get_Element("format")+"') \"GC"+String.valueOf(i+1)+"\"";
            }else
             stmt=stmt+"\"GC"+String.valueOf(i+1)+"\"";
        ci++;
        }
        for (int i=0;i<seriesProps.size();i++){
            colsinfo.get(ci).LuiDATATYPE=seriesProps.get(i).Get_Element("res_datatype");
            stmt=stmt+",";
            if (is_not_null(seriesProps.get(i).Get_Element("format"))){
             //stmt=stmt+"to_char(\"SF"+String.valueOf(i+1)+"\",'"+seriesProps.get(i).Get_Element("format")+"') \"SF"+String.valueOf(i+1)+"\"";
            // Форматное преобразование чисел оказалось очень опасным могут быть пробелы, всякие E и т.п. что не позволит строку корректно перевести в 
          // JAVA-тип Double и не позволит сосчитать dimstat - стптистику измерений
          // поэтому оставим без форматного преобразрвания
             stmt=stmt+"\"SF"+String.valueOf(i+1)+"\"";
            }else
             stmt=stmt+"\"SF"+String.valueOf(i+1)+"\"";
            ci++;
        }
      while (colsinfo.size()>ci){
            colsinfo.remove(colsinfo.size()-1);
           
        }
        stmt=stmt+" from ("+Query+")q$f";
        if (is_not_null(chartPref.get("ORDER_BY"))){
            Query=stmt+chartPref.get("ORDER_BY");
            PreparedStatement ps=null;
            try {
                ps=lc.getConnection().prepareStatement(Query);
                stmt=Query;
                ps.close();
            } catch(SQLException sex){if (ps!=null)ps.close();chartPref.remove("ORDER_BY");}
        }
        Query=stmt;
        } finally {
            if (mlc!=null){
          app.metaConnPool.SetFree(mlc);
                          }
            if (lc!=null){
          if (cursor!=null)lc.CursorClose(cursor);
          if (appConn.getSessionMode()=='C')  appConn.connPool.SetFree(lc);
      }
        }
   /* option o=new option();
    o.animation=true;
    makeDataSet();
    if (!chartType.equals("MAP"))o.dataset=dataset;
    else{
        eserie serie=new eserie();
        serie.label=new elabel();
        serie.type="map";
        serie.label.show=true; 
          if (chartPref.Get_Element("MAP_LABELSHOW").equals("N")) serie.label.show=false;
        serie.label.formatter="{b}: {c}";
        int si=Integer.valueOf(NVL(chartPref.get("CFG"),"0"));
        serie.name=seriesProps.get(si).Get_Element("name");
        this.makeMapData(si, serie);
        o.series=new ArrayList<>();
        o.series.add(serie);
    }
    return app.toJSON(o);*/
   return get("Y");
}
  public String getAddon(){
      if (chartType.equals("WHR"))  
           return app.toJSON(WHR).replace("\"налл\"","null");
      else return "";
  }
  public void makeAddon(String reload,option o){
    if (chartType.equals("WHR"))  
        {
       if (reload.equals("Y") || WHR==null){
       if (WHR==null) WHR=new eWhrData();
           WHR.internalRatio=0.5;
           if (chartPref.containsKey("WHRGRID_INTRATIO")){
              WHR.internalRatio=Double.valueOf(chartPref.get("WHRGRID_INTRATIO"))/100.0;
          }
           if(WHR.data==null)WHR.data=new ArrayList<>();
           else WHR.data.clear();
           int pSi=Integer.valueOf(NVL(chartPref.get("CFG"),"0"));
     
       ArrayList clrs=colors;
    /*   if (chartPref.containsKey("COLORS")){
        clrs=new ArrayList<>();
        String newcolors=chartPref.Get_Element("COLORS");
        clrs=this.makeColorsArray(newcolors,false);
      if (clrs.size()==0)clrs=colors;
    }*/
     Double min=null;
     Double max=null;
     String preferVal=null;
     String sname=seriesProps.get(pSi).Get_Element("name");
     try{
         min=Double.valueOf(this.dimsStats.get(sname).min);
         max=Double.valueOf(this.dimsStats.get(sname).max);
     } catch (Exception ex){}
     
     
    if ((min==null || max==null || (min>=0 && max>=0) || (min<=0 && max<=0))==false){
        // надо учитывать предпочитаемые значения
        preferVal=NVL(chartPref.Get_Element(chartType+"_PREFVAL"),"+");// предпочитаемые значения
    }  
       for (int i=dataset.source.size()-1;i>=0;i--){
          
          if (dataset.source.get(i).get(pSi)==null)continue;
          if (dataset.source.get(i).get(1+pSi)==null)continue;
          if (String.valueOf(dataset.source.get(i).get(1+pSi))==null)continue;
          if (String.valueOf(dataset.source.get(i).get(1+pSi)).equals("null"))continue;
         if (String.valueOf(dataset.source.get(i).get(1+pSi)).equals(""))continue;
          eWhrDataItem dataItem=new eWhrDataItem();
          dataItem.name=dataset.source.get(i).get(0).toString();
          Double v=Double.valueOf(String.valueOf(dataset.source.get(i).get(1+pSi)));
          dataItem.value=v;
          if (preferVal!=null){
              if (preferVal.equals("+")&& v<0)dataItem.value="налл";
              if (preferVal.equals("-")&& v>0)dataItem.value="налл";
          } 
          dataItem.itemStyle=new eitemStyle();
          dataItem.itemStyle.opacity=1.0;
          if (chartPref.containsKey("WHRGRID_OPACITY")){
              dataItem.itemStyle.opacity=1.0-Double.valueOf(chartPref.get("WHRGRID_OPACITY"))/100.0;
          }
          
          
          //if (!chartPref.containsKey("Deselect_"+dataItem.name))
          WHR.data.add(dataItem);   
          }
        int cc=0;
        o.legend.data=new ArrayList<>();
        for (int i=WHR.data.size()-1;i>=0;i--){
            if (cc>=clrs.size())cc=0;
             elegendDataItem ldi=new elegendDataItem();
                ldi.name=WHR.data.get(i).name;
                ldi.textStyle=new eTextStyle();
                ldi.textStyle.color="rgba(0,0,0,1)";
            if (WHR.data.get(i).value.toString().equals("налл")){
                WHR.data.get(i).itemStyle.color="rgba(225,225,225,1)";
                 ldi.textStyle.color="rgba(225,225,225,1)";
               // chartPref.Add_Element("Deselect_"+WHR.data.get(i).name,"false");
            }
            else
            WHR.data.get(i).itemStyle.color=clrs.get(cc);
            
            if (chartPref.containsKey("Deselect_"+WHR.data.get(i).name)){
            WHR.data.get(i).value="налл";
            }
            o.legend.data.add(ldi);
            cc++;
        }
       }
    
        }
    
    
  }
  @SuppressWarnings("unchecked")
  public String get(String reload) throws LuiException, SQLException{
    
    if (xBoxAxis!=null) xBoxAxis.clear();
    if (yBoxAxis!=null) yBoxAxis.clear();
    
    LuiDbConn mlc=null;
    try{
    mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());        
    ///???шаблоныchartPref=mlc.getSelectAllRowsTwoColsValMap("select prop_code,value from lui_t_data_group_chart_pref_val where grouping_id="+DgId+" and chart_seq="+Level);
    chartPref=new LuiCollection(mlc.getSelectResult("select lui_f_dg_get_chart_pref_vals("+DgId+","+Level+")"));
    if (chartPref==null)chartPref=new LuiCollection("");
    sizeCoeff=1.0;
    if (!frm.getProperty("CHART_SIZE_TYPE").equals("WL")){ // если это не пейзаж по величине окна
        if (chartPref.containsKey("SIZE4COEFF_L")){ // но осталься опорный размер
            chartPref.Erase_Element("SIZE4COEFF_L"); // удалим его
            mlc.executeDML("delete from lui_t_data_group_chart_pref_val where prop_code='SIZE4COEFF_L' and grouping_id="+DgId+" and chart_seq="+Level); // и из базы тоже
        }
    }
    if (!frm.getProperty("CHART_SIZE_TYPE").equals("WP")){// если это не портрет по величине окна
        if (chartPref.containsKey("SIZE4COEFF_P")){// но осталься опорный размер
            chartPref.Erase_Element("SIZE4COEFF_P"); // удалим его
            mlc.executeDML("delete from lui_t_data_group_chart_pref_val where prop_code='SIZE4COEFF_P' and grouping_id="+DgId+" and chart_seq="+Level);// и из базы тоже
        }
    }
    if (frm.getProperty("CHART_SIZE_TYPE").equals("WL")){// если это пейзаж по величине окна
        if (!chartPref.containsKey("SIZE4COEFF_L") && frm.properties.containsKey("ChartWidth")&& frm.properties.containsKey("ChartHeight")){ // и ещё не вычислен опорный размер а размеры диаграммы есть в свойствах
            Double w=Double.valueOf(frm.getProperty("ChartWidth"));
            Double h=Double.valueOf(frm.getProperty("ChartHeight"));
            if (w/1.4142>h)  w=h*1.4142; // вычислим пейзажную ширину опираясь на текущие размеры диаграммы
            h=w/1.4142;
            chartPref.Add_Element("SIZE4COEFF_L",String.valueOf(Math.round(w))); 
            frm.setProperty("ChartHeight", String.valueOf(Math.round(h)));
            frm.setProperty("ChartWidth", String.valueOf(Math.round(w)));
            // и сохраним в свойствах чтобы потом вычислять по ней коэффициент
            //mlc.executeDML("insert into lui_t_data_group_chart_pref_val(prop_code,grouping_id,chart_seq,value) values('SIZE4COEFF_L',"+DgId+","+Level+","+frm.getProperty("ChartWidth")+")");
            mlc.executeDML("insert into lui_t_data_group_chart_pref_val(prop_code,grouping_id,chart_seq,value) values('SIZE4COEFF_L',"+DgId+","+Level+","+String.valueOf(Math.round(w))+")");
        }
    }
    if (frm.getProperty("CHART_SIZE_TYPE").equals("WP")){// если это портрет по величине окна
        if (!chartPref.containsKey("SIZE4COEFF_P")&& frm.properties.containsKey("ChartWidth")&& frm.properties.containsKey("ChartHeight")){// и ещё не вычислен опорный размер а размеры диаграммы есть в свойствах
            Double w=Double.valueOf(frm.getProperty("ChartWidth"));
            Double h=Double.valueOf(frm.getProperty("ChartHeight"));
            if (h/1.4142>w) h=w*1.4142; // вычислим портретную высоту опираясь на текущие размеры диаграммы
            w=h/1.4142;
            chartPref.Add_Element("SIZE4COEFF_P",String.valueOf(Math.round(h)));
            frm.setProperty("ChartHeight", String.valueOf(Math.round(h)));
            frm.setProperty("ChartWidth", String.valueOf(Math.round(w)));
            // и сохраним в свойствах чтобы потом вычислять по ней коэффициент
            mlc.executeDML("insert into lui_t_data_group_chart_pref_val(prop_code,grouping_id,chart_seq,value) values('SIZE4COEFF_P',"+DgId+","+Level+","+String.valueOf(Math.round(h))+")");
        }
    }
  
    if (frm.getProperty("CHART_SIZE_TYPE").equals("WL")){
      Double ck=Double.valueOf(NVL(chartPref.Get_Element("SIZE4COEFF_L"),"1314.0"));
      if (frm.properties.containsKey("ChartWidth")) {
          sizeCoeff=Double.valueOf(frm.getProperty("ChartWidth"))/ck;
      }      
        }
    if (frm.getProperty("CHART_SIZE_TYPE").equals("WP")){
       Double ck=Double.valueOf(NVL(chartPref.Get_Element("SIZE4COEFF_P"),"812.0"));
      if (frm.properties.containsKey("ChartHeight")) {
          sizeCoeff=Double.valueOf(frm.getProperty("ChartHeight"))/ck;
      }      
        }
    
    if (chartType.equals("BAR")||chartType.equals("BARG")){
    if (is_not_null(chartPref.Get_Element("2DCHART_TYPE"))){
            chartType=chartPref.Get_Element("2DCHART_TYPE");
        }
    else chartType="BAR";
    }
    if (chartType.equals("BOX")||chartType.equals("BOXG")){
    if (is_not_null(chartPref.Get_Element("BOXCHART_TYPE"))){
            chartType=chartPref.Get_Element("BOXCHART_TYPE");
        }
    else chartType="BOX";
    }
    colors=new ArrayList<>();
    defcolors=mlc.getSelectResult("select lui_f_dg_get_chart_colors('"+app.code+"',"+DgId+","+Level+")");
        if (is_null(defcolors)){
            defcolors="rgb(58,112,163);rgb(62,156,208);rgb(58,163,62);rgb(163,160,58);rgb(150,0,0);rgb(163,58,58);rgb(163,58,157);rgb(0,0,0);\n" +
"rgb(0,112,192);rgb(0,152,188);rgb(0,176,80);rgb(204,233,0);rgb(255,55,0);rgb(205,0,0);rgb(255,55,255);rgb(157,157,157);\n" +
"rgb(0,102,255);rgb(0,204,255);rgb(0,204,0);rgb(234,255,0);rgb(255,155,55);rgb(255,55,55);rgb(255,102,255);rgb(217,217,217);\n" +
"rgb(0,0,255);rgb(0,255,255);rgb(0,255,0);rgb(255,255,0);rgb(255,128,0);rgb(255,0,0);rgb(255,0,255);rgb(255,255,255);";
        }
        colors=this.makeColorsArray(defcolors,false);
    if (chartType.equals("MAP")||chartType.equals("WHR")||chartType.equals("PIE")|| chartType.equals("BAR3D") ||chartType.equals("MAP3D")){// защита от плохого CFG
     int cfg;
     int maxcfg=1;
     String cfgpropcode="CFG";
     if (chartType.equals("BAR3D") ||chartType.equals("MAP3D")) cfgpropcode="CFG3D";
     String newcfg=chartPref.Get_Element(cfgpropcode);
     if (chartType.equals("MAP")||chartType.equals("PIE")||chartType.equals("WHR")){
         maxcfg=seriesProps.size()-1;
     } 
        try{
        cfg=Integer.valueOf(NVL(chartPref.Get_Element(cfgpropcode),"0"));
     } catch(Exception ex) {
         cfg=0; 
         chartPref.Add_Element(cfgpropcode, "0");
                                
     }
        if (cfg>maxcfg) {
            chartPref.Add_Element(cfgpropcode, "0");
            
        } 
     String oldcfg=frm.getVal("UserChartDGConfiguration");
     if (!oldcfg.equals(newcfg)){
         this.sendConfigList();
     }
     frm.setVal("UserChartDGConfiguration",chartPref.Get_Element(cfgpropcode));
    }
    
    option o=new option();
    o.animation=true;
    if (app.windows.get(frm.getVal("WindowID")).getProperty("AbleStatus").equals("Disable"))o.animation=false;
    o.color=colors;
    /*if (chartPref.containsKey("COLORS")){
        o.color=new ArrayList<>();
        String newcolors=chartPref.Get_Element("COLORS");
        o.color=this.makeColorsArray(newcolors,false);
      if (o.color.size()==0)o.color=colors;
    }*/
    
    o.tooltip=new etooltip();
    o.tooltip.show=true;
    if (chartType.equals("MAP")){
    
        o.tooltip.trigger="item";
        MAPVMcolorList=null;
        //o.animation=false;
    }
    if ( !chartType.equals("BOX") && !chartType.equals("BOXG") && 
            !chartType.equals("BAR3D") && !chartType.equals("SCT3D") && !chartType.equals("PIE") && !chartType.equals("WHR")
            && !chartType.equals("MAP")){
     o.tooltip.axisPointer=new eAxisPointer();
     o.tooltip.axisPointer.type="shadow";//line
     o.tooltip.trigger="axis";
    }
    if (!chartType.equals("MAP") //&& !chartType.equals("BOX") && !chartType.equals("BOXG")
            ){
     o.legend=new elegend();
     o.legend.itemGap=10.0*sizeCoeff;
     o.legend.itemHeight=14.0*sizeCoeff;
     o.legend.itemWidth=25*sizeCoeff;
    if (chartType.equals("PIE") || chartType.equals("WHR")){
        String prefix=chartType+"_";
      if (NVL(chartPref.Get_Element(prefix+"LEGEND_SHOW"),"Y").equals("Y")) 
        o.legend.show=true;
        else o.legend.show=false;
        //o.legend.bottom=1;
        o.legend.orient="vertical";
        if (chartPref.containsKey(prefix+"LEGEND_ORIENT"))o.legend.orient=chartPref.Get_Element(prefix+"LEGEND_ORIENT");
        o.legend.type="scroll";
        if (chartPref.containsKey(prefix+"LEGEND_SCROLL")){
            if (chartPref.get(prefix+"LEGEND_SCROLL").equals("N")){
            o.legend.type="plain";        
            }
        }
        o.legend.right="0%";
        if (chartPref.containsKey(prefix+"LEGEND_RIGHT"))o.legend.right=chartPref.Get_Element(prefix+"LEGEND_RIGHT")+"%";  
        o.legend.top="20%";
        if (chartPref.containsKey(prefix+"LEGEND_TOP"))o.legend.top=chartPref.Get_Element(prefix+"LEGEND_TOP")+"%";
        o.legend.textStyle=new eTextStyle();
        o.legend.textStyle.fontSize=12.0;
        if (chartPref.containsKey(prefix+"LEGEND_FONTSIZE"))o.legend.textStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_FONTSIZE"));
        o.legend.textStyle.fontSize=o.legend.textStyle.fontSize*sizeCoeff;
        o.legend.textStyle.color="rgb(0,0,0)";
        if (chartPref.containsKey(prefix+"LEGEND_FONTCOLOR"))o.legend.textStyle.color=chartPref.Get_Element(prefix+"LEGEND_FONTCOLOR");
        o.legend.textStyle.fontStyle="normal";
        if (chartPref.containsKey(prefix+"LEGEND_FONTSTYLE"))o.legend.textStyle.fontStyle=chartPref.Get_Element(prefix+"LEGEND_FONTSTYLE");
        o.legend.textStyle.fontWeight="normal";
        if (chartPref.containsKey(prefix+"LEGEND_FONTWEIGHT"))o.legend.textStyle.fontWeight=chartPref.Get_Element(prefix+"LEGEND_FONTWEIGHT");
        o.legend.itemWidth=25.0;
        if (chartPref.containsKey(prefix+"LEGEND_ITEMWIDTH"))o.legend.itemWidth=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_ITEMWIDTH"));
        o.legend.itemGap=10.0;
        if (chartPref.containsKey(prefix+"LEGEND_ITEMGAP"))o.legend.itemGap=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_ITEMGAP"));
        o.legend.itemHeight=14.0;
        if (chartPref.containsKey(prefix+"LEGEND_ITEMHEIGHT"))o.legend.itemHeight=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_ITEMHEIGHT"));
        o.legend.itemGap=o.legend.itemGap*sizeCoeff;
        o.legend.itemHeight=o.legend.itemHeight*sizeCoeff;
        o.legend.itemWidth=o.legend.itemWidth*sizeCoeff;
        o.legend.icon="roundRect";
        if (chartPref.containsKey(prefix+"LEGEND_ICON"))o.legend.icon=chartPref.Get_Element(prefix+"LEGEND_ICON");
        
    } else {
        String prefix="";
        if (chartType.equals("BOX")||chartType.equals("BOXG"))prefix="BOX_";
       if (NVL(chartPref.Get_Element(prefix+"LEGEND_SHOW"),"Y").equals("Y")) 
        o.legend.show=true;
        else o.legend.show=false;
        o.legend.left="10%";
        if (chartPref.containsKey(prefix+"LEGEND_LEFT"))o.legend.left=chartPref.Get_Element(prefix+"LEGEND_LEFT")+"%"; 
        o.legend.top="0%";
        if (chartPref.containsKey(prefix+"LEGEND_TOP"))o.legend.top=chartPref.Get_Element(prefix+"LEGEND_TOP")+"%"; 
         o.legend.textStyle=new eTextStyle();
        o.legend.textStyle.fontSize=12.0;
        if (chartPref.containsKey(prefix+"LEGEND_FONTSIZE"))o.legend.textStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_FONTSIZE"));
        o.legend.textStyle.fontSize=o.legend.textStyle.fontSize*sizeCoeff;
        o.legend.textStyle.color="rgb(0,0,0)";
        if (chartPref.containsKey(prefix+"LEGEND_FONTCOLOR"))o.legend.textStyle.color=chartPref.Get_Element(prefix+"LEGEND_FONTCOLOR");
        o.legend.textStyle.fontStyle="normal";
        if (chartPref.containsKey(prefix+"LEGEND_FONTSTYLE"))o.legend.textStyle.fontStyle=chartPref.Get_Element(prefix+"LEGEND_FONTSTYLE");
        o.legend.textStyle.fontWeight="normal";
        if (chartPref.containsKey(prefix+"LEGEND_FONTWEIGHT"))o.legend.textStyle.fontWeight=chartPref.Get_Element(prefix+"LEGEND_FONTWEIGHT");
        o.legend.itemWidth=25.0;
        if (chartPref.containsKey(prefix+"LEGEND_ITEMWIDTH"))o.legend.itemWidth=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_ITEMWIDTH"));
        o.legend.itemGap=10.0;
        if (chartPref.containsKey(prefix+"LEGEND_ITEMGAP"))o.legend.itemGap=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_ITEMGAP"));
        o.legend.itemHeight=14.0;
        if (chartPref.containsKey(prefix+"LEGEND_ITEMHEIGHT"))o.legend.itemHeight=Double.valueOf(chartPref.Get_Element(prefix+"LEGEND_ITEMHEIGHT"));
        o.legend.itemGap=o.legend.itemGap*sizeCoeff;
        o.legend.itemHeight=o.legend.itemHeight*sizeCoeff;
        o.legend.itemWidth=o.legend.itemWidth*sizeCoeff;
        o.legend.icon="налл";
        if (chartPref.containsKey(prefix+"LEGEND_ICON"))o.legend.icon=chartPref.Get_Element(prefix+"LEGEND_ICON");
    }
    }
    
    if (reload.equals("Y") || dataset==null || dimsStats==null){
        makeDataSet();
        if (!chartType.equals("MAP") && !chartType.equals("BOX")&& !chartType.equals("BOXG") && !chartType.equals("WHR"))o.dataset=dataset;
    }
    
    if (chartType.equals("WHR")) { // доделка шайбы серии будут поверхностями 
        makeAddon("Y",o);
        }
    

    
    //гриды
    if (chartType.equals("BOX") ||chartType.equals("BOXG") || chartType.equals("BAR") || chartType.equals("LINE") || chartType.equals("SCT")
            || chartType.equals("BARG")) {
    o.grid=new egrid();
    o.grid.containLabel=true;
    o.grid.show=true;
    o.grid.left="10%";
    o.grid.top="9%";
    o.grid.width="80%";
    o.grid.height="80%";
    String prefix="2DGRID_";
    if (chartType.equals("BOX") || chartType.equals("BOXG"))prefix="BOXGRID_";
    if (chartPref.containsKey(prefix+"WIDTH"))
    o.grid.width=this.chartPref.Get_Element(prefix+"WIDTH")+"%";
    if (chartPref.containsKey(prefix+"HEIGHT"))
    o.grid.height=this.chartPref.Get_Element(prefix+"HEIGHT")+"%";
    if (chartPref.containsKey(prefix+"LEFT"))
    o.grid.left=this.chartPref.Get_Element(prefix+"LEFT")+"%";
    if (chartPref.containsKey(prefix+"TOP"))
    o.grid.top=this.chartPref.Get_Element(prefix+"TOP")+"%";
    }
    
    if (chartType.equals("BAR3D")||chartType.equals("SCT3D")||chartType.equals("WHR")){
    String prefix="3DGRID_";
    if (chartType.equals("WHR")) prefix="WHRGRID_";
    o.grid3D=new egrid();
   // o.grid3D.zlevel=20;
    o.grid3D.left="0%";
    if (chartPref.containsKey(prefix+"LEFT"))o.grid3D.left=chartPref.Get_Element(prefix+"LEFT")+"%";
    o.grid3D.top="0%";
    if (chartPref.containsKey(prefix+"TOP"))o.grid3D.top=chartPref.Get_Element(prefix+"TOP")+"%";
    o.grid3D.boxWidth=100;
    if (chartPref.containsKey(prefix+"BOXWIDTH"))o.grid3D.boxWidth=Integer.valueOf(chartPref.Get_Element(prefix+"BOXWIDTH"));
    o.grid3D.boxDepth=100;
    if (chartPref.containsKey(prefix+"BOXDEPTH"))o.grid3D.boxDepth=Integer.valueOf(chartPref.Get_Element(prefix+"BOXDEPTH"));
    o.grid3D.boxHeight=100;
    if (chartType.equals("WHR"))o.grid3D.boxHeight=20;
    if (chartPref.containsKey(prefix+"BOXHEIGHT"))o.grid3D.boxHeight=Integer.valueOf(chartPref.Get_Element(prefix+"BOXHEIGHT"));
    o.grid3D.show=true;
    if (chartType.equals("WHR"))o.grid3D.show=false;
        
    //o.grid3D.temporalSuperSampling=new etemporalSuperSampling();
    //o.grid3D.temporalSuperSampling.enable=true;
    o.grid3D.light=new elight();
    o.grid3D.light.main=new elightM();
    o.grid3D.light.main.color="rgb(255,255,255)";
    if (chartPref.containsKey(prefix+"LIGHTCOLOR")){
     o.grid3D.light.main.color=chartPref.Get_Element(prefix+"LIGHTCOLOR");   
    }
    o.grid3D.light.main.intensity=1.0;
    if (chartPref.containsKey(prefix+"LIGHTINTENSITY")){
     o.grid3D.light.main.intensity=Double.valueOf(chartPref.Get_Element(prefix+"LIGHTINTENSITY"));   
    }
    o.grid3D.light.main.shadow=false;
    o.grid3D.light.main.quality="ultra";
    o.grid3D.light.ambient=new elightM();
    o.grid3D.light.ambient.color="rgb(255,255,255)";
    if (chartPref.containsKey(prefix+"AMBIENTCOLOR")){
     o.grid3D.light.ambient.color=chartPref.Get_Element(prefix+"AMBIENTCOLOR");   
    }
    o.grid3D.light.ambient.intensity=0.2;
    if (chartPref.containsKey(prefix+"AMBIENTINTENSITY")){
     o.grid3D.light.ambient.intensity=Double.valueOf(chartPref.Get_Element(prefix+"AMBIENTINTENSITY"));   
    }
    o.grid3D.viewControl=new eviewControl();
    if (reload.equals("Y")||reload.equals("Z")){
    o.grid3D.viewControl.distance=220;
    if (chartPref.containsKey(prefix+"DISTANCE")){
     o.grid3D.viewControl.distance=Integer.valueOf(chartPref.Get_Element(prefix+"DISTANCE"));   
    }
    o.grid3D.viewControl.alpha=20;
    if (chartPref.containsKey(prefix+"ALPHA")){
     o.grid3D.viewControl.alpha=Integer.valueOf(chartPref.Get_Element(prefix+"ALPHA"));   
    }
    o.grid3D.viewControl.beta=40;
    if (chartType.equals("WHR"))o.grid3D.viewControl.beta=-90;
    
    }   
    o.grid3D.viewControl.rotateSensitivity=new ArrayList<>();
    o.grid3D.viewControl.rotateSensitivity.add(1);
    o.grid3D.viewControl.rotateSensitivity.add(1);
    o.grid3D.viewControl.dumping=0.8;
    o.grid3D.viewControl.panSensitivity=1;
    o.grid3D.viewControl.autoRotate=autorotate3D;
    /*if (chartPref.containsKey("3DGRID_LEFT"))
    o.grid3D.left=this.chartPref.Get_Element("3DGRID_LEFT")+"%";
    if (chartPref.containsKey("3DGRID_TOP"))
    o.grid3D.top=this.chartPref.Get_Element("3DGRID_TOP")+"%";*/
    }
    // серии должны быть иенно тут
    if (!chartType.equals("WHR")) { // для шайб отдельный get
    makeSeries(o,reload,mlc); 
    o.series=series;}
    else {
        series=new ArrayList<>();
        for (int i=0;i<seriesProps.size();i++){
        eserie dummy=new eserie();
        dummy.name=seriesProps.get(i).Get_Element("name");
        series.add(dummy);}
    }
   // датазумы
    if (chartType.equals("BOX") ||chartType.equals("BOXG")){
     o.dataZoom=new ArrayList<>();
     edataZoom dzl=new edataZoom();
     dzl.type="slider";
     
     if (chartType.equals("BOXG")){
         dzl.orient="horizontal";
         dzl.bottom="0%";
         dzl.xAxisIndex=0;
         dzl.height=20.0*sizeCoeff;
     } else {
      dzl.orient="vertical";
     dzl.left="0%";
     dzl.yAxisIndex=0;
     dzl.width=20.0*sizeCoeff;   
     }
     
     dzl.show=false;
     edataZoom dzr=new edataZoom();
     dzr.type="slider";
     
     if (chartType.equals("BOXG")){
         dzr.orient="horizontal";
         dzr.top="5%";
         dzr.xAxisIndex=1;
          dzr.height=20.0*sizeCoeff;
     } else {
      dzr.orient="vertical";
     dzr.right="0%";
     dzr.yAxisIndex=1;
     dzr.width=20.0*sizeCoeff;   
     }
     
     dzr.show=false;
     String prefix="BOXGRID_";
     if (chartPref.containsKey(prefix+"SLIDERGAP"))
     {
      if (chartType.equals("BOX")){
      dzr.right=chartPref.Get_Element(prefix+"SLIDERGAP")+"%";
      dzl.left=chartPref.Get_Element(prefix+"SLIDERGAP")+"%";
      }
      if (chartType.equals("BOXG")){
        dzl.bottom=chartPref.Get_Element(prefix+"SLIDERGAP")+"%";
        dzr.top=String.valueOf(5+Integer.valueOf(chartPref.Get_Element(prefix+"SLIDERGAP")))+"%";
      }
     }
     if (chartPref.containsKey(prefix+"SLIDERWIDTH")){
         if (chartType.equals("BOX")){
         dzl.width=Double.valueOf(chartPref.Get_Element(prefix+"SLIDERWIDTH"))*sizeCoeff;
         dzr.width=Double.valueOf(chartPref.Get_Element(prefix+"SLIDERWIDTH"))*sizeCoeff;
         }
         if (chartType.equals("BOXG")){
         dzl.height=Double.valueOf(chartPref.Get_Element(prefix+"SLIDERWIDTH"))*sizeCoeff;
         dzr.height=Double.valueOf(chartPref.Get_Element(prefix+"SLIDERWIDTH"))*sizeCoeff;
         }
     }
     // по левой/правой оси есть графики?
     boolean left=false;
     boolean right=false;
     for (int i=0;i<series.size();i++){
        if (chartType.equals("BOX")){
        if (series.get(i).yAxisIndex==0) {left=true;}
        if (series.get(i).yAxisIndex==1) {right=true;}
        }
        if (chartType.equals("BOXG")){
        if (series.get(i).xAxisIndex==0) {left=true;}
        if (series.get(i).xAxisIndex==1) {right=true;}
        }
        }
     
     if (NVL(chartPref.Get_Element(prefix+"SLIDERSHOW"),"N").equals("Y")){
         if (left) dzl.show=true;
         if (right)dzr.show=true;
     }
     o.dataZoom.add(dzl);
     o.dataZoom.add(dzr);
    }
    
    if (chartType.equals("BAR") || chartType.equals("LINE") || chartType.equals("SCT")
            || chartType.equals("BARG") ){
        o.dataZoom=new ArrayList<>();
        edataZoom dz=new edataZoom();
        dz.type="inside";
        
        String prefix="2DGRID_";
        
        o.dataZoom.add(dz);
        dz=new edataZoom();
        dz.type="slider";
        if (chartType.equals("BARG") ){
         dz.yAxisIndex=0;
         dz.right="0%";
         dz.orient="vertical";
         if (chartPref.containsKey(prefix+"SLIDERGAP"))dz.right=chartPref.Get_Element(prefix+"SLIDERGAP")+"%";
          dz.width=20.0*sizeCoeff;
          if (chartPref.containsKey(prefix+"SLIDERWIDTH"))dz.width=Double.valueOf(chartPref.Get_Element(prefix+"SLIDERWIDTH"))*sizeCoeff;
        }
        else {
        dz.height=20.0*sizeCoeff;
        if (chartPref.containsKey(prefix+"SLIDERWIDTH"))dz.height=Double.valueOf(chartPref.Get_Element(prefix+"SLIDERWIDTH"))*sizeCoeff;
        dz.orient="horizontal";
        dz.bottom="0%";
        if (chartPref.containsKey(prefix+"SLIDERGAP"))dz.bottom=chartPref.Get_Element(prefix+"SLIDERGAP")+"%";
        }
        if (NVL(chartPref.Get_Element(prefix+"SLIDERSHOW"),"N").equals("N"))
        dz.show=false;
        else dz.show=true;
        o.dataZoom.add(dz);
    }
    
    
//    titles=o.title;
    // оси 2D и BOX
    //if (chartType.equals("BAR") || chartType.equals("LINE") || chartType.equals("SCT")){
     if (!like(chartType,"%G") && !like(chartType,"%3D")&& !like(chartType,"%MAP")&& !like(chartType,"%PIE")&&!like(chartType,"%WHR")){ // если плоская вертикаль
      o.xAxis=new ArrayList<>();
      eaxis xax=new eaxis();
      String prefix="2DAXES";
      if (chartType.equals("BOX"))prefix="BOXAXES";
      xax.type="category";
      xax.inverse=false;
      if (chartPref.Get_Element(prefix+"(C)_INVERSE").equals("Y")){
      xax.inverse=true;    
      }
     
      
      xax.position="bottom";
      if (chartPref.Get_Element(prefix+"(C)_POSITION").equals("opposite")){
      xax.position="top";    
      }
      xax.splitLine=new eSplitLine();
      xax.splitLine.show=false;
      if (chartPref.Get_Element(prefix+"(C)_SPLITSHOW").equals("Y")){
      xax.splitLine.show=true;
      }
      xax.splitLine.lineStyle=new elineStyle();
      xax.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey(prefix+"(C)_SPLITCOLOR")){
      xax.splitLine.lineStyle.color=chartPref.Get_Element(prefix+"(C)_SPLITCOLOR");
      }
      xax.splitLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(C)_SPLITSTYLE")){
      xax.splitLine.lineStyle.type=chartPref.Get_Element(prefix+"(C)_SPLITSTYLE");
      }
      xax.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_SPLITWIDTH")){
      xax.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(C)_SPLITWIDTH"))*sizeCoeff;
      }
      if (xax.splitLine.lineStyle.width<1.0)xax.splitLine.lineStyle.width=1.0;
      xax.axisLine=new eAxisLine();xax.axisLine.onZero=false;
      xax.axisLine.show=true;
      if (chartPref.Get_Element(prefix+"(C)_SHOW").equals("N")){
      xax.axisLine.show=false;
      }
      xax.axisLine.lineStyle=new elineStyle();
      xax.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey(prefix+"(C)_COLOR"))xax.axisLine.lineStyle.color=chartPref.Get_Element(prefix+"(C)_COLOR");
      xax.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_WIDTH"))xax.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(C)_WIDTH"))*sizeCoeff;
      if (xax.axisLine.lineStyle.width<1.0)xax.axisLine.lineStyle.width=1.0;
      xax.axisLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(C)_STYLE"))xax.axisLine.lineStyle.type=chartPref.Get_Element(prefix+"(C)_STYLE");
      if (colsinfo.get(0).LuiDATATYPE.equals("DATETIME"))xax.type="time";
      if (colsinfo.get(0).LuiDATATYPE.equals("NUMBER"))xax.type="value"; 
      if (!xax.type.equals("category")) { // если это не ось символьная,то вычислим её минимум и максимум
        String dskey=groupProps.get(0).Get_Element("name");
        xax.min="dataMin";
        xax.max="dataMax";
        if (xax.type.equals("value")&& dimsStats!=null && 
                dimsStats.get(dskey)!=null &&
                dimsStats.get(dskey).min!=null &&
                dimsStats.get(dskey).max!=null){
           xax.min=dimsStats.get(dskey).min; 
           xax.max=dimsStats.get(dskey).max; 
           if (dimsStats.get(dskey).pmin!=null){
             double pmin=Double.valueOf(dimsStats.get(dskey).pmin);
             double min=Double.valueOf(dimsStats.get(dskey).min);
             double max=Double.valueOf(dimsStats.get(dskey).max);
             min=min-(pmin-min);
             max=max+(pmin-min);
             xax.min=min;
             xax.max=max;
           }
        } 
          
      }
      if (xax.type.equals("value")){
      if  (chartPref.containsKey(prefix+"(C)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element(prefix+"(C)_MIN"));
          xax.min=minZ;
          
      }
     
      if  (chartPref.containsKey(prefix+"(C)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element(prefix+"(C)_MAX"));
          xax.max=maxZ;
          
      }}
      xax.nameRotate=0;
      if (chartPref.containsKey(prefix+"(C)_NAMEROTATE")){
          xax.nameRotate=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_NAMEROTATE"));
      }
      xax.name="налл";
      if (chartPref.Get_Element(prefix+"(C)_NAMESHOW").equals("Y")){
      xax.name=getAxisName("X");
       if (chartPref.containsKey(prefix+"(C)_NAMETEXT")){
           xax.name=chartPref.Get_Element(prefix+"(C)_NAMETEXT");
       }
      }
      xax.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_NAMEGAP")){
      xax.nameGap=Double.valueOf(chartPref.Get_Element(prefix+"(C)_NAMEGAP"))*sizeCoeff;
      }
      xax.nameLocation="end";
      if (chartPref.containsKey(prefix+"(C)_NAMELOCATION")){
      xax.nameLocation=chartPref.Get_Element(prefix+"(C)_NAMELOCATION");
      }
      xax.nameTextStyle=new eTextStyle();
      xax.nameTextStyle.fontSize=12.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTSIZE")){
      xax.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(C)_NAMEFONTSIZE"))*sizeCoeff;
      }
      xax.nameTextStyle.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTSTYLE")){
      xax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(C)_NAMEFONTSTYLE");
      }
      xax.nameTextStyle.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTWEIGHT")){
      xax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(C)_NAMEFONTWEIGHT");
      }
      xax.nameTextStyle.color="налл";
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTCOLOR")){
      xax.nameTextStyle.color=chartPref.Get_Element(prefix+"(C)_NAMEFONTCOLOR");
      }
      
      xax.axisLabel=new eAxisLabel();
      xax.axisLabel.interval="налл";
      if (chartPref.containsKey(prefix+"(C)_LABELINTERVAL")){
      xax.axisLabel.interval=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_LABELINTERVAL"));
      }
      xax.axisLabel.show=true;
      if (chartPref.Get_Element(prefix+"(C)_LABELSHOW").equals("N")){
      xax.axisLabel.show=false;
      }
      xax.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_LABELFONTSIZE")){
      xax.axisLabel.fontSize=sizeCoeff*Double.valueOf(chartPref.Get_Element(prefix+"(C)_LABELFONTSIZE"));
      }
      xax.axisLabel.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(C)_LABELFONTSTYLE")){
      xax.axisLabel.fontStyle=chartPref.Get_Element(prefix+"(C)_LABELFONTSTYLE");
      }
      xax.axisLabel.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(C)_LABELFONTWEIGHT")){
      xax.axisLabel.fontWeight=chartPref.Get_Element(prefix+"(C)_LABELFONTWEIGHT");
      }
      xax.axisLabel.color="налл";
      if (chartPref.containsKey(prefix+"(C)_LABELFONTCOLOR")){
      xax.axisLabel.color=chartPref.Get_Element(prefix+"(C)_LABELFONTCOLOR");
      }
      xax.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_LABELMARGIN")){
      xax.axisLabel.margin=Double.valueOf(chartPref.Get_Element(prefix+"(C)_LABELMARGIN"))*sizeCoeff;
      }
      xax.axisLabel.showMaxLabel=true;
      xax.axisLabel.rotate=0;
      xax.axisLabel.rotate=0;
      if (chartPref.containsKey(prefix+"(C)_LABELROTATE")){
      xax.axisLabel.rotate=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_LABELROTATE"));
      }
      xax.triggerEvent=true;
      if (chartType.equals("BOX")){
          xax.data=new ArrayList();
          for (int xi=0;xi<seriesProps.size();xi++){
              xax.data.add(seriesProps.get(xi).Get_Element("name"));
          }
      }
      o.xAxis.add(xax);
      o.yAxis=new ArrayList<>();
      eaxis y1ax=new eaxis();
      y1ax.inverse=false;
      if (chartPref.Get_Element(prefix+"(V1)_INVERSE").equals("Y")){
      y1ax.inverse=true;    
      }
      y1ax.type="value";
      y1ax.min="налл";
      if  (chartPref.containsKey(prefix+"(V1)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_MIN"));
          y1ax.min=minZ;
      }
      y1ax.max="налл";
      if  (chartPref.containsKey(prefix+"(V1)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_MAX"));
          y1ax.max=maxZ;
      }
      y1ax.logBase="налл";
      if  (chartPref.containsKey(prefix+"(V1)_LOGBASE")){
          Double logBaze=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_LOGBASE"));
          y1ax.logBase=logBaze;
          y1ax.type="log";
      }
      
      y1ax.splitLine=new eSplitLine();
      y1ax.splitLine.show=true;
      if (chartPref.Get_Element(prefix+"(V1)_SPLITSHOW").equals("N")){
      y1ax.splitLine.show=false;
      }
      y1ax.axisLine=new eAxisLine();y1ax.axisLine.onZero=false;
      y1ax.axisLine.show=true;
      if (chartPref.Get_Element(prefix+"(V1)_SHOW").equals("N")){
      y1ax.axisLine.show=false;
      }
      y1ax.splitLine.lineStyle=new elineStyle();
      y1ax.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey(prefix+"(V1)_SPLITCOLOR")){
      y1ax.splitLine.lineStyle.color=chartPref.Get_Element(prefix+"(V1)_SPLITCOLOR");
      }
      y1ax.splitLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V1)_SPLITSTYLE")){
      y1ax.splitLine.lineStyle.type=chartPref.Get_Element(prefix+"(V1)_SPLITSTYLE");
      }
      y1ax.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_SPLITWIDTH")){
      y1ax.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_SPLITWIDTH"))*sizeCoeff;
      if (y1ax.splitLine.lineStyle.width<1.0)y1ax.splitLine.lineStyle.width=1.0;
      }
      y1ax.axisLine.lineStyle=new elineStyle();
      y1ax.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey(prefix+"(V1)_COLOR"))y1ax.axisLine.lineStyle.color=chartPref.Get_Element(prefix+"(V1)_COLOR");
      y1ax.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_WIDTH"))y1ax.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_WIDTH"))*sizeCoeff;
      if (y1ax.axisLine.lineStyle.width<1.0)y1ax.axisLine.lineStyle.width=1.0;
      y1ax.axisLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V1)_STYLE"))y1ax.axisLine.lineStyle.type=chartPref.Get_Element(prefix+"(V1)_STYLE");
     
      y1ax.nameRotate=0;
      if (chartPref.containsKey(prefix+"(V1)_NAMEROTATE")){
          y1ax.nameRotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V1)_NAMEROTATE"));
      }
      y1ax.name="налл";
      if (chartPref.Get_Element(prefix+"(V1)_NAMESHOW").equals("Y")){
      y1ax.name=getAxisName("Y1");
       if (chartPref.containsKey(prefix+"(V1)_NAMETEXT")){
           y1ax.name=chartPref.Get_Element(prefix+"(V1)_NAMETEXT");
       }
      }
      y1ax.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_NAMEGAP")){
      y1ax.nameGap=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_NAMEGAP"))*sizeCoeff;
      }
      y1ax.nameLocation="end";
      if (chartPref.containsKey(prefix+"(V1)_NAMELOCATION")){
      y1ax.nameLocation=chartPref.Get_Element(prefix+"(V1)_NAMELOCATION");
      }
      y1ax.nameTextStyle=new eTextStyle();
      y1ax.nameTextStyle.fontSize=12.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTSIZE")){
      y1ax.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_NAMEFONTSIZE"))*sizeCoeff;
      }
      y1ax.nameTextStyle.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTSTYLE")){
      y1ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V1)_NAMEFONTSTYLE");
      }
      y1ax.nameTextStyle.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTWEIGHT")){
      y1ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V1)_NAMEFONTWEIGHT");
      }
      y1ax.nameTextStyle.color="налл";
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTCOLOR")){
      y1ax.nameTextStyle.color=chartPref.Get_Element(prefix+"(V1)_NAMEFONTCOLOR");
      }
      
      
      y1ax.axisLabel=new eAxisLabel();
      y1ax.axisLabel.show=true;
      if (chartPref.Get_Element(prefix+"(V1)_LABELSHOW").equals("N")){
      y1ax.axisLabel.show=false;
      }
      y1ax.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTSIZE")){
      y1ax.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_LABELFONTSIZE"))*sizeCoeff;
      }
      y1ax.axisLabel.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTSTYLE")){
      y1ax.axisLabel.fontStyle=chartPref.Get_Element(prefix+"(V1)_LABELFONTSTYLE");
      }
      y1ax.axisLabel.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTWEIGHT")){
      y1ax.axisLabel.fontWeight=chartPref.Get_Element(prefix+"(V1)_LABELFONTWEIGHT");
      }
      y1ax.axisLabel.color="налл";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTCOLOR")){
      y1ax.axisLabel.color=chartPref.Get_Element(prefix+"(V1)_LABELFONTCOLOR");
      }
      y1ax.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_LABELMARGIN")){
      y1ax.axisLabel.margin=Integer.valueOf(chartPref.Get_Element(prefix+"(V1)_LABELMARGIN"))*sizeCoeff;
      }
      y1ax.axisLabel.showMaxLabel=true;
      y1ax.axisLabel.rotate=0;
      y1ax.axisLabel.rotate=0;
      if (chartPref.containsKey(prefix+"(V1)_LABELROTATE")){
      y1ax.axisLabel.rotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V1)_LABELROTATE"));
      }
      y1ax.position="left";
      y1ax.triggerEvent=true;
      o.yAxis.add(y1ax);
      eaxis y2ax=new eaxis();
      y2ax.inverse=false;
      if (chartPref.Get_Element(prefix+"(V2)_INVERSE").equals("Y")){
      y2ax.inverse=true;    
      }
      y2ax.type="value";
      y2ax.min="налл";
      if  (chartPref.containsKey(prefix+"(V2)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_MIN"));
          y2ax.min=minZ;
      }
      y2ax.max="налл";
      if  (chartPref.containsKey(prefix+"(V2)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_MAX"));
          y2ax.max=maxZ;
      }
      y2ax.logBase="налл";
      if  (chartPref.containsKey(prefix+"(V2)_LOGBASE")){
          Double logBaze=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_LOGBASE"));
          y2ax.logBase=logBaze;
          y2ax.type="log";
      }
      
      y2ax.splitLine=new eSplitLine();
      y2ax.splitLine.show=true;
      if (chartPref.Get_Element(prefix+"(V2)_SPLITSHOW").equals("N")){
      y2ax.splitLine.show=false;
      }
      y2ax.splitLine.lineStyle=new elineStyle();
      y2ax.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey(prefix+"(V2)_SPLITCOLOR")){
      y2ax.splitLine.lineStyle.color=chartPref.Get_Element(prefix+"(V2)_SPLITCOLOR");
      }
      y2ax.splitLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V2)_SPLITSTYLE")){
      y2ax.splitLine.lineStyle.type=chartPref.Get_Element(prefix+"(V2)_SPLITSTYLE");
      }
      y2ax.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_SPLITWIDTH")){
      y2ax.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_SPLITWIDTH"))*sizeCoeff;
      }
      if(y2ax.splitLine.lineStyle.width<1.0)y2ax.splitLine.lineStyle.width=1.0;
      
      y2ax.axisLine=new eAxisLine();y2ax.axisLine.onZero=false;
      y2ax.axisLine.show=true;
      if (chartPref.Get_Element(prefix+"(V2)_SHOW").equals("N")){
      y2ax.axisLine.show=false;
      }
      y2ax.axisLine.lineStyle=new elineStyle();
      y2ax.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey(prefix+"(V2)_COLOR"))y2ax.axisLine.lineStyle.color=chartPref.Get_Element(prefix+"(V2)_COLOR");
      y2ax.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_WIDTH"))y2ax.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_WIDTH"))*sizeCoeff;
      if (y2ax.axisLine.lineStyle.width<1.0)y2ax.axisLine.lineStyle.width=1.0;
      y2ax.axisLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V2)_STYLE"))y2ax.axisLine.lineStyle.type=chartPref.Get_Element(prefix+"(V2)_STYLE");

      y2ax.nameRotate=0;
      if (chartPref.containsKey(prefix+"(V2)_NAMEROTATE")){
          y2ax.nameRotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V2)_NAMEROTATE"));
      }
      y2ax.name="налл";
      if (chartPref.Get_Element(prefix+"(V2)_NAMESHOW").equals("Y")){
      y2ax.name=getAxisName("Y2");
       if (chartPref.containsKey(prefix+"(V2)_NAMETEXT")){
           y2ax.name=chartPref.Get_Element(prefix+"(V2)_NAMETEXT");
       }
      }
      y2ax.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_NAMEGAP")){
      y2ax.nameGap=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_NAMEGAP"))*sizeCoeff;
      }
      y2ax.nameLocation="end";
      if (chartPref.containsKey(prefix+"(V2)_NAMELOCATION")){
      y2ax.nameLocation=chartPref.Get_Element(prefix+"(V2)_NAMELOCATION");
      }
      y2ax.nameTextStyle=new eTextStyle();
      y2ax.nameTextStyle.fontSize=12.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTSIZE")){
      y2ax.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_NAMEFONTSIZE"))*sizeCoeff;
      }
      y2ax.nameTextStyle.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTSTYLE")){
      y2ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V2)_NAMEFONTSTYLE");
      }
      y2ax.nameTextStyle.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTWEIGHT")){
      y2ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V2)_NAMEFONTWEIGHT");
      }
      y2ax.nameTextStyle.color="налл";
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTCOLOR")){
      y2ax.nameTextStyle.color=chartPref.Get_Element(prefix+"(V2)_NAMEFONTCOLOR");
      }
      
      
      y2ax.axisLabel=new eAxisLabel();
      y2ax.axisLabel.show=true;
      if (chartPref.Get_Element(prefix+"(V2)_LABELSHOW").equals("N")){
      y2ax.axisLabel.show=false;
      }
      y2ax.axisLabel.fontSize=10*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTSIZE")){
      y2ax.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_LABELFONTSIZE"))*sizeCoeff;
      }
      y2ax.axisLabel.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTSTYLE")){
      y2ax.axisLabel.fontStyle=chartPref.Get_Element(prefix+"(V2)_LABELFONTSTYLE");
      }
      y2ax.axisLabel.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTWEIGHT")){
      y2ax.axisLabel.fontWeight=chartPref.Get_Element(prefix+"(V2)_LABELFONTWEIGHT");
      }
      y2ax.axisLabel.color="налл";
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTCOLOR")){
      y2ax.axisLabel.color=chartPref.Get_Element(prefix+"(V2)_LABELFONTCOLOR");
      }
      y2ax.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_LABELMARGIN")){
      y2ax.axisLabel.margin=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_LABELMARGIN"))*sizeCoeff;
      }      
      y2ax.axisLabel.showMaxLabel=true;
      y2ax.axisLabel.rotate=0;
      if (chartPref.containsKey(prefix+"(V2)_LABELROTATE")){
      y2ax.axisLabel.rotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V2)_LABELROTATE"));
      }
      y2ax.position="right";
      y2ax.triggerEvent=true;
      o.yAxis.add(y2ax);
    }
    if (like(chartType,"%G")){ //если плоская горизонталь
      o.yAxis=new ArrayList<>();
      eaxis yax=new eaxis();
      String prefix="2DAXES";
      if (chartType.equals("BOXG"))prefix="BOXAXES";
      yax.inverse=false;
      if (chartPref.Get_Element(prefix+"(C)_INVERSE").equals("Y")){
      yax.inverse=true;    
      }
      yax.type="category";
     // yax.min="dataMin";

      yax.position="left";
      if (chartPref.Get_Element(prefix+"(C)_POSITION").equals("opposite")){
      yax.position="right";    
      }
      yax.splitLine=new eSplitLine();
      yax.splitLine.show=false;
      if (chartPref.Get_Element(prefix+"(C)_SPLITSHOW").equals("Y")){
      yax.splitLine.show=true;
      }
      yax.splitLine.lineStyle=new elineStyle();
      yax.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey(prefix+"(C)_SPLITCOLOR")){
      yax.splitLine.lineStyle.color=chartPref.Get_Element(prefix+"(C)_SPLITCOLOR");
      }
      yax.splitLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(C)_SPLITSTYLE")){
      yax.splitLine.lineStyle.type=chartPref.Get_Element(prefix+"(C)_SPLITSTYLE");
      }
      yax.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_SPLITWIDTH")){
      yax.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(C)_SPLITWIDTH"))*sizeCoeff;
      }
      if (yax.splitLine.lineStyle.width<1.0)yax.splitLine.lineStyle.width=1.0;
      yax.axisLine=new eAxisLine();yax.axisLine.onZero=false;
      yax.axisLine.show=true;
      if (chartPref.Get_Element(prefix+"(C)_SHOW").equals("N")){
      yax.axisLine.show=false;
      }
      yax.axisLine.lineStyle=new elineStyle();
      yax.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey(prefix+"(C)_COLOR"))yax.axisLine.lineStyle.color=chartPref.Get_Element(prefix+"(C)_COLOR");
      yax.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_WIDTH"))yax.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(C)_WIDTH"))*sizeCoeff;
      if (yax.axisLine.lineStyle.width<1.0)yax.axisLine.lineStyle.width=1.0;
      yax.axisLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(C)_STYLE"))yax.axisLine.lineStyle.type=chartPref.Get_Element(prefix+"(C)_STYLE");
      if (colsinfo.get(0).LuiDATATYPE.equals("DATETIME"))yax.type="time";
      if (colsinfo.get(0).LuiDATATYPE.equals("NUMBER"))yax.type="value";
if (!yax.type.equals("category")) { // если это не ось символьная,то вычислим её минимум и максимум
        String dskey=groupProps.get(0).Get_Element("name");
        yax.min="dataMin";
        yax.max="dataMax";
        if (yax.type.equals("value")&& dimsStats!=null && 
                dimsStats.get(dskey)!=null &&
                dimsStats.get(dskey).min!=null &&
                dimsStats.get(dskey).max!=null){
           yax.min=dimsStats.get(dskey).min; 
           yax.max=dimsStats.get(dskey).max; 
           if (dimsStats.get(dskey).pmin!=null){
             double pmin=Double.valueOf(dimsStats.get(dskey).pmin);
             double min=Double.valueOf(dimsStats.get(dskey).min);
             double max=Double.valueOf(dimsStats.get(dskey).max);
             min=min-(pmin-min);
             max=max+(pmin-min);
             yax.min=min;
             yax.max=max;
           }
        } 
          
      }
if (yax.type.equals("value")){
      if  (chartPref.containsKey(prefix+"(C)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element(prefix+"(C)_MIN"));
          yax.min=minZ;
          
      }
     
      if  (chartPref.containsKey(prefix+"(C)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element(prefix+"(C)_MAX"));
          yax.max=maxZ;
          
      }}
yax.nameRotate=0;
      if (chartPref.containsKey(prefix+"(C)_NAMEROTATE")){
          yax.nameRotate=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_NAMEROTATE"));
      }
      yax.name="налл";
      if (chartPref.Get_Element(prefix+"(C)_NAMESHOW").equals("Y")){
      yax.name=this.getAxisName("Y");
       if (chartPref.containsKey(prefix+"(C)_NAMETEXT")){
           yax.name=chartPref.Get_Element(prefix+"(C)_NAMETEXT");
       }
      }
      yax.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_NAMEGAP")){
      yax.nameGap=Double.valueOf(chartPref.Get_Element(prefix+"(C)_NAMEGAP"))*sizeCoeff;
      }
      yax.nameLocation="end";
      if (chartPref.containsKey(prefix+"(C)_NAMELOCATION")){
      yax.nameLocation=chartPref.Get_Element(prefix+"(C)_NAMELOCATION");
      }
      yax.nameTextStyle=new eTextStyle();
      yax.nameTextStyle.fontSize=12.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTSIZE")){
      yax.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(C)_NAMEFONTSIZE"))*sizeCoeff;
      }
      yax.nameTextStyle.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTSTYLE")){
      yax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(C)_NAMEFONTSTYLE");
      }
      yax.nameTextStyle.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTWEIGHT")){
      yax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(C)_NAMEFONTWEIGHT");
      }
      yax.nameTextStyle.color="налл";
      if (chartPref.containsKey(prefix+"(C)_NAMEFONTCOLOR")){
      yax.nameTextStyle.color=chartPref.Get_Element(prefix+"(C)_NAMEFONTCOLOR");
      }
      
     
      
      yax.axisLabel=new eAxisLabel();
      yax.axisLabel.interval="налл";
      if (chartPref.containsKey(prefix+"(C)_LABELINTERVAL")){
      yax.axisLabel.interval=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_LABELINTERVAL"));
      }
      yax.axisLabel.show=true;
      if (chartPref.Get_Element(prefix+"(C)_LABELSHOW").equals("N")){
      yax.axisLabel.show=false;
      }
      yax.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_LABELFONTSIZE")){
      yax.axisLabel.fontSize=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_LABELFONTSIZE"))*sizeCoeff;
      }
      yax.axisLabel.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(C)_LABELFONTSTYLE")){
      yax.axisLabel.fontStyle=chartPref.Get_Element(prefix+"(C)_LABELFONTSTYLE");
      }
      yax.axisLabel.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(C)_LABELFONTWEIGHT")){
      yax.axisLabel.fontWeight=chartPref.Get_Element(prefix+"(C)_LABELFONTWEIGHT");
      }
      yax.axisLabel.color="налл";
      if (chartPref.containsKey(prefix+"(C)_LABELFONTCOLOR")){
      yax.axisLabel.color=chartPref.Get_Element(prefix+"(C)_LABELFONTCOLOR");
      }
      yax.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(C)_LABELMARGIN")){
      yax.axisLabel.margin=Double.valueOf(chartPref.Get_Element(prefix+"(C)_LABELMARGIN"))*sizeCoeff;
      }
      yax.axisLabel.showMaxLabel=true;
      yax.axisLabel.rotate=0;
      if (chartPref.containsKey(prefix+"(C)_LABELROTATE")){
      yax.axisLabel.rotate=Integer.valueOf(chartPref.Get_Element(prefix+"(C)_LABELROTATE"));
      }
      yax.triggerEvent=true;
      if (chartType.equals("BOXG")){
          yax.data=new ArrayList();
          for (int xi=0;xi<seriesProps.size();xi++){
              yax.data.add(seriesProps.get(xi).Get_Element("name"));
          }
      }
      o.yAxis.add(yax);
      o.xAxis=new ArrayList<>();
      eaxis x1ax=new eaxis();
      x1ax.inverse=false;
      if (chartPref.Get_Element(prefix+"(V1)_INVERSE").equals("Y")){
      x1ax.inverse=true;    
      }
      x1ax.type="value";
      x1ax.min="налл";
      if  (chartPref.containsKey(prefix+"(V1)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_MIN"));
          x1ax.min=minZ;
      }
      x1ax.max="налл";
      if  (chartPref.containsKey(prefix+"(V1)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_MAX"));
          x1ax.max=maxZ;
      }
      x1ax.logBase="налл";
      if  (chartPref.containsKey(prefix+"(V1)_LOGBASE")){
          Double logBaze=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_LOGBASE"));
          x1ax.logBase=logBaze;
          x1ax.type="log";
      }
      
      x1ax.splitLine=new eSplitLine();
      x1ax.splitLine.show=true;
      if (chartPref.Get_Element(prefix+"(V1)_SPLITSHOW").equals("N")){
      x1ax.splitLine.show=false;
      }
      x1ax.splitLine.lineStyle=new elineStyle();
      x1ax.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey(prefix+"(V1)_SPLITCOLOR")){
      x1ax.splitLine.lineStyle.color=chartPref.Get_Element(prefix+"(V1)_SPLITCOLOR");
      }
      x1ax.splitLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V1)_SPLITSTYLE")){
      x1ax.splitLine.lineStyle.type=chartPref.Get_Element(prefix+"(V1)_SPLITSTYLE");
      }
      x1ax.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_SPLITWIDTH")){
      x1ax.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_SPLITWIDTH"))*sizeCoeff;
      }
      if (x1ax.splitLine.lineStyle.width<1.0)x1ax.splitLine.lineStyle.width=1.0;
      x1ax.axisLine=new eAxisLine();x1ax.axisLine.onZero=false;
      x1ax.axisLine.show=true;
      if (chartPref.Get_Element(prefix+"(V1)_SHOW").equals("N")){
      x1ax.axisLine.show=false;
      }
      x1ax.axisLine.lineStyle=new elineStyle();
      x1ax.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey(prefix+"(V1)_COLOR"))x1ax.axisLine.lineStyle.color=chartPref.Get_Element(prefix+"(V1)_COLOR");
      x1ax.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_WIDTH"))x1ax.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_WIDTH"))*sizeCoeff;
      if(x1ax.axisLine.lineStyle.width<1.0)x1ax.axisLine.lineStyle.width=1.0;
      x1ax.axisLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V1)_STYLE"))x1ax.axisLine.lineStyle.type=chartPref.Get_Element(prefix+"(V1)_STYLE");
      x1ax.axisLabel=new eAxisLabel();
      x1ax.axisLabel.show=true;
      if (chartPref.Get_Element(prefix+"(V1)_LABELSHOW").equals("N")){
      x1ax.axisLabel.show=false;
      }
      x1ax.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTSIZE")){
      x1ax.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_LABELFONTSIZE"));
      }
      x1ax.axisLabel.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTSTYLE")){
      x1ax.axisLabel.fontStyle=chartPref.Get_Element(prefix+"(V1)_LABELFONTSTYLE");
      }
      x1ax.axisLabel.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTWEIGHT")){
      x1ax.axisLabel.fontWeight=chartPref.Get_Element(prefix+"(V1)_LABELFONTWEIGHT");
      }
      x1ax.axisLabel.color="налл";
      if (chartPref.containsKey(prefix+"(V1)_LABELFONTCOLOR")){
      x1ax.axisLabel.color=chartPref.Get_Element(prefix+"(V1)_LABELFONTCOLOR");
      }
      x1ax.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_LABELMARGIN")){
      x1ax.axisLabel.margin=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_LABELMARGIN"))*sizeCoeff;
      }

      x1ax.axisLabel.showMaxLabel=true;
      x1ax.axisLabel.rotate=0;
      if (chartPref.containsKey(prefix+"(V1)_LABELROTATE")){
      x1ax.axisLabel.rotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V1)_LABELROTATE"));
      }
      x1ax.position="bottom";

      x1ax.nameRotate=0;
      if (chartPref.containsKey(prefix+"(V1)_NAMEROTATE")){
          x1ax.nameRotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V1)_NAMEROTATE"));
      }
      x1ax.name="налл";
      if (chartPref.Get_Element(prefix+"(V1)_NAMESHOW").equals("Y")){
      x1ax.name=getAxisName("X1");
       if (chartPref.containsKey(prefix+"(V1)_NAMETEXT")){
           x1ax.name=chartPref.Get_Element(prefix+"(V1)_NAMETEXT");
       }
      }
      x1ax.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_NAMEGAP")){
      x1ax.nameGap=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_NAMEGAP"))*sizeCoeff;
      }
      x1ax.nameLocation="end";
      if (chartPref.containsKey(prefix+"(V1)_NAMELOCATION")){
      x1ax.nameLocation=chartPref.Get_Element(prefix+"(V1)_NAMELOCATION");
      }
      x1ax.nameTextStyle=new eTextStyle();
      x1ax.nameTextStyle.fontSize=12.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTSIZE")){
      x1ax.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V1)_NAMEFONTSIZE"))*sizeCoeff;
      }
      x1ax.nameTextStyle.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTSTYLE")){
      x1ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V1)_NAMEFONTSTYLE");
      }
      x1ax.nameTextStyle.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTWEIGHT")){
      x1ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V1)_NAMEFONTWEIGHT");
      }
      x1ax.nameTextStyle.color="налл";
      if (chartPref.containsKey(prefix+"(V1)_NAMEFONTCOLOR")){
      x1ax.nameTextStyle.color=chartPref.Get_Element(prefix+"(V1)_NAMEFONTCOLOR");
      }
      
      x1ax.triggerEvent=true;
      o.xAxis.add(x1ax);
      
      eaxis x2ax=new eaxis();
      x2ax.inverse=false;
      if (chartPref.Get_Element(prefix+"(V2)_INVERSE").equals("Y")){
      x2ax.inverse=true;    
      }
      x2ax.type="value";
      x2ax.min="налл";
      if  (chartPref.containsKey(prefix+"(V2)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_MIN"));
          x2ax.min=minZ;
      }
      x2ax.max="налл";
      if  (chartPref.containsKey(prefix+"(V2)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_MAX"));
          x2ax.max=maxZ;
      }
      x2ax.logBase="налл";
      if  (chartPref.containsKey(prefix+"(V2)_LOGBASE")){
          Double logBaze=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_LOGBASE"));
          x2ax.logBase=logBaze;
          x2ax.type="log";
      }
            
      x2ax.splitLine=new eSplitLine();
      x2ax.splitLine.show=true;
      if (chartPref.Get_Element(prefix+"(V2)_SPLITSHOW").equals("N")){
      x2ax.splitLine.show=false;
      }
      x2ax.splitLine.lineStyle=new elineStyle();
      x2ax.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey(prefix+"(V2)_SPLITCOLOR")){
      x2ax.splitLine.lineStyle.color=chartPref.Get_Element(prefix+"(V2)_SPLITCOLOR");
      }
      x2ax.splitLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V2)_SPLITSTYLE")){
      x2ax.splitLine.lineStyle.type=chartPref.Get_Element(prefix+"(V2)_SPLITSTYLE");
      }
      x2ax.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_SPLITWIDTH")){
      x2ax.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_SPLITWIDTH"))*sizeCoeff;
      }
      if(x2ax.splitLine.lineStyle.width<1.0)x2ax.splitLine.lineStyle.width=1.0;
      x2ax.axisLine=new eAxisLine();x2ax.axisLine.onZero=false;
      x2ax.axisLine.show=true;
      if (chartPref.Get_Element(prefix+"(V2)_SHOW").equals("N")){
      x2ax.axisLine.show=false;
      }
      x2ax.axisLine.lineStyle=new elineStyle();
      x2ax.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey(prefix+"(V2)_COLOR"))x2ax.axisLine.lineStyle.color=chartPref.Get_Element(prefix+"(V2)_COLOR");
      x2ax.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_WIDTH"))x2ax.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_WIDTH"))*sizeCoeff;
      if(x2ax.axisLine.lineStyle.width<1.0)x2ax.axisLine.lineStyle.width=1.0;
      x2ax.axisLine.lineStyle.type="solid";
      if (chartPref.containsKey(prefix+"(V2)_STYLE"))x2ax.axisLine.lineStyle.type=chartPref.Get_Element(prefix+"(V2)_STYLE");
      
      
      x2ax.axisLabel=new eAxisLabel();
      x2ax.axisLabel.show=true;
      if (chartPref.Get_Element(prefix+"(V2)_LABELSHOW").equals("N")){
      x2ax.axisLabel.show=false;
      }
      x2ax.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTSIZE")){
      x2ax.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_LABELFONTSIZE"))*sizeCoeff;
      }
      x2ax.axisLabel.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTSTYLE")){
      x2ax.axisLabel.fontStyle=chartPref.Get_Element(prefix+"(V2)_LABELFONTSTYLE");
      }
      x2ax.axisLabel.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTWEIGHT")){
      x2ax.axisLabel.fontWeight=chartPref.Get_Element(prefix+"(V2)_LABELFONTWEIGHT");
      }
      x2ax.axisLabel.color="налл";
      if (chartPref.containsKey(prefix+"(V2)_LABELFONTCOLOR")){
      x2ax.axisLabel.color=chartPref.Get_Element(prefix+"(V2)_LABELFONTCOLOR");
      }
      x2ax.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_LABELMARGIN")){
      x2ax.axisLabel.margin=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_LABELMARGIN"))*sizeCoeff;
      }

      x2ax.axisLabel.showMaxLabel=true;
      x2ax.axisLabel.rotate=0;
      if (chartPref.containsKey(prefix+"(V2)_LABELROTATE")){
      x2ax.axisLabel.rotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V2)_LABELROTATE"));
      }
      x2ax.position="top";

      x2ax.nameRotate=0;
      if (chartPref.containsKey(prefix+"(V2)_NAMEROTATE")){
          x2ax.nameRotate=Integer.valueOf(chartPref.Get_Element(prefix+"(V2)_NAMEROTATE"));
      }
      x2ax.name="налл";
      if (chartPref.Get_Element(prefix+"(V2)_NAMESHOW").equals("Y")){
      x2ax.name=getAxisName("X2");
       if (chartPref.containsKey(prefix+"(V2)_NAMETEXT")){
           x2ax.name=chartPref.Get_Element(prefix+"(V2)_NAMETEXT");
       }
      }
      x2ax.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_NAMEGAP")){
      x2ax.nameGap=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_NAMEGAP"))*sizeCoeff;
      }
      x2ax.nameLocation="end";
      if (chartPref.containsKey(prefix+"(V2)_NAMELOCATION")){
      x2ax.nameLocation=chartPref.Get_Element(prefix+"(V2)_NAMELOCATION");
      }
      x2ax.nameTextStyle=new eTextStyle();
      x2ax.nameTextStyle.fontSize=12.0*sizeCoeff;
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTSIZE")){
      x2ax.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element(prefix+"(V2)_NAMEFONTSIZE"))*sizeCoeff;
      }
      x2ax.nameTextStyle.fontStyle="normal";
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTSTYLE")){
      x2ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V2)_NAMEFONTSTYLE");
      }
      x2ax.nameTextStyle.fontWeight="normal";
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTWEIGHT")){
      x2ax.nameTextStyle.fontStyle=chartPref.Get_Element(prefix+"(V2)_NAMEFONTWEIGHT");
      }
      x2ax.nameTextStyle.color="налл";
      if (chartPref.containsKey(prefix+"(V2)_NAMEFONTCOLOR")){
      x2ax.nameTextStyle.color=chartPref.Get_Element(prefix+"(V2)_NAMEFONTCOLOR");
      }
      
      x2ax.triggerEvent=true;
      o.xAxis.add(x2ax);
      
    }
    // оси 3D можно формировать только после получения axisDatas он делается в makeDataSet()
    if (like(chartType,"%3D")){
      o.xAxis3D=new eaxis();
      o.xAxis3D.type="category";
      o.xAxis3D.min="dataMin";

      if (colsinfo.get(0).LuiDATATYPE.equals("DATETIME"))o.xAxis3D.type="time";
      if (colsinfo.get(0).LuiDATATYPE.equals("NUMBER"))o.xAxis3D.type="value";
      if ((reload.equals("Y") ||
              !NVL(chartPref.Get_Element("3DAXES(X)_INVERSE"),"N").equals(this.xAxis3DlastInversion))
              && axisDatas!=null && axisDatas.size()>0){
        if (axisDatas.get(0)!=null && axisDatas.get(0).size()>0) {
          if (NVL(chartPref.Get_Element("3DAXES(X)_INVERSE"),"N").equals(this.xAxis3DlastInversion))
           o.xAxis3D.data=axisDatas.get(0);
          else 
          {
            ArrayList nad=new ArrayList<>();
            for (int adi=axisDatas.get(0).size()-1;adi>=0;adi--){
                nad.add(axisDatas.get(0).get(adi));
            }
            axisDatas.set(0,nad);
            o.xAxis3D.data=axisDatas.get(0);
            xAxis3DlastInversion=NVL(chartPref.Get_Element("3DAXES(X)_INVERSE"),"N");
          }   
        } 
      }
      o.xAxis3D.name="налл";
       if (chartPref.Get_Element("3DAXES(X)_NAMESHOW").equals("Y")){
      o.xAxis3D.name=getAxisName("X");
       if (chartPref.containsKey("3DAXES(X)_NAMETEXT")){
           o.xAxis3D.name=chartPref.Get_Element("3DAXES(X)_NAMETEXT");
       }
      }
      o.xAxis3D.nameTextStyle=new eTextStyle(); 
      o.xAxis3D.nameTextStyle.fontSize=12.0*sizeCoeff;
       if (chartPref.containsKey("3DAXES(X)_NAMEFONTSIZE")){
      o.xAxis3D.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element("3DAXES(X)_NAMEFONTSIZE"))*sizeCoeff;
      }
      o.xAxis3D.nameTextStyle.fontStyle="normal"; 
      if (chartPref.containsKey("3DAXES(X)_NAMEFONTSTYLE")){
      o.xAxis3D.nameTextStyle.fontStyle=chartPref.Get_Element("3DAXES(X)_NAMEFONTSTYLE");
      }
      o.xAxis3D.nameTextStyle.fontWeight="normal"; 
      if (chartPref.containsKey("3DAXES(X)_NAMEFONTWEIGHT")){
      o.xAxis3D.nameTextStyle.fontWeight=chartPref.Get_Element("3DAXES(X)_NAMEFONTWEIGHT");
      }
      o.xAxis3D.nameTextStyle.color="налл";
      if (chartPref.containsKey("3DAXES(X)_NAMEFONTCOLOR")){
      o.xAxis3D.nameTextStyle.color=chartPref.Get_Element("3DAXES(X)_NAMEFONTCOLOR");
      }
      o.xAxis3D.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(X)_NAMEGAP")){
      o.xAxis3D.nameGap=Integer.valueOf(chartPref.Get_Element("3DAXES(X)_NAMEGAP"))*sizeCoeff;
      }
      o.xAxis3D.axisLabel=new eAxisLabel();
      o.xAxis3D.axisLabel.interval="налл";
      if (chartPref.containsKey("3DAXES(X)_LABELINTERVAL")){
      o.xAxis3D.axisLabel.interval=Integer.valueOf(chartPref.Get_Element("3DAXES(X)_LABELINTERVAL"));
      }
      o.xAxis3D.axisLabel.show=true;
      if (chartPref.Get_Element("3DAXES(X)_LABELSHOW").equals("N")){
      o.xAxis3D.axisLabel.show=false;
      }
      o.xAxis3D.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(X)_LABELFONTSIZE")){
      o.xAxis3D.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element("3DAXES(X)_LABELFONTSIZE"))*sizeCoeff;
      }
      o.xAxis3D.axisLabel.fontStyle="normal";
      if (chartPref.containsKey("3DAXES(X)_LABELFONTSTYLE")){
      o.xAxis3D.axisLabel.fontStyle=chartPref.Get_Element("3DAXES(X)_LABELFONTSTYLE");
      }
      o.xAxis3D.axisLabel.fontWeight="normal";
      if (chartPref.containsKey("3DAXES(X)_LABELFONTWEIGHT")){
      o.xAxis3D.axisLabel.fontWeight=chartPref.Get_Element("3DAXES(X)_LABELFONTWEIGHT");
      }
      o.xAxis3D.axisLabel.color="налл";
      if (chartPref.containsKey("3DAXES(X)_LABELFONTCOLOR")){
      o.xAxis3D.axisLabel.color=chartPref.Get_Element("3DAXES(X)_LABELFONTCOLOR");
      }
      o.xAxis3D.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(X)_LABELMARGIN")){
      o.xAxis3D.axisLabel.margin=Double.valueOf(chartPref.Get_Element("3DAXES(X)_LABELMARGIN"))*sizeCoeff;
      }
      o.xAxis3D.splitLine=new eSplitLine();
      o.xAxis3D.splitLine.show=true;
      if (chartPref.Get_Element("3DAXES(X)_SPLITSHOW").equals("N")){
      o.xAxis3D.splitLine.show=false;
      }
      o.xAxis3D.splitLine.lineStyle=new elineStyle();
      o.xAxis3D.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey("3DAXES(X)_SPLITCOLOR")){
      o.xAxis3D.splitLine.lineStyle.color=chartPref.Get_Element("3DAXES(X)_SPLITCOLOR");
      }
      o.xAxis3D.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(X)_SPLITWIDTH")){
      o.xAxis3D.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element("3DAXES(X)_SPLITWIDTH"))*sizeCoeff;
      }
      if (o.xAxis3D.splitLine.lineStyle.width<1.0)o.xAxis3D.splitLine.lineStyle.width=1.0;
      o.xAxis3D.axisLine=new eAxisLine();
      o.xAxis3D.axisLine.lineStyle=new elineStyle();
      o.xAxis3D.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey("3DAXES(X)_COLOR"))o.xAxis3D.axisLine.lineStyle.color=chartPref.Get_Element("3DAXES(X)_COLOR");
      o.xAxis3D.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(X)_WIDTH"))o.xAxis3D.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element("3DAXES(X)_WIDTH"))*sizeCoeff;
      if (o.xAxis3D.axisLine.lineStyle.width<1.0)o.xAxis3D.axisLine.lineStyle.width=1.0;
      if (chartPref.Get_Element("3DAXES(X)_SHOW").equals("N")){
      o.xAxis3D.axisLine.lineStyle.width=0.0;
      }
      
      o.yAxis3D=new eaxis();
      o.yAxis3D.type="category";
      o.yAxis3D.min="dataMin";

      if (colsinfo.get(1).LuiDATATYPE.equals("DATETIME"))o.yAxis3D.type="time";
      if (colsinfo.get(1).LuiDATATYPE.equals("NUMBER"))o.yAxis3D.type="value";
      if ((reload.equals("Y") ||
              !NVL(chartPref.Get_Element("3DAXES(Y)_INVERSE"),"N").equals(this.yAxis3DlastInversion))
              && axisDatas!=null && axisDatas.size()>1){
        if (axisDatas.get(1)!=null && axisDatas.get(1).size()>0) {
          if (NVL(chartPref.Get_Element("3DAXES(Y)_INVERSE"),"N").equals(this.yAxis3DlastInversion))
           o.yAxis3D.data=axisDatas.get(1);
          else 
          {
            ArrayList nad=new ArrayList<>();
            for (int adi=axisDatas.get(1).size()-1;adi>=0;adi--){
                nad.add(axisDatas.get(1).get(adi));
            }
            axisDatas.set(1,nad);
            o.yAxis3D.data=axisDatas.get(1);
            yAxis3DlastInversion=NVL(chartPref.Get_Element("3DAXES(Y)_INVERSE"),"N");
          }   
        } 
      }
      o.yAxis3D.name="налл";
       if (chartPref.Get_Element("3DAXES(Y)_NAMESHOW").equals("Y")){
      o.yAxis3D.name=getAxisName("Y");
       if (chartPref.containsKey("3DAXES(Y)_NAMETEXT")){
           o.yAxis3D.name=chartPref.Get_Element("3DAXES(Y)_NAMETEXT");
       }
      }
      o.yAxis3D.nameTextStyle=new eTextStyle(); 
      o.yAxis3D.nameTextStyle.fontSize=12.0*sizeCoeff;
       if (chartPref.containsKey("3DAXES(Y)_NAMEFONTSIZE")){
      o.yAxis3D.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element("3DAXES(Y)_NAMEFONTSIZE"))*sizeCoeff;
      }
      o.yAxis3D.nameTextStyle.fontStyle="normal"; 
      if (chartPref.containsKey("3DAXES(Y)_NAMEFONTSTYLE")){
      o.yAxis3D.nameTextStyle.fontStyle=chartPref.Get_Element("3DAXES(Y)_NAMEFONTSTYLE");
      }
      o.yAxis3D.nameTextStyle.fontWeight="normal"; 
      if (chartPref.containsKey("3DAXES(Y)_NAMEFONTWEIGHT")){
      o.yAxis3D.nameTextStyle.fontWeight=chartPref.Get_Element("3DAXES(Y)_NAMEFONTWEIGHT");
      }
      o.yAxis3D.nameTextStyle.color="налл";
      if (chartPref.containsKey("3DAXES(Y)_NAMEFONTCOLOR")){
      o.yAxis3D.nameTextStyle.color=chartPref.Get_Element("3DAXES(Y)_NAMEFONTCOLOR");
      }
      o.yAxis3D.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Y)_NAMEGAP")){
      o.yAxis3D.nameGap=Double.valueOf(chartPref.Get_Element("3DAXES(Y)_NAMEGAP"))*sizeCoeff;
      }
      o.yAxis3D.axisLabel=new eAxisLabel();
      o.yAxis3D.axisLabel.interval="налл";
      if (chartPref.containsKey("3DAXES(Y)_LABELINTERVAL")){
      o.yAxis3D.axisLabel.interval=Integer.valueOf(chartPref.Get_Element("3DAXES(Y)_LABELINTERVAL"));
      }
      o.yAxis3D.axisLabel.show=true;
      if (chartPref.Get_Element("3DAXES(Y)_LABELSHOW").equals("N")){
      o.yAxis3D.axisLabel.show=false;
      }
      o.yAxis3D.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Y)_LABELFONTSIZE")){
      o.yAxis3D.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element("3DAXES(Y)_LABELFONTSIZE"))*sizeCoeff;
      }
      o.yAxis3D.axisLabel.fontStyle="normal";
      if (chartPref.containsKey("3DAXES(Y)_LABELFONTSTYLE")){
      o.yAxis3D.axisLabel.fontStyle=chartPref.Get_Element("3DAXES(Y)_LABELFONTSTYLE");
      }
      o.yAxis3D.axisLabel.fontWeight="normal";
      if (chartPref.containsKey("3DAXES(Y)_LABELFONTWEIGHT")){
      o.yAxis3D.axisLabel.fontWeight=chartPref.Get_Element("3DAXES(Y)_LABELFONTWEIGHT");
      }
      o.yAxis3D.axisLabel.color="налл";
      if (chartPref.containsKey("3DAXES(Y)_LABELFONTCOLOR")){
      o.yAxis3D.axisLabel.color=chartPref.Get_Element("3DAXES(Y)_LABELFONTCOLOR");
      }
      o.yAxis3D.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Y)_LABELMARGIN")){
      o.yAxis3D.axisLabel.margin=Double.valueOf(chartPref.Get_Element("3DAXES(Y)_LABELMARGIN"))*sizeCoeff;
      }
      o.yAxis3D.splitLine=new eSplitLine();
      o.yAxis3D.splitLine.show=true;
      if (chartPref.Get_Element("3DAXES(Y)_SPLITSHOW").equals("N")){
      o.yAxis3D.splitLine.show=false;
      }
      o.yAxis3D.splitLine.lineStyle=new elineStyle();
      o.yAxis3D.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey("3DAXES(Y)_SPLITCOLOR")){
      o.yAxis3D.splitLine.lineStyle.color=chartPref.Get_Element("3DAXES(Y)_SPLITCOLOR");
      }
      o.yAxis3D.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Y)_SPLITWIDTH")){
      o.yAxis3D.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element("3DAXES(Y)_SPLITWIDTH"))*sizeCoeff;
      }
      if (o.yAxis3D.splitLine.lineStyle.width<1.0)o.yAxis3D.splitLine.lineStyle.width=1.0;
      o.yAxis3D.axisLine=new eAxisLine();
      o.yAxis3D.axisLine.lineStyle=new elineStyle();
      o.yAxis3D.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey("3DAXES(Y)_COLOR"))o.yAxis3D.axisLine.lineStyle.color=chartPref.Get_Element("3DAXES(Y)_COLOR");
      o.yAxis3D.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Y)_WIDTH"))o.yAxis3D.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element("3DAXES(Y)_WIDTH"))*sizeCoeff;
      if (o.yAxis3D.axisLine.lineStyle.width<1.0)o.yAxis3D.axisLine.lineStyle.width=1.0;
      if (chartPref.Get_Element("3DAXES(Y)_SHOW").equals("N")){
      o.yAxis3D.axisLine.lineStyle.width=0.0;
      }
      
      o.zAxis3D=new eaxis();
      o.zAxis3D.type="value";
      o.zAxis3D.name="налл";
      o.zAxis3D.min="налл";
      if  (chartPref.containsKey("3DAXES(Z)_MIN")){
          Double minZ=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_MIN"));
          o.zAxis3D.min=minZ;
      }
      o.zAxis3D.max="налл";
      if  (chartPref.containsKey("3DAXES(Z)_MAX")){
          Double maxZ=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_MAX"));
          o.zAxis3D.max=maxZ;
      }
      o.zAxis3D.logBase="налл";
      if  (chartPref.containsKey("3DAXES(Z)_LOGBASE")){
          Double logBaze=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_LOGBASE"));
          o.zAxis3D.logBase=logBaze;
          o.zAxis3D.type="log";
      }
       if (chartPref.Get_Element("3DAXES(Z)_NAMESHOW").equals("Y")){
      o.zAxis3D.name=getAxisName("Z");
       if (chartPref.containsKey("3DAXES(Z)_NAMETEXT")){
           o.zAxis3D.name=chartPref.Get_Element("3DAXES(Z)_NAMETEXT");
       }
      }
      o.zAxis3D.nameTextStyle=new eTextStyle(); 
      o.zAxis3D.nameTextStyle.fontSize=12.0*sizeCoeff;
       if (chartPref.containsKey("3DAXES(Z)_NAMEFONTSIZE")){
      o.zAxis3D.nameTextStyle.fontSize=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_NAMEFONTSIZE"))*sizeCoeff;
      }
      o.zAxis3D.nameTextStyle.fontStyle="normal"; 
      if (chartPref.containsKey("3DAXES(Z)_NAMEFONTSTYLE")){
      o.zAxis3D.nameTextStyle.fontStyle=chartPref.Get_Element("3DAXES(Z)_NAMEFONTSTYLE");
      }
      o.zAxis3D.nameTextStyle.fontWeight="normal"; 
      if (chartPref.containsKey("3DAXES(Z)_NAMEFONTWEIGHT")){
      o.zAxis3D.nameTextStyle.fontWeight=chartPref.Get_Element("3DAXES(Z)_NAMEFONTWEIGHT");
      }
      o.zAxis3D.nameTextStyle.color="налл";
      if (chartPref.containsKey("3DAXES(Z)_NAMEFONTCOLOR")){
      o.zAxis3D.nameTextStyle.color=chartPref.Get_Element("3DAXES(Z)_NAMEFONTCOLOR");
      }
      o.zAxis3D.nameGap=15.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Z)_NAMEGAP")){
      o.zAxis3D.nameGap=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_NAMEGAP"))*sizeCoeff;
      }
      o.zAxis3D.axisLabel=new eAxisLabel();
      o.zAxis3D.axisLabel.show=true;
      if (chartPref.Get_Element("3DAXES(Z)_LABELSHOW").equals("N")){
      o.zAxis3D.axisLabel.show=false;
      }
      o.zAxis3D.axisLabel.fontSize=10.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Z)_LABELFONTSIZE")){
      o.zAxis3D.axisLabel.fontSize=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_LABELFONTSIZE"))*sizeCoeff;
      }
      o.zAxis3D.axisLabel.fontStyle="normal";
      if (chartPref.containsKey("3DAXES(Z)_LABELFONTSTYLE")){
      o.zAxis3D.axisLabel.fontStyle=chartPref.Get_Element("3DAXES(Z)_LABELFONTSTYLE");
      }
      o.zAxis3D.axisLabel.fontWeight="normal";
      if (chartPref.containsKey("3DAXES(Z)_LABELFONTWEIGHT")){
      o.zAxis3D.axisLabel.fontWeight=chartPref.Get_Element("3DAXES(Z)_LABELFONTWEIGHT");
      }
      o.zAxis3D.axisLabel.color="налл";
      if (chartPref.containsKey("3DAXES(Z)_LABELFONTCOLOR")){
      o.zAxis3D.axisLabel.color=chartPref.Get_Element("3DAXES(Z)_LABELFONTCOLOR");
      }
      o.zAxis3D.axisLabel.margin=8.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Z)_LABELMARGIN")){
      o.zAxis3D.axisLabel.margin=Integer.valueOf(chartPref.Get_Element("3DAXES(Z)_LABELMARGIN"))*sizeCoeff;
      }
      o.zAxis3D.splitLine=new eSplitLine();
      o.zAxis3D.splitLine.show=true;
      if (chartPref.Get_Element("3DAXES(Z)_SPLITSHOW").equals("N")){
      o.zAxis3D.splitLine.show=false;
      }
      o.zAxis3D.splitLine.lineStyle=new elineStyle();
      o.zAxis3D.splitLine.lineStyle.color="rgb(204, 204, 204)";
      if (chartPref.containsKey("3DAXES(Z)_SPLITCOLOR")){
      o.zAxis3D.splitLine.lineStyle.color=chartPref.Get_Element("3DAXES(Z)_SPLITCOLOR");
      }
      o.zAxis3D.splitLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Z)_SPLITWIDTH")){
      o.zAxis3D.splitLine.lineStyle.width=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_SPLITWIDTH"))*sizeCoeff;
      }
      if(o.zAxis3D.splitLine.lineStyle.width<1.0)o.zAxis3D.splitLine.lineStyle.width=1.0;
      o.zAxis3D.axisLine=new eAxisLine();
      o.zAxis3D.axisLine.lineStyle=new elineStyle();
      o.zAxis3D.axisLine.lineStyle.color="rgb(51, 51, 51)";
      if (chartPref.containsKey("3DAXES(Z)_COLOR"))o.zAxis3D.axisLine.lineStyle.color=chartPref.Get_Element("3DAXES(Z)_COLOR");
      o.zAxis3D.axisLine.lineStyle.width=1.0*sizeCoeff;
      if (chartPref.containsKey("3DAXES(Z)_WIDTH"))o.zAxis3D.axisLine.lineStyle.width=Double.valueOf(chartPref.Get_Element("3DAXES(Z)_WIDTH"))*sizeCoeff;
      if(o.zAxis3D.axisLine.lineStyle.width<1.0)o.zAxis3D.axisLine.lineStyle.width=1.0;
      if (chartPref.Get_Element("3DAXES(Z)_SHOW").equals("N")){
      o.zAxis3D.axisLine.lineStyle.width=0.0;
      }
    }
    if (xBoxAxis!=null){
        for(int i=0;i<xBoxAxis.size();i++)o.xAxis.add(xBoxAxis.get(i));
    }
    if (yBoxAxis!=null){
        for(int i=0;i<yBoxAxis.size();i++)o.yAxis.add(yBoxAxis.get(i));
    }
    /* попытка создавать серии после осей оказалась неудачной*/
    // makeSeries(o,reload,mlc); 
    /*Визуальный мап*/
    if (!chartType.equals("WHR") && (!reload.equals("z") || frm.getProperty("CHART_SIZE_TYPE").equals("WL")|| frm.getProperty("CHART_SIZE_TYPE").equals("WP"))){
    o.visualMap=new ArrayList<>();
    switch (chartType){
        case "MAP":
        
        evisualMap mm=new evisualMap();
//        mm.borderWidth=0;
        mm.textStyle=new eTextStyle();
        mm.textStyle.fontFamily="monospace"; //  длч лучшего отображения колоночек цифр при кусочном мапе
        mm.textStyle.fontSize=12.0*sizeCoeff;
        mm.calculable=true;
        mm.show=true;
        int si=Integer.valueOf(NVL(chartPref.get("CFG"),"0"));
        mm.type="continuous";
        mm.range="налл";
        mm.orient="vertical";
        if (chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_MODE").equals("P")) {
            if (chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_SHOW").equals("N")) mm.show=false;
            mm.type="piecewise";
            makeVMpieces(si,mlc,mm);
            mm.textStyle.fontSize=Double.valueOf(NVL(chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_FONTSIZE"),"12"))*sizeCoeff;
            mm.itemGap=10.0*sizeCoeff;
            mm.itemWidth=20.0*sizeCoeff;
            mm.itemHeight=14.0*sizeCoeff;
            mm.left="0%";
        if (chartPref.containsKey("MAPVMP("+String.valueOf(si+1)+")_LEFT"))
            mm.left=chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_LEFT")+"%";
        mm.top="10%";
        if (chartPref.containsKey("MAPVMP("+String.valueOf(si+1)+")_TOP"))
            mm.top=chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_TOP")+"%";
        } else {
            mm.itemHeight=Double.valueOf(NVL(chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_LENGTH"),"140"))*sizeCoeff;
            mm.itemWidth=20.0*sizeCoeff;
            if (chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_SHOW").equals("N")) mm.show=false;
            if (chartPref.containsKey("MAPVM("+String.valueOf(si+1)+")_ORIENT"))
            mm.orient=chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_ORIENT");
            mm.inRange=new einRange();
            //makeColorsArray4Map(si,series.get(0).itemStyle.myColor);
            mm.inRange.color=MAPVMcolorList;
            mm.left="0%";
        if (chartPref.containsKey("MAPVM("+String.valueOf(si+1)+")_LEFT"))
            mm.left=chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_LEFT")+"%";
        mm.top="10%";
        if (chartPref.containsKey("MAPVM("+String.valueOf(si+1)+")_TOP"))
            mm.top=chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_TOP")+"%";
        }
        mm.seriesIndex=0;
//        mm.orient="vertical";
        
        mm.dimension=seriesProps.get(si).Get_Element("name");
        if (dimsStats!=null && dimsStats.get(mm.dimension)!=null && dimsStats.get(mm.dimension).max!=null){
        mm.max=Double.valueOf(this.dimsStats.get(mm.dimension).max);
        mm.min=Double.valueOf(this.dimsStats.get(mm.dimension).min);
        if (Objects.equals(mm.max, mm.min)){
           if (mm.max>0) mm.min=0.0;
           else mm.max=0.0;
        }
        }
        mm.dimension=null;
        o.visualMap.add(mm);
         
        break;
        case "BAR3D":
        case "SCT3D":
        case "BAR":
        case "LINE":
        case "SCT":
        case "BARG":
        for (int i=0;i<seriesProps.size();i++){
          String curveID=String.valueOf(i+1);
          if (like(chartType,"%3D")) curveID="3DVM("+curveID+")_";
          else curveID="2DVM("+curveID+")_";
          String axmap=NVL(chartPref.Get_Element(curveID+"AXIS"),"N");
      //   if (!NVL(chartPref.Get_Element("3DVM("+curveID+")_AXIS"),"N").equals("N")){
           evisualMap vm=new evisualMap(); 
           vm.seriesIndex=i;
           vm.inRange=new einRange();
           if (series.get(i).itemStyle!=null && series.get(i).itemStyle.myColor!=null){
              ArrayList colorList2 =new ArrayList<>();
              colorList2.add(series.get(i).itemStyle.myColor);
            vm.inRange.color=colorList2;
           }
          
           if (axmap.equals("N")
               || chartPref.containsKey("Deselect_"+series.get(i).name)){
            vm.seriesIndex=-10-i;
            vm.show=false;
           }
               else{
               vm.textStyle=new eTextStyle();
               vm.textStyle.fontSize=10.0*sizeCoeff;   
              if ((series.get(i).type.equals("bar") || series.get(i).type.equals("scatter")) && 
                      chartPref.Get_Element("2DCURVE("+String.valueOf(i+1)+")_LIGHTSHOW").equals("Y")){
                  /*vm.inRange.color.clear();
                  vm.inRange.color.add(null);*/
                  vm.inRange.color=null;
                  vm.inRange.opacity=new ArrayList<>();  
                  
                  Double blight=1.0;
            if (chartPref.containsKey(curveID+"BLIGHT")){
               blight=Double.valueOf(chartPref.Get_Element(curveID+"BLIGHT"))/100.0;
            }
            Double elight=0.0;
            if (chartPref.containsKey(curveID+"ELIGHT")){
               elight=Double.valueOf(chartPref.Get_Element(curveID+"ELIGHT"))/100.0;
            }
            vm.inRange.opacity.add(elight);
            vm.inRange.opacity.add(blight);
            vm.controller=new evisualMapController();
            vm.controller.inRange=new einRange();
              ArrayList colorList3 =new ArrayList<>();
              colorList3.add(
              this.modifyColor4light(series.get(i).itemStyle.myColor,blight)        
              );
              colorList3.add(
              this.modifyColor4light(series.get(i).itemStyle.myColor,elight)        
              );
            vm.controller.inRange.color=colorList3;
              }
           else {
            vm.inRange.colorLightness=new ArrayList<>();    
            Double blight=1.0;
            if (chartPref.containsKey(curveID+"BLIGHT")){
               blight=Double.valueOf(chartPref.Get_Element(curveID+"BLIGHT"))/100.0;
            }
            Double elight=0.0;
            if (chartPref.containsKey(curveID+"ELIGHT")){
               elight=Double.valueOf(chartPref.Get_Element(curveID+"ELIGHT"))/100.0;
            }
            vm.inRange.colorLightness.add(blight);
            vm.inRange.colorLightness.add(elight);
            vm.controller=new evisualMapController();
            vm.controller.inRange=vm.inRange;
           }
                   }
           if (axmap.equals("Z") || axmap.equals("V")){
          vm.top=String.valueOf(i*20)+"%";
           if (chartPref.containsKey(curveID+"TOP")){
             vm.top=chartPref.Get_Element(curveID+"TOP")+"%";
           }
           vm.left="0%";
           if (chartPref.containsKey(curveID+"LEFT")){
             vm.left=chartPref.Get_Element(curveID+"LEFT")+"%";
           }
           vm.orient="vertical";
           if (chartPref.containsKey(curveID+"ORIENT")){
             vm.orient=chartPref.Get_Element(curveID+"ORIENT");
           }
           vm.itemHeight=Double.valueOf(NVL(chartPref.Get_Element(curveID+"LENGTH"),"70"))*sizeCoeff;
           vm.itemWidth=20.0*sizeCoeff;
           vm.calculable=true;
           
           
           vm.show=true;
           if (chartPref.Get_Element(curveID+"SHOW").equals("N") || chartPref.containsKey("Deselect_"+series.get(i).name)){
               vm.show=false;
           }
                
           vm.type="continuous";
           vm.range="налл";
           vm.dimension=seriesProps.get(i).Get_Element("name");
           if (dimsStats.get(vm.dimension).max!=null && dimsStats.get(vm.dimension).min!=null){
           vm.max=Double.valueOf(this.dimsStats.get(vm.dimension).max);
           vm.min=Double.valueOf(this.dimsStats.get(vm.dimension).min);
           
           }} 
           if (axmap.equals("X")||axmap.equals("Y")||axmap.equals("C")) {
               vm.type="piecewise";  
             vm.show=false;
             vm.splitNumber=2.0;
             int dim=0;
             if (axmap.equals("Y")){
                 dim=1;
             }
             vm.dimension=groupProps.get(dim).Get_Element("name");
             if (dimsStats!=null && dimsStats.get(groupProps.get(dim).Get_Element("name"))!=null
                     && dimsStats.get(groupProps.get(dim).Get_Element("name")).countDistinct!=null){
               vm.splitNumber=dimsStats.get(groupProps.get(dim).Get_Element("name")).countDistinct;  
             }
             if (dataset.dimensions.get(dim).type.equals("ordinal"))
             vm.max=vm.splitNumber-1.0;
             if (dataset.dimensions.get(dim).type.equals("time")){
             vm.type="continuous";}
             if (dataset.dimensions.get(dim).type.equals("number")){
               if (dimsStats.get(vm.dimension).max!=null && dimsStats.get(vm.dimension).min!=null){   
               vm.max=Double.valueOf(this.dimsStats.get(vm.dimension).max);
               vm.min=Double.valueOf(this.dimsStats.get(vm.dimension).min);
               }
             }
           }
           o.visualMap.add(vm);
         //}
           
    
        }    
        break;
    }
    }
    // загловки
    makeTitles(o,mlc,reload);
    // отключённые серии
     String deselected="";
     if (chartType.equals("PIE") || chartType.equals("WHR")){
       for (String key:chartPref.keySet()){
          if (like(key,"Deselect_%")){
              if (is_not_null(deselected))deselected=deselected+",";
              deselected=deselected+app.toJSON(key.substring(9))+":false";
          }
       }  
     }else{
     for (int i=0;i<series.size();i++){
         if (this.chartPref.containsKey("Deselect_"+series.get(i).name)){
           if (is_not_null(deselected))deselected=deselected+",";
           deselected=deselected+app.toJSON(series.get(i).name)+":false";
         }
     }
     }
     deselected="{"+deselected+"}";
     if (series.size()>3 && bigData && is2dScatter)o.tooltip.axisPointer.type="none"; // если данных много и есть 2D-скатерть, то даже 5-й echarts сбоит на указетеле осевого тултипа гася точки скатерти поэтому установим указатель в none
     //if (deselected.equals("{}"))deselected="null";
     return app.toJSON(o).replace("\"налл\"","null").replace("\"$deselected series$\"", deselected);
    
    }
                finally{
        if (mlc!=null){
            app.metaConnPool.SetFree(mlc);
        }
    }
   
  }
  public ArrayList<ArrayList<String>> makeBoxData(int pSi) {
      
      ArrayList<ArrayList<String>> boxSctData;
      boxSctData = new ArrayList<ArrayList<String>>();
      ArrayList<String> boxdata =new ArrayList<>();
      ArrayList<String> sctdata =new ArrayList<>();
      ArrayList<String> sctnamesdata = new ArrayList<>();
      double[] sourcedata= new double[dataset.source.size()];
      Double v;
      
      
      for (int i=0;i<dataset.source.size();i++){
          if (dataset.source.get(i).get(1+pSi)==null)continue;
          if (dataset.source.get(i).get(1+pSi).equals(""))continue;
          v=Double.valueOf(String.valueOf(dataset.source.get(i).get(1+pSi)));
          sourcedata[i]=v;
      }
      int q1=25;
      if (chartPref.containsKey("BOX("+String.valueOf(pSi+1)+")_Q1"))
          q1=Integer.valueOf(chartPref.get("BOX("+String.valueOf(pSi+1)+")_Q1"));
      int q3=75;
      if (chartPref.containsKey("BOX("+String.valueOf(pSi+1)+")_Q3"))
          q3=Integer.valueOf(chartPref.get("BOX("+String.valueOf(pSi+1)+")_Q3"));
      int min=9;
      if (chartPref.containsKey("BOX("+String.valueOf(pSi+1)+")_MIN"))
          min=Integer.valueOf(chartPref.get("BOX("+String.valueOf(pSi+1)+")_MIN"));
      int max=91;
      if (chartPref.containsKey("BOX("+String.valueOf(pSi+1)+")_MAX"))
          max=Integer.valueOf(chartPref.get("BOX("+String.valueOf(pSi+1)+")_MAX"));
      String method="F";
      double k=1.5;
      if (chartPref.containsKey("BOX("+String.valueOf(pSi+1)+")_K"))
          k=Double.valueOf(chartPref.get("BOX("+String.valueOf(pSi+1)+")_K"));
      
      if (chartPref.containsKey("BOX("+String.valueOf(pSi+1)+")_M"))
          method=chartPref.get("BOX("+String.valueOf(pSi+1)+")_M");
      
      DescriptiveStatistics stats = new DescriptiveStatistics(sourcedata);
      String EM=NVL(chartPref.get("BOX("+String.valueOf(pSi+1)+")_EM"),"L");
      switch (EM){
          case "L":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.LEGACY));
          break;
          case "R1":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_1));
          break;
          case "R2":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_2));
          break;
          case "R3":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_3));
          break;
          case "R4":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_4));
          break;
          case "R5":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_5));
          break;
          case "R6":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_6));
          break;
          case "R7":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_7));
          break;
          case "R8":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_8));
          break;
          case "R9":
          stats.setPercentileImpl(new Percentile().withEstimationType(Percentile.EstimationType.R_9));
          break;
      }
      
      //https://en.wikipedia.org/wiki/Quantile
      //file:///D:/my-java/commons-math3-3.6.1-bin/commons-math3-3.6.1/docs/apidocs/index.html
      Double Q1=stats.getPercentile(q1);
      Double Q3=stats.getPercentile(q3);
      if (method.equals("P"))  boxdata.add(String.valueOf(stats.getPercentile(min)));
      else {boxdata.add(String.valueOf(Q1-k*(Q3-Q1)));}
      boxdata.add(String.valueOf(stats.getPercentile(q1)));
      boxdata.add(String.valueOf(stats.getPercentile(50)));
      boxdata.add(String.valueOf(stats.getPercentile(q3)));
       
      if (method.equals("P"))  boxdata.add(String.valueOf(stats.getPercentile(max)));
      else{boxdata.add(String.valueOf(Q3+k*(Q3-Q1)));}
      if (NVL(chartPref.get("BOX("+String.valueOf(pSi+1)+")_FM"),"Y").equals("Y")){
        double l=Double.valueOf(boxdata.get(0));
        double r=Double.valueOf(boxdata.get(4));
        Double mi=null;
        Double ma=null;
        for (int i=0;i<sourcedata.length;i++){
        if (sourcedata[i]<l ||sourcedata[i]>r)continue;
        if (mi==null || mi>sourcedata[i])mi=sourcedata[i];
        if (ma==null || ma<sourcedata[i])ma=sourcedata[i];
        }
       ArrayList<String> nboxdata=new ArrayList<>();
       if (mi!=null)
       nboxdata.add(String.valueOf(mi));
       else nboxdata.add(boxdata.get(0));
       nboxdata.add(boxdata.get(1));
       nboxdata.add(boxdata.get(2));
       nboxdata.add(boxdata.get(3));
       if(ma!=null)nboxdata.add(String.valueOf(ma));
       else nboxdata.add(boxdata.get(4));
       boxdata=nboxdata;
      }
      boxSctData.add(boxdata);
      for (int i=0;i<sourcedata.length;i++){
         if (sourcedata[i]<Double.valueOf(boxdata.get(0)) ||sourcedata[i]>Double.valueOf(boxdata.get(4))) sctdata.add(String.valueOf(sourcedata[i]));
      }
      boxSctData.add(sctdata);
      for (int i=0;i<sctdata.size();i++){
        String names="";
        for (int j=0;j<dataset.source.size();j++){
          if (dataset.source.get(j).get(1+pSi)==null)continue;
          String vs=String.valueOf(dataset.source.get(j).get(1+pSi));
            if (vs.equals(sctdata.get(i))){
            if (names!="")names=names+", ";
            names=names+dataset.source.get(j).get(0).toString();
          }
          
      }
      sctnamesdata.add(names);
      }
      boxSctData.add(sctnamesdata);
      return boxSctData;
  }
  /**
   * Вычисление названия региона по id кликнутого title
   * @param pid
   * @return 
   */
@SuppressWarnings("unchecked")
  public String getRegionName4TitleId(String pid){
     String rc="";
     if (is_not_null(pid)){
     int id=Integer.valueOf(pid);
     if (series!=null){
     Integer di=titles.get(id).di;
     if (di!=null){
     @SuppressWarnings("unchecked")
     ArrayList<eMapData> MapData;
         MapData = (ArrayList<eMapData>) series.get(0).data;
     if (di<MapData.size())rc=MapData.get(di).name;
     }
     }}
     return rc;
  }
/**
 * Изготовление заголовков, легенды карты и контрола для режима настройки названий
 * всё это - etitlte'ы
 * @param o
 * @param mlc
 * @param reload
 * @throws SQLException
 * @throws LuiException 
 */  
private void makeTitles(option o,LuiDbConn mlc,String reload) throws SQLException, LuiException{
    etitle ttit=new etitle();
    ttit.show=true;
    int si=0;
    try{
    si=Integer.valueOf(NVL(chartPref.get("CFG"),"0"));
    } catch (Exception ex){si=0;}
    String titleWin="TITLE2(1)_";
    String titleTop="TITLE0(1)_";
    String titleBot="TITLE1(1)_";
    String wtext="";
    if (chartType.equals("PIE") || chartType.equals("MAP")|| chartType.equals("WHR")){
          titleWin="TITLE2()_";
     titleTop="TITLE0()_";
     titleBot="TITLE1()_";
        String ci=String.valueOf(si+1);
        for (String kp:chartPref.keySet()){
            if (like(kp,"TITLE0("+ci+")_%"))titleTop="TITLE0("+ci+")_";
            if (like(kp,"TITLE1("+ci+")_%"))titleBot="TITLE1("+ci+")_";
            if (like(kp,"TITLE2("+ci+")_%"))titleWin="TITLE2("+ci+")_";
        }
    }
    
    
    
     
    //заголовок окна
    
    /*if (app.NLS.currentLang.code.equals("RUS")) {
        wtext="{У}";
    }
    else{
        wtext="{W}";
    }*/
    wtext=app.NLS.NLS("RUS:{H:Отбор в предшествующих диаграммах};ENG:{H:Selection in parent charts};");
    if (chartPref.containsKey(titleWin+"TEXT")){
      wtext=chartPref.Get_Element(titleWin+"TEXT");  
    }    
    wtext=this.parseTitle(wtext,mlc);
    frm.addProperty("HEADER",wtext);frm.properties.get("HEADER").clearCompVal();
    LuiClCommandGroup XMLcg;
 LuiClCommand XMLcmd = null;
 
    XMLcg=app.commandWriter.addGroup("ChartTitle "+frm.getFormID());
    XMLcg.addParameter("FormID",frm.getFormID());
    XMLcmd=XMLcg.addCommand("Form");
    XMLcmd.addScaPar("Title",frm.getFormTtle());
    // текст вверу диаграммы
    /*if (app.NLS.currentLang.code.equals("RUS")) {
        if (chartType.equals("PIE") || chartType.equals("MAP")) ttit.text="{П}/{К}\n{У}\nВсего: {И}";        
        else ttit.text="{У}";
    }
    else{
        if (chartType.equals("PIE") || chartType.equals("MAP")) ttit.text="{V}/{C}\n{W}\nTotal: {T}";        
        else ttit.text="{W}";
    } */
    ttit.text=app.NLS.NLS("RUS:{H:Отбор в предшествующих диаграммах};ENG:{H:Selection in parent charts};");
    if  (chartType.equals("PIE") || chartType.equals("MAP")|| chartType.equals("WHR")) {
        ttit.text=app.NLS.NLS("RUS:{H:Название показателя};ENG:{H:Indicator name};");
    }
    
    
            //this.ChartTitle;
    ttit.textStyle=new eTextStyle();
    ttit.textStyle.fontSize=12.0*sizeCoeff;
    ttit.top="0%";
    ttit.right="0%";
    ttit.left="налл"; 
    ttit.triggerEvent=true;
    //ttit.textStyle=new eTextStyle();
    ttit.textStyle.fontStyle="normal";
    ttit.textStyle.fontWeight="bold";
    ttit.textStyle.color="rgb(51, 51, 51)";
    if (chartPref.containsKey(titleTop+"TOP")){
      ttit.top=chartPref.Get_Element(titleTop+"TOP")+"%";  
    }
    if (chartPref.containsKey(titleTop+"RIGHT")){
      ttit.right=chartPref.Get_Element(titleTop+"RIGHT")+"%";  
    }
    if (chartPref.containsKey(titleTop+"FONTSIZE")){
      ttit.textStyle.fontSize=Double.valueOf(chartPref.Get_Element(titleTop+"FONTSIZE"))*sizeCoeff;  
    }
    if (chartPref.containsKey(titleTop+"FONTSTYLE")){
      ttit.textStyle.fontStyle=chartPref.Get_Element(titleTop+"FONTSTYLE");  
    }
    if (chartPref.containsKey(titleTop+"FONTWEIGHT")){
      ttit.textStyle.fontWeight=chartPref.Get_Element(titleTop+"FONTWEIGHT");  
    }
    if (chartPref.containsKey(titleTop+"FONTCOLOR")){
      ttit.textStyle.color=chartPref.Get_Element(titleTop+"FONTCOLOR");  
    }
    ttit.textStyle.lineHeight=ttit.textStyle.fontSize;
    if (chartPref.containsKey(titleTop+"LINESPACING")){
     Double ls=Double.valueOf(chartPref.get(titleTop+"LINESPACING"))*sizeCoeff;
     ttit.textStyle.lineHeight=ttit.textStyle.lineHeight+ls;
     if (is_not_null(this.frm.getProperty("ChartHeight"))){
     // тут надо вычислить на сколько %% надо поднять заголовок вверх
     Double ch=Double.valueOf(this.frm.getProperty("ChartHeight"))/100.0;// высота диаграммы в пикселях поделенная на 100 = вес в пикселях одного процента
     ch=ls/ch; 
     ttit.top=String.valueOf(Double.valueOf(ttit.top.replace("%",""))-ch/2)+"%";
     //ttit.top=String.valueOf(0-ls/2);
    }
    }
    if (chartPref.containsKey(titleTop+"TEXT")){
      ttit.text=chartPref.Get_Element(titleTop+"TEXT");  
    }
    ttit.textAlign="auto";
    if (chartPref.containsKey(titleTop+"ALIGN")){
      ttit.textAlign=chartPref.Get_Element(titleTop+"ALIGN");  
      if (ttit.textAlign.equals("right")||ttit.textAlign.equals("center")) {
        
        int left=100-Integer.valueOf(ttit.right.toString().replace("%",""))-1;
        ttit.left=String.valueOf(left)+"%";
        ttit.right="налл";
    }
    }    
    ttit.text=this.parseTitle(ttit.text,mlc);
    
    titles=new ArrayList<>();
    titles.add(ttit);
  // текст в левом нихнем углу
    etitle btit=new etitle();
    btit.show=true;
    btit.bottom="0%";
    if (chartPref.containsKey(titleBot+"BOTTOM")){
      btit.bottom=chartPref.Get_Element(titleBot+"BOTTOM")+"%";  
    }
    btit.left="0%";
    if (chartPref.containsKey(titleBot+"LEFT")){
      btit.left=chartPref.Get_Element(titleBot+"LEFT")+"%";  
    }
    btit.textStyle=new eTextStyle();
    btit.textStyle.fontSize=8.0*sizeCoeff;
    if (chartPref.containsKey(titleBot+"FONTSIZE")){
      btit.textStyle.fontSize=Double.valueOf(chartPref.Get_Element(titleBot+"FONTSIZE"))*sizeCoeff;  
    }
    btit.textStyle.fontStyle="normal";
    if (chartPref.containsKey(titleBot+"FONTSTYLE")){
      btit.textStyle.fontStyle=chartPref.Get_Element(titleBot+"FONTSTYLE");  
    }
    btit.textStyle.fontWeight="normal";
    if (chartPref.containsKey(titleBot+"FONTWEIGHT")){
      btit.textStyle.fontWeight=chartPref.Get_Element(titleBot+"FONTWEIGHT");  
    }
    btit.textStyle.color="rgb(51, 51, 51)";
    if (chartPref.containsKey(titleBot+"FONTCOLOR")){
      btit.textStyle.color=chartPref.Get_Element(titleBot+"FONTCOLOR");  
    }
    
    btit.triggerEvent=true;
    if (app.NLS.currentLang.code.equals("RUS")){
       // btit.text="{H:Г}-{H:М}-{H:Д} {H:ч}:{H:м}";
       btit.text="";
    } else {
       // btit.text="{H:Y}-{H:M}-{H:D} {H:h}:{H:m}";
       btit.text="";
    }
    if (chartPref.containsKey(titleBot+"TEXT")){
      btit.text=chartPref.Get_Element(titleBot+"TEXT");  
    }  
    btit.textAlign="auto";
    if (chartPref.containsKey(titleTop+"ALIGN")){
      btit.textAlign=chartPref.Get_Element(titleTop+"ALIGN");  
    }
    btit.text=this.parseTitle(btit.text,mlc);
    titles.add(btit);
    if (chartType.equals("PIE")||chartType.equals("WHR"))
    this.addPieModeTitle(titles);
    if (chartType.equals("MAP")){
    this.addLabelTuneTitles(titles);
    
    if (mapLegend!=null && mapLegend.size()>0 
                && (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("L")||excSignShow)
                && !chartPref.Get_Element("MAP_LEGEND_SHOW").equals("N")){
                     if (chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_MODE").equals("P")) {
                   if (NVL(chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_ADAPTIVE"),"Y").equals("Y")){
                       for (int i=0;i<mapLegend.size();i++){
                           if (mapLegend.get(i).value==null)continue;
                           mapLegend.get(i).color=this.getColor4valueVMP(mapLegend.get(i).value, si);
                       }
                   } 
               }

            this.makeMapLabelLegend(titles, mlc,seriesProps.get(si).Get_Element("format"),o);
        }  else {
            for (int i=0;i<app.gMap.maps.get(mapCode).GEOJSON.features.size();i++){
                etitle letn=new etitle();
                letn.show=false;
                titles.add(letn);
            }
        } 
    }
o.title=titles;
}
@SuppressWarnings("unchecked")
public String fireRegion() throws LuiException, SQLException{
    option o=new option();
    String rs=frm.getProperty("REGION_SELECTED");
    if (oldRegionSelected.equals(rs))return app.toJSON(o);  
    
    int si=Integer.valueOf(NVL(chartPref.get("CFG"),"0"));// id показателя
    /* // делаем данные для карты
    o.series=new ArrayList<>();
    eserie s=new eserie();
    this.makeMapData(si, s);*/
    o.series=series;
    ArrayList<eMapData> MapData;
    MapData = (ArrayList<eMapData>) o.series.get(0).data;
    Integer di;
    int r;
    // для начала надо погасить горящий сейчас регион
    if (is_not_null(oldRegionSelected)) {
        // r=номер заголовка
        r=Integer.valueOf(oldRegionSelected);
        // вынимаем id данных карты из заголовка
        di=titles.get(r).di;
        if (di!=null && di<MapData.size()) MapData.get(di).selected=false;
        oldRegionSelected="";
    } 
    // а потом поджеч новый если надо  
    if (is_not_null(rs)) {
        // r=номер заголовка
        r=Integer.valueOf(rs);
        // вынимаем id данных карты из заголовка
        di=titles.get(r).di;
        if (di!=null && di<MapData.size()) MapData.get(di).selected=true;
        oldRegionSelected=rs;
    }
    return app.toJSON(o).replace("\"налл\"","null");
}
  /**
   * Генерация дефолтного набора цветов для неприрывной раскраски карты
   * @param si
   * @return
   * @throws ScriptException 
   */
  public String getDefColor4VM(int si) throws ScriptException{
      String rc="";
      int ci;
      ci=si;
          while (ci>=colors.size()){ci=ci-colors.size();}
      String firstColor=colors.get(ci);
      firstColor=NVL(firstColor,"rgb(58,112,163)");
      String lastColor="rgb(255,255,255)";
      String[] crows=defcolors.split("\n");
      ci=0;
      for (int r=0;r<crows.length;r++){
         if (!rc.equals("")) rc=rc+"\n";
          String[] ccols=crows[r].split(";");
          for (int c=0;c<ccols.length;c++){
              if (ci==0) rc=firstColor+";";
              else {
                 if (ci==colors.size()-1) 
                 {
                     rc=rc+lastColor+';';
                 }
                 else rc=rc+";";
              }
          ci++;    
          }
          
      }
      
      return rc;
  }
public String getRegionLabelAttr(String region) throws LuiException, SQLException{
    LuiCollection col=new LuiCollection("");
    col.Add_Element("S",frm.getProperty("MapScale"));
    col.Add_Element("F",frm.getProperty("CurrentLabelSize"));
    col.Add_Element("X","0");
    col.Add_Element("Y","0");
    if (chartPref.containsKey("MAP_LABEL("+region+")")) { 
           col=new LuiCollection(chartPref.Get_Element("MAP_LABEL("+region+")"));
       } else {
        if (app.gMap.maps.get(mapCode).labels!=null && app.gMap.maps.get(mapCode).labels.containsKey(region)) {
               col=app.gMap.maps.get(mapCode).labels.get(region);
           }
    }
    if (!col.containsKey("X"))col.Add_Element("X","0");
    if (!col.containsKey("Y"))col.Add_Element("Y","0");
    if (!col.containsKey("R"))col.Add_Element("R","1");
    return col.toString();
}  
/**
 * Изготовление метки для региона
 * @param show
 * @param emd
 * @param sign
 * @throws LuiException
 * @throws SQLException 
 * Возвращает путую стороку если принято решение не выводить метку и не пустую если выводить
 */
private boolean makeMapRegionLabel(eserie serie,eMapData emd,String sign) throws LuiException, SQLException{
   String safeSign=sign;
   int offsetC=1;
   emd.label=new elabel(); 
   /*emd.label.show=false;
   emd.label.formatter=null;
   emd.label.fontSize=0.0;*/
   emd.label.show=serie.label.show;
   emd.label.fontSize=serie.label.fontSize;
   emd.label.fontStyle=serie.label.fontStyle;
   emd.label.fontWeight=serie.label.fontWeight;
   emd.label.color=  serie.label.color;
   emd.label.formatter=serie.label.formatter;
   if (emd.value==null || "".equals(emd.value))emd.label.formatter=emd.label.formatter.replace("{c}","");
   //if (emd.value.equals(""))emd.label.formatter=emd.label.formatter.replace("{c}","");
   boolean rc=false;
    if (serie.label.show){
       LuiCollection col=null;
       if (chartPref.containsKey("MAP_LABEL("+emd.name+")")) { 
           col=new LuiCollection(chartPref.Get_Element("MAP_LABEL("+emd.name+")"));
       } else {
           if (app.gMap.maps.get(mapCode).labels!=null && app.gMap.maps.get(mapCode).labels.containsKey(emd.name)) {
               col=app.gMap.maps.get(mapCode).labels.get(emd.name);
           }
       }
       
       if (col!=null) {
           String Show=col.Get_Element("D");
           if (!Show.equals("L")){ // если не требуется отображать условные обозначения
           if (Show.equals("N") || // отображать названия 
                   Show.equals("YND") || // отображать названия без данных
                   NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("Y") // или показывать названия уровня карты
               ||  NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("YND") // или название без данных уровня карты
                   )sign=""; // отключаем условное обозначение
           if (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("YND")) rc=true;// потребуется отображение легенды
           if (Show.equals("YND")){
           emd.label.formatter="{b}"; 
           rc=true;
           }
           } else {
               if (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("Y")) rc=true; // потребуется отображение легенды
           }
           //if (Show.equals("L") || !chartPref.Get_Element("MAP_LABELSHOW").equals("N"))sign=emd.name;
           Double storedScale=Double.valueOf(col.Get_Element("S"));
           Double storedFont=Double.valueOf(col.Get_Element("F"));
           Double currentScale=Double.valueOf(Math.round(Double.valueOf(frm.getProperty("MapScale"))*100.0)/100.0);
           Double coeff=1.0;
           Double coeffW=1.0;
           Double coeffH=1.0;
           if (is_not_null(col.Get_Element("H")) && is_not_null(col.Get_Element("W")) && is_not_null(frm.getProperty("ChartWidth")) && 
                   is_not_null(frm.getProperty("ChartHeight"))){
           Double currentWidth=Double.valueOf(frm.getProperty("ChartWidth"));
           Double currentHeight=Double.valueOf(frm.getProperty("ChartHeight"));
           Double storedWidth=Double.valueOf(col.Get_Element("W"));
           Double storedHeight=Double.valueOf(col.Get_Element("H"));
           // вписывется ли исходный прямоугольник в новый?
           //if (storedWidth<=currentWidth && storedHeight<=currentHeight){ //если вписывается
               
           //} else { // если не вписывается, то 
             //  if (storedWidth>currentWidth){ // если не вписывается по ширине
                   // вычислим коэффициент уменьшения по ширине
                   coeffW=currentWidth/storedWidth;
               //}
               //if (storedHeight>currentHeight){ // если не вписывается по высоте
                   // вычислим коэффициент уменьшения по ширине
                   coeffH=currentHeight/storedHeight;
              // }
               coeff=Math.min(coeffW, coeffH);
              // coeff=coeffH;
               //coeff=1.0;
          // }
          /* Double storedD=Math.sqrt(storedWidth*storedWidth+storedHeight*storedHeight);
           Double sin=storedWidth/storedD;
           Double currentD=currentWidth/sin;
           coeff=currentD/storedD;*/
           //coeff=Math.min(currentWidth,currentHeight)/Math.min(storedWidth,storedHeight); неудачная формула
           currentScale=coeff*currentScale;
           }
           //if (currentScale>=storedScale) {
                        //Long di=Math.round(storedFont*currentScale/storedScale);
                        //emd.label.fontSize=Integer.valueOf(di.toString());
                        emd.label.fontSize=Math.max(0,storedFont*currentScale/storedScale);
                        if (is_not_null(safeSign) && (Show.equals("N")||Show.equals("YND")) && emd.label.fontSize<storedFont){ 
                        // 26.08.2021 это попытка быстро прикрутить автомат перехода с названий на метки при уменьшенн масщтаба
                        // Т.е. если задано отображение названия и шрифт уменьшился то переходим на отображение метки
                        // при этом шрифт увеличивем в два раза и делеим смещения тоже на два
                            sign=safeSign;emd.label.fontSize=emd.label.fontSize*2;offsetC=2;
                            // ваще-то бред сивой кобылы причём старой и выжевшей из ума
                        }
           
             //       }
           
              if (emd.label.fontSize>0){emd.label.show=true;
              if (is_not_null(sign))emd.label.formatter=sign;
              int rows=1;
              if ((Show.equals("N")||Show.equals("YND")) && sign.equals("")){
                rows=Integer.valueOf(NVL(col.Get_Element("R"),"1"));
                if (rows>1){
                emd.label.formatter=emd.name;
                if (emd.value!=null && !emd.value.equals("") && Show.equals("N"))emd.label.formatter=emd.label.formatter+": "+emd.value.toString();
                }
              }
              String[] wArray=emd.label.formatter.split(" ", rows);
              boolean splitted=false;
               if (col.containsKey("X") || col.containsKey("Y") /*|| emd.value.equals("")*/){
                       int offsetX=Integer.valueOf(NVL(col.Get_Element("X"),"0"))/offsetC;
                       int offsetY=Integer.valueOf(NVL(col.Get_Element("Y"),"0"))/offsetC;
                       if (coeff+coeff/2<1)offsetX=(int)(Double.valueOf(offsetX)/(coeff+coeff/2));
                       if (coeff+coeff/2<1)offsetY=(int)(Double.valueOf(offsetY)/(coeff+coeff/2));
                if (offsetY!=0 || offsetX!=0 /*|| emd.value.equals("")*/){       
                   //emd.label.formatter="{b}: {c}";
                   //if (emd.value.equals(""))emd.label.formatter="{b}:";
                  //// if (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("YND"))emd.label.formatter="{b}";
                   //if (Show.equals("YND"))emd.label.formatter="{b}";
                   //if (is_not_null(sign))emd.label.formatter=sign;
                   if (offsetX!=0){
                       emd.label.formatter="";
                       if (offsetX>0) {
                           for(int wai=0;wai<wArray.length;wai++){
                               String w=wArray[wai];
                               if (is_not_null(w)){
                                   w=LuiString.Ladd(w,' ',100+offsetX);
                                   w=LuiString.Radd(w,' ',100-offsetX);
                                   w=w+"\n";
                                   emd.label.formatter=emd.label.formatter+w;
                               }
                           }
                           splitted=true;
                           //emd.label.formatter=LuiString.Ladd(emd.label.formatter,' ',100+offsetX);
                           //emd.label.formatter=LuiString.Radd(emd.label.formatter,' ',100-offsetX);
                           } else {
                           offsetX=0-offsetX;
                           for(int wai=0;wai<wArray.length;wai++){
                               String w=wArray[wai];
                               if (is_not_null(w)){
                                   w=LuiString.Ladd(w,' ',100-offsetX);
                                   w=LuiString.Radd(w,' ',100+offsetX);
                                   w=w+"\n";
                                   emd.label.formatter=emd.label.formatter+w;
                               }
                           }
                           splitted=true;
                           //emd.label.formatter=LuiString.Ladd(emd.label.formatter,' ',100-offsetX);
                           //emd.label.formatter=LuiString.Radd(emd.label.formatter,' ',100+offsetX);
                                  }   
                   }
                   if (offsetY!=0){
                       if (rows>1 && !splitted) {
                   emd.label.formatter="";
                   for(int wai=0;wai<wArray.length;wai++){
                               String w=wArray[wai];
                               if (is_not_null(w)){
                                   w=w+"\n";
                                   emd.label.formatter=emd.label.formatter+w;
                               }
                           }
                     splitted=true;}
                       if (offsetY>0) {
                       for (int i=0;i<offsetY;i++) emd.label.formatter=emd.label.formatter+"\n";
                           } else {
                           for (int i=offsetY;i<0;i++) emd.label.formatter="\n"+emd.label.formatter;
                       }   
                   }
               }}
               if (rows>1 ) {
                   if (!splitted){
                   emd.label.formatter="";
                   for(int wai=0;wai<wArray.length;wai++){
                               String w=wArray[wai];
                               if (is_not_null(w)){
                                   w=w+"\n";
                                   emd.label.formatter=emd.label.formatter+w;
                               }
                           }
                   }
                   if (!NVL(col.Get_Element("A"),"C").equals("C")){
                   emd.label.formatter="{a|"+emd.label.formatter+"}";
                   emd.label.rich=new erich();
                   emd.label.rich.a=new eTextStyle();
                   emd.label.rich.a.fontSize=emd.label.fontSize;
                   if (NVL(col.Get_Element("A"),"C").equals("R"))
                   emd.label.rich.a.align="right";
                   else 
                   emd.label.rich.a.align="left";
                   }
               }
              }
              else {emd.label.fontSize=null;emd.label.formatter=null;}
       }
    }
    return rc;
}
  
@SuppressWarnings("unchecked")
  public void makeSeries(option o,String pReload,LuiDbConn mlc) throws LuiException, SQLException {
      series=new ArrayList<>();
      eencode sencode;
      // изготовление двух серий для BOX и BOXG
      int si=0;
      int ci;
      if (chartType.equals("BOX")||chartType.equals("BOXG")){ // если ящик
      if (xBoxAxis!=null)xBoxAxis.clear();
      if (yBoxAxis!=null)yBoxAxis.clear();
      PreparedStatement stmt4format=null;    
      try  {
      String format=seriesProps.get(si).Get_Element("format");
      String select4format="";
      if (is_null(format)){ format="FM999G999G999G999G990.00";}
      if (is_null(format)){ 
          if (mlc.getDBvendor().equals("ORA")) select4format="select to_char(?)"; 
          if (mlc.getDBvendor().equals("PG")) select4format="select ?::text";
      }
      else select4format="select to_char(?,'"+format+"')";
      if (mlc.getDBvendor().equals("ORA")) select4format=select4format+" from dual";
      stmt4format=mlc.getConnection().prepareStatement(select4format);
          ArrayList<ArrayList<String>> data;
          ArrayList<ArrayList<String>> boxdata;
          ArrayList<String> box;
          
          for (int i=0;i<colsinfo.size();i++){
          if (!like(colsinfo.get(i).alias,"SF%"))continue;
          eaxis ax=new eaxis();
          ax.show=false;
          ax.axisLabel=new eAxisLabel();
          ax.axisLabel.show=false;
          ax.position="bottom";
          
          if (chartType.equals("BOXG"))ax.position="left";
          ax.type="category";
          
          ax.data=new ArrayList<>();
          for (int j=0;j<seriesProps.size();j++){
             
             ax.data.add(seriesProps.get(j).Get_Element("name"));
          }   
          if (chartType.equals("BOX")) {
            if (xBoxAxis==null)xBoxAxis=new ArrayList<>();
            xBoxAxis.add(ax);
          } else {
            if (yBoxAxis==null)yBoxAxis=new ArrayList<>();  
            yBoxAxis.add(ax);
          }
          eserie boxserie = new eserie();
          boxserie.type="boxplot";
          // для каждой кривой по 2-е серии- ящик и скатерть
          data=this.makeBoxData(si);//два массова
           boxdata=new ArrayList<>(); // каждая серия это набор ящиков среди которых только один не пустой
            for (int j=0;j<seriesProps.size();j++){
              if (j==si)box=data.get(0);
              else box=new ArrayList<>();
              boxdata.add(box);
            }
            box=data.get(0);
            boxserie.data=boxdata;
            boxserie.name=seriesProps.get(si).Get_Element("name");
            boxserie.itemStyle=new eitemStyle();
            boxserie.itemStyle.borderColor=o.color.get(si);
            boxserie.itemStyle.borderWidth=1.0*sizeCoeff;
            String prefix="BOX("+String.valueOf(si+1)+")_";
            if (chartPref.containsKey(prefix+"BORDERCOLOR")) {
                boxserie.itemStyle.borderColor=chartPref.Get_Element(prefix+"BORDERCOLOR");
            }
            if (chartPref.containsKey(prefix+"BORDERWIDTH")) {
                boxserie.itemStyle.borderWidth=Double.valueOf(chartPref.Get_Element(prefix+"BORDERWIDTH"))*sizeCoeff;
            }
            if(boxserie.itemStyle.borderWidth<1.0)boxserie.itemStyle.borderWidth=1.0;
            boxserie.tooltip=new etooltip();
              stmt4format.setDouble(1,Double.valueOf(box.get(4)));stmt4format.execute();stmt4format.getResultSet().next();
              String max=stmt4format.getResultSet().getString(1);stmt4format.getResultSet().close();
              stmt4format.setDouble(1,Double.valueOf(box.get(3)));stmt4format.execute();stmt4format.getResultSet().next();
              String q3=stmt4format.getResultSet().getString(1);stmt4format.getResultSet().close();
              stmt4format.setDouble(1,Double.valueOf(box.get(2)));stmt4format.execute();stmt4format.getResultSet().next();
              String median=stmt4format.getResultSet().getString(1);stmt4format.getResultSet().close();
              stmt4format.setDouble(1,Double.valueOf(box.get(1)));stmt4format.execute();stmt4format.getResultSet().next();
              String q1=stmt4format.getResultSet().getString(1);stmt4format.getResultSet().close();
              stmt4format.setDouble(1,Double.valueOf(box.get(0)));stmt4format.execute();stmt4format.getResultSet().next();
              String min=stmt4format.getResultSet().getString(1);stmt4format.getResultSet().close();
            boxserie.tooltip.formatter="{b}:<br>max: "
                                +max
                                +"<br>Q3: "+q3
                                +"<br>Median: "+median
                                +"<br>Q1: "+q1
                                +"<br>min: "+min
                                +"<br>"+app.NLS.NLS("RUS:вылетов;ENG:outliers;")+": "+String.valueOf(data.get(1).size());
            boxserie.xAxisIndex=0;
            boxserie.yAxisIndex=0;
            String vAxis=NVL(chartPref.Get_Element("BOX("+String.valueOf(si+1)+")_VAXIS"),"V1");
           if (like(chartType,"%G")){
               if (vAxis.equals("V2")) boxserie.xAxisIndex=1;
               boxserie.yAxisIndex=yBoxAxis.size();
           } else {
               if (vAxis.equals("V2") //||si>1
                       ) boxserie.yAxisIndex=1;
               boxserie.xAxisIndex=xBoxAxis.size();
           }
           series.add(boxserie);
           eserie sctserie = new eserie();
            sctserie.type="scatter";
            sctserie.name=seriesProps.get(si).Get_Element("name");
            sctserie.itemStyle=new eitemStyle();
            sctserie.itemStyle.color=boxserie.itemStyle.borderColor;
            sctserie.symbolSize=1.0;
            if (chartPref.containsKey(prefix+"SCATTERSYMBOLSIZE")) {
                sctserie.symbolSize=Double.valueOf(chartPref.Get_Element(prefix+"SCATTERSYMBOLSIZE"));
            }
            sctserie.symbolSize=sctserie.symbolSize*10.0*sizeCoeff;
            if (sctserie.symbolSize<1.0)sctserie.symbolSize=1.0;
           ArrayList<eBoxOutData> boxOutdata=new ArrayList<>();
            // крутим выпавшие точки
            for (int outi=0;outi<data.get(1).size();outi++){
                eBoxOutData outpoint = new eBoxOutData();
                outpoint.name=seriesProps.get(si).Get_Element("name");
                outpoint.tooltip=new etooltip();
                stmt4format.setDouble(1,Double.valueOf(data.get(1).get(outi)));stmt4format.execute();stmt4format.getResultSet().next();
                String out=stmt4format.getResultSet().getString(1);stmt4format.getResultSet().close();
                outpoint.tooltip.formatter="{b}:<br>"+app.NLS.NLS("RUS:вылет;ENG:outlier;")+": "+out+"-"+data.get(2).get(outi);
                outpoint.value=new ArrayList<>();
                if (chartType.equals("BOX")){
                outpoint.value.add(seriesProps.get(si).Get_Element("name"));
                outpoint.value.add(String.valueOf(data.get(1).get(outi)));
                } else {
                    outpoint.value.add(String.valueOf(data.get(1).get(outi)));
                    outpoint.value.add(seriesProps.get(si).Get_Element("name"));
                }
                boxOutdata.add(outpoint);
            }
            sctserie.data=boxOutdata;
            sctserie.xAxisIndex=0;
            sctserie.yAxisIndex=0;
            
           if (like(chartType,"%G")){
               if (vAxis.equals("V2")) sctserie.xAxisIndex=1;
               sctserie.yAxisIndex=yBoxAxis.size();
           } else {
               if (vAxis.equals("V2") //||si>1
                       ) sctserie.yAxisIndex=1;
               sctserie.xAxisIndex=xBoxAxis.size();
           }
            series.add(sctserie);
           si++;
          }
      } finally{
          if (stmt4format!=null)stmt4format.close();
      }
          return;
          
      }
      
      
      for (int i=0;i<colsinfo.size();i++){
          
      if (!like(colsinfo.get(i).alias,"SF%"))continue;   
      if ((chartType.equals("PIE") || chartType.equals("MAP")) // ??? WHR ???
              && !NVL(chartPref.get("CFG"),"0").equals(String.valueOf(si))){si++; continue;}
      eserie serie=new eserie();
      ci=si;
          while (ci>=o.color.size()){ci=ci-o.color.size();}
      serie.name=seriesProps.get(si).Get_Element("name");
        switch (chartType){
          case "BAR3D":
          case "SCT3D":
          serie.type="bar3D";
          if (chartType.equals("SCT3D"))serie.type="scatter3D";
          if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_TYPE")) {
               serie.type=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_TYPE");
           }
          if (serie.type.equals("scatter3D"))
          {
               serie.symbolSize=15.0*sizeCoeff;
               if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_SCATTERSYMBOLSIZE")) {
                   serie.symbolSize=Double.valueOf(chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_SCATTERSYMBOLSIZE"))*sizeCoeff;
               }
               if (serie.symbolSize<1.0)serie.symbolSize=1.0;
          }
          if (serie.type.equals("bar3D"))
          {
             if (dimsStats!=null && 
                     dimsStats.containsKey(groupProps.get(0).Get_Element("name")) && 
                     dimsStats.get(groupProps.get(0).Get_Element("name")).countDistinct!=null){
             Double width=dimsStats.get(groupProps.get(0).Get_Element("name")).countDistinct;
             width=(o.grid3D.boxWidth/width)*0.8;
             Double depth=dimsStats.get(groupProps.get(1).Get_Element("name")).countDistinct;
             depth=(o.grid3D.boxDepth/depth)*0.7;
             serie.barSize=new ArrayList<>();
             
             if (NVL(chartPref.Get_Element("CFG3D"),"0").equals("1")){
             //serie.barSize.add(width);
             //serie.barSize.add(depth);
             serie.stack="1";
             }
             else {
             //serie.barSize.add(width*(1-si*0.2));
             width=width*(1-si*0.2);
             //serie.barSize.add(depth*(1-si*0.1));
             depth=depth*(1-si*0.1);
             }
             if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_BARWIDTH")) {
                  width=Double.valueOf(chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_BARWIDTH"));
              }
             if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_BARDEPTH")) {
                  depth=Double.valueOf(chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_BARDEPTH"));
              }
             serie.barSize.add(width);
             serie.barSize.add(depth);
          }
          }
          serie.shading="lambert";
          serie.bevelSize=0.1;
          serie.bevelSmoothness=2.0;
          serie.emphasis=new eemphasis();
          serie.emphasis.label=new elabel();
          serie.emphasis.label.show=false;
          serie.emphasis.color="adaptive";
          serie.emphasis.opacity=0.7;
          serie.tooltip=new etooltip();
          serie.tooltip.show=true;
          
          serie.itemStyle=new eitemStyle();
      /*    if (is_not_null(seriesProps.get(si).Get_Element("color"))){
            serie.itemStyle.color=getColor(seriesProps.get(si).Get_Element("color"));
            serie.itemStyle.opacity=Double.valueOf(seriesProps.get(si).Get_Element("opacity"));
          }*/
          sencode=new eencode();
          sencode.x=groupProps.get(0).Get_Element("name");
          sencode.y=groupProps.get(1).Get_Element("name");
          sencode.z=seriesProps.get(si).Get_Element("name");
          serie.encode=sencode;
          /*if (is_not_null(chartPref.Get_Element("S"+String.valueOf(si+1)+"COLOR"))){
             serie.itemStyle=new eitemStyle();
             serie.itemStyle.color=chartPref.Get_Element("S"+String.valueOf(si+1)+"COLOR");
           }*/
          
          serie.itemStyle.color=o.color.get(ci);
          serie.itemStyle.myColor=o.color.get(ci);
          if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_COLOR")) {
               serie.itemStyle.color=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_COLOR");
               serie.itemStyle.myColor=serie.itemStyle.color.toString();
           }
          serie.label=new elabel();
          serie.label.show=false;
          if (chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELSHOW").equals("Y")) {
                serie.label.show=true;
           }
           serie.label.fontSize=12.0*sizeCoeff;
           if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LABELFONTSIZE")) {
                serie.label.fontSize=Double.valueOf(chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELFONTSIZE"))*sizeCoeff;
           }
           serie.label.fontStyle="normal";
           if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LABELFONTSTYLE")) {
                serie.label.fontStyle=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELFONTSTYLE");
           }
           serie.label.fontWeight="normal";
           if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LABELFONTWEIGHT")) {
                serie.label.fontWeight=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELFONTWEIGHT");
           }
           serie.label.color="налл";
           if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LABELFONTCOLOR")) {
                serie.label.color=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELFONTCOLOR");
           }          
           serie.label.position="top";
           if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LABELPOSITION")) {
                serie.label.position=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELPOSITION");
           }
           serie.label.distance=3;
           if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LABELDISTANCE")) {
                serie.label.distance=Integer.valueOf(chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LABELDISTANCE"));
           }
          break;
          case "MAP":
          if (!pReload.equals("N") && !pReload.equals("z")){
          serie.zoom=1.0;
          if (chartPref.containsKey("MAP_ZOOM")){
              serie.zoom=Double.valueOf(chartPref.Get_Element("MAP_ZOOM"));
          }
          frm.addProperty("MapScale",String.valueOf(serie.zoom));
          serie.left="10%";
          serie.top="10%";
          if (chartPref.containsKey("MAP_LEFT")){
              serie.left=chartPref.Get_Element("MAP_LEFT")+"%";
          }
          if (chartPref.containsKey("MAP_TOP")){
              serie.top=chartPref.Get_Element("MAP_TOP")+"%";
          }
          }
          serie.type="map";
          
          //serie.geoIndex=0;
          serie.map=mapCode;
          serie.roam=false;
          if (frm.getProperty("Roam").equals("Y")){
             serie.roam=true;
          }
          serie.aspectScale=1.0;
          serie.nameProperty=app.gMap.maps.get(mapCode).nameProperty;
          
          serie.label=new elabel();
          serie.label.show=true; 
          if (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("N")) serie.label.show=false;
          if (!frm.getProperty("CurrentLabelSize").equals(""))serie.label.show=true;
           serie.label.fontSize=10.0*sizeCoeff;
           if (chartPref.containsKey("MAP_LABELFONTSIZE")) {
                serie.label.fontSize=Double.valueOf(chartPref.Get_Element("MAP_LABELFONTSIZE"))*sizeCoeff;
           }
           serie.label.fontStyle="normal";
           if (chartPref.containsKey("MAP_LABELFONTSTYLE")) {
                serie.label.fontStyle=chartPref.Get_Element("MAP_LABELFONTSTYLE");
           }
           serie.label.fontWeight="normal";
           if (chartPref.containsKey("MAP_LABELFONTWEIGHT")) {
                serie.label.fontWeight=chartPref.Get_Element("MAP_LABELFONTWEIGHT");
           }
           serie.label.color="rgb(0, 0, 0)";
           if (chartPref.containsKey("MAP_LABELFONTCOLOR")) {
                serie.label.color=chartPref.Get_Element("MAP_LABELFONTCOLOR");
           }
           serie.label.formatter="{b}: {c}";
           if (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("YND"))serie.label.formatter="{b}";
          
          serie.itemStyle=new eitemStyle();
          serie.itemStyle.color=o.color.get(ci);
          serie.itemStyle.areaColor=NVL(chartPref.Get_Element("MAP_NULLSCOLOR"),"rgb(238, 238, 238)");
          serie.itemStyle.myColor=o.color.get(ci);
          serie.itemStyle.borderWidth=5.0/10.0;
          if (chartPref.containsKey("MAP_BORDERWIDTH")){
              serie.itemStyle.borderWidth=Double.valueOf(chartPref.Get_Element("MAP_BORDERWIDTH"))/10.0;
          }
          serie.itemStyle.borderWidth=serie.itemStyle.borderWidth*sizeCoeff;
          if (serie.itemStyle.borderWidth<0.3)serie.itemStyle.borderWidth=0.3;
          serie.itemStyle.borderType="solid";
          if (chartPref.containsKey("MAP_BORDERTYPE")){
              serie.itemStyle.borderType=chartPref.Get_Element("MAP_BORDERTYPE");
          }
          serie.itemStyle.borderColor="rgb(147, 147, 147)";
          if (chartPref.containsKey("MAP_BORDERCOLOR")){
              serie.itemStyle.borderColor=chartPref.Get_Element("MAP_BORDERCOLOR");
          }
          
          serie.itemStyle.emphasis=new eemphasis();
          serie.itemStyle.emphasis.areaColor="налл";
          serie.itemStyle.emphasis.color="налл";
          serie.itemStyle.emphasis.shadowOffsetX=0;
          serie.itemStyle.emphasis.shadowOffsetY=0;
          serie.itemStyle.emphasis.shadowBlur=20;
          serie.itemStyle.emphasis.borderWidth=0;
          serie.itemStyle.emphasis.shadowColor="rgba(0, 0, 0, 0.5)";
          /*serie.itemStyle.emphasis.label=new elabel();
          serie.itemStyle.emphasis.label.show=true;
          serie.itemStyle.emphasis.label.formatter="{b}: {c}";
          if (!frm.getProperty("CurrentLabelSize").equals(""))serie.itemStyle.emphasis.label.show=false; 31 08 2021*/
          makeMapData(si,serie,mlc);
          serie.label=null;
          break;
          case "PIE":
          serie.type="pie";
          serie.top="0%";
          if (this.chartPref.containsKey("PIE_CHART_TOP")){
            serie.top=chartPref.Get_Element("PIE_CHART_TOP")+"%";
          }
          serie.left="0%";
          if (this.chartPref.containsKey("PIE_CHART_LEFT")) {
            serie.left=chartPref.Get_Element("PIE_CHART_LEFT")+"%";
          }
          ArrayList acenter=new ArrayList<>();
          
          String left="40%";
          String top="50%";
          
          if (this.chartPref.containsKey("PIE_LEFT")) {
            left=chartPref.Get_Element("PIE_LEFT")+"%";
          }
          if (this.chartPref.containsKey("PIE_TOP")){
            top=chartPref.Get_Element("PIE_TOP")+"%";
          }  
          acenter.add(left);
          acenter.add(top);
          serie.center=acenter;
          
          serie.label=new elabel();
          serie.label.position="outside";
          
          if (chartPref.containsKey("PIE_LABEL_ALIGN_TO")){
              serie.label.alignTo=chartPref.get("PIE_LABEL_ALIGN_TO");
               
          }
          serie.label.rotate=(Integer)0;
          if (chartPref.containsKey("PIE_LABEL_POSITION")) {
            if (chartPref.get("PIE_LABEL_POSITION").equals("radial"))  {
                serie.label.rotate=(Boolean)true;
                serie.label.position="inside";}
            else serie.label.position=chartPref.get("PIE_LABEL_POSITION");
          }
          serie.label.alignTo="none";
          if (chartPref.containsKey("PIE_LABEL_ALIGN_TO")){
              serie.label.alignTo=chartPref.get("PIE_LABEL_ALIGN_TO");     
          }
          
          if (serie.label.position.equals("outside"))serie.label.position="outer";
          serie.label.margin=NVL(chartPref.get("PIE_LABEL_MARGIN"),"25")+"%";
          serie.label.fontSize=12.0*sizeCoeff;
          if (this.chartPref.containsKey("PIE_LABEL_FONTSIZE"))
          serie.label.fontSize=Double.valueOf(chartPref.Get_Element("PIE_LABEL_FONTSIZE"))*sizeCoeff;
          serie.label.fontStyle="normal";
          if (this.chartPref.containsKey("PIE_LABEL_FONTSTYLE"))
          serie.label.fontStyle=chartPref.Get_Element("PIE_LABEL_FONTSTYLE");
          serie.label.fontWeight="normal";
          if (this.chartPref.containsKey("PIE_LABEL_FONTWEIGHT"))
          serie.label.fontWeight=chartPref.Get_Element("PIE_LABEL_FONTWEIGHT");
          serie.label.color="";
          if (this.chartPref.containsKey("PIE_LABEL_FONTCOLOR"))
          serie.label.color=chartPref.Get_Element("PIE_LABEL_FONTCOLOR");
          
          serie.label.show=true;
          serie.roseType=false;
          if (this.chartPref.containsKey("PIE_ROSE_TYPE"))
            serie.roseType=chartPref.Get_Element("PIE_ROSE_TYPE");  
          serie.labelLine=new elabelLine();
          serie.labelLine.show=true;
          if (chartPref.Get_Element("PIE_LABEL_SHOW").equals("N")){
          serie.label.show=false;
          serie.labelLine.show=false;}
          
              serie.labelLine.lineStyle=new elineStyle();
          if (is_not_null(serie.label.color)){    
              serie.labelLine.lineStyle.color=serie.label.color;
          } else
              serie.labelLine.lineStyle.color="налл";
          serie.labelLine.length="1%";
          if (chartPref.containsKey("PIE_LABEL_LINE_LENGTH")){
              serie.labelLine.length=chartPref.get("PIE_LABEL_LINE_LENGTH")+"%";
          }
          serie.labelLine.length2="1%";
          if (chartPref.containsKey("PIE_LABEL_LINE_LENGTH2")){
              serie.labelLine.length2=chartPref.get("PIE_LABEL_LINE_LENGTH2")+"%";
          }
          String plc=NVL(chartPref.Get_Element("PIE_LABEL_CONTENT"),"NV");
          serie.label.formatter="{b}: {@"+serie.name+"}";
          if (plc.equals("N"))serie.label.formatter="{b}";
          if (plc.equals("V"))serie.label.formatter="{@"+serie.name+"}";
          serie.selectedMode="single";
          serie.radius=NVL(chartPref.Get_Element("PIE_RADIUS"),"55")+"%";
         /* serie.center=new ArrayList<>();
          if (NVL(chartPref.Get_Element("PIE_LEGEND"),"Y").equals("Y")) 
               serie.center.add("40%");
          else serie.center.add("50%");
          serie.center.add("50%");*/
          serie.itemStyle=new eitemStyle();
          serie.itemStyle.emphasis=new eemphasis();
          serie.itemStyle.emphasis.shadowBlur=10;
          serie.itemStyle.emphasis.shadowOffsetX=0;
          serie.itemStyle.emphasis.shadowColor="rgba(0, 0, 0, 0.5)";
          /* Это старый способ передачи данных в круговую диаграмму закоментирован 17.06.2021 в связи с необходимостью вывода либо >=0 либо <=0
          sencode=new eencode();
          sencode.itemName=groupProps.get(0).Get_Element("name");          
          sencode.value=seriesProps.get(si).Get_Element("name");
          serie.encode=sencode;*/
          ArrayList<eWhrDataItem> piedatas=new ArrayList<>();
           Double min=null;
     Double max=null;
     String preferVal=null;
     try{
         min=Double.valueOf(this.dimsStats.get(serie.name).min);
         max=Double.valueOf(this.dimsStats.get(serie.name).max);
     } catch (Exception ex){}
      if ((min==null || max==null || (min>=0 && max>=0) || (min<=0 && max<=0))==false){
        // надо учитывать предпочитаемые значения
        preferVal=NVL(chartPref.Get_Element(chartType+"_PREFVAL"),"+");// предпочитаемые значения
    }
      o.legend.data=new ArrayList<>();
     int cc=0;
     ArrayList clrs=colors;
   /* if (chartPref.containsKey("COLORS")){
        clrs=new ArrayList<>();
        String newcolors=chartPref.Get_Element("COLORS");
        clrs=this.makeColorsArray(newcolors,false);
      if (clrs.size()==0)clrs=colors;}*/
      for (int pi=0;pi<dataset.source.size();pi++){
        if (cc>=clrs.size()){
            cc=0;
        }
        elegendDataItem ldi=new elegendDataItem();
         ldi.name=dataset.source.get(pi).get(0).toString();
         ldi.textStyle=new eTextStyle();
         ldi.textStyle.color="rgba(0,0,0,1)";
        if (dataset.source.get(pi).get(si)==null)continue;
        if (dataset.source.get(pi).get(si).equals(""))continue;
          if (dataset.source.get(pi).get(1+si)==null)continue;
          if (String.valueOf(dataset.source.get(pi).get(1+si))==null)continue;
          if (String.valueOf(dataset.source.get(pi).get(1+si)).equals("null"))continue;
          if (String.valueOf(dataset.source.get(pi).get(1+si)).equals(""))continue;
                    eWhrDataItem dataItem=new eWhrDataItem();
          dataItem.name=dataset.source.get(pi).get(0).toString();
          Double v=Double.valueOf(String.valueOf(dataset.source.get(pi).get(1+si)));
          dataItem.value=v;
          dataItem.itemStyle=new eitemStyle();
          dataItem.itemStyle.color=clrs.get(cc);
          if (preferVal!=null){
              if (preferVal.equals("+")&& v<0){dataItem.value="налл";ldi.textStyle.color="rgba(225,225,225,1)";dataItem.itemStyle.color="rgba(225,225,225,1)";}
              if (preferVal.equals("-")&& v>0){dataItem.value="налл";ldi.textStyle.color="rgba(225,225,225,1)";dataItem.itemStyle.color="rgba(225,225,225,1)";}
          } 
        piedatas.add(dataItem);
        o.legend.data.add(ldi);
        cc++;
      }
      serie.data=piedatas;
          /*
            if (o!=null){
              String tot="";
              if(this.dimsStats.get(serie.name).sum!=null){
              tot=String.valueOf(this.dimsStats.get(serie.name).sum);
              if (is_not_null(tot)){
              if (dimsStats.get(serie.name).sum==Math.round(dimsStats.get(serie.name).sum)){
                  tot=tot.replace(".0","");
              } 
              } 
             }
              o.title.get(0).text=serie.encode.value+"/"+serie.encode.itemName+"\n"+o.title.get(0).text;
              if (app.NLS.currentLang.code.equals("RUS"))
              o.title.get(0).text=o.title.get(0).text+"\nВсего:"+tot;
              else
              o.title.get(0).text=o.title.get(0).text+"\nTotal:"+tot;            
          }*/
          break; 
    /*      case "BOX":
          case "BOXG":
          serie.type="boxplot";
          
          ArrayList<ArrayList<Double>>  boxSCTdata=this.makeBoxData(si);
          ArrayList<ArrayList<Double>>  aboxData=new ArrayList<ArrayList<Double>>();
          aboxData.add(boxSCTdata.get(0));
          serie.data=aboxData;
          eencode senc=new eencode();
          senc.x=seriesProps.get(si).Get_Element("name");
          serie.xAxisIndex=0;
           serie.yAxisIndex=0;
           String vAxisb=NVL(chartPref.Get_Element("BOX("+String.valueOf(si+1)+")_VAXIS"),"V1");
           if (like(chartType,"%G")){
               if (vAxisb.equals("V2")) serie.xAxisIndex=1;
               senc.y=seriesProps.get(si).Get_Element("name");
           } else {
               senc.x=seriesProps.get(si).Get_Element("name");
               if (vAxisb.equals("V2")) serie.yAxisIndex=1;
           }
          serie.encode=senc;
          serie.itemStyle=new eitemStyle();
          serie.itemStyle.borderColor=o.color.get(ci);
          serie.itemStyle.myColor=o.color.get(ci);
          if (chartPref.containsKey("BOX("+String.valueOf(si+1)+")_COLOR")) {
               serie.itemStyle.borderColor=chartPref.Get_Element("BOX("+String.valueOf(si+1)+")_COLOR");
               serie.itemStyle.myColor=serie.itemStyle.color.toString();
           }
          break; */
          case "BAR":
          case "BARG":
          case "LINE":
          case "SCT":
           serie.type="bar";
           serie.zlevel=si;
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_ZLEVEL")) {
               serie.zlevel=Integer.valueOf(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_ZLEVEL"));
           } 
           if (chartType.equals("LINE")) serie.type="line";
           if (chartType.equals("SCT")) serie.type="scatter";
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_TYPE")) {
               serie.type=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_TYPE");
           }
           if (serie.type.equals("line")) {
               serie.lineStyle=new elineStyle();
              
               serie.lineStyle.width=2.0*sizeCoeff;
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LINEWIDTH")) {
                  serie.lineStyle.width=Double.valueOf(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LINEWIDTH"))*sizeCoeff;
              }
               if(serie.lineStyle.width<1.0)serie.lineStyle.width=1.0;
               serie.lineStyle.type="solid";
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LINESTYLE")) {
                  serie.lineStyle.type=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LINESTYLE");
              }
               serie.smooth=false;
               if (chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LINESMOOTH").equals("line_smooth")) {
                  serie.smooth=true;
                  serie.smoothMonotone="x";
                  if (chartType.equals("BARG"))serie.smoothMonotone="y";
              }
               serie.step=false;
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LINESTEP")) {
                  serie.step=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LINESTEP");
              }
               serie.areaStyle=new eareaStyle();
               serie.areaStyle.opacity=0.0;
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LINEAREAOPACITY")) {
                   serie.areaStyle.opacity=Double.valueOf(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LINEAREAOPACITY"))/100.0;
               }
               serie.symbolSize=4.0*sizeCoeff;
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LINESYMBOLSIZE")) {
                   serie.symbolSize=Double.valueOf(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LINESYMBOLSIZE"))*sizeCoeff;
               }
               if(serie.symbolSize<1.0)serie.symbolSize=1.0;
           }
           if (serie.type.equals("scatter")) {
               serie.symbolSize=15.0*sizeCoeff;
               is2dScatter=true;
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_SCATTERSYMBOLSIZE")) {
                   serie.symbolSize=Double.valueOf(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_SCATTERSYMBOLSIZE"))*sizeCoeff;
               }
               if(serie.symbolSize<1.0)serie.symbolSize=1.0;
           }
           if (serie.type.equals("bar")){
               serie.barWidth="налл";
              if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_BARWIDTH")) {
                  serie.barWidth=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_BARWIDTH")+"%";
              }
              
           }
           serie.xAxisIndex=0;
           serie.yAxisIndex=0;
           String vAxis=NVL(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_VAXIS"),"V1");
           if (like(chartType,"%G")){
               if (vAxis.equals("V2")) serie.xAxisIndex=1;
           } else {
               if (vAxis.equals("V2")) serie.yAxisIndex=1;
           }
           serie.stack=NVL(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_STACK"),"налл");
           
           serie.itemStyle=new eitemStyle();
          
          serie.itemStyle.color=o.color.get(ci);
          serie.itemStyle.myColor=o.color.get(ci);
          if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_COLOR")) {
               serie.itemStyle.color=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_COLOR");
               serie.itemStyle.myColor=serie.itemStyle.color.toString();
           }
          if (serie.type.equals("scatter")||serie.type.equals("bar")){
            if (chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LIGHTSHOW").equals("Y")) { 
               String lightColor="rgb(214, 214, 214)";
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LIGHTCOLOR")) {
                 lightColor=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LIGHTCOLOR");
                 }
                  eExtColor extC=new eExtColor();
                            extC.global=false;
                  if (serie.type.equals("bar")){          
                            extC.type="linear"; 
                         if (like(chartType,"%G")) {
                            extC.y=-0.09;
                            extC.x=0.0;
                            extC.y2=1.0;
                            extC.x2=0.0; 
                         }  else {
                            extC.x=-0.09;
                            extC.y=0.0;
                            extC.x2=1.0;
                            extC.y2=0.0;
                         } 
                         ArrayList<eColorStop> cSa=new ArrayList<>();
                            eColorStop cS1=new eColorStop();
                            cS1.color=serie.itemStyle.myColor;
                            cS1.offset=0.0;
                            eColorStop cS2=new eColorStop();
                            cS2.color=lightColor;
                            cS2.offset=0.35;
                            eColorStop cS3=new eColorStop();
                            cS3.color=serie.itemStyle.myColor;
                            cS3.offset=0.8;
                            cSa.add(cS1);
                            cSa.add(cS2);
                            cSa.add(cS3);
                            extC.colorStops=cSa;                
                  }
                  else {
                            extC.type="radial"; 
                            if (like(chartType,"%G")) {
                            extC.y=0.22;
                            extC.x=0.28;
                            extC.y2=1.0;
                            extC.x2=0.0;
                         }  else {
                            extC.x=0.22;
                            extC.y=0.28;
                            extC.x2=1.0;
                            extC.y2=0.0;
                         }
                         ArrayList<eColorStop> cSa=new ArrayList<>();
                            eColorStop cS1=new eColorStop();
                            cS1.color=lightColor;
                            cS1.offset=0.0;
                            eColorStop cS2=new eColorStop();
                            cS2.color=serie.itemStyle.myColor;
                            cS2.offset=0.99;
                            cSa.add(cS1);
                            cSa.add(cS2);
                            extC.colorStops=cSa;    
                  }
            
            serie.itemStyle.color=extC;
            }
            if (chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_SHADOWSHOW").equals("Y")) {  
                 serie.itemStyle.shadowColor="rgb(153, 153, 153)"; 
                 if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_SHADOWCOLOR")) {
                 serie.itemStyle.shadowColor=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_SHADOWCOLOR");
                 }
                 
                 serie.itemStyle.shadowBlur=15;
                 if (like(chartType,"%G")) {
                            serie.itemStyle.shadowOffsetX=0;
                            serie.itemStyle.shadowOffsetY=15.0*sizeCoeff;
                 } else {
                            serie.itemStyle.shadowOffsetY=0;
                            serie.itemStyle.shadowOffsetX=15.0*sizeCoeff;
                 }
                 
            } else {
                 serie.itemStyle.shadowColor="налл"; 
                 serie.itemStyle.shadowBlur="налл"; 
                 serie.itemStyle.shadowOffsetX="налл"; 
                 serie.itemStyle.shadowOffsetY="налл"; 
            }
          }
          if (serie.type.equals("line")){
           if (chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_SHADOWSHOW").equals("Y")) {    
              serie.lineStyle.shadowBlur=Math.max(10,serie.lineStyle.width/3+serie.lineStyle.width);
              serie.lineStyle.shadowColor="rgb(153, 153, 153)"; 
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_SHADOWCOLOR")) {
                 serie.lineStyle.shadowColor=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_SHADOWCOLOR");
                 }
                 if (like(chartType,"%G")) {
                            serie.lineStyle.shadowOffsetX=10.0*sizeCoeff;
                            serie.lineStyle.shadowOffsetY=5.0*sizeCoeff;
                 } else {
                            serie.lineStyle.shadowOffsetY=10.0*sizeCoeff;
                            serie.lineStyle.shadowOffsetX=5.0*sizeCoeff;
                 }
          } else {
                 serie.lineStyle.shadowColor="налл"; 
                 serie.lineStyle.shadowBlur="налл"; 
                 serie.lineStyle.shadowOffsetX="налл"; 
                 serie.lineStyle.shadowOffsetY="налл"; 
           } 
          }
           serie.label=new elabel();
           serie.label.show=false;           
           if (chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELSHOW").equals("Y")) {
                serie.label.show=true;
           }
           serie.label.fontSize=12.0*sizeCoeff;
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LABELFONTSIZE")) {
                serie.label.fontSize=Double.valueOf(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELFONTSIZE"))*sizeCoeff;
           }
           serie.label.fontStyle="normal";
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LABELFONTSTYLE")) {
                serie.label.fontStyle=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELFONTSTYLE");
           }
           serie.label.fontWeight="normal";
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LABELFONTWEIGHT")) {
                serie.label.fontWeight=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELFONTWEIGHT");
           }
           serie.label.color="налл";
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LABELFONTCOLOR")) {
                serie.label.color=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELFONTCOLOR");
           }
           serie.label.position="inside";
           if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LABELPOSITION")) {
                serie.label.position=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELPOSITION");
           }
           serie.label.offset=new ArrayList<>();
           serie.label.offset.add(Double.valueOf(NVL(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELXOFFSET"),"0"))*sizeCoeff);
           serie.label.offset.add(Double.valueOf(NVL(chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LABELYOFFSET"),"0"))*sizeCoeff);
           sencode=new eencode();
           if (chartType.equals("BARG")){
           sencode.y=groupProps.get(0).Get_Element("name");
           sencode.x=seriesProps.get(si).Get_Element("name");
           } else {
           sencode.x=groupProps.get(0).Get_Element("name");
           sencode.y=seriesProps.get(si).Get_Element("name");
           }
           serie.encode=sencode;
          break;
      }
      
      series.add(serie);
      
      
      si++;
      }
      int sz=series.size();
      for (si=0;si<sz;si++){
          eserie serie=series.get(si);
         if (serie.type.equals("bar3D")||serie.type.equals("scatter3D")){
             //подсветка икры
          eserie l1 = new eserie();eserie l2 = new eserie();  
          l1.zlevel=-9;l1.type="scatter3D";l1.data=new ArrayList();l1.id="l1-"+si;
          l2.zlevel=-8;l2.type="scatter3D";l2.data=new ArrayList();l2.id="l2-"+si;
          l1.encode="налл";l2.encode="налл";
          if (serie.type.equals("scatter3D")){
           if (chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LIGHTSHOW").equals("Y")
                 && !chartPref.Get_Element("Deselect_"+serie.name).equals("Y")
                 && (is_null(serie.stack)|| si==0
                 )) {    
              String lightColor="rgb(214, 214, 214)";
              if (chartPref.containsKey("3DCURVE("+String.valueOf(si+1)+")_LIGHTCOLOR")) {
                 lightColor=chartPref.Get_Element("3DCURVE("+String.valueOf(si+1)+")_LIGHTCOLOR");
                 } 
               l1.data="налл";
               l2.data="налл";
               l1.encode=serie.encode;
               l2.encode=serie.encode;
               l1.silent=true;l2.silent=true;
               l1.itemStyle=new eitemStyle();
               l1.itemStyle.color=lightColor;
               l1.itemStyle.opacity=0.1;
               l1.symbolSize=serie.symbolSize/2.0;
              // l2.blendMode="lighter";
               l2.itemStyle=new eitemStyle();
               l2.itemStyle.color=lightColor;
               l2.itemStyle.opacity=0.3;
               l2.symbolSize=l1.symbolSize/2.0;
               
          }}
         series.add(l1);series.add(l2);}
         if (serie.type.equals("line")||serie.type.equals("bar")||serie.type.equals("scatter")){
      eserie l1 = new eserie();eserie l2 = new eserie();  
      l1.z=3;l1.zlevel=serie.zlevel;l1.type="scatter";l1.id="l1-"+si;l1.tooltip=new etooltip();l1.tooltip.show=false;
      l2.z=3;l2.zlevel=serie.zlevel;l2.type="scatter";l2.id="l2-"+si;l2.tooltip=new etooltip();l2.tooltip.show=false;
        l1.silent=true;l2.silent=true;
        l1.encode=serie.encode;
        l2.encode=serie.encode;
        l1.stack="налл";
        l2.stack="налл";
        l1.animation=false;
        l2.animation=false;
        if (!serie.stack.equals("налл")){
         if (!chartPref.Get_Element("Deselect_"+serie.name).equals("Y")){   
          l1.stack="l1"+serie.stack;
          l2.stack="l2"+serie.stack;
         }
        }
        
        l1.itemStyle=new eitemStyle();
        l1.itemStyle.color="rgba(255,255,255,0)";
        l1.symbolSize=0.0;
        l2.symbolSize=0.0;
        l2.itemStyle=l1.itemStyle;
        l1.xAxisIndex=serie.xAxisIndex;
         l1.yAxisIndex=serie.yAxisIndex;
         l2.xAxisIndex=serie.xAxisIndex;
         l2.yAxisIndex=serie.yAxisIndex;
         serie.animation=true;//true!!!
      //l1.encode="налл";l2.encode="налл";
      //l1.data=new ArrayList();l2.data=new ArrayList();
      if (serie.type.equals("line")){
         if (chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LIGHTSHOW").equals("Y")
                 && !chartPref.Get_Element("Deselect_"+serie.name).equals("Y")
                 //&& (is_null(serie.stack)|| si==0)
                 ) { 
             l1.type="line";
             l2.type="line";
             //serie.animation=false;
               /*l1.data="налл";
               l2.data="налл";
               l1.encode=serie.encode;
               l2.encode=serie.encode;
             */
               String lightColor="rgb(214, 214, 214)";
               if (chartPref.containsKey("2DCURVE("+String.valueOf(si+1)+")_LIGHTCOLOR")) {
                 lightColor=chartPref.Get_Element("2DCURVE("+String.valueOf(si+1)+")_LIGHTCOLOR");
                 } 
         
         
         l1.smooth=serie.smooth;
         l1.smoothMonotone=serie.smoothMonotone;
         l1.itemStyle= new eitemStyle();
         l1.itemStyle.color=lightColor;
         
         
         l1.lineStyle=new elineStyle();
         l1.lineStyle.color=lightColor;
         l1.lineStyle.type="solid";
         l1.lineStyle.width=serie.lineStyle.width/2.0;
         l1.lineStyle.opacity=0.3;
         l1.lineStyle.shadowColor=lightColor;
         l1.lineStyle.shadowBlur=serie.lineStyle.width/2.0;
         l1.lineStyle.shadowOffsetX=0;
         l1.lineStyle.shadowOffsetY=-serie.lineStyle.width*2.0/3.0;
         if (like(chartType,"%G")) {
             l1.lineStyle.shadowOffsetY=0;
         l1.lineStyle.shadowOffsetX=-serie.lineStyle.width*2.0/3.0;
         }
         //l1.stack=serie.stack;
         l1.step=serie.step;
         
         
         l2.smooth=serie.smooth;
         l2.smoothMonotone=serie.smoothMonotone;
         l2.itemStyle= new eitemStyle();
         l2.itemStyle.color=lightColor;
         l2.lineStyle=new elineStyle();
         l2.lineStyle.type="solid";
         
         l2.silent=true;
         //l2.zlevel=serie.zlevel;
         //l2.z=si;
         l2.lineStyle.width=l1.lineStyle.width/2.0;
         l2.lineStyle.opacity=0.4;
         l2.lineStyle.shadowColor=lightColor;
         l2.lineStyle.shadowBlur=-serie.lineStyle.width/3.0;
         l2.lineStyle.shadowOffsetX=0;
         l2.lineStyle.shadowOffsetY=-serie.lineStyle.width/5.0;
         if (like(chartType,"%G")) {
         l2.lineStyle.shadowOffsetY=0;
         l2.lineStyle.shadowOffsetX=serie.lineStyle.width/5.0;  
         
         }
         //l2.stack=serie.stack;
         l2.step=serie.step;  
      }} series.add(l1);series.add(l2); } 
      }
  }
  /**
   * Изготоволение данных для карты. Просто адресация на dataset не годится. Т.к. требуется расписать свойства каждого региона
   * @param si - id кривой
   * @param serie - кривая
   * @throws LuiException
   * @throws SQLException 
   */
  public void makeMapData(int si,eserie serie,LuiDbConn mlc) throws LuiException, SQLException{
      if (this.MAPpValues==null)MAPpValues=new ArrayList<>();
      MAPpValues.clear();
      //seriesProps.get(si).Get_Element("format")
      String format=seriesProps.get(si).Get_Element("format");
      String select4format="";
      PreparedStatement stmt4format=null;
      if (is_null(format)){ 
          if (mlc.getDBvendor().equals("ORA")) select4format="select to_char(?)"; 
          if (mlc.getDBvendor().equals("PG")) select4format="select ?::text";
      }
      else select4format="select to_char(?,'"+format+"')";
      if (mlc.getDBvendor().equals("ORA")) select4format=select4format+" from dual";
      stmt4format=mlc.getConnection().prepareStatement(select4format);
      try{
      if (this.MAPnValues==null)MAPnValues=new ArrayList<>();
      MAPnValues.clear();
      ArrayList<eMapData> MapData=new ArrayList<>();
     // ArrayList<String> mapColors=null;
      Double min=null;
      Double max=null;
      makeColorsArray4Map(si,serie.itemStyle.myColor);
             if (dimsStats!=null && dimsStats.get(serie.name)!=null && dimsStats.get(serie.name).max!=null){
             max=Double.valueOf(this.dimsStats.get(serie.name).max);
             min=Double.valueOf(this.dimsStats.get(serie.name).min);
              if (Objects.equals(max, min)){
              if (max>0) min=0.0;
              else max=0.0;
              }
             }
      
      mapLegend=null;
      mapLegendSignIsNumeric=true;
      String nameInSet;
          Integer inSetIndex=null;
          String nameprop=app.gMap.maps.get(mapCode).nameProperty;
          for (int i=0;i<app.gMap.maps.get(mapCode).GEOJSON.features.size();i++){
              eMapData emd=new eMapData();
              emd.emphasis=new eemphasis();
              emd.emphasis.label=new elabel();
              emd.emphasis.label.show=true;
              if (!frm.getProperty("CurrentLabelSize").equals(""))emd.emphasis.label.show=false;
              emd.emphasis.label.formatter="{b}: {c}";
              emd.name=app.gMap.maps.get(mapCode).GEOJSON.features.get(i).properties.get(nameprop);
              
              inSetIndex=null;
              for (int j=0;j<dataset.source.size();j++){
                  if (dataset.source.get(j)!=null && dataset.source.get(j).get(0)!=null){
                  nameInSet=dataset.source.get(j).get(0).toString();
                  if (nameInSet.equals(emd.name)){inSetIndex=j;break;}
                  }
              }
              emd.value=null;
              if (inSetIndex!=null) {
              emd.value=dataset.source.get(inSetIndex).get(si+1);
              }
              if (emd.value==null){
               emd.emphasis.label.formatter=emd.emphasis.label.formatter.replace("{c}","");
               emd.value="";
              }
              String sign="";
             // if (chartPref.Get_Element("MAP_LABELSHOW").equals("L")){
                  if (!is_not_null(String.valueOf(emd.value))){
                      emd.emphasis.label.formatter=emd.emphasis.label.formatter.replace("{c}","");
                  }
                  sign=String.valueOf(0-(i+1));
                  if (inSetIndex!=null) sign=String.valueOf(inSetIndex+1);
              if (is_not_null(app.gMap.maps.get(mapCode).featuresHM.get(emd.name))) sign=app.gMap.maps.get(mapCode).featuresHM.get(emd.name);
              else{
              if (app.gMap.maps.get(mapCode).GEOJSON.features.get(i).properties.containsKey("label")){
                  sign=app.gMap.maps.get(mapCode).GEOJSON.features.get(i).properties.get("label");
              } 
              }
              
              mapLegendItem mli=new mapLegendItem();
              mli.name=emd.name;mli.sign=sign;
              mli.di=i;
              
              if (is_not_null(sign)){
              try{
                Double d=Double.valueOf(sign);
              }catch(Exception ex){mapLegendSignIsNumeric=false;}
              }
              mli.value=null;
              if (inSetIndex!=null && is_not_null(String.valueOf(emd.value))) {
              mli.value=Double.valueOf(String.valueOf(emd.value));
              }
              mli.color="rgba(255,255,255,1)";
             if (mli.value!=null){ 
             if (NVL(chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_MODE"),"C").equals("C")){ 
             if (max!=null && min!=null && mli.value!=null  ){
              mli.color=this.getColor4value(mli.value,min,max, MAPVMcolorList);
             } } else {
              mli.color=this.getColor4valueVMP(mli.value, si);
             }
             /*if (like(emd.name,"%Чукот%")&& inSetIndex!=null && dataset.source.get(inSetIndex).get(si+1)!=null){// если это чукотка и у неё есть значение
                  // выясним её цвет
                  //if (!like (mli.color.replace(" ",""),"%(255,255,255%")) { // если не белый то раницы сделаем нулевыми для белого - нельзя сольётся с океаном
                  emd.itemStyle=new eitemStyle();
                  emd.itemStyle.borderWidth=0.0;
                  emd.itemStyle.borderColor=mli.color;
                  emd.itemStyle.shadowColor=serie.itemStyle.borderColor;
                  emd.itemStyle.shadowBlur=2;
                  //}
              }*/
             }
            boolean b=makeMapRegionLabel(serie,emd,sign);
            if (NVL(chartPref.Get_Element("MAP_NULLSLABEL"),"N").equals("Y") && is_null(String.valueOf(emd.value))){
                   emd.label.show=false;
                   b=false;
              }
            if (b)excSignShow=true;
            if (NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("L") || b
                ||NVL(chartPref.Get_Element("MAP_LABELSHOW"),"L").equals("YND")    ){  
                if (mapLegend==null) mapLegend=new ArrayList<>();
                mapLegend.add(mli);}
              //} 
              emd.selected=false;
              if (NVL(chartPref.Get_Element("MAP_NULLSBORDER"),"N").equals("Y") && is_null(String.valueOf(emd.value))){
                   emd.itemStyle=new eitemStyle();
                   emd.itemStyle.borderWidth=1.0;
                   emd.itemStyle.borderColor=NVL(chartPref.Get_Element("MAP_NULLSCOLOR"),"rgb(238, 238, 238)");
                   
              }
             /* if (like(emd.name,"%Чукот%")&& inSetIndex!=null && dataset.source.get(inSetIndex).get(si+1)!=null){// если это чукотка и у неё есть значение
               
                   String borderColor=serie.itemStyle.borderColor.replace(" ","");
                   if (like(borderColor,"%(255,255,255)%") || (serie.itemStyle.borderWidth<0.9 && serie.itemStyle.borderWidth>0.1)){
                  emd.itemStyle=new eitemStyle();
                  emd.itemStyle.borderWidth=0.0;
                  emd.itemStyle.shadowColor=serie.itemStyle.borderColor;
                  emd.itemStyle.shadowBlur=2;
                  }
              }
                */      
              
              //makeMapRegionLabel(serie.label.show,emd,sign);
              // определение цвета для метки
              if (is_not_null(chartPref.Get_Element("MAP_LABELFONTCOLOR"))){
                  emd.label.color=chartPref.Get_Element("MAP_LABELFONTCOLOR"); // если цвет явно задан
              } else { 
                 if (!chartPref.containsKey("MAP_LABELFONTCOLOR")){ // если цвет совсем не задан
                   emd.label.color="rgb(0,0,0)";  
                 } else { // задан, но пуст - значит адаптивно
                  String regColor="rgb(255,255,255)";
                  emd.label.color="rgb(0,0,0)";
                  if (inSetIndex!=null && dataset.source.get(inSetIndex).get(si+1)!=null && !dataset.source.get(inSetIndex).get(si+1).equals("")){
                  if (NVL(chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_MODE"),"C").equals("C")){ 
                      if (MAPVMcolorList!=null && min!=null && max!=null)
                       regColor=getColor4value((Double)emd.value,min,max, MAPVMcolorList);
                   } else {
                       regColor=getColor4valueVMP((Double)emd.value, si);
                   }
                  String rgba[]=regColor.replace(" ","").replace("(","").replace(")","").replace("rgba","").replace("rgb","").split(",");
                  Double lignh=(0.299*Double.valueOf(rgba[0])+0.587*Double.valueOf(rgba[1])+0.114*Double.valueOf(rgba[2]))/255.0;
                  if (rgba.length>3) lignh=lignh*(2-Double.valueOf(rgba[3]));
                  if (lignh<0.5)emd.label.color="rgb(255,255,255)";
              }
              }
          }
              emd.tooltip=new etooltip();
              if (is_not_null(emd.value.toString())){
              stmt4format.setDouble(1,(Double) emd.value);
              stmt4format.execute();
              stmt4format.getResultSet().next();
              //stmt4format.getResultSet().getString(1);
              emd.tooltip.formatter=emd.name+"<br><b>"+serie.name+"</b>: "+stmt4format.getResultSet().getString(1);
              stmt4format.getResultSet().close();
              } else 
                      emd.tooltip.formatter=emd.name+"<br><b>"+serie.name+"</b>: "+emd.value.toString();
              if (inSetIndex!=null) {
              for(int k=1;k<dataset.dimensions.size();k++){
                 if (k!=si+1){
                  if (dataset.source.get(inSetIndex).get(k)!=null && is_not_null(dataset.source.get(inSetIndex).get(k).toString())) {
                  stmt4format.setDouble(1,(Double)dataset.source.get(inSetIndex).get(k));
                  stmt4format.execute();
                  stmt4format.getResultSet().next();
                  emd.tooltip.formatter= emd.tooltip.formatter+"<br>"+dataset.dimensions.get(k).name+": "+stmt4format.getResultSet().getString(1);
                  stmt4format.getResultSet().close();
                    //emd.tooltip.formatter= emd.tooltip.formatter+"<br>"+"{b}"+": "+
                             dataset.source.get(inSetIndex).get(k);
                  } else {
                      emd.tooltip.formatter= emd.tooltip.formatter+"<br>"+dataset.dimensions.get(k).name+": "+
                             dataset.source.get(inSetIndex).get(k);
                  }
                 }
              }
              }
              MapData.add(emd);
              Double v=null;
              try{
              v=(Double)(emd.value);
                  } catch(Exception ex){}
              if (v!=null){
                  if (v>=0) {
                      MAPpValues.add(v);
                  } else {
                      MAPnValues.add(0-v);
                  }
              }
          }
          serie.data=MapData;
          Collections.sort(MAPpValues);
          Collections.sort(MAPnValues);
          
          
              
          
  } finally {
          if (stmt4format!=null){
              stmt4format.close();
          }
      }
  }
  public void makeDataSet() throws LuiException, SQLException{  
    dataset=new edataset();
    dataset.dimensions=new ArrayList<>();
    dimsStats=new HashMap<>();
    String stmt;
    for(int i=0;i<colsinfo.size();i++){
        //ds.count=0.0;
        //ds.countDistinct=0.0;
        String dimName;
        int idx=Integer.valueOf(colsinfo.get(i).alias.substring(2))-1;
        if (like(colsinfo.get(i).alias,"GC%")){
            if (idx>=groupProps.size())continue;
            dimName=groupProps.get(idx).Get_Element("name");
        } else {
            if (idx>=seriesProps.size())continue;
            dimName=seriesProps.get(idx).Get_Element("name");
        }
        edim dim=new edim();
        dim.name=dimName;
        dimStats ds=new dimStats();
        
        dim.type="ordinal";
        switch (colsinfo.get(i).LuiDATATYPE){
            case "NUMBER":
            dim.type="number";
            break;
            case "DATETIME":
            dim.type="time";
            break;
        }
        if (like(colsinfo.get(i).alias,"GC%")){ // если это ось группирующих столбцов (X)
        
       if (chartType.equals("BAR")||chartType.equals("LINE")||chartType.equals("SCT")||chartType.equals("BARG")){
          for (String stack:chartPref.keySet()){
              if (like(stack,"2DCURVE(%)_STACK")) {
                  dim.type="ordinal";
                  break;
              }
          }
            
       } 
        }
        dataset.dimensions.add(dim);
        
        
        dimsStats.put(dim.name, ds);
    }
    dataset.source=new ArrayList<>();
    axisDatas=new ArrayList<>();
    
    Integer cursor=null;
    LuiDbConn lc=null;
    LuiAppConn appConn=null;
    PreparedStatement ps=null;
    ResultSet rs=null;
    try{
     appConn=app.userDbConnections.get(usrConnCode);
     if(appConn.getSessionMode()=='C') { // если работаем через пул коммунальных
              lc=appConn.connPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());
              } else lc=appConn.currentConnection;
     
     cursor=lc.CursorOpen(Query);
     boolean nullsfiltred;
     Double v;
     String vs;
     String stmt4convert;
     String format;
     stmt4convert="select to_char(?,?)";
                     if (lc.getDBvendor().equals("ORA")){
                       stmt4convert=stmt4convert+" from dual";
                     }
     Connection c=lc.getConnection();
     ps=c.prepareStatement(stmt4convert);
     while (lc.CursorNextRow(cursor)){
       ArrayList<String> row=lc.CursorGetRow(cursor);
       if (chartType.equals("MAP")){
         if (row.get(0)==null) continue;
         if (!app.gMap.maps.containsKey(mapCode))continue;
         if (app.gMap.maps.get(mapCode).featuresHM==null)continue;
         if (!app.gMap.maps.get(mapCode).featuresHM.containsKey(row.get(0))){
             continue;
         }
       }
       
       if (like(chartType,"%3D")){
        nullsfiltred=false;   
           for (int i=0;i<colsinfo.size();i++){
               if ( row.get(i)==null && !colsinfo.get(i).LuiDATATYPE.equals("CHAR")){
           nullsfiltred=true;
           break;
       }
           }
       if (nullsfiltred)continue;    
       }
       ArrayList<Object> dataset_row=new ArrayList<>();
       int axisDataIndex=0;
       
       for (int i=0;i<colsinfo.size();i++){
        String dn=dataset.dimensions.get(i).name;
       if ( like(chartType,"%3D") && // Если 3D и
               like(colsinfo.get(i).alias,"GC%") && colsinfo.get(i).LuiDATATYPE.equals("CHAR")){ // если это ось И ОНА СИМВОЛЬНАЯ
          ArrayList<String> axisData;  // формируем данные для оси
         if (axisDatas.size()<axisDataIndex+1){
             axisData=new ArrayList<>();
             axisDatas.add(axisData);
         } else {
             axisData=axisDatas.get(axisDataIndex);
         }
         
         if (!axisData.contains(row.get(i))){
             axisData.add(row.get(i));
         }
         axisDataIndex++;  
         } // если это ось и 3D
        
        if (row.get(i)==null){
            //dataset_row.add(null);
            dataset_row.add("");
        } else {
           if (colsinfo.get(i).LuiDATATYPE.equals("NUMBER")){ // если число
             v=null;
             if (like(colsinfo.get(i).alias,"SF%")){ //и это показатель
                 Integer si=Integer.valueOf(colsinfo.get(i).alias.replace("SF",""))-1;
                 format=this.seriesProps.get(si).Get_Element("format");
                 if (is_not_null(format)){  
                     ps.setDouble(1,Double.valueOf(row.get(i)));
                     ps.setString(2,format);
                     rs=ps.executeQuery();
                     rs.next();
                     vs=rs.getString(1);
                     rs.close();
                     vs=vs.replace(" ","").replace(String.valueOf((char)160),"");
                     try{
                        v=Double.valueOf(vs);
                     } catch (Exception cex){
                         String here="here";
                     }
                     rs.close();
                     rs=null;
                     
                 }
             }
             if (v==null) v=Double.valueOf(row.get(i).replace(" ","").replace(String.valueOf((char)160),"")); // если v ещё не заполнено
             dataset_row.add(v);
             if (dimsStats.get(dn).sum==null)dimsStats.get(dn).sum=v;
             else dimsStats.get(dn).sum=dimsStats.get(dn).sum+v;
             
             if (dimsStats.get(dn).min==null){dimsStats.get(dn).min=String.valueOf(v);
             
             }
             else {
               if (v<Double.valueOf(dimsStats.get(dn).min)) dimsStats.get(dn).min=String.valueOf(v);
               else {
                  if  (dimsStats.get(dn).pmin==null)dimsStats.get(dn).pmin=String.valueOf(v);
                  else {
                      if (v<Double.valueOf(dimsStats.get(dn).pmin))dimsStats.get(dn).pmin=String.valueOf(v);
                  }
               }
             }
             if (dimsStats.get(dn).max==null)dimsStats.get(dn).max=String.valueOf(v);
             else {
               if (v>Double.valueOf(dimsStats.get(dn).max)) dimsStats.get(dn).max=String.valueOf(v);  
             }
             if (dimsStats.get(dn).avg==null)dimsStats.get(dn).avg=v;
             else dimsStats.get(dn).avg=dimsStats.get(dn).avg+v;
             if (dimsStats.get(dn).countDistinct==null)dimsStats.get(dn).countDistinct=1.0;
             else {
               boolean b=false;
               for (int j=0;j<dataset.source.size();j++){
                  if (dataset.source.get(j).get(i)!=null){
                     String s=String.valueOf(dataset.source.get(j).get(i));
                     if (s=="")continue;
                     Double sv=Double.valueOf(s);
                     if (v==sv) {b=true;break;}
                  } 
               }
               if (!b)dimsStats.get(dn).countDistinct++;
             }
           } else { // если не число
             dataset_row.add(row.get(i));
             if (dimsStats.get(dn).countDistinct==null)dimsStats.get(dn).countDistinct=1.0;
             else {
               boolean b=false;
               for (int j=0;j<dataset.source.size();j++){
                  if (dataset.source.get(j).get(i)!=null){
                     String s=String.valueOf(dataset.source.get(j).get(i));
                     if (s.equals(row.get(i))) {b=true;break;}
                  } 
               }
               if (!b)dimsStats.get(dn).countDistinct++;
             }
             if (dimsStats.get(dn).min==null)dimsStats.get(dn).min=row.get(i);
             else {
               if (dimsStats.get(dn).min.compareTo(row.get(i))<0) dimsStats.get(dn).min=row.get(i);
             }
             if (dimsStats.get(dn).max==null)dimsStats.get(dn).max=row.get(i);
             else {
               if (dimsStats.get(dn).max.compareTo(row.get(i))>0) dimsStats.get(dn).max=row.get(i);
             }
           }
           
        }
       }
      
       dataset.source.add(dataset_row);
     }
   /*  эта исскуственная принудительная сортировка 18.11.2021 показалась мне лишней т.к. мешает сортировке задаваемой при отображении диаграммы
     списком
   if (axisDatas!=null && axisDatas.size()>0){
     LuiDbConn mlc=null;    
     try {    
     mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());        
         for (int i=0;i<axisDatas.size();i++){
         ArrayList<ArrayList<String>> arrsorted=mlc.getSelectAllRowsValList("select value from json_array_elements_text('"+
                 app.toJSON(axisDatas.get(i))+"'::json) order by value");
         axisDatas.get(i).clear();
         for (int ai=0;ai<arrsorted.size();ai++){
             axisDatas.get(i).add(arrsorted.get(ai).get(0));
         }
         }
     } finally {app.metaConnPool.SetFree(mlc);}
     
     }
     */
     bigData=false;
     for (int i=0;i<dataset.dimensions.size();i++){
     String k=dataset.dimensions.get(i).name;
     dimsStats.get(k).count=Double.valueOf(String.valueOf(dataset.source.size()));
     if (dimsStats.get(k).count>1500) bigData=true;
     if (dimsStats.get(k).avg!=null) dimsStats.get(k).avg=dimsStats.get(k).avg/dimsStats.get(k).count;   
     }
    makeFormParameters4Titles(lc);
    } finally {
      if (rs!=null && !rs.isClosed()){
          try{rs.close();}catch(Exception ex){}
      }  
      if (ps!=null && !ps.isClosed()){
        try{ps.close();}catch(Exception ex){}
      }
      if (lc!=null){
          if (cursor!=null && lc.CursorisOpen(cursor))try{lc.CursorClose(cursor);}catch(Exception ex){}
          if (appConn.getSessionMode()=='C') appConn.connPool.SetFree(lc);
                      
      }
  }
  }
public String getAxisName(String pAxis){
 String rc="";
    switch (chartType){
       case "PIE":break;
       case "BAR":case "LINE":case "SCT":
       if (pAxis.equals("X"))rc= groupProps.get(0).Get_Element("name");
       if (pAxis.equals("Y2")||pAxis.equals("Y1")){
       int ind=0;
       if (pAxis.equals("Y2"))ind=1;
       int cnt=0;    
         for (int i=0;i<series.size();i++){
           if (series.get(i)==null)continue;
           if (series.get(i).name==null)continue;   
           if (series.get(i).yAxisIndex==ind){
             cnt++;
             if (cnt>1)rc="";
             else rc=series.get(i).name;
           }  
         }  
       if (pAxis.equals("Y1")) rc=NVL(chartPref.Get_Element("Y1_NAME"),rc);
       else rc=NVL(chartPref.Get_Element("Y2_NAME"),rc);  
       }
       
       break;
       case "BARG":
       if (pAxis.equals("Y"))rc=groupProps.get(0).Get_Element("name");
       if (pAxis.equals("X2")||pAxis.equals("X1")){
       int ind=0;
       if (pAxis.equals("X2"))ind=1;
       int cnt=0;    
         for (int i=0;i<series.size();i++){
             if (series.get(i)==null)continue;
             if (series.get(i).name==null)continue;
           if (series.get(i).xAxisIndex==ind){
             cnt++;
             if (cnt>1)rc="";
             else rc=series.get(i).name;
           }  
         }  
       }
       
       break;
       case "BAR3D":
       case "SCT3D":
       if (pAxis.equals("X"))rc= groupProps.get(0).Get_Element("name");    
       if (pAxis.equals("Y"))rc= groupProps.get(1).Get_Element("name");    
       if (pAxis.equals("Z")){
       int cnt=0;    
         for (int i=0;i<series.size();i++){
             if (series.get(i)==null)continue;
             if (series.get(i).name==null)continue;
             cnt++;
             if (cnt>1)rc="";
             else rc=series.get(i).name;
        
         }  
       
       }
       
       }
    return rc;
 }
public void sendConfigList() throws LuiException, SQLException{
  if (seriesProps.size()<2) return;
  CurCfg="";
  String gfcol="";
  switch (chartType){
      case "BAR":
      case "LINE":
      case "SCT":
      case "BARG":
       return;   
      case "BAR3D":
      case "SCT3D":
       CurCfg=NVL(chartPref.Get_Element("CFG3D"),"0");
             if (app.NLS.currentLang.code.equals("RUS")){
           gfcol="0:Матрёшка;1:Стопка;";

       } else {
           gfcol="0:Matryoshka;1:Stack;";;

       }    
      gfcol=gfcol.replace(CurCfg+":",":"); 
      break;   
      
      
      case "PIE":
      case "MAP":
      case "WHR":
      CurCfg=NVL(chartPref.Get_Element("CFG"),"0");    
      for (int i=0;i<seriesProps.size();i++){
        if (!CurCfg.equals(String.valueOf(i)))
        gfcol=gfcol+String.valueOf(i);
        gfcol=gfcol+":"+seriesProps.get(i).Get_Element("name").replace(";",",")+";";
      }    
      break;    
  }
  LuiClCommandGroup XMLcg=app.commandWriter.addGroup("DgChartConfList");
    LuiClCommand XMLcmd=XMLcg.addCommand("Form");
    XMLcmd.addScaPar("FormID",frm.getFormID());
    XMLcmd.addScaPar("ConfigList",gfcol);
}
public ArrayList<Double> getBrightness4Color(String pColor){
    ArrayList<Double> rc=new ArrayList<>();
    /*if ("r_green".equals(pColor)){
    rc.add(0.91);        
    rc.add(0.2);
  
    }else {
    rc.add(0.91);    
    rc.add(0.4);
    
    }*/
    rc.add(0.91);    
    rc.add(0.3);
    return rc;
}
/*public ArrayList<String> getColorSpectr(String pColor){
    ArrayList<String> rc=new ArrayList<>();
    switch (pColor){
        case "r_blue":
            rc.add("rgba(180,212,243,1)");//rc.add("#b4d4f3");
            rc.add("rgba(58,112,163,1)");
        break;
        case "r_black":    
            rc.add("rgba(223,222,222,1)");//rc.add("#dfdede");
            rc.add("rgba(51,51,51,1)");
        break;
        case "r_brown":
            rc.add("rgba(246,210,186,1)");//rc.add("#f6d2ba");
            rc.add("rgba(170,94,44,1)");
        break;
        case "r_red":
            rc.add("rgba(248,177,177,1)");//rc.add("#f8b1b1");
            rc.add("rgba(218,19,19,1)");
        break;
        case "r_orange":
            rc.add("rgba(246,207,179,1)");//rc.add("#f6cfb3");
            rc.add("rgba(255,106,0,1)");
        break;
        case "r_yellow":
            rc.add("rgba(248,243,177,1)");//rc.add("#f8f3b1");
            rc.add("rgba(255,238,0,1)");
        break;    
        case "r_lblue":
            rc.add("rgba(204,248,248,1)");//rc.add("#ccf8f8");
            rc.add("rgba(0,255,255,1)");
        break;
        case "r_magenta":
            rc.add("rgba(235,204,248,1)");//rc.add("#ebccf8");
            rc.add("rgba(178,0,255,1)");
        break;
        case "r_green":
            rc.add("rgba(185,239,192,1)");//rc.add("#b9efc0");
            rc.add("rgba(7,161,27,1)");
        break;
    }
return rc;
}*/
/*public String getColor(String pColor){
    if (pColor.equals("r_blue"))return "rgba(58,112,163,1)";//"#3a70a3";
    if (pColor.equals("r_black"))return "rgba(51,51,51,1)";//"#333333";
    if (pColor.equals("r_brown"))return "rgba(170,94,44,1)";// "#aa5e2c";
    if (pColor.equals("r_red"))return   "rgba(218,19,19,1)";//""#da1313";
    if (pColor.equals("r_orange"))return "rgba(255,106,0,1)";//"#ff6a00";
    if (pColor.equals("r_yellow"))return "rgba(255,238,0,1)";//"#ffee00";
    if (pColor.equals("r_lblue"))return "rgba(0,255,255,1)";// "#00ffff";
    if (pColor.equals("r_magenta"))return "rgba(178,0,255,1)";//"#b200ff";
    if (pColor.equals("r_green"))return "rgba(7,161,27,1)";//"#07a11b";
    return pColor.substring(2);

}*/
public String getSerieDefColor(int seq){
    int ci=seq-1;
    while (ci>=colors.size()){
        ci=ci-colors.size();
    }
    return colors.get(ci);
}
public void setAutorotate(String r){
    if (r.equals("Y"))
    this.autorotate3D=true;
    else
        this.autorotate3D=false;
}
public String parseTitle(String pTitle,LuiDbConn pmlc) throws SQLException, LuiException{
    LuiDbConn mlc=pmlc;
    
    
    pTitle=pTitle.replace("{Г}", datetimecol.Get_Element("yyyy"));pTitle=pTitle.replace("{Y}", datetimecol.Get_Element("yyyy"));
    pTitle=pTitle.replace("{М}", datetimecol.Get_Element("mm"));pTitle=pTitle.replace("{M}", datetimecol.Get_Element("mm"));
    pTitle=pTitle.replace("{Д}", datetimecol.Get_Element("dd"));pTitle=pTitle.replace("{D}", datetimecol.Get_Element("dd"));
    pTitle=pTitle.replace("{ч}", datetimecol.Get_Element("hh"));pTitle=pTitle.replace("{h}", datetimecol.Get_Element("hh"));
    pTitle=pTitle.replace("{м}", datetimecol.Get_Element("mi"));pTitle=pTitle.replace("{m}", datetimecol.Get_Element("mi"));
    //if (app.NLS.currentLang.code.equals("RUS"))
    //ttit.text="{П}/{К}\n"+"{У}\n"+"{И}";
    //else ttit.text="{V}/{C}\n"+"{W}\n"+"{T}";
    String V="";
      for (int i=0;i<seriesProps.size();i++){
          if (is_not_null(seriesProps.get(i).Get_Element("name"))){
              if (V!="")V=V+", ";
              V=V+seriesProps.get(i).Get_Element("name");
          }
      }
/*    for (int i=0;i<series.size();i++){
        if (is_not_null(series.get(i).name)){
        if (V!="")V=V+", ";
        V=V+series.get(i).name;
        }
    }*/
    String C="";
    for (int i=0;i<groupProps.size();i++){
        if (C!="")C=C+", ";
        C=C+groupProps.get(i).Get_Element("name");
    }
    String W=this.ChartTitle;
    String T="";
    PreparedStatement ps=null;
    
    ResultSet rs=null;
    try{
        if (pmlc==null){
        mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());        
    }
    String stmt4convert="select to_char(?,?)";
    if (mlc.getDBvendor().equals("ORA")){
        stmt4convert=stmt4convert+" from dual";
    }
    ps=mlc.getConnection().prepareStatement(stmt4convert);
    
    String format;
    String vs;
    
    for (int i=0;i<seriesProps.size();i++){
        if (series.size()<=i)continue;
        if (is_null(series.get(i).name))continue;
        if (T!="")T=T+", ";
        if (!(chartType.equals("MAP")||chartType.equals("PIE")||chartType.equals("WHR"))) T=T+series.get(i).name+"=";
       if (dimsStats!=null && dimsStats.containsKey(series.get(i).name) && dimsStats.get(series.get(i).name).sum!=null){
        Double d=dimsStats.get(series.get(i).name).sum;
        format=seriesProps.get(i).Get_Element("format");
        if (is_not_null(format)){
        ps.setDouble(1,d);
        ps.setString(2,format);
        rs=ps.executeQuery();
                     rs.next();
                     vs=rs.getString(1);
                     rs.close();
                     vs=vs.replace(" ","").replace(String.valueOf((char)160),"");
               try{
                 d=Double.valueOf(vs);
               } catch (Exception ex){
                 d=dimsStats.get(series.get(i).name).sum;  
               }
        }
        Boolean billion=false;
        if (Math.abs(d)>1000000.0) {
            d=d/1000000.0;d=Math.round(d*100.0)/100.0;
         billion=true;
        }
        if  (d==Math.round(d)) 
            T=T+d.toString().replace(".0","");
        else T=T+d.toString();
        
        if (billion){ 
            if(app.NLS.currentLang.code.equals("RUS")) {
                T=T+" млн.";
            } else {
                T=T+" mill.";
            }
        }    
    }
    } 
    pTitle=pTitle.replace("{П}",V);pTitle=pTitle.replace("{V}",V); // имена показателей
    pTitle=pTitle.replace("{К}",C);pTitle=pTitle.replace("{C}",C); // имена категорий
    pTitle=pTitle.replace("{У}",W);pTitle=pTitle.replace("{W}",W); // условие
    pTitle=pTitle.replace("{И}",T);pTitle=pTitle.replace("{T}",T); // итоги
    if (groupOutput!=null && groupOutput.size()>0){
        for (int i=0;i<groupOutput.size();i++){
            pTitle=pTitle.replace("{"+groupOutput.get(i).Get_Element("name")+"}",NVL(groupOutput.get(i).Get_Element("value"),""));
        }
    }
    } finally{
    if (rs!=null && !rs.isClosed())try{rs.close();}catch(Exception ex){}
    if (ps!=null && !ps.isClosed())try{ps.close();}catch(Exception ex){}
    if (pmlc==null) {app.metaConnPool.SetFree(mlc);}
    }
    LuiAppProp p=frm.addProperty("chart$title", pTitle);
    pTitle=p.getComputedProperty();
    return pTitle;
}

public void callDetail4AllCharts() throws LuiException, SQLException{
  String win=frm.getVal("WindowID");
  for (String fc:app.forms.keySet()){
      LuiAppForm dfrm=app.forms.get(fc);
      if (!dfrm.getVal("WindowID").equals(win))continue;
      dfrm.addProperty("ForceDetail","Y");
      if (dfrm.elements.containsKey("DETAIL") && dfrm.elements.get("DETAIL").getType().equals("ACTION")){
        if (dfrm.elements.get("DETAIL").properties.get("ACTIVE").isDynamic())
          dfrm.elements.get("DETAIL").properties.get("ACTIVE").clearCompVal();
      }
      String ec=dfrm.checkHotKey("DETAIL","Form");
      if (is_not_null(ec)){
          dfrm.runAction(ec);
      }
      dfrm.properties.remove("ForceDetail");
  }
}
/**
 * Формирование легенды условных обозначений для карты эта легенда строиться из множества объектов типа etitle
 * так сделано чтобы при клике в элемент была возможность по ComponentIndex что-то сделать например подсветить регион
 * или выполнить вызов другого графика
 * @return 
 */
public void makeMapLabelLegend(ArrayList<etitle> pTitles,LuiDbConn mlc,String pFormat,option o) throws SQLException, LuiException{
   // количество столбцов
   int cols=Integer.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_COLUMNS"),"5"));
   // размер шрифта
   Double fontsize=Double.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_FONTSIZE"),"9"))*sizeCoeff;
   // положение слева 1-го столбца
   Double left=Double.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_LEFT"),"10"))*sizeCoeff;
   // ширина зоны имён
   Double nameWidth=Double.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_NWIDTH"),"200"))*sizeCoeff;
   // ширина зоны значений
   Double valWidth=Integer.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_VWIDTH"),"50"))*sizeCoeff;
   // расстояние между столбцами
   Double colGap=Integer.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_COLGAP"),"10"))*sizeCoeff;
   // сортировка
   String orderBy=NVL(chartPref.Get_Element("MAP_LEGEND_ORDERBY"),"sign");
   String where="";
   if (chartPref.Get_Element("MAP_LEGEND_SHOW").equals("NOT_NULL")){
       where=" where value is not null";
   }
   // немного норализуем left
   if (frm.properties.containsKey("ChartWidth")){
   if ((left+nameWidth+valWidth)>Double.valueOf(frm.getProperty("ChartWidth"))){
      left= Double.valueOf(frm.getProperty("ChartWidth"))-(nameWidth+valWidth);
   }
   }
   // сочиняем запрос к легенде
   String stmt="select di,sign,name,";
   if (is_null(pFormat)) stmt=stmt+"value";
   else
   stmt=stmt+"to_char(value,'"+pFormat+"')";
   stmt=stmt+"\"val\",color from json_to_recordset('"+
           app.toJSON(mapLegend)+"') as rec(di numeric,sign ";
   if (mapLegendSignIsNumeric) stmt=stmt+"numeric";
   else stmt=stmt+"text";
   stmt=stmt+",name text,value numeric,color text)";
   stmt=stmt+where;
   stmt=stmt+" order by "+orderBy;
   ArrayList<LuiCollection> aecol=mlc.getSelectAllRowsValMap(stmt);
   if (aecol==null)return;
   // вычислим количество строк
   int rows=aecol.size()/cols;
   if (rows*cols<aecol.size())rows++;
   // положение снизу 1-й строки
   Double bot=fontsize*2*rows+Double.valueOf(NVL(chartPref.Get_Element("MAP_LEGEND_BOTTOM"),"10"))*sizeCoeff;
   
   int ile=0;//индекс элемента легенды
   // крутим столбцы легенды
   for (int ic=0;ic<cols;ic++){
     Double bottom=bot;
     // внутри столбца крутим строки
     for (int ir=0;ir<rows;ir++){
         String v=NVL(aecol.get(ile).Get_Element("val"),"");
         if (is_null(pFormat)){
             v=LuiString.RTrim(v,"0");
             if (like(v,"%."))v=v.replace(".","");
         }
         // сочиняем объект etitle
         etitle lt=new etitle();
         lt.di=Integer.valueOf(aecol.get(ile).Get_Element("di"));
         lt.left=left;
         lt.show=true;
         lt.triggerEvent=true;
         lt.bottom=bottom;
         lt.text="{a|"+aecol.get(ile).Get_Element("sign")+". "+aecol.get(ile).Get_Element("name")+"}{b|"+
                 v+"}";
         lt.textStyle=new eTextStyle();
         lt.textStyle.lineHeight=Double.valueOf(String.valueOf(fontsize-1));
         lt.textStyle.rich=new erich();
                  lt.textStyle.rich.a=new eTextStyle();
         lt.textStyle.rich.a.align="left";
         lt.textStyle.rich.a.color=NVL(chartPref.Get_Element("MAP_LEGEND_FONTCOLOR"),"rgb(0 ,0 ,0 )");
         lt.textStyle.rich.a.fontSize=Double.valueOf(String.valueOf(fontsize));
         lt.textStyle.rich.a.fontWeight=NVL(chartPref.Get_Element("MAP_LEGEND_FONTWEIGHT"),"normal");
         lt.textStyle.rich.a.fontStyle=NVL(chartPref.Get_Element("MAP_LEGEND_FONTSTYLE"),"normal");
         //lt.textStyle.rich.a.fontFamily="Calibri";
         lt.textStyle.rich.a.width=nameWidth;
         lt.textStyle.rich.b=new eTextStyle();
         lt.textStyle.rich.b.align="right";
         lt.textStyle.rich.b.color="rgb(0 ,0 ,0 )";
         if (is_not_null(chartPref.Get_Element("MAP_LEGEND_FONTCOLOR"))){
             lt.textStyle.rich.b.color=chartPref.Get_Element("MAP_LEGEND_FONTCOLOR");
         } else {
             String rgba[]=aecol.get(ile).Get_Element("color").replace(" ","").replace("(","").replace(")","").replace("rgba","").replace("rgb","").split(",");
             Double lignh=(0.299*Double.valueOf(rgba[0])+0.587*Double.valueOf(rgba[1])+0.114*Double.valueOf(rgba[2]))/255.0;
             if (rgba.length>3) lignh=lignh*(2-Double.valueOf(rgba[3]));
             if (lignh<0.5)lt.textStyle.rich.b.color="rgb(255,255,255)";
         }
         
         lt.textStyle.rich.b.fontSize=Double.valueOf(String.valueOf(fontsize));
         lt.textStyle.rich.b.fontWeight=NVL(chartPref.Get_Element("MAP_LEGEND_FONTWEIGHT"),"normal");
         lt.textStyle.rich.b.fontStyle=NVL(chartPref.Get_Element("MAP_LEGEND_FONTSTYLE"),"normal");
         //lt.textStyle.rich.b.fontFamily="Calibri";
         lt.textStyle.rich.b.width=valWidth;
         lt.textStyle.rich.b.backgroundColor=aecol.get(ile).Get_Element("color");
         
         lt.textStyle.rich.b.borderColor=aecol.get(ile).Get_Element("color");
         lt.textStyle.rich.b.borderWidth=fontsize;
         // помещаем в массив
         pTitles.add(lt);
         // изменяем положение следующей строки
         bottom=bottom-(fontsize*2);
         ile++;
         if (ile>=aecol.size())break;
     }
     // изменяем положение следующкго столбца
     left=left+nameWidth+valWidth+colGap;
     if (ile>=aecol.size())break;
   }
   for (int i=ile;i<mapLegend.size();i++){
       etitle lt=new etitle();
       lt.show=false;
       pTitles.add(lt);
       
   }
}
/**
 * Генерация коллекции кусочной раскраски для бланка редактирования кусочной раскраски
 * Выполняется с учётом следующего
 * Если кусочной раскраски ещё нет - генерируем по умолчанию
 * Если уже есть то вычисляем её пригодность для текущего min/max серии si
 * Если не подходит использкм уже созданный ранее пользователем набор цветов а диапазоны генерируем вновь
 */
public String getVMPcollection4blank(int si) throws LuiException, SQLException{
    String rc="";
    LuiDbConn mlc=null;
    try{
       mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser()); 
       String oldCol=mlc.getSelectResult("select lui_f_dg_get_chart_pref_val("+DgId+","+Level+",'MAPVMP("+String.valueOf(si+1)+")_COLORS')");
       if (is_null(oldCol)) return this.makeVMpiecesDefault(si, null, null, null, null, null);
       LuiCollection col=new LuiCollection(oldCol);
        if (NVL(chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_ADAPTIVE"),"Y").equals("N")) return col.toString();
       String sname=series.get(0).name;
       if (dimsStats.get(sname).min!=null && dimsStats.get(sname).max!=null && dimsStats.get(sname).min!=dimsStats.get(sname).max){
     String sdmin=dimsStats.get(sname).min;
     String sdmax=dimsStats.get(sname).max;
     String somin="";
     String somax="";      
     if (col.size()>0){
     somin=col.Get_Element("C1").split("/")[1];
     somax=col.Get_Element("C"+String.valueOf(col.size())).split("/")[2];    
     try{
          somin=String.valueOf(Double.valueOf(somin));
          somax=String.valueOf(Double.valueOf(somax));
      }catch(Exception ex){}
     }
     if (!somin.equals(sdmin) || !somax.equals(sdmax)){
      LuiCollection newCol=new LuiCollection(this.makeVMpiecesDefault(si, null, null, col.size(),"",""));
      if (col.size()!=newCol.size()) return newCol.toString();
      for (String ckey:col.keySet()){
        String color=col.Get_Element(ckey).split("/")[0];
        String nmin=newCol.Get_Element(ckey).split("/")[1];
        String nmax=newCol.Get_Element(ckey).split("/")[2];
        newCol.Add_Element(ckey, color+"/"+nmin+"/"+nmax);
      }  
       return newCol.toString();
    } else return col.toString();
       } else 
           return this.makeVMpiecesDefault(si, null, null, null, null, null);
    }finally {
            if (mlc!=null) app.metaConnPool.SetFree(mlc);
            }
    
}
/**
 * Создание массива pieces для кусочной раскраски с учётом того, какую раскраску и кусочки
 * пользователь настроил и сохранил в БД
     * @param si - id кривой
 */
@SuppressWarnings("UnusedAssignment")
public void makeVMpieces(int si,LuiDbConn mlc,evisualMap vmp) throws SQLException{
    ArrayList<epiece> pieces = new ArrayList<>();
    ArrayList<LuiCollection> mma= new ArrayList<>();
    PreparedStatement ps;
    ps = null;
    ResultSet rs=null;
    String stmt4convert;
     String format=seriesProps.get(si).Get_Element("format");
     stmt4convert="select to_char(?,?)";
                     if (mlc.getDBvendor().equals("ORA")){
                       stmt4convert=stmt4convert+" from dual";
                     }
    LuiCollection col=new LuiCollection(chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_COLORS"));
      //попытка анализа и авто перестройки
   if (NVL(chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_ADAPTIVE"),"Y").equals("Y")){
  String sname=series.get(0).name;
  if (dimsStats.get(sname).min!=null && dimsStats.get(sname).max!=null){
     String sdmin=dimsStats.get(sname).min;
     String sdmax=dimsStats.get(sname).max;
     String somin="";
     String somax="";
     String scolor="";
     String ecolor="";
     if (col.size()>0){
     somin=col.Get_Element("C1").split("/")[1];
     scolor=col.Get_Element("C1").split("/")[0];
     somax=col.Get_Element("C"+String.valueOf(col.size())).split("/")[2];
     ecolor=col.Get_Element("C"+String.valueOf(col.size())).split("/")[0];
      try{
          somin=String.valueOf(Double.valueOf(somin));
          somax=String.valueOf(Double.valueOf(somax));
      }catch(Exception ex){}
     }
    if (!somin.equals(sdmin) || !somax.equals(sdmax)){
      LuiCollection newCol=new LuiCollection(
              this.makeVMpiecesDefault(si, null, null, col.size(),scolor,ecolor)
      );
      if (col.size()==newCol.size()){
      for (String ckey:col.keySet()){
        String color=col.Get_Element(ckey).split("/")[0];
        String nmin=newCol.Get_Element(ckey).split("/")[1];
        String nmax=newCol.Get_Element(ckey).split("/")[2];
        newCol.Add_Element(ckey, color+"/"+nmin+"/"+nmax);
      }
      }
      /*ArrayList<String> newColorList=new ArrayList<>(); распределение цвета по жиапазонам 
      for (String ckey:newCol.keySet()){
        //String color=col.Get_Element(ckey).split("/")[0]; !!! ноавый цвет???
        String color=newCol.Get_Element(ckey).split("/")[0];
        newColorList.add(color);
        String nmin=newCol.Get_Element(ckey).split("/")[1];
        String nmax=newCol.Get_Element(ckey).split("/")[2];
        newCol.Add_Element(ckey, color+"/"+nmin+"/"+nmax);
      }  */
       col=newCol;
       chartPref.Add_Element("MAPVMP("+String.valueOf(si+1)+")_COLORS",col.toString());
    }
  }}
try {                     
     Connection c=mlc.getConnection();
     ps=c.prepareStatement(stmt4convert);

    int maxlengthval=0;
    boolean minminus=false;
    boolean maxminus=false;
    Character c160=(char)160;
    int rcnt=0;
    for (String key:col.keySet()){
        rcnt++;
        String elements[]=col.get(key).split("/");
        String min=elements[1];
        String max=elements[2];
        if (Double.valueOf(min)<0)minminus=true;
        if (Double.valueOf(max)<0)maxminus=true;
        if (is_not_null(format)){
            ps.setDouble(1,Double.valueOf(min));
            ps.setString(2,format);
            rs=ps.executeQuery();
            rs.next();
            min=rs.getString(1);
            rs.close();
            ps.setDouble(1,Double.valueOf(max));
            ps.setString(2,format);
            rs=ps.executeQuery();
            rs.next();
            max=rs.getString(1);
            rs.close();
        }
         if (min.length()>maxlengthval)maxlengthval=min.length();
         if (max.length()>maxlengthval)maxlengthval=max.length();
         mma.add(new LuiCollection("min:"+min+";max:"+max+";")); 
    }
       int rnum=0;
    for (String key:col.keySet()){
        rnum++;
        String elements[]=col.get(key).split("/");
         epiece pie=new epiece();
         pie.color=elements[0];
         if (rnum==1){pie.lte=Double.valueOf(elements[2]);
      //    String dmin=NVL(dimsStats.get(series.get(si).name).min,"");
      //   if (!dmin.equals(Double.valueOf(elements[1]).toString())) {vmp.borderWidth=2;vmp.borderColor="red";}
                     }
         else {
             if (rnum==rcnt) {pie.gt=Double.valueOf(elements[1]);
        //      String dmax=NVL(dimsStats.get(series.get(si).name).max,"");
         //if (!dmax.equals(Double.valueOf(elements[2]).toString())) {vmp.borderWidth=2;vmp.borderColor="red";}
             }
             else {
                 pie.min=Double.valueOf(elements[1]);
                 pie.max=Double.valueOf(elements[2]);
             }
         }
         String min=mma.get(rnum-1).Get_Element("min");
         if (minminus && !like(min,"%-%"))min=" "+min;
         min=LuiString.Ladd(min,' ',maxlengthval-min.length()+1);
         String max=mma.get(rnum-1).Get_Element("max");
         if (maxminus && !like(max,"%-%"))max=" "+max;
         max=LuiString.Ladd(max,' ',maxlengthval-max.length()+1);
         pie.label=min+" - "+max;
         pieces.add(pie);
    }
  
            
} finally {
    if (ps!=null) ps.close();
}   
    
    vmp.pieces=pieces;
    
}
/**
 * Создание первоначального дефолтного мессива для кусочного VM 
     * @param si -- id кривой
 * @param pMin -- минимум
 * @param pMax -- максимум
 * @param pRanges -- кол.диапазонов
 * @param pStartColor -- начальный цвет
 * @param pEndColor -- конечный цвет
 * @return -- коллекция вида C1:color1/min1/max1;C2:color2/min2/max2;...;
 */
public String makeVMpiecesDefault(int si,Double pMin,Double pMax,Integer pRanges,String pStartColor, String pEndColor){
    
    ArrayList<epiece> pieces;
    ArrayList<String> colors = MAPVMcolorList;
            //this.makeColorsArray4Map(si, series.get(0).itemStyle.myColor);
    
    if (colors.size()>=2){
        if (is_null(pStartColor)) pStartColor=colors.get(0);
        if (is_null(pEndColor)) pEndColor=colors.get(colors.size()-1);
    }
    if (is_null(pStartColor)) pStartColor="rgb(255,255,255)";
    if (is_null(pEndColor)) pEndColor=series.get(0).itemStyle.myColor;
    
    if (pRanges==null || pRanges==0)pRanges=5;
    if (pMin==null){
        if (dimsStats!=null){
            if (dimsStats.containsKey(series.get(0).name)){
                if (is_not_null(dimsStats.get(series.get(0).name).min)){
                    pMin=Double.valueOf(dimsStats.get(series.get(0).name).min);
                }
            }
        }
    }
    if (pMin==null)pMin=0.0;
    if (pMax==null){
        if (dimsStats!=null){
            if (dimsStats.containsKey(series.get(0).name)){
                if (is_not_null(dimsStats.get(series.get(0).name).max)){
                    pMax=Double.valueOf(dimsStats.get(series.get(0).name).max);
                }
            }
        }
    }
    if (pMax==null)pMax=100.0;
    if (pMin==null)pMin=0.0;
    if (pMin.toString().equals(pMax.toString())){
        if (pMin==0.0)pMax=100.0;
        else pMin=pMax/2;
    }
    
    if (pMin<0 && pMax>0 && MAPnValues.size()>pRanges/2 && MAPpValues.size()>pRanges/2
            && !pStartColor.replace(" ","").equals("rgb(255,255,255)")&& !pEndColor.replace(" ","").equals("rgb(255,255,255)")) {
        //если есть переход через 0 и начальный и конечный цвета не белые
        pieces= makeVMpiecesDefaultCooldHot(si,pRanges,pStartColor,pEndColor);
    } else {
        
    pieces = new ArrayList<>();
    //if (colors.size()!=3){
    colors.clear();
    colors.add(pStartColor);colors.add(pEndColor);
    //}
    //вначале определим размер типового кусочка
    Double vPie=(pMax-pMin)/pRanges;
    if (vPie>10) vPie=Double.valueOf(String.valueOf(Math.round(vPie))); // Если он больше 10 округлим его до целого.
    int picnt=1;
    for(double left=pMin;left<pMax;left=left+vPie){
        epiece pie=new epiece();
        pie.min=left;
        if (left+vPie>pMax ||picnt>=pRanges) pie.max=pMax;
        else pie.max=left+vPie;
        pie.color="";
        if (pie.max>=pMax ||picnt>=pRanges) pie.color=pEndColor;
        else {
            if (pie.min<=pMin ||picnt==1)pie.color=pStartColor;
            else {
                // расчёт цвета              
                pie.color=this.getColor4value((pie.max+pie.min)/2.0, pMin, pMax, colors);
            }
        }
        pieces.add(pie);
        if (picnt>=pRanges)break;
        if (pie.max>=pMax)break;
        picnt++;
    }
    }
LuiCollection col=new LuiCollection("");    
 for (int i=0;i<pieces.size();i++){
   String min=LuiString.RTrim(String.format("%f",Double.valueOf(pieces.get(i).min.toString())).replace(",","."),"0");
   if (like(min,"%."))min=min.replace(".","");
   String max=LuiString.RTrim(String.format("%f",Double.valueOf(pieces.get(i).max.toString())).replace(",","."),"0");
   if (like(max,"%."))max=max.replace(".","");
   col.Add_Element("C"+String.valueOf(i+1),pieces.get(i).color+"/"+min+"/"+max);
 }
 return col.toString();
}  
/**
 * Изготовление кусочного VM алгоритмом холодно-горячо
 * @param si
 * @param pRanges
 * @param pStartColor
 * @param pEndColor
 * @return 
 */
ArrayList<epiece> makeVMpiecesDefaultCooldHot(int si,int pRanges,String pStartColor, String pEndColor){
    ArrayList<epiece> pieces=new ArrayList<>();
    ArrayList<epiece> ppieces=new ArrayList<>();
    ArrayList<epiece> npieces=new ArrayList<>();
    epiece cpiece=new epiece();
    boolean rchet=false;
    int ppranges; // количество холодных и горячих диапазонов
    int pmembers; // среднее количество членов положительного диапазона
    int nmembers;// среднее количество членов отрицательного диапазона
    int sp=0;// начальное из положительного массива
    int sn=0;// начальное из отрицательного массива
    if ((pRanges/2)*2 == pRanges) {
        rchet=true;ppranges=pRanges/2;
    } else ppranges=(pRanges-1)/2;
    if (!rchet) {//если количество диапазонов нечётное определим свойства центрального диапазона
        cpiece.color="rgb(245,245,245)";
        //определение границ центрального диапазона
        // определим min положительное >0
        int pp=0;
        for(;pp<MAPpValues.size();pp++){
            if (MAPpValues.get(pp)>0)break;
        }
        cpiece.max=Math.min(Math.abs(MAPnValues.get(0)),Math.abs(MAPpValues.get(pp)));
        cpiece.min=0-cpiece.max;
        // определяем количество положительных попавших в этот центральный
        int pInCenter=0;
        for(int i=0;i<MAPpValues.size();i++){
            if (MAPpValues.get(i)>cpiece.min && MAPpValues.get(i)<cpiece.max) pInCenter++;
        }
        // определяем количество отрицательных попавших в этот центральный
        int nInCenter=0;
        for(int i=0;i<MAPnValues.size();i++){
            if ((0-MAPnValues.get(i))>cpiece.min && (0-MAPpValues.get(i))<cpiece.max) nInCenter++;
        }

        pmembers=(int)Math.ceil((Double.valueOf(String.valueOf(MAPpValues.size()-pInCenter)))/Double.valueOf(String.valueOf(ppranges)));
        nmembers=(int)Math.ceil((Double.valueOf(String.valueOf(MAPnValues.size()-nInCenter)))/Double.valueOf(String.valueOf(ppranges)));
        //nmembers=(MAPnValues.size()-nInCenter)/ppranges;
        sp=pInCenter;
        sn=nInCenter;
    } else {
        pmembers=MAPpValues.size()/ppranges;
        nmembers=MAPnValues.size()/ppranges;
    }
    // расчёт положительных диапазонов
    // пара цветов
    ArrayList<String> colors=new ArrayList<>();
    colors.add("rgb(255,255,255)");
    colors.add(pEndColor);
    for(int i=0;i<ppranges;i++){
        // создаём диапазон
        epiece pie=new epiece();
        // набиваем в диапазон нужное количество значений
        if (sp>=MAPpValues.size()) break; // защита от выхода за пределы
        pie.min=MAPpValues.get(sp); //начало диапазона
        for(int spi=sp;spi<sp+pmembers;spi++){
        if (spi>=MAPpValues.size()) break; // защита от выхода за пределы
        pie.max=MAPpValues.get(spi); //конец диапазона
        }
        if (rchet)
        pie.color=this.getColor4value(Double.valueOf(String.valueOf(i+1)), 0.0,Double.valueOf(String.valueOf(ppranges)),colors);
        else
        pie.color=this.getColor4value(Double.valueOf(String.valueOf(i+1)), 0.0,Double.valueOf(String.valueOf(ppranges)),colors);
        ppieces.add(pie);
        sp=sp+pmembers;
        if (sp>=MAPpValues.size()) break; // защита от выхода за пределы
    }
    if (ppieces.size()>0){
    ppieces.get(ppieces.size()-1).max=MAPpValues.get(MAPpValues.size()-1);
    if (rchet) ppieces.get(0).min=0.0;
    }
    // расчёт отрицательных диапазонов
    // пара цветов
    colors.clear();
    colors.add(pStartColor);
    colors.add("rgb(255,255,255)");
    
    
    
    for(int i=0;i<ppranges;i++){
        // создаём диапазон
        epiece pie=new epiece();
        // набиваем в диапазон нужное количество значений
        if (sn>=MAPnValues.size()) break; // защита от выхода за пределы
        pie.max=0-MAPnValues.get(sn); //начало диапазона
        for(int sni=sn;sni<sn+nmembers;sni++){
        if (sni>=MAPnValues.size()) break; // защита от выхода за пределы
        pie.min=0-MAPnValues.get(sni); //конец диапазона
        }
         if (rchet)
        pie.color=this.getColor4value(Double.valueOf(String.valueOf(0-(i+1))),Double.valueOf(String.valueOf(0-ppranges)), 0.0,colors);
        else
        pie.color=this.getColor4value(Double.valueOf(String.valueOf(0-(i+1))),Double.valueOf(String.valueOf(0-ppranges)), 0.0,colors);
        npieces.add(pie);
        sn=sn+nmembers;
        if (sn>=MAPnValues.size()) break; // защита от выхода за пределы
    }
    if (npieces.size()>0){
    npieces.get(npieces.size()-1).min=0-MAPnValues.get(MAPnValues.size()-1);
    if (rchet) npieces.get(0).max=0.0;
    }
    // формирование результата
    for (int i=npieces.size()-1;i>=0;i--)pieces.add(npieces.get(i));
    if (!rchet)pieces.add(cpiece);
    for (int i=0;i<ppieces.size();i++)pieces.add(ppieces.get(i));
    for (int i=1;i<pieces.size();i++){
        pieces.get(i).min=pieces.get(i-1).max;
    }
    return pieces;
}
/**
 * Вычисление цвета для значения в случае кусочного VisualMap
 * 
 */
public String getColor4valueVMP(Double pValue,int si){
    String rc="rgb(255,255,255)";
    LuiCollection col=new LuiCollection(chartPref.Get_Element("MAPVMP("+String.valueOf(si+1)+")_COLORS"));
    for (String key:col.keySet()){
    String elements[]=col.get(key).split("/");
         if (pValue<=Double.valueOf(elements[2].replace(" ","").replace(String.valueOf((char)160),""))){
           rc=elements[0];
           break;
         }
    rc=elements[0];
    }
   return rc;    
}
/**
     * Вычисление цвета для значения в случае неприрывного VisualMap
     * @param pValue --значение
     * @param pMin   -- минимум
     * @param pMax   -- максимум
     * @param pVMcolors -- набор цветов через запятую
     * @return
     */
    public String getColor4value(Double pValue,Double pMin,Double pMax,ArrayList<String> pVMcolors){
    String rc="";
    if (pVMcolors.size()<1) return rc;
    if (pVMcolors.size()==1) return pVMcolors.get(0);
    // на соколько фрагментов надо разбить диапазон?
    int dn=pVMcolors.size()-1;
    Double step=(pMax-pMin)/dn;
    Double dmin=pMin;
    Double dmax;
    for (int d=0;d<dn;d++){ // крутим диапазоны
        // для диапазона определяем его верхнее и нижнее значение
    dmax=dmin+step;
    if (pValue>=dmin && (pValue<dmax || (d==dn-1 && pValue>=dmax))) { // если pValue попадает в диапазон
    String startColor=pVMcolors.get(d).replace(" ","").replace("rgba","").replace("rgb","").replace("(","").replace(")","");
    String endColor=pVMcolors.get(d+1).replace(" ","").replace("rgba","").replace("rgb","").replace("(","").replace(")","");
    String[] colorComponent=startColor.split(",");
    Double sR=255.0;
    Double sG=255.0;
    Double sB=255.0;
    try{
    sR=Double.valueOf(colorComponent[0]);
    sG=Double.valueOf(colorComponent[1]);
    sB=Double.valueOf(colorComponent[2]);
    } catch (Exception ex){ }
    Double sO=1.0;
    if (colorComponent.length==4){
        try{
        sO=Double.valueOf(colorComponent[3]);
        } catch (Exception ex){ }
    }
    colorComponent=endColor.split(",");
    Double eR=255.0;
    Double eG=255.0;
    Double eB=255.0;
    try{
    eR=Double.valueOf(colorComponent[0]);
    eG=Double.valueOf(colorComponent[1]);
    eB=Double.valueOf(colorComponent[2]);
      } catch (Exception ex){ }
    Double eO=1.0;
    if (colorComponent.length==4){
        try{
        eO=Double.valueOf(colorComponent[3]);
          } catch (Exception ex){ }
    }
    String r=String.valueOf(Math.round(sR+(eR-sR)*(pValue-dmin)/(dmax-dmin)));
    String g=String.valueOf(Math.round(sG+(eG-sG)*(pValue-dmin)/(dmax-dmin)));
    String b=String.valueOf(Math.round(sB+(eB-sB)*(pValue-dmin)/(dmax-dmin)));
    Double dO=Math.round((sO+(eO-sO)*(pValue-dmin)/(dmax-dmin))*1000.0)/1000.0;
    String o=String.valueOf(dO);
    return "rgba("+r+","+g+","+b+","+o+")";
    }
    dmin=dmin+step;
    }
    return rc;
}
/**
 * Максимальное значение кривой
 * @param pCurveId
 * @return 
 */
    public String getMax4Curve(String pCurveIds){
    String rc="";
    int pCurveId=Integer.valueOf(pCurveIds)-1;
    
    if (series!=null && series.size()>=pCurveId){
        if (this.dimsStats!=null && dimsStats.containsKey(series.get(pCurveId).name)){
            if (dimsStats.get(series.get(pCurveId).name).max!=null){
                Double d=Double.valueOf(dimsStats.get(series.get(pCurveId).name).max);
                rc=LuiString.RTrim(String.format("%f",d).replace(",","."),"0");
                if (like(rc,"%."))rc=rc.replace(".","");
                
            }
        }
    }
    return rc;
}
/**
 * Минимальное значение кривой
 * @param pCurveId
 * @return 
 */
    public String getMin4Curve(String pCurveIds){
    String rc="";
    int pCurveId=Integer.valueOf(pCurveIds)-1;
    if (series!=null && series.size()>=pCurveId){
        if (this.dimsStats!=null && dimsStats.containsKey(series.get(pCurveId).name)){
            if (dimsStats.get(series.get(pCurveId).name).min!=null){
             Double d=Double.valueOf(dimsStats.get(series.get(pCurveId).name).min);
                rc=LuiString.RTrim(String.format("%f",d).replace(",","."),"0");
                if (like(rc,"%."))rc=rc.replace(".","");
                
        }}
    }
    return rc;
}    
/**
 * Мутация цвета под соответствующую яркость. Используется для visual map 2D-кривых. Для обеспечения цветов циллиндров и шлангов.
 * Т.к. при применении в VM явного управления чркостью цилиндры теряли градиент колорстопный
 * @param pColor
 * @param pLight
 * @return 
 */
public String modifyColor4light(String pColor,Double pLight){
   String rc;
   Double r;
   Double g;
   Double b;
   String[] src=pColor.replace("rgba","").replace("rgb","").replace("(","").replace(")","").split(",");
   if (src.length<3) return pColor;
   r=Double.valueOf(src[0]);
   g=Double.valueOf(src[1]);
   b=Double.valueOf(src[2]);
   r=(255.0-r)*(pLight)+r;
   g=(255.0-g)*(pLight)+g;
   b=(255.0-b)*(pLight)+b;
   
   rc="rgb("+String.valueOf(Math.round(r))+","
           +String.valueOf(Math.round(g))+","
           +String.valueOf(Math.round(b))+")";
   
   return rc;

}
/*public String getQuery(LuiDbConn lc,LuiDbConn mlc) throws SQLException{
    String rc="";
    // 1 определим начиная с какого группирующего столбца надо вести отсчёт
    rc=lc.getSelectResult("select  sum((case chart_type \n" +
                               "        when 'BAR3D' then '2'\n" +
                               "        when 'SCT3D' then '2'\n" +
                               "        else '1' end)::numeric)\n" +
                        "from lui_t_data_group_chart_pref where grouping_id="+this.DgId+" and seq<="+this.Level);
    if (is_null(rc))return "";
    int startWith=Integer.valueOf(rc);
    // начинаем генерацию фразы select
    ArrayList<LuiCollection> AGC=lc.getSelectAllRowsValMap("select src_column, src_datatype ,func,format from lui_t_data_group_function where  grouping_id="+this.DgId+" and seq>="+this.Level+" order by seq");
    for (int i=0;i<AGC.size();i++){
        
    }
    return rc;
} */  
public String checkMap() throws LuiException, SQLException{
    if (frm.getProperty("ForceDetail").equals("Y"))return "Y";
    String rc;
    if (!chartPref.containsKey("MAP_CODE"))rc="Y";
      //  LuiDbConn mlc=null;
       /* if (is_null(frm.getVal("MapRefreshed")) ){
            
            LuiClCommandGroup XMLcg=app.commandWriter.addAddGroup("MapRefresh");
            LuiClCommand 
               XMLcmd=XMLcg.addCommand("Event");
               XMLcmd.addScaPar("EventCode","ToolBarButton");
               XMLcmd.addScaPar("Params","FormID:"+frm.getFormID()+";Name:refresh;");
               //XMLcmd.addJPar("MS", "5000");
               //XMLcmd=XMLcg.addCommand("Event");
               //XMLcmd.addScaPar("EventCode","ToolBarButton");
               //XMLcmd.addScaPar("Params","FormID:"+frm.getFormID()+";Name:refresh;");
               
            frm.setVal("MapRefreshed", "Y");
        }*/
      //try{   
       // mlc=app.metaConnPool.GetFree(app.NLS.currentLang.locale,app.NLS.currentLang.code,app.code,app.getLuiSessionID(),app.getAppUser());        
    
             String mapName=this.getValueFromOuotputByCode(chartPref.Get_Element("MAP_CODE"));
                     //mlc.getSelectResult("select value from lui_t_data_grouping_output where grouping_id="+DgId+" and code='"+chartPref.get("MAP_CODE")+"'"); 
             if (is_null(mapName))rc= "N";
             else {
             if (mapName.equals(NVL(mapCodeParamValue,"")))rc= "Y";
             rc= "N";
             }
    //}finally{
    //      app.metaConnPool.SetFree(mlc);
    //  }
   /*if (rc=="N"){
       LuiClCommandGroup XMLcg=app.commandWriter.addGroup("Refresh");
               LuiClCommand XMLcmd=XMLcg.addCommand("Event");
               XMLcmd.addScaPar("EventCode","ToolBarButton");
               XMLcmd.addScaPar("Params","FormID:"+frm.getFormID()+";Name:refresh;");
   } */  
   return rc;
}
/**
 * выдача значения из lui_t_data_grouping_output по коду
 */
public String getValueFromOuotputByCode(String pCode){
    if (groupOutput==null || groupOutput.size()==0)return "";
    for(int i=0;i<groupOutput.size();i++){
        if (groupOutput.get(i).Get_Element("code").equals(pCode))return groupOutput.get(i).Get_Element("value");
    }
    return "";
}
/**
 * выдача значения из lui_t_data_grouping_output по имени
 */
public String getValueFromOuotputByName(String pName){
    if (groupOutput==null || groupOutput.size()==0)return "";
    for(int i=0;i<groupOutput.size();i++){
        if (groupOutput.get(i).Get_Element("name").equals(pName))return groupOutput.get(i).Get_Element("value");
    }
    return "";
}
/** определения визуальных эффектов для списка подменяющего диаграмму
 * 
 * @param pV - значение
 * @param ColCode - код столбца
 * @return -- цвет фона
 */
public String getV4LIST(String pV,String ColCode,String pDef){
   if (this.chartType.equals("PIE")) return ""; 
   if (is_null(pV))return "";
   String VIZ=pDef;
   String bg=null;
   String tx=null;
   Double v=null;
   Double min=null;
   Double max=null;
   Integer si=null;
   try {
   v=Double.valueOf(pV);
   si=Integer.valueOf(ColCode.replace("SF",""))-1;
   }catch(Exception ex){}
   if (si==null || v==null) return pDef;
   if (this.chartType.equals("MAP")){
     Integer chartsi=null;  
     try {
     chartsi=Integer.valueOf(NVL(frm.getVal("UserChartDGConfiguration"),"0"));
     } catch (Exception ex){}
     if (chartsi==null || chartsi!=si){
         return pDef;
     }
     String sname=series.get(0).name;
     if (dimsStats!=null && dimsStats.get(sname)!=null && dimsStats.get(sname).max!=null){
         max=Double.valueOf(this.dimsStats.get(sname).max);
             min=Double.valueOf(this.dimsStats.get(sname).min);
              if (Objects.equals(max, min)){
              if (max>0) min=0.0;
              else max=0.0;
              }
     }
     if (min==null || max==null)return pDef;
     if (NVL(chartPref.Get_Element("MAPVM("+String.valueOf(si+1)+")_MODE"),"C").equals("C")){ 
             
             bg=this.getColor4value(v,min,max, MAPVMcolorList);
              } else {
             bg=this.getColor4valueVMP(v, si);
             }
             
   } else {
    return pDef;      
   }
   if (is_not_null(bg)){
   bg.replace(" ","");
   VIZ="BACKGROUND("+bg+")";
   String rgba[]=bg.replace("(","").replace(")","").replace("rgba","").replace("rgb","").split(",");
             Double lignh=(0.299*Double.valueOf(rgba[0])+0.587*Double.valueOf(rgba[1])+0.114*Double.valueOf(rgba[2]))/255.0;
             if (rgba.length>3) lignh=lignh*(2-Double.valueOf(rgba[3]));
             if (lignh<0.5) VIZ=VIZ+" TEXTCOLOR(rgb(255,255,255))";
            
   
   }
   
   return VIZ;
}
/**
 * Перемещение графика по z-level
 * @param pComponentIndex номер графика от нуля
 * @param pDir направление
 * @throws LuiException
 * @throws SQLException 
 */
public void changeZlevel(String pComponentIndex, String pDir) throws LuiException, SQLException{
    
    if (!frm.getProperty("ClickComponentType").equals("series"))return;
    int ss=seriesProps.size();
    if (ss<2)return;
    if (is_null(pComponentIndex))return;
    if (ss-1<Integer.valueOf(pComponentIndex))return;
    int currentZlevel=series.get(Integer.valueOf(pComponentIndex)).zlevel;
    
    if (pDir.equals("UP")){
        if (currentZlevel>=ss-1)return;
        series.get(Integer.valueOf(pComponentIndex)).zlevel++;
        for(int i=0;i<ss;i++){
            if (i==Integer.valueOf(pComponentIndex))continue;
            if (series.get(Integer.valueOf(pComponentIndex)).zlevel==series.get(i).zlevel)
            {
             series.get(i).zlevel--;
             break;
            }
        }
    } else
    {
        if (currentZlevel<=0)return ;
        series.get(Integer.valueOf(pComponentIndex)).zlevel--;
        for(int i=0;i<ss;i++){
            if (i==Integer.valueOf(pComponentIndex))continue;
            if (series.get(Integer.valueOf(pComponentIndex)).zlevel==series.get(i).zlevel)
            {
             series.get(i).zlevel++;
             break;
            }
        }
    }
    LuiDbConn mlc=null;
    try{
    mlc=frm.application.metaConnPool.GetFree(frm.application.NLS.currentLang.locale,frm.application.NLS.currentLang.code,frm.application.code,frm.application.getLuiSessionID(),frm.application.getAppUser());
    mlc.executeDML("delete from lui_t_data_group_chart_pref_val where grouping_id="+this.DgId+" and chart_seq="+this.Level+" and prop_code like '2DCURVE(%)_ZLEVEL'");
    for (int i=0;i<ss;i++){
        if (i!=series.get(i).zlevel){
            mlc.executeDML("insert into lui_t_data_group_chart_pref_val(grouping_id,chart_seq,prop_code,value) values("
                    + this.DgId+","+this.Level+",'2DCURVE("+String.valueOf(i+1)+")_ZLEVEL','"+String.valueOf(series.get(i).zlevel)+"')");
        }
    }
    } finally {
        if (mlc!=null)frm.application.metaConnPool.SetFree(mlc);
    }
}
/**
 * Проверка возможности передвижения графика по z-level
 * @param pComponentIndex номер графика начиная с нуля
 * @param pDir направление
 * @return Y/N
 * @throws LuiException
 * @throws SQLException 
 */
public String isChangeZlevelAllowed(String pComponentIndex, String pDir) throws LuiException, SQLException{
    if (!frm.getProperty("ClickComponentType").equals("series"))return "N";
    int ss=seriesProps.size();
    if (ss<2)return "N";
    if (is_null(pComponentIndex))return "N";
    if (ss-1<Integer.valueOf(pComponentIndex))return "N";
    int currentZlevel=series.get(Integer.valueOf(pComponentIndex)).zlevel;
    
    if (pDir.equals("UP")){
        if (currentZlevel<ss-1)return "Y";
    } else
    {
        if (currentZlevel>0)return "Y";
    }
    return "N";
}
/**
 * Создание в форме параметров
 */
public void makeFormParameters4Titles(LuiDbConn mlc) throws LuiException, SQLException{
   PreparedStatement ps=null;
    String stmt4convert="select to_char(?,?)";
    if (mlc.getDBvendor().equals("ORA")){
        stmt4convert=stmt4convert+" from dual";
    }
    ps=mlc.getConnection().prepareStatement(stmt4convert);
    ResultSet rs=null;
    String format;
    String vs;
    LuiAppElement pel;
    try{
  // ну начнём с осмотра выхлопа предковых диаграмм
  String predicats="";
  LuiCollection col;
  if (groupOutput!=null){
  
  for (int i=0;i<groupOutput.size();i++){
      col=groupOutput.get(i);
      if (Integer.valueOf(col.Get_Element("chart_seq"))>=Integer.valueOf(this.Level))continue;
      if (like(col.Get_Element("code"),"P$%GC%")){ // если это измерение - ось категорий
         
          String ni=col.Get_Element("code").split("GC")[1];
          if (ni.equals("0")){ // если это навязанный параметр
          pel=frm.addElement("N$"+col.Get_Element("code"),"PARAM",null,col.Get_Element("name"),null);
          pel.addProperty("Value",col.Get_Element("value"));
             
          } else {
          pel=frm.addElement("N$SGC"+ni,"PARAM",null,app.NLS.NLS("RUS:Обозначение измерения ;ENG:Axis short name ;")+ni,null);
          pel.addProperty("Value",col.Get_Element("name"));
         
          pel=frm.addElement("N$NGC"+ni,"PARAM",null,app.NLS.NLS("RUS:Название измерения ;ENG:Axis name ;")+ni,null);
          pel.addProperty("Value",NVL(col.Get_Element("hint"),col.Get_Element("name")));
         
          pel=frm.addElement("N$VGC"+ni,"PARAM",null,app.NLS.NLS("RUS:Значение измерения ;ENG:Axis value ;")+ni,null);
          pel.addProperty("Value",col.Get_Element("value"));
          }
          if (is_not_null(col.Get_Element("predicat4show")) && !col.Get_Element("predicat4show").equals("null")){
          if (!predicats.equals(""))predicats=predicats+"\n";
          predicats=predicats+col.Get_Element("predicat4show");}
      }
        
  }
  }
  pel=frm.addElement("N$PREDICATS4SHOW","PARAM",null,app.NLS.NLS("RUS:Отбор в предшествующих диаграммах;ENG:Selection in parent charts;"),null);
          pel.addProperty("Value",predicats);
  // теперь отображаемые показатели и их суммы и средние
   for (int i=0;i<seriesProps.size();i++){
       col=seriesProps.get(i);
       String ni="";
         String nni="";
         String sn=col.Get_Element("name");
         if (chartType.equals("MAP")|| chartType.equals("PIE")|| chartType.equals("WHR")) {
           if (!String.valueOf(i).equals(NVL(chartPref.get("CFG"),"0"))) continue;  
         }else { 
         ni=String.valueOf(i+1);
         nni=" "+ni;
         }
         pel=frm.addElement("N$SSF"+ni,"PARAM",null,app.NLS.NLS("RUS:Обозначение показателя;ENG:Indicator short name ;")+nni,null);
         pel.addProperty("Value",col.Get_Element("name"));
         pel=frm.addElement("N$NSF"+ni,"PARAM",null,app.NLS.NLS("RUS:Название показателя;ENG:Indicator name;")+nni,null);
         pel.addProperty("Value",NVL(col.Get_Element("hint"),col.Get_Element("name")));
         //pel=frm.addElement("N$VSF"+ni,"PARAM",null,app.NLS.NLS("RUS:Значение показателя;ENG:Indicator value;")+nni,null);
         //pel.addProperty("Value","");
         pel=frm.addElement("N$VSF_SUM"+ni,"PARAM",null,app.NLS.NLS("RUS:Cумма значений показателя;ENG:Sum of indicator values;")+nni,null);
         pel.addProperty("Value","");
        if (dimsStats!=null && dimsStats.containsKey(sn) && dimsStats.get(sn).sum!=null){
        Double d=dimsStats.get(sn).sum;
        format=col.Get_Element("format");
        if (is_not_null(format)){
        ps.setDouble(1,d);
        ps.setString(2,format);
        rs=ps.executeQuery();
                     rs.next();
                     vs=rs.getString(1);
                     rs.close();
                     vs=vs.replace(" ","").replace(String.valueOf((char)160),"");
               try{
                 d=Double.valueOf(vs);
               } catch (Exception ex){
                 d=dimsStats.get(series.get(i).name).sum;  
               }
        }
        Boolean billion=false;
        if (Math.abs(d)>1000000.0) {
            d=d/1000000.0;d=Math.round(d*100.0)/100.0;
         billion=true;
        }
        if  (d==Math.round(d)) 
            vs=d.toString().replace(".0","");
        else vs=d.toString();
        
        if (billion){ 
            if(app.NLS.currentLang.code.equals("RUS")) {
                vs=vs+" млн.";
            } else {
                vs=vs+" mill.";
            }
        }
        pel.addProperty("Value", vs);
      }
      pel=frm.addElement("N$VSF_AVG"+ni,"PARAM",null,app.NLS.NLS("RUS:Среднее значене показателя;ENG:Average of indicator values;")+nni,null);
         pel.addProperty("Value","");
        if (dimsStats!=null && dimsStats.containsKey(sn) && dimsStats.get(sn).avg!=null){
        Double d=dimsStats.get(sn).avg;
        format=col.Get_Element("format");
        if (is_not_null(format)){
        ps.setDouble(1,d);
        ps.setString(2,format);
        rs=ps.executeQuery();
                     rs.next();
                     vs=rs.getString(1);
                     rs.close();
                     vs=vs.replace(" ","").replace(String.valueOf((char)160),"");
               try{
                 d=Double.valueOf(vs);
               } catch (Exception ex){
                 d=dimsStats.get(series.get(i).name).avg;  
               }
        }
        Boolean billion=false;
        if (Math.abs(d)>1000000.0) {
            d=d/1000000.0;d=Math.round(d*100.0)/100.0;
         billion=true;
        }
        if  (d==Math.round(d)) 
            vs=d.toString().replace(".0","");
        else vs=d.toString();
        
        if (billion){ 
            if(app.NLS.currentLang.code.equals("RUS")) {
                vs=vs+" млн.";
            } else {
                vs=vs+" mill.";
            }
        }
        pel.addProperty("Value", vs);
      }
      pel=frm.addElement("N$VSF_CNT"+ni,"PARAM",null,app.NLS.NLS("RUS:Количество значений показателя;ENG:Count of indicator values;")+nni,null);
         pel.addProperty("Value","");
        if (dimsStats!=null && dimsStats.containsKey(sn) && dimsStats.get(sn).count!=null){
        Double d=dimsStats.get(sn).count;
        vs=d.toString().replace(".0","");
        pel.addProperty("Value", vs);
      }  
          } 
 // теперь отображаемые оси - измерения
  for (int i=0;i<groupProps.size();i++){
      col=groupProps.get(i);
      String ni="";
      if (i==0) ni="X";
      else ni="Y";
      
      String nni="";
      if (groupProps.size()>1){
      if (i==0) ni=" X";
      else ni=" Y";
      }
      pel=frm.addElement("N$SGC"+ni,"PARAM",null,app.NLS.NLS("RUS:Обозначение измерения;ENG:Axis short name;")+nni,null);
          pel.addProperty("Value",col.Get_Element("name"));
         
          pel=frm.addElement("N$NGC"+ni,"PARAM",null,app.NLS.NLS("RUS:Название измерения;ENG:Axis name;")+nni,null);
         pel.addProperty("Value",NVL(col.Get_Element("hint"),col.Get_Element("name")));
         
        //  pel=frm.addElement("N$VGC"+ni,"PARAM",null,app.NLS.NLS("RUS:Значение измерения;ENG:Axis value;")+nni,null);
       //   pel.addProperty("Value","");
  }
 // теперь параметры даты-времени
  pel=frm.addElement("N$YYYY","PARAM",null,app.NLS.NLS("RUS:Г;ENG:Y;"),null);
          pel.addProperty("Value",datetimecol.Get_Element("yyyy"));
  pel=frm.addElement("N$MM","PARAM",null,app.NLS.NLS("RUS:М;ENG:M;"),null);
          pel.addProperty("Value",datetimecol.Get_Element("mm"));
  pel=frm.addElement("N$DD","PARAM",null,app.NLS.NLS("RUS:Д;ENG:D;"),null);
          pel.addProperty("Value",datetimecol.Get_Element("dd"));          
  pel=frm.addElement("N$HH","PARAM",null,app.NLS.NLS("RUS:ч;ENG:h;"),null);
          pel.addProperty("Value",datetimecol.Get_Element("hh"));
  pel=frm.addElement("N$MI","PARAM",null,app.NLS.NLS("RUS:м;ENG:m;"),null);
          pel.addProperty("Value",datetimecol.Get_Element("mi"));
 } finally{
    if (rs!=null)rs.close();
    if (ps!=null)ps.close();
    } 
}
}